
// DMIH 2001 - Prvi dan natjecanja
// Srednjoskolska skupina - I. podskupina
// Zadatak BARKOD
// Autor rjesenja Zvonimir Bujanovic
// Nesluzbeno rjesenje

#include<stdio.h>
#include<stdlib.h>

#define INFILE     "BARCODE.in"
#define OUTFILE    "BARCODE.out"
#define MAXN       100
#define CRNIZNAK   'X'
#define BIJZNAK    '.'
#define NEZNAMZN   '?'

#define CRNA       1
#define BIJELA     -1
#define NEZNAM     0

int n, znam[MAXN], boje[MAXN];

void load_data ( void )
{
 int i, j;
 char s[MAXN+1];
 FILE *f=fopen (INFILE, "rt");

 fscanf (f, "%d\n", &n);
 for (i=0; i<5; i++)
     {
      fscanf (f, "%[^\n]\n", s);
      for (j=0; j<n; j++)
          switch (s[j])
            {
             case CRNIZNAK : boje[j]=CRNA; break;
             case BIJZNAK  : boje[j]=BIJELA; break;
             default       : ;
            }
     }
}

void solve ( void )
{
 int flag=1, i;

 while (flag)
   {
    flag=0;
    for (i=0; i<n-2; i++)
        {
         if (boje[i]*boje[i+1]==1 && !boje[i+2]) { boje[i+2]=-boje[i]; flag=1; }
         if (boje[i]*boje[i+2]==1 && !boje[i+1]) { boje[i+1]=-boje[i]; flag=1; }
         if (boje[i+1]*boje[i+2]==1 && !boje[i]) { boje[i]=-boje[i+1]; flag=1; }
        }
   }
}

void write_output ( void )
{
 int i, j;
 FILE *f=fopen (OUTFILE, "wt");

 for (i=0; i<n; i++)
     if (boje[i]==NEZNAM)
        {
         fprintf (f, "UNDETERMINABLE\n");
         fclose (f);
         exit (0);
        }

 i=0;
 while (i<n)
   switch (boje[i])
     {
      case CRNA   : j=1;
                    while (i+j<n && boje[i+j]==CRNA) j++;
                    fprintf (f, "%d", j-1);
                    i+=j;
                    break;

      case BIJELA : j=1;
                    while (i+j<n && boje[i+j]==BIJELA) j++;
                    fprintf (f, "%d", j-1);
                    i+=j;
                    break;
      default     : ;
     }

fprintf(f, "\n");
 fclose (f);
}

int main ( void )
{
 load_data();
 solve();
 write_output();
 return 0;
}
