
// Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic

/*

Brojke na satu prikazujemo pomocu znakova '#' i '.' i to tako da svaku
od cetiri brojke prikazemo kao niz od 15 znakova u polju 'brojke_na_satu'.
Ispravan izgled znamenki pamtimo na isti nacin u polju 'ispravne_znamenke'.

Da bi odredili da li je moguce da je neka brojka bila prikazana na satu
potrebno je jednostavno provjeriti da li svakoj upaljenoj lampici na satu
odgovara upaljena lampica na ispravnoj znamenci.

Zadatak rijesavamo tako da isprobamo sve moguce kombinacije znamenki
redoslijedom od manjeg vremena prema vecem i ispisemo rjesenje cim
naidjemo na kombinaciju znamenki koja odgovara izgledu sata.

*/

#include <stdio.h>

//

char ispravne_znamenke[10][16] = { "####.##.##.####",
                                   "..#..#..#..#..#",
                                   "###..#####..###",
                                   "###..####..####",
                                   "#.##.####..#..#",
                                   "####..###..####",
                                   "####..####.####",
                                   "###..#..#..#..#",
                                   "####.#####.####",
                                   "####.####..####" };

char brojke_na_satu[4][16];

struct {
         int sati,minuta;
       } rjesenje;

FILE *file;

//

void ucitaj_podatke(void)
{
  int i,j;

  //

  file = fopen("CLOCK.IN","rt");

  for (i = 0;i < 5;++i)
    for (j = 0;j < 4;++j)
      fscanf(file,"%s",brojke_na_satu[j] + 3 * i);

  fclose(file);
}

//

int odgovara(int koja_znamenka,int broj)
{
  int i;

  //

  for (i = 0;i < 15;++i)
    if (brojke_na_satu[koja_znamenka][i] == '#' && ispravne_znamenke[broj][i] == '.')
      return 0;

  return 1;
}

//

void rijesi(void)
{
  int i,j;

  //

  for (i = 0;i < 24;++i)
    for (j = 0;j < 60;++j)
      if (odgovara(0,i / 10) && odgovara(1,i % 10) &&
          odgovara(2,j / 10) && odgovara(3,j % 10))
      {
        rjesenje.sati = i;
        rjesenje.minuta = j;

        return;
      }
}

//

void ispisi_rjesenje(void)
{
  file = fopen("CLOCK.OUT","wt");

  fprintf(file,"%02d:%02d\n",rjesenje.sati,rjesenje.minuta);

  fclose(file);
}

//

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  //

  return 0;
}
