
// Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic

/*

Da bismo rijesili zadatak potrebno je iz svake adrese odrediti domenu i
moramo odrzavati listu dosad posjecenih domena zajedno s brojem posjeta
svakoj od njih. Kada procitamo sve adrese jednostavno ispisemo sve domene
koje su posjecene najveci broj puta.
U funkciji odredi_domenu() odredjujemo domenu iz adrese, dok u funkciji
azuriraj_listu_domena() azuriramo listu domena tj. ako se odredjena domena
vec pojavila povecavamo broj posjeta toj domeni za jedan, a ako se jos
nije pojavila, dodajemo je u listu.

*/

#include <stdio.h>
#include <string.h>

//

#define MAX_ADRESA 100
#define MAX_ZNAKOVA 50

//

int broj_domena;

struct {
         char naziv[4];
         int broj_posjeta;
       } domene[MAX_ADRESA];

//

void odredi_domenu(char *adresa,char *domena)
{
  int i;
  int indeks,pocetak,kraj;

  //

  pocetak = indeks = 0;

  if (!strncmp(adresa,"http://",7))
    pocetak = indeks = 7;

  while (1)
  {
    if (adresa[indeks] == '\0' || adresa[indeks] == '/')
    {
      kraj = indeks - 1;
      break;
    }

    if (adresa[indeks] == '.')
      pocetak = indeks + 1;

    ++indeks;
  }

  for (i = pocetak;i <= kraj;++i)
    domena[i - pocetak] = adresa[i];

  domena[kraj - pocetak + 1] = '\0';
}

//

void azuriraj_listu_domena(char *domena)
{
  int i;
  int ima;

  //

  ima = 0;

  for (i = 0;i < broj_domena;++i)
    if (!strcmp(domene[i].naziv,domena))
    {
      ++domene[i].broj_posjeta;
      ima = 1;

      break;
    }

  if (!ima)
  {
    strcpy(domene[broj_domena].naziv,domena);
    domene[broj_domena].broj_posjeta = 1;
    ++broj_domena;
  }
}

//

int main(void)
{
  int i;
  int broj_adresa;
  char adresa[MAX_ZNAKOVA + 1],domena[4];
  int max_posjeta;

  FILE *file;

  //

  file = fopen("DOMAINS.IN","rt");

  fscanf(file,"%d",&broj_adresa);

  broj_domena = 0;

  for (i = 0;i < broj_adresa;++i)
  {
    fscanf(file,"%s",adresa);

    odredi_domenu(adresa,domena);
    azuriraj_listu_domena(domena);
  }

  fclose(file);

  //

  max_posjeta = 0;

  for (i = 0;i < broj_domena;++i)
    if (!max_posjeta || domene[i].broj_posjeta > max_posjeta)
      max_posjeta = domene[i].broj_posjeta;

  //

  file = fopen("DOMAINS.OUT","wt");

  fprintf(file,"%d\n",max_posjeta);

  for (i = 0;i < broj_domena;++i)
    if (domene[i].broj_posjeta == max_posjeta)
      fprintf(file,"%s ",domene[i].naziv);

  fprintf(file,"\n");

  fclose(file);

  //

  return 0;
}
