
// Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic

/*

Oznacimo s maraka[i] odnosno s kuna[i] najvecu mogucu kolicinu maraka
odnosno kuna koju mozemo posjedovati poslije eventualnih transakcija
i-tog dana.

Ako i-tog dana mozemo posjedovati najvise maraka[i] maraka, to znaci da
ili (i-1)-og dana mozemo posjedovati toliko maraka (pa i-ti dan ne vrsimo
nikakve transakcije) ili (i-1)-og dana mozemo posjedovati tocno toliko
kuna da promjenom tih kuna u marke mozemo dobiti maraka[i] maraka.

Dakle vrijede relacije:

maraka[i] = max(maraka[i - 1],kuna[i - 1] / tecaj[i].prodajni * 100)
kuna[i] = max(kuna[i - 1],maraka[i - 1] * tecaj.kupovni[i] / 100)

Rjesenje zadatka je broj maraka[broj_dana] kojeg odredjujemo dinamicki
tj. tako da pomocu gornje relacije odredjujemo vrijednosti maraka[i]
i kuna[i] za sve vece i vece indekse 'i'.

Pocetni uvjeti su ocito:

maraka[0] = 100
kuna[0] = 0

U ovoj implementaciji ne pamti se cijelo polje nego samo vrijednosti za
prethodni dan.

*/

#include <stdio.h>
#include <stdlib.h>

//

#define MAX_DANA 100

//

int broj_dana;

struct {
         int kupovni,prodajni;
       } tecaj[MAX_DANA];

double rjesenje;

FILE *file;

//

void ucitaj_podatke(void)
{
  int i;

  //

  file = fopen("EXCHANGE.IN","rt");

  fscanf(file,"%d",&broj_dana);

  for (i = 0;i < broj_dana;++i)
    fscanf(file,"%d%d",&tecaj[i].kupovni,&tecaj[i].prodajni);

  fclose(file);
}

//

void rijesi(void)
{
  int i;
  double jucer_maraka,jucer_kuna;
  double maraka,kuna;

  //

  jucer_maraka = 100.0;
  jucer_kuna = 0.0;

  for (i = 0;i < broj_dana;++i)
  {
    maraka = max(jucer_maraka,jucer_kuna / tecaj[i].prodajni * 100);
    kuna = max(jucer_kuna,jucer_maraka * tecaj[i].kupovni / 100);

    jucer_maraka = maraka;
    jucer_kuna = kuna;
  }

  rjesenje = maraka;
}

//

void ispisi_rjesenje(void)
{
  file = fopen("EXCHANGE.OUT","wt");

  fprintf(file,"%.2lf\n",rjesenje);

  fclose(file);
}

//

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  //

  return 0;
}
