
// Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic

/*

Zadatak rjesavamo dinamicki.

Neka je zadana rijec zapisana u varijabli 'niz_znakova' tako da prvi
znak u rijeci ima indeks 0, a zadnji znak ima indeks 'duljina_niza - 1'.

Neka 'palindrom(a,b)' vrijedi ako je dio rijeci od a-tog znaka do
b-tog znaka palindrom.

Minimalni broj palindroma od pocetka niza do p-tog znaka ('polje[p]')
racuna se na sljedeci nacin:

1. Ako je cijela rijec do p-tog znaka palindrom tj. ako vrijedi
'palindrom(0,p)', tada je minimalni broj palindroma do tog znaka jednak 1.

2. Inace se promatra svaki prethodni r-ti znak, r<p, kod kojeg vrijedi
'palindrom(r+1,p)' (tj. rijec koju cine znakovi od (r+1)-og do p-tog
cine palindrom). Ako je minimalni broj palindroma do r-tog znaka
jednak M, tada je minimalni broj palindroma do p-tog znaka jednak M+1.
Od svih znakova ispred p-tog, odabere se onaj kod kojega je M minimalan.

Rjesenje zadatka je 'polje[duljina_niza - 1]'.

*/

#include <stdio.h>
#include <string.h>

//

#define MAX_ZNAKOVA 100

//

char niz_znakova[MAX_ZNAKOVA + 1];
int duljina_niza;

int rjesenje;

FILE *file;

//

void ucitaj_podatke(void)
{
  file = fopen("PALIN.IN","rt");

  fscanf(file,"%s",niz_znakova);

  duljina_niza = strlen(niz_znakova);

  fclose(file);
}

//

int palindrom(int pocetak,int kraj)
{
  while (1)
  {
    if (niz_znakova[pocetak] != niz_znakova[kraj])
      return 0;

    ++pocetak;
    --kraj;

    if (pocetak >= kraj)
      break;
  }

  return 1;
}

//

void rijesi(void)
{
  int i,j;
  int polje[MAX_ZNAKOVA];
  int minimalno;

  //

  for (i = 0;i < duljina_niza;++i)
  {
    if (palindrom(0,i))
    {
      polje[i] = 1;
      continue;
    }

    minimalno = 0;

    for (j = 0;j < i;++j)
      if (palindrom(j + 1,i) && (!minimalno || polje[j] < minimalno))
        minimalno = polje[j];

    polje[i] = minimalno + 1;
  }

  rjesenje = polje[duljina_niza - 1];
}

//

void ispisi_rjesenje(void)
{
  file = fopen("PALIN.OUT","wt");

  fprintf(file,"%d\n",rjesenje);

  fclose(file);
}

//

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  //

  return 0;
}
