
/*
HIO 2002
Zadatak LIVADA, Programski jezik C
*/

#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

#define INFILE  "meadow.in"
#define OUTFILE "meadow.out"
#define MAXINT  1000000000

using namespace std;

typedef pair<int, int> tocka;

int n, m;
vector<tocka> cvijet;

void citaj_ulaz (void)
{
        ifstream input(INFILE);
        input >> n;
        input >> m;
        for (int i=0; i<n; i++)
        {
                tocka a;
                input >> a.first >> a.second;
                cvijet.push_back(a);
        }
        input.close();
}

int udaljenost (tocka a, tocka b)
{
        return (a.first-b.first)*(a.first-b.first)+(a.second-b.second)*(a.second-b.second);
}

void rijesi (void)
{
        int zadnji;
        vector<int> gotovo(n, 0);
        vector<int> udalj(n, MAXINT);

        zadnji=0;
        udalj[0]=0;
        gotovo[0]=1;
        for (int i=0; i<n-1; i++)
        {
                int naj=0;
                while (gotovo[naj]) naj++;
                for (int j=naj; j<n; j++) if (!gotovo[j])
                {
                        udalj[j]=min(udalj[j], udaljenost(cvijet[j], cvijet[zadnji]));
                        if (udalj[j]<udalj[naj]) naj=j;
                }
                gotovo[naj]=1;
                zadnji=naj;
        }

        sort(udalj.begin(), udalj.end());

        ofstream output(OUTFILE);
        output << sqrt((double) udalj[n-m]) << endl;
        output.close();
}

int main (void)
{
        citaj_ulaz();
        rijesi();
        return 0;
}
