
/*
Regional Competition 2002, Seniors
Problem AIRPLANE, Solution in C
*/

#include <stdio.h>

#define INPUT_FILE  "airplane.in"
#define OUTPUT_FILE "airplane.out"
#define MAX_PUTNIKA 1000
#define MAX_REDOVA  1000

int broj_putnika,broj_redova;
int cilj[MAX_PUTNIKA + 1];
int rjesenje;
FILE *file;

void ucitaj_podatke(void)
{
  int i;

  file = fopen(INPUT_FILE,"r");
  fscanf(file,"%d",&broj_putnika);
  broj_redova = 1;
  for (i = 1;i <= broj_putnika;++i)
  {
    fscanf(file,"%d",cilj + i);
    if (cilj[i] > broj_redova)
      broj_redova = cilj[i];
  }
  fclose(file);
}

int max3(int a,int b,int c)
{
  if (a > b && a > c)
    return a;
  if (b > c)
    return b;
  return c;
}

void rijesi(void)
{
  int i,j;
  int redovi[MAX_REDOVA + 1];

  for (i = 0;i <= broj_redova;++i)
    redovi[i] = 0;

  for (i = 1;i <= broj_putnika;++i)
  {
    for (j = 1;j < cilj[i];++j)
      redovi[j] = max3(redovi[j - 1] + 1,redovi[j] + 1,redovi[j + 1]);
    redovi[cilj[i]] = max3(redovi[cilj[i] - 1],redovi[cilj[i]],0) + 5;
  }

  rjesenje = redovi[1];
  for (i = 2;i <= broj_redova;++i)
    if (redovi[i] > rjesenje)
      rjesenje = redovi[i];
}

void ispisi_rjesenje(void)
{
  file = fopen(OUTPUT_FILE,"w");
  fprintf(file,"%d\n",rjesenje);
  fclose(file);
}

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  return 0;
}
