
/*
Regional Competition 2002, Seniors
Problem ELBOW, Solution in C
*/

#include <stdio.h>
#include <string.h>

#define INPUT_FILE  "elbow.in"
#define OUTPUT_FILE "elbow.out"
#define MAX_ZNAKOVA 150

char prva_rijec[MAX_ZNAKOVA + 1],druga_rijec[MAX_ZNAKOVA + 1],treca_rijec[2 * MAX_ZNAKOVA + 1];
int duljina1,duljina2;
int tablica[MAX_ZNAKOVA + 1][MAX_ZNAKOVA + 1];
FILE *file;

void ucitaj_podatke(void)
{
  file = fopen(INPUT_FILE,"r");
  fscanf(file,"%s%s%s",prva_rijec,druga_rijec,treca_rijec);
  duljina1 = strlen(prva_rijec);
  duljina2 = strlen(druga_rijec);
  fclose(file);
}

void rijesi(void)
{
  int i,j;

  for (i = 0;i <= duljina1;++i)
    for (j = 0;j <= duljina2;++j)
      tablica[i][j] = 0;
  tablica[0][0] = 999;

  for (i = 0;i <= duljina1;++i)
    for (j = 0;j <= duljina2;++j)
    {
      if (i && tablica[i - 1][j] && prva_rijec[i - 1] == treca_rijec[i + j - 1])
        tablica[i][j] = 1;
      if (j && tablica[i][j - 1] && druga_rijec[j - 1] == treca_rijec[i + j - 1])
        tablica[i][j] = 2;
    }
}

void ispisi_rjesenje(void)
{
  int i;
  int a,b;
  int rjesenje[2 * MAX_ZNAKOVA];

  a = duljina1;
  b = duljina2;
  for (i = 0;i < duljina1 + duljina2;++i)
  {
    rjesenje[a + b - 1] = tablica[a][b];
    if (tablica[a][b] == 1)
      --a;
    else
      --b;
  }

  file = fopen(OUTPUT_FILE,"w");
  for (i = 0;i < duljina1 + duljina2;++i)
    fprintf(file,"%d",rjesenje[i]);
  fprintf(file,"\n");
  fclose(file);
}

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  return 0;
}
