
/*
Croatia 2003
Croatian Olympiad in Informatics
Problem A1, Programming language C++
*/

#include <fstream>
#include <set>
#include <algorithm>

using namespace std;

#define INFILE			"a1.in"
#define OUTFILE			"a1.out"
#define MAXRUPA			100000
#define MAXSEG			100000

int duljina_segmenta, broj_rupa, rupa[MAXRUPA], total, rjesenje, najmanje_segmenata=2*MAXSEG;

struct inter
{
	int begin, end;
};

struct po_pocetku
{
	bool operator ()(const inter &a, const inter &b)
	{
		if (a.begin < b.begin) return true;
		if (a.begin > b.begin) return false;
		if (a.end < b.end) return true;
		if (a.end > b.end) return false;
		return false;
	}
};

struct po_kraju
{
	bool operator ()(const inter &a, const inter &b)
	{
		if (a.end < b.end) return true;
		if (a.end > b.end) return false;
		if (a.begin < b.begin) return true;
		if (a.begin > b.begin) return false;
		return false;
	}
};

inter interval[MAXSEG*2];
int broj_intervala;

void load_data ( void )
{
	ifstream fin(INFILE);

	fin >> duljina_segmenta >> broj_rupa;
	for (int i=0; i<broj_rupa; i++)
	{
		fin >> rupa[i];
		rupa[i]--;
	}

	fin.close();
}

void solve ( void )
{
	// napravi segmente od svih premalih razmaka
	int currupa, oldrupa, pocetak_intervala, kraj_intervala;

	currupa=0;
	while (currupa < broj_rupa)
	{
		pocetak_intervala=(rupa[currupa]+1)%duljina_segmenta; oldrupa=currupa++;
		while (currupa<broj_rupa && rupa[currupa]-rupa[currupa-1]<=duljina_segmenta) currupa++;
		kraj_intervala=rupa[currupa-1]%duljina_segmenta;

		if ((kraj_intervala+1)%duljina_segmenta != pocetak_intervala)
		{
			if (pocetak_intervala <= kraj_intervala)
			{
				interval[broj_intervala].begin=pocetak_intervala;
				interval[broj_intervala++].end=kraj_intervala;
			}
			else
			{
				interval[broj_intervala].begin=0;
				interval[broj_intervala++].end=kraj_intervala;
				interval[broj_intervala].begin=pocetak_intervala;
				interval[broj_intervala++].end=duljina_segmenta-1;
			}
		}

		total+=(rupa[currupa-1]-(rupa[oldrupa]+1-duljina_segmenta)+1)/duljina_segmenta;
	}

	// sad prebroji koji broj se nalazi u najmanje intervala
	if (broj_intervala==0)
	{
		najmanje_segmenata=0; return;
	}

	sort (interval, interval+broj_intervala, po_pocetku());
	int u_koliko_segmenata=0, curseg=0;
	multiset<inter, po_kraju> desni_heap;
	multiset<inter, po_kraju>::iterator mmap_i;

	for (int i=0; i<duljina_segmenta; i++)
	{
		while (interval[curseg].begin==i)
		{
			desni_heap.insert (interval[curseg++]);
			u_koliko_segmenata++;
		}

		while (!desni_heap.empty() && (mmap_i=desni_heap.begin())->end < i)
		{
			desni_heap.erase (mmap_i);
			u_koliko_segmenata--;
		}

		if (u_koliko_segmenata < najmanje_segmenata)
		{
			rjesenje=i; najmanje_segmenata=u_koliko_segmenata;
		}
	}
}

void write_solution ( void )
{
	ofstream fout(OUTFILE);
	int i;

        fout << najmanje_segmenata+total << endl;

	if (broj_intervala==0)
	{
		for (i=0; i<duljina_segmenta; i++)
                        fout << i+1 << " ";
                fout << endl;
		fout.close();
		return;
	}

	// sad ispisi one koji se nalaze u tih najmanje segmenata
	int u_koliko_segmenata=0, curseg=0;
	multiset<inter, po_kraju> desni_heap;
	multiset<inter, po_kraju>::iterator mmap_i;

	for (i=0; i<duljina_segmenta; i++)
	{
		while (interval[curseg].begin==i)
		{
			desni_heap.insert (interval[curseg++]);
			u_koliko_segmenata++;
		}

		while (!desni_heap.empty() && (mmap_i=desni_heap.begin())->end < i)
		{
			desni_heap.erase (mmap_i);
			u_koliko_segmenata--;
		}

                if (u_koliko_segmenata == najmanje_segmenata)
		{
                        fout << i+1 << " ";
		}
	}

        fout << endl;
	fout.close();
}

int main ( void )
{
	load_data();
	solve();
	write_solution();

	return 0;
}
