
/*
Croatia 2003
Croatian Olympiad in Informatics
Problem MREZA, Programming language C++
*/

#include <iostream>
#include <fstream>
#include <string>
#include <vector>

using namespace std;

#define MAX_PUT                 100000

//input:
int nx, ny;
string put;

//output:
vector<int> najK, najL;
int najDist;

//temporary:
int pozX[MAX_PUT+1]; //do zadanog koraka
int pozY[MAX_PUT+1]; //do zadanog koraka
int maxLeft[MAX_PUT+1]; //poslje zadanog koraka
int maxRight[MAX_PUT+1]; //poslje zadanog koraka
int maxDown[MAX_PUT+1]; //poslje zadanog koraka
int maxUp[MAX_PUT+1]; //poslje zadanog koraka
int pomakX[MAX_PUT+1]; //poslje zadanog koraka
int pomakY[MAX_PUT+1]; //poslje zadanog koraka
int maxValidniPocetak; //koliko poteza smije sadrzavati pocetni dio

void input ( void )
{
        ifstream fin ("mreza.in");
	int np;
	fin >> nx >> ny >> np;
	fin >> put;

        if (put.size()!=np) exit(-1);
        if (put.size()>MAX_PUT) exit(-1);
}

void pomak (int x0, int y0, char p, int &x1, int &y1)
{
	switch (p)
	{
                case 'U': x1=x0; y1=y0+1; break;
                case 'D': x1=x0; y1=y0-1; break;
                case 'R': x1=x0+1; y1=y0; break;
                case 'L': x1=x0-1; y1=y0; break;
	}
}

void preprocess ( void )
{
	int i;

        pozX[0]=0;
        pozY[0]=0;
        for (i=0; i<put.size(); i++)
                pomak (pozX[i], pozY[i], put[i], pozX[i+1], pozY[i+1]);

        pomakX[put.size()]=0;
        pomakY[put.size()]=0;
        for (i=put.size()-1; i>=0; i--)
                pomak (pomakX[i+1], pomakY[i+1], put[i], pomakX[i], pomakY[i]);

        maxLeft[put.size()]=0;
        maxRight[put.size()]=0;
        maxUp[put.size()]=0;
        maxDown[put.size()]=0;
        for (i=put.size()-1; i>=0; i--)
	{
                pomak (maxLeft[i+1], maxUp[i+1], put[i], maxLeft[i], maxUp[i]);
                pomak (maxRight[i+1], maxDown[i+1], put[i], maxRight[i], maxDown[i]);

                if (maxLeft[i]>0) maxLeft[i]=0;
                if (maxRight[i]<0) maxRight[i]=0;
                if (maxUp[i]<0) maxUp[i]=0;
                if (maxDown[i]>0) maxDown[i]=0;
	}

        maxValidniPocetak=put.size()-1; // mora se barem jedan ukloniti
        for (i=1; i<=put.size(); i++)
                if (pozX[i]<0 || pozX[i]>nx || pozY[i]<0 || pozY[i]>ny)
		{
                        maxValidniPocetak=i-1;
			break;
		}
}

void solve ( void )
{
	preprocess();

        najDist=nx+ny+1;
	int k, l;
        for (k=0; k<maxValidniPocetak+1; k++)
                for (l=k; l<put.size(); l++)
		{
                        if (pozX[k]+maxLeft[l+1]<0) continue;
                        if (pozX[k]+maxRight[l+1]>nx) continue;
                        if (pozY[k]+maxDown[l+1]<0) continue;
                        if (pozY[k]+maxUp[l+1]>ny) continue;

                        int finalX=pozX[k]+pomakX[l+1];
                        int finalY=pozY[k]+pomakY[l+1];
                        int dist=(nx-finalX)+(ny-finalY);
                        if (dist<najDist)
			{
                                najDist=dist;
				najK.clear();
				najK.push_back(k);
				najL.clear();
				najL.push_back(l);
			}
                        else if (dist==najDist)
			{
				najK.push_back(k);
				najL.push_back(l);
			}
		}
}

void output ( void )
{
        ofstream fout ("mreza.out");
        fout << najK[0]+1 << " " << najL[0]+1 << endl;
}

int main ( void )
{
	input();
	solve();
	output();

	return 0;
}
