
/*
Croatia 2003
Croatian Olympiad in Informatics
Problem SLALOM, Programming language C
*/

#define ULAZ   "slalom.in"
#define IZLAZ  "slalom.out"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int ccw (int ax, int ay, int bx, int by, int cx, int cy)
{
	int dx1 = bx - ax, dx2 = cx - bx;
	int dy1 = by - ay, dy2 = cy - by;

	double res = (dx1 * (double) dy2 - (double) dx2 * dy1);
	if (res < 0) return -1;
	if (res > 0) return 1;
	return 0;
}

int main (void)
{
	FILE *fp = fopen (ULAZ, "rt");
	int n, i, j;
	double d = 0;
	int sx, sy, lx, ly, dx, dy, li, di;
	int *a, *b, *y;

	fscanf (fp, "%d", &n);
        ++n;

	fscanf (fp, "%d%d", &sx, &sy);
	y = malloc (sizeof (int) * n);
	a = malloc (sizeof (int) * n);
	b = malloc (sizeof (int) * n);
	for (i = 0; i < n - 1; ++i)
		fscanf (fp, "%d%d%d", &a[i], &b[i], &y[i]);

	fscanf (fp, "%d%d", &a[n - 1], &y[n - 1]);
        b[n - 1] = a[n - 1];


	fclose (fp);

	fp = fopen (IZLAZ, "wt");

	lx = sx - 1, dx = sx + 1;
	ly = dy = sy;
        li = di = 0;

	for (i = 0; i < n;)
	{
		for (j = i; j < n; ++j)
		{
			int la, lb, da, db, ax, ay, bx, by;

			ax = a[j], bx = b[j];
			ay = by = y[j];

			la = ccw (sx, sy, lx, ly, ax, ay);
			da = ccw (sx, sy, dx, dy, ax, ay);
			lb = ccw (sx, sy, lx, ly, bx, by);
			db = ccw (sx, sy, dx, dy, bx, by);

			if (lb < 0)			// vrata su lijevo od pogleda		=> l je nova tocka
			{
				d += hypot (sx - lx, sy - ly),
				sx = lx, sy = ly;
				lx = sx - 1, dx = sx + 1;
                                ly = dy = sy;
                                i = li + 1;
				break;
			}
			else if (da > 0)	// vrata su desno od pogleda		=> d je nova tocka
			{
				d += hypot (sx - dx, sy - dy),
				sx = dx, sy = dy;
				lx = sx - 1, dx = sx + 1;
                                ly = dy = sy;
                                i = di + 1;
				break;
			}
			else if (la <= 0 && db >= 0)	// gledamo dio vrata	=> nista se ne mijenja
				;
			else
			{
				if (la >= 0 && da <= 0)	// a je unutar pogleda	=> l = a
					lx = ax, ly = ay, li = j;
				if (lb >= 0 && db <= 0)	// b je unutar pogleda	=> b = d
					dx = bx, dy = by, di = j;
			}
		}
		if (j == n)
		{
			d += hypot (sx - a[n - 1], sy - y[n - 1]);
			break;
		}
	}

        fprintf (fp, "%.4f\n", d);

	fclose (fp);

	return 0;
}
