
/*
Croatia 2003
Croatian Olympiad in Informatics
Problem SLALOM, Programming language C++
*/

#include <complex>
#include <cstdio>
#include <vector>

#define NONE -1

using namespace std;

class point { public: int x, y; };
class line { public: point l, r; };

point start, cilj;
vector< line > vrata;

inline double dist( point &a, point &b ) {
   return hypot( a.x - b.x, a.y - b.y );
}

inline int ccw( point &a, point &b, point &c ) {
   int p = (b.x-a.x) * (c.y-a.y) - (c.x-a.x) * (b.y-a.y);
   if( p < 0 ) return -1;
   if( p > 0 ) return 1;
   return 0;
}

void input() {
   int i, n;
   line t;
   scanf( "%d", &n );
   scanf( "%d%d", &start.x, &start.y );
   for( i = 0; i < n; ++i ) {
      scanf( "%d%d%d", &(t.l.x), &(t.r.x), &(t.l.y) );
      t.r.y = t.l.y;
      vrata.push_back( t );
   }
   scanf( "%d%d", &cilj.x, &cilj.y );
}

double solve( point &a, point &b, int i, int j ) {
   int k, m;
   double t, max = 0;
   int aa = a.y - b.y;
   int bb = b.x - a.x;
   int cc = a.x * b.y - b.x * a.y;

   for( k = i+1; k < j; ++k )
      if( ccw( a, b, vrata[k].l ) > 0 ) {
         t = abs( aa * vrata[k].l.x + bb * vrata[k].l.y + cc ) / hypot( aa, bb );
         if( t > max ) { max = t; m = k; }
      }

   if( max > 0 ) return solve( a, vrata[m].l, i, m ) +
                        solve( vrata[m].l, b, m, j );

   for( k = i+1; k < j; ++k )
      if( ccw( a, b, vrata[k].r ) < 0 ) {
         t = abs( aa * vrata[k].r.x + bb * vrata[k].r.y + cc ) / hypot( aa, bb );
         if( t > max ) { max = t; m = k; }
      }

   if( max > 0 ) return solve( a, vrata[m].r, i, m ) +
                        solve( vrata[m].r, b, m, j );

   return dist( a, b );
}

int main( void ) {
   freopen( "slalom.in", "rt", stdin );
   freopen( "slalom.out", "wt", stdout );

   input();
   printf( "%.4lf\n", solve( start, cilj, -1, vrata.size() ) );

   fclose( stdin );
   fclose( stdout );
   return 0;
}
