
/*
Croatia 2003
National Competition - Second day - Juniors
Problem JOKER, Programming language C
*/

#include <stdio.h>
#include <stdlib.h>

#define IN_FILE                 "joker.in"
#define OUT_FILE                "joker.out"
#define MAX_M                   5000000

struct cut { int from, to; };

int n, m;
struct cut c[MAX_M];

void read_input(void)
{
	int i;
        FILE *fp = fopen (IN_FILE, "r");

        fscanf (fp, "%d%d", &n, &m);
        for (i=0; i<m; i++)
		fscanf(fp, "%d%d", &c[i].from, &c[i].to);

	fclose(fp);
}

int cutcmp (const void *a, const void *b)
{
	const int af = ((const struct cut*)a)->from;
	const int bf = ((const struct cut*)b)->from;

	if(af > bf) return -1;
	if(bf > af) return 1;
	return 0;
}

int test(void)
{
	int nn = n, i;

        for (i=0; i<m; i++)
	{
		if(c[i].to >= nn)
			return 0;
                nn-=c[i].to-c[i].from+1;
	}

        return (nn==1);
}

void write_output (int ok)
{
	int i;
        FILE *fp = fopen (OUT_FILE, "w");

	if(ok == 0)
                fprintf (fp, "-1\n");
	else
                for (i=0; i<m; i++)
                        fprintf (fp, "%d %d\n", c[i].from, c[i].to);

        fclose (fp);
}

int main(void)
{
	read_input();
        qsort (c, m, sizeof(struct cut), cutcmp);
        write_output (test());

	return 0;
}
