
/*
Croatia 2003
National Competition - First day - Seniors
Problem LINIJE, Programming language C++
*/

#include <fstream>
#include <list>
#include <set>

using namespace std;

#define INFILE			"linije.in"
#define OUTFILE			"linije.out"
#define MAXLINIJA               20000
#define MAXSTANICA		10000

list<int> linije_kroz_stanicu[MAXLINIJA];
set<int> susjedi[MAXSTANICA];
int boja[MAXLINIJA], bio[MAXSTANICA], broj_stanica, broj_linija;

void load_data ( void )
{
        int i;
	ifstream fin (INFILE);
	int quando, stari, novi;
	fin >> broj_stanica >> broj_linija;

        for (i=0; i<broj_linija; i++)
	{
		fin >> quando; stari=-1;
		while (quando--)
		{
			fin >> novi; linije_kroz_stanicu[--novi].push_back (i);
			if (stari!=-1) { susjedi[stari].insert(novi); susjedi[novi].insert(stari); }
			stari=novi;
		}
	}
}

void farbaj (int vrh)
{
	static set<int> ne_smijem; // treba mi samo jedna instanca; mogu ovo i s poljem pa sortirat al mi se ne da
        list<int>::iterator list_i;
	bio[vrh]=1; ne_smijem.clear();

	// prvo skuzi koje boje ne smijes koristit za neofarbane linije
        for (list_i=linije_kroz_stanicu[vrh].begin(); list_i!=linije_kroz_stanicu[vrh].end(); list_i++)
		if (boja[*list_i]) ne_smijem.insert (boja[*list_i]);

	// i sad obojaj sve neobojane linije kroz ovaj vrh sa dopustenim bojama
	int trenutna_boja=1;
	for (list_i=linije_kroz_stanicu[vrh].begin(); list_i!=linije_kroz_stanicu[vrh].end(); list_i++)
		if (!boja[*list_i])
		{
			while (ne_smijem.find (trenutna_boja) != ne_smijem.end()) trenutna_boja++;
			boja[*list_i]=trenutna_boja++;
		}

	// gotov sam s ovim vrhom, idi u sve susjede
	for (set<int>::iterator set_i=susjedi[vrh].begin(); set_i!=susjedi[vrh].end(); set_i++)
		if (!bio[*set_i]) farbaj (*set_i);
}

void write_solution ( void )
{
	ofstream fout(OUTFILE);
        int i;
	// skuzi koliko si boja potrosio
	int max=0;
        for (i=0; i<broj_linija; i++)
		if (boja[i]>max) max=boja[i];

	fout << max << endl;
	for (i=0; i<broj_linija; i++)
                fout << boja[i] << (i==broj_linija-1 ? '\n' : ' ');

	fout.close();
}

int main ( void )
{
        int i;
	load_data();
        for (i=0; i<broj_stanica; i++)
		if (!bio[i]) farbaj(i);
	write_solution();

	return 0;
}
