
/*
Croatia 2003
National Competition - Second day - Seniors
Problem JEZIK, Programming language C
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define IN_FILE                 "jezik.in"
#define OUT_FILE                "jezik.out"
#define MAX_N                   10000
#define MAX_LEN                 100

struct list
{
	int v;
	struct list *next;
};

int n, was[MAX_N];
struct list *adj[MAX_N];
int queue[MAX_N], h, t;


void dodaj (struct list **l, int v)
{
        struct list *temp=(struct list*) malloc (sizeof(struct list));
        temp->v=v;
        temp->next=*l;
        *l=temp;
}

void read_input ( void )
{
	char s[MAX_LEN + 2], *t;
        FILE *fp=fopen (IN_FILE, "r");

        n=0;
        while (1)
	{
                fgets (s, MAX_LEN + 1, fp);
                if (s[0]=='.') break;

                t=strstr (s, "IDI");
                while (t!=NULL)
		{
                        t+=4;
                        dodaj (&adj[n], atoi(t) - 1);
                        t=strstr (t, "ILI");
		}

                if (strstr (s, "RADI")!=NULL)
                        dodaj (&adj[n], n+1);
		n++;
	}

        fclose (fp);
}

void bfs ( void )
{
	struct list *l;

        queue[h++]=0; was[0]=1;
	do
        {
                l=adj[queue[t++]];
                while (l!=NULL)
		{
                        if (!was[l->v])
			{
                                queue[h++]=l->v;
                                was[l->v]=1;
			}
                        l=l->next;
		}
        } while (h!=t);
}

int count ( void )
{
        int c=0, i;

        for (i=0; i<n; i++)
                if (!was[i])
			c++;

	return c;
}

void write_output (int c)
{
        FILE *fp=fopen (OUT_FILE, "w");

        fprintf (fp, "%d\n", c);

        fclose (fp);
}

int main ( void )
{
	read_input();
	bfs();
	write_output(count());

	return 0;
}
