
/*
Croatia 2003
National Competition - Second day - Seniors
Problem TOKI, Programming language C
*/

#include <stdio.h>
#include <string.h>

#define INFILE                                  "toki.in"
#define OUTFILE                                 "toki.out"
#define MAXLEN                                  2100

#define INFTY                                   15000

char prvi[MAXLEN+1], drugi[MAXLEN+1];
struct { short koliko, unatrag, di_je_znak; } tbl[MAXLEN+1][MAXLEN+1];
int len1, len2, di_je_zadnji[MAXLEN]['z'-'a'+1];

void load_data ( void )
{
	FILE *f=fopen (INFILE, "rt");

	fscanf (f, "%s%s", prvi, drugi);
	fclose (f);
}

void rek (int i, int j)
{
	// dinamika

	// vec sam bio tu
	if (tbl[i][j].koliko!=0) return;

	// ako je drugi string prazan, rjesenje je bilo koji znak prvog
	if (j==0)
	{
		tbl[i][0].koliko=1; tbl[i][0].di_je_znak=0; tbl[i][0].unatrag=-1;
		return;
	}

	// ako se prvi string sastoji od samo jednog znaka, onda imamo rjesenje akko ga nema u drugom nizu
	if (i==0)
        {
		if (di_je_zadnji[j][prvi[0]-'a']==0)
		{
			tbl[0][j].koliko=1; tbl[0][j].di_je_znak=0; tbl[0][j].unatrag=-1; return;
		}
		else
		{
			tbl[0][j].koliko=INFTY; return;
		}
        }

	// ako nema tog slova uopce
	if (di_je_zadnji[j][prvi[i]-'a'] == 0)
	{
		tbl[i][j].koliko=1, tbl[i][j].unatrag=-1, tbl[i][j].di_je_znak=i;
		return;
	}

	// sad opceniti slucaj: i!=0 && j!=0 && di_je_zadnji!=0
	// ako je bolje ne dodati zadnje slovo
	rek(i-1, j); rek (i-1, di_je_zadnji[j][prvi[i]-'a']-1);

	if (tbl[i-1][j].koliko < tbl[i-1][di_je_zadnji[j][prvi[i]-'a']-1].koliko+1)
	{
		// ako je bolje ostavit staru rijec
		tbl[i][j].koliko=tbl[i-1][j].koliko;
		tbl[i][j].di_je_znak=-1;
		tbl[i][j].unatrag=j;
	}
	else
	{
		// ako je bolje dodat slovo prvi[i]
		tbl[i][j].koliko=tbl[i-1][di_je_zadnji[j][prvi[i]-'a']-1].koliko+1;
		tbl[i][j].di_je_znak=i;
		tbl[i][j].unatrag=di_je_zadnji[j][prvi[i]-'a']-1; // kud se treba vratit
	}
}

void solve ( void )
{
	int i, j;
	len1=strlen (prvi), len2=strlen (drugi);

	// prvo treba napravit polje di je zadnje slovo u 2. nizu prije svakog od mjesta
	for (i='a'; i<='z'; i++) di_je_zadnji[0][i-'a']=0;

	for (i=1; i<=len2; i++)
		for (j='a'; j<='z'; j++)
		{
			di_je_zadnji[i][j-'a']=di_je_zadnji[i-1][j-'a'];
			if (drugi[i-1]==j)
			{
				di_je_zadnji[i][j-'a']=i;
			}
		}

	rek (len1-1, len2);
}

void write_solution ( void )
{
	FILE *fout=fopen(OUTFILE, "wt");
	char rje[MAXLEN];
	int i, j, cur=0;

	fprintf (fout, "%d\n", tbl[i=len1-1][j=len2].koliko);
	if (tbl[i][j].di_je_znak!=-1) rje[cur++]=prvi[tbl[i][j].di_je_znak];

	while (tbl[i][j].unatrag != -1)
	{
		j=tbl[i][j].unatrag; i--;
		if (tbl[i][j].di_je_znak!=-1)
			rje[cur++]=prvi[tbl[i][j].di_je_znak];
	}

	for (cur--; cur>=0; cur--)
		fprintf (fout, "%c", rje[cur]);

	fprintf (fout, "\n");

	fclose (fout);
}

int main ( void )
{
	load_data();
	solve();
	write_solution();

	return 0;
}
