
/*
Croatia 2003
Regional Competition - Juniors
Problem PIZZA, Programming language C
*/

#include <stdio.h>
#include <math.h>

#define INPUT_FILE  "pizza.in"
#define OUTPUT_FILE "pizza.out"

#define MAX_RESTORANA 20
#define MAX_NEBODERA 100

int broj_restorana;
int radijus,broj_lokacija;
int broj_nebodera;
struct lokacija {
                  int x,y;
                } lokacije[MAX_RESTORANA];
struct neboder {
                 int x,y;
                 int broj_stanovnika;
               } neboderi[MAX_NEBODERA];

int polje[MAX_RESTORANA][MAX_NEBODERA];
int bio[MAX_RESTORANA];
int rjesenje;
FILE *file;

void ucitaj_podatke(void)
{
  int i;

  file = fopen(INPUT_FILE,"r");
  fscanf(file,"%d%d",&broj_restorana,&radijus);
  fscanf(file,"%d",&broj_lokacija);
  for (i = 0;i < broj_lokacija;++i)
    fscanf(file,"%d%d",&lokacije[i].x,&lokacije[i].y);

  fscanf(file,"%d",&broj_nebodera);
  for (i = 0;i < broj_nebodera;++i)
    fscanf(file,"%d%d%d",&neboderi[i].x,&neboderi[i].y,
                         &neboderi[i].broj_stanovnika);

  fclose(file);
}

int doseg(int lokacija,int neboder)
{
  if ((lokacije[lokacija].x - neboderi[neboder].x) *
      (lokacije[lokacija].x - neboderi[neboder].x) +
      (lokacije[lokacija].y - neboderi[neboder].y) *
      (lokacije[lokacija].y - neboderi[neboder].y) <= radijus * radijus)
    return 1;
  return 0;
}

void radi(int gdje,int koliko)
{
  int i,j;
  int ukupno;
  int uzmi[MAX_NEBODERA];

  if (koliko == broj_restorana)
  {
    for (i = 0;i < broj_nebodera;++i)
      uzmi[i] = 0;

    for (i = 0;i < broj_lokacija;++i)
      if (bio[i])
        for (j = 0;j < broj_nebodera;++j)
          if (polje[i][j])
            uzmi[j] = 1;

    ukupno = 0;
    for (i = 0;i < broj_nebodera;++i)
      if (uzmi[i])
        ukupno += neboderi[i].broj_stanovnika;

    if (ukupno > rjesenje)
      rjesenje = ukupno;

    return;
  }

  for (i = gdje;i < broj_lokacija;++i)
  {
    bio[i] = 1;
    radi(i + 1,koliko + 1);
    bio[i] = 0;
  }
}

void rijesi(void)
{
  int i,j;

  for (i = 0;i < broj_lokacija;++i)
    for (j = 0;j < broj_nebodera;++j)
      if (doseg(i,j))
        polje[i][j] = 1;
      else
        polje[i][j] = 0;

  for (i = 0;i < broj_lokacija;++i)
    bio[i] = 0;
  rjesenje = 0;
  radi(0,0);
}

void ispisi_rjesenje(void)
{
  file = fopen(OUTPUT_FILE,"w");
  fprintf(file,"%d\n",rjesenje);
  fclose(file);
}

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  return 0;
}
