
/*
Croatia 2003
Regional Competition - Juniors
Problem PIZZA, Programming language C++
*/

#include <fstream>
#include <vector>

#define INFILE  "pizza.in"
#define OUTFILE "pizza.out"

using namespace std;

ifstream input(INFILE);
ofstream output(OUTFILE);

struct tocka
{
        int x;
        int y;
};

int k, r;
int m, n;
vector<tocka> restoran;
vector<tocka> neboder;
vector<vector<int> > moze;
vector<int> broj;
vector<int> koji;
int rjesenje;
int ukupno;

/* funkcija vraca kvadrat udaljenocti dvije tocke */
int udalj (tocka a, tocka b)
{
        return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

/* rekurzivna funkcija koja ispituje sve kombinacije */
void radi (int prvi, int koliko)
{
        if (m-prvi<koliko) return ;
        if (koliko<0) return ;
        if (prvi==m && koliko>0) return ;
        if (prvi==m && koliko==0)
        {
                if (ukupno>rjesenje) rjesenje=ukupno;
                return ;
        }
        /* na mjesto prvi ne stavljamo restoran */
        radi(prvi+1, koliko);

        for (int i=0; i<moze[prvi].size(); i++)
            if (koji[moze[prvi][i]]==-1)
            {
                koji[moze[prvi][i]]=prvi;
                ukupno+=broj[moze[prvi][i]];
            }

        /* na mjesto prvi stavljamo restoran */
        radi(prvi+1, koliko-1);

        for (int i=0; i<moze[prvi].size(); i++)
            if (koji[moze[prvi][i]]==prvi)
            {
                koji[moze[prvi][i]]=-1;
                ukupno-=broj[moze[prvi][i]];
            }

}

int main (void)
{
        /* ucitavanje ulaznih podataka */
        input >> k >> r;
        input >> m;
        restoran=vector<tocka>(m);
        for (int i=0; i<m; i++)
            input >> restoran[i].x >> restoran[i].y;
        input >> n;
        neboder=vector<tocka>(n);
        broj=vector<int>(n);
        for (int i=0; i<n; i++)
            input >> neboder[i].x >> neboder[i].y >> broj[i];


        moze=vector<vector<int> >(m);
        for (int i=0; i<m; i++)
            for (int j=0; j<n; j++)
                if (udalj(restoran[i], neboder[j])<=r*r)
                   moze[i].push_back(j);

        rjesenje=0;
        ukupno=0;
        koji=vector<int>(n, -1);
        /* ispitivanje svih kombinacija */
        radi(0, k);

        output << rjesenje << endl;

        input.close();
        output.close();
        return 0;
}
