
{
Izborne pripreme 2004 - Prvi izborni ispit
Zadatak MAPA
}

{
   Ovaj zadatak mozemo rjesiti na slijedeci nacin.
   Sortiramo te tocke po nekim random pravcima(to moze
   biti po x, po y ili po nekom drugom pravcu).
   Kod svakog sortiranja provjeravamo da li mozemo
   smanjiti dosadasnji rezultat. Tako sortiramo nekoliko
   puta i svaki put provjeravamo za slijedecih k tocaka.
   Slozenost nam je t*NlogN*k, pri cemu nam je t broj
   sortiranja. Ovdje smo koristili merge sort.
   Merge sort sortira na slijedeci nacin:
      1. Sortiramo prvu polovicu
      2. Sortiramo drugu polovicu
      3. Ovaj korak ponavljamo ovisno o broju clanova
         koje treba sortirati. Dakle imamo neki brojac
         koji nam govori na kojem smo trenutno mjestu u
         prvoj i drugoj polovici. Ako je trenutni clan
         u prvoj polovici manji od onog u drugoj polovici
         tada njega dodamo i pomaknemo poziciju na slijedeceg.
         U suprotnom to radimo za drugu polovicu.
}

Type
  Tocka = Record
    x: longint;
    y: longint;
  End;
  NizTocaka = Array[1..100000] of Tocka;

Var
  A : longint;
  B : longint;
  i, j, t, N : longint;
  Rjesenje, Udalj : longint;
  Kut : real;
  Niz : NizTocaka;
  Tmp : NizTocaka;


Function Manji( P, Q : Tocka ) : boolean;
Begin
  If P.x*A + P.y*B < Q.x*a + Q.y*B then Manji := true else Manji := false;
End;

Procedure MergeSort( L, R : longint );
Var i, j, k, M : longint;
Begin
  If L = R then Exit;
  M := (L+R) div 2;
  MergeSort( L, M );
  MergeSort( M+1, R );

  For i := L to R do Tmp[i] := Niz[i];

  i := L; j := M+1; k := L;

  While (i <= M) and (j <= R) do
    If Manji( Tmp[i], Tmp[j] ) then Begin Niz[k] := Tmp[i]; Inc( i ); Inc( k ); End
                               else Begin Niz[k] := Tmp[j]; Inc( j ); Inc( k ); End;
  While i <= M do Begin Niz[k] := Tmp[i]; Inc( i ); Inc( k ); End;
  While j <= R do Begin Niz[k] := Tmp[j]; Inc( j ); Inc( k ); End;
End;

Function Max2( a, b : longint ) : longint;
Begin If a > b then Max2 := a else Max2 := b; End;

Function Min2( a, b : longint ) : longint;
Begin If a < b then Min2 := a else Min2 := b; End;

Begin
  Readln( N );
  For i := 1 to N do Readln( Niz[i].x, Niz[i].y );
  For i := 1 to N do Niz[i].y := Niz[i].y * 3;

  Rjesenje := 10000000;

  Randomize;

  For t := 1 to 25 do
  Begin
    Kut := (Random( 1000 ) * 2 * 3.141592653) / 1000;
    A := Round( sin( Kut ) * 200 );
    B := Round( cos( Kut ) * 200 );
    MergeSort( 1, N );
    For i := 1 to 25 do
      For j := 1 to N-i do
      Begin
        Udalj := Max2( Abs(Niz[j].x-Niz[j+i].x), Abs(Niz[j].y-Niz[j+i].y) );
        Rjesenje := Min2( Rjesenje, Udalj );
      End;
  End;

  Writeln( Rjesenje/3 :4:2 );
End.
