
/*
DMIH 2004 - Drugi dan natjecanja
Srednjoskolska skupina - II. podskupina
Zadatak MARS
*/

#include <cstdio>
#include <string>
#include <vector>

using namespace std;

int n;
char niz[1024];
vector<int> d[1001];
int log10[1001];

void init() {
  for( int i = 2; i <= 1000; ++i )
    for( int j = 1; j < i; ++j )
      if( !(i%j) ) d[i].push_back( j );
  for( int i = 0; i < 10; ++i ) log10[i] = 0;
  for( int i = 10; i < 100; ++i ) log10[i] = 1;
  for( int i = 100; i < 1000; ++i ) log10[i] = 2;
  log10[1000] = 3;
}

int opt[1001][1001];
int how[1001][1001];
const int inf = 1000000;

void dp() {
  for( int i = 0; i < n; ++i ) opt[i][1] = 1;
  for( int len = 2; len <= n; ++len ) {
    for( int i = 0; i+len <= n; ++i ) {
      opt[i][len] = inf;

      for( int j = 1; j < len; ++j ) {
        if( opt[i][len] > opt[i][j] + opt[i+j][len-j] ) {
          opt[i][len] = opt[i][j] + opt[i+j][len-j];
          how[i][len] = j;
        }
      }

      for( vector<int>::iterator j = d[len].begin(); j != d[len].end(); ++j ) {
        int a = (*j), b = len/(*j), k;
        int t = opt[i][a] + 3 + log10[b];
        if( t >= opt[i][len] ) continue;

        for( k = 0; k+a < len; ++k )
          if( niz[i+k] != niz[i+k+a] ) break;
        if( k+a==len ) {
          opt[i][len] = t;
          how[i][len] = -a;
        }
      }
    }
  }
}

void reconstruct( int i, int len ) {
  if( len == 1 ) {
    printf( "%c", niz[i] );
  } else if( how[i][len] >= 0 ) {
    reconstruct( i, how[i][len] );
    reconstruct( i+how[i][len], len-how[i][len] );
  } else {
    printf( "(" );
    reconstruct( i, -how[i][len] );
    printf( ")%d", len/(-how[i][len]) );
  }
}

int main( void ) {
  init();

  scanf( "%s", niz );
  n = strlen( niz );

  dp();

  reconstruct( 0, n );
  printf( "\n" );

  return 0;
}
