
(*
    Zupanijsko natjecanje 2004 / 1. podskupina
    2. zadatak - FUSNOTE
    Rjesenje napisao Ivan Sikiric (isikiric@hotmail.com)

Opis algoritma:
Minimalan broj stranica postize se pohlepnom strategijom - ocito nema smisla
neki redak staviti na novu stranicu, ako ima mjesta na trenutnoj stranici jer
slijedeci redak mora doci nakon njega. Ako imamo vise fusnota za isti redak,
jednostavno im zbrojimo duljine, jer sve moraju biti na istoj stranici s tim
retkom. Ako na trenutnoj stranici nema mjesta, morat cemo sve staviti na novu
stranicu. Iako fusnote moramo staviti na dno stranice, a ne odmah nakon retka
na koji se odnose, nas samo zanima koliko redaka moramo rezervirati na toj
stranici, a ne njihov poredak, pa mozemo potreban broj redaka za fusnote
odmah pribrojiti.
n, k, f, x, y - brojevi iz teksta zadatka.
red2 - trenutni redak
red1 - prethodni obradjeni redak
fus  - ukupan broj redaka svih fusnota koje treba dodati za trenutni redak
str  - trenutno rjesenje - broj iskoristenih stranica
jos  - broj redaka na trenutnoj stranici
Citamo redom podatke o fusnotama. Kad saznamo ukupnu duljinu svih fusnota za
trenutni redak, prvo izracunamo koliko stranica trebamo za sve retke prije
njega ((jos+red2-red1-1) div k), a zatim i koliko ce redaka ostati na zadnjoj
(trenutnoj) stranici (jos := (jos+red2-red1-1) mod k). Ako trenutni redak
stane na trenutnu stranicu zajedno sa fusnotama, povecamo broj redaka na
stranici (za fus+1), inace trebamo novu stranicu (na kojoj odmah potrosimo
fus+1 redaka). Na kraju pogledamo koliko jos stranica trebamo za sve
preostale retke do kraja knjige (one koji nemaju fusnota).
Slozenost algoritma: O(f)

*)

program fusnote;
var i, n, k, f, x, y, red2, red1, fus, str, jos : longint;
begin
    readln(n, k);
    readln(f);

    str:=0;
    red1 := 0;
    jos := 0;
    readln(red2, fus);
    for i:=1 to f do
    begin
        if i<f then readln(x, y);
        if (x>red2)or(i=f) then
        begin
            jos := jos + red2-1-red1;
            str := str + jos div k;
            jos := jos mod k;
            if jos+fus+1>k then
            begin
                str:=str+1;
                jos:=fus+1;
            end else jos:=jos+fus+1;
            red1 := red2;
            red2 := x;
            fus := y;
        end else fus:=fus+y;
    end;
    jos := jos + n-red1;
    str := str + jos div k;
    if jos mod k > 0 then str:=str+1;

    writeln(str);
end.
