
(*
    Zupanijsko natjecanje 2004 / 1. podskupina
    4. zadatak - HUGO
    Rjesenje napisao Ivan Sikiric (isikiric@hotmail.com)

Opis algoritma:
Zadatak rjesavamo dinamickim programiranjem.
sek[i, j] - broj jabuka koje padaju u i-toj sekundi na polje j (tj. 0 ili 1).
J[i, j] - broj jabuka koje mozemo pokupiti u prvih j sekundi tako se na kraju
nalazimo na polju "i", ili -BESKONACNO, ako tada ne mozemo biti na polju "i".
J[i, 1]=-BESKONACNO, i<>n div 2 + 1
J[n div 2 + 1, 1]=1 ako u 1 sekundi pada jabuka na to polje, 0 inace
za j>1:
J[i, j] = jabuka+max(J[i-1, j-1], J[i, j-1], J[i+1, j-1])
gdje je jabuka=1 ako jabuka pada na polje i u sekundi j, a 0 inace
rjesenje: max ( J[i, ZADNJA_SEKUNDA )
Kako nam za racunanje j-tog stupca tablice J trebaju samo podaci (j-1)-og
stupca, ne moramo pamtiti cijelu tablicu nego samo 2 stupca.
*)

program hugo;
const MAXN = 999;
      MAXK = 3000;
      MAXSEC = 100000;
      NINF = -1000000000;     // -BESKONACNO
var staro, novo : array[0..MAXN+1] of longint;
    sek : array[1..MAXN, 1..MAXK+1] of longint;
    k : array[1..MAXN] of longint;
    n, i, j, jabuka : longint;
begin
    read(n);
    for i:=1 to n do
    begin
        readln;
        read(k[i]);
        for j:=1 to k[i] do read(sek[i, j]);
        sek[i, k[i]+1]:=MAXSEC+1;
        if (sek[i, 1]<>1)or(i=n div 2 +1) then k[i]:=1 else k[i]:=2;
    end;
    for i:=0 to n+1 do staro[i]:=NINF;
    i := n div 2 + 1;
    if sek[i, k[i]]=1 then
    begin
        inc(k[i]);
        jabuka:=1;
    end else jabuka:=0;
    staro[i] := jabuka;
    for j:=2 to MAXSEC do
    begin
        for i:=1 to n do
        begin
            novo[i]:=NINF;
            if sek[i, k[i]]=j then
            begin
                inc(k[i]);
                jabuka:=1;
            end else jabuka:=0;
            if novo[i]<staro[i-1]+jabuka then novo[i]:=staro[i-1]+jabuka;
            if novo[i]<staro[i]+jabuka then novo[i]:=staro[i]+jabuka;
            if novo[i]<staro[i+1]+jabuka then novo[i]:=staro[i+1]+jabuka;
        end;
        for i:=1 to n do staro[i]:=novo[i];
    end;
    j:=NINF;
    for i:=1 to n do if staro[i]>j then j:=staro[i];
    writeln(j);
end.
