
/*
  Croatia 2005 / Final Exam #1
  Problem PAPIR

  Za rjesavanje ovog zadatka nuzno je primjetiti da nam niti jedno presavijanje
  ne moze naskoditi prilikom trazenja najkrace moguce presavijene vrpce. Naime
  rezultat svakog pravilnog presavijanja je jednak rezanju nekog pocetnog dijela
  vrpce (kada je K manji od polovice trenutne duljine vrpce), ili rezanju
  zavrsnog dijela vrpce i okretanju vrpce (kada je K veci od polovice trenutne
  duljine).

  Dakle rjesenje ovog zadatka u svakom koraku nalazi bilo koje pravilno
  presavijanje i presavija traku sve dok daljnje presavijanje nije moguce. Kako
  bi rjesenje bilo efikasno potrebno je traziti predavijanje od kracih prema
  duzima tako da kada se potrosi puno vremena na presavijanje onda se i dosta
  trake odreze pa ostane manje posla.

  Slozenost: O(n^2)
*/

#include <iostream>

using namespace std;

const int MAX=1000000;

int n;
char s[MAX+1];

int l;
int m;
int r[MAX];

void citaj_ulaz (void)
{
  cin >> n;
  cin >> s;
}

int lijevo (int prvi, int zadnji)
{
  for (int i=1; prvi+2*i-1<=zadnji; i++)
  {
    int ok=1;
    for (int j=0; j<i && ok; j++)
      if (s[prvi+j]==s[prvi+2*i-1-j])
        ok=0;
    if (ok) return i;
  }
  return 0;
}

int desno (int prvi, int zadnji)
{
  for (int i=1; prvi+2*i-1<=zadnji; i++)
  {
    int ok=1;
    for (int j=0; j<i && ok; j++)
      if (s[zadnji-j]==s[zadnji-2*i+1+j])
        ok=0;
    if (ok) return i;
  }
  return 0;
}

void rijesi (void)
{
  m=0;
  int prvi=0;
  int zadnji=n-1;
  int dalje=1;
  int flip=1;
  while (prvi<zadnji && dalje)
  {
    dalje=0;
    int k;
    if ((k=lijevo(prvi, zadnji))!=0)
    {
      dalje=1;
      r[m++]=flip?k:zadnji-prvi+1-k;
      if (2*r[m-1]>zadnji-prvi+1) flip=!flip;
      prvi+=k;
      continue ;
    }
    if ((k=desno(prvi, zadnji))!=0)
    {
      dalje=1;
      r[m++]=flip?zadnji-prvi+1-k:k;
      if (2*r[m-1]>zadnji-prvi+1) flip=!flip;
      zadnji-=k;
    }
  }
  l=zadnji-prvi+1;
}

void ispisi_rjesenje (void)
{
  cout << l << endl;
  cout << m << endl;
  cout << r[0];
  for (int i=1; i<m; i++)
    cout << " " << r[i];
  cout << endl;
}

int main (void)
{
  citaj_ulaz();
  rijesi();
  ispisi_rjesenje();

  return 0;
}
