
(*
  Croatia 2005 / Final Exam #1
  Problem PAPIR

  Za rjesavanje ovog zadatka nuzno je primjetiti da nam niti jedno presavijanje
  ne moze naskoditi prilikom trazenja najkrace moguce presavijene vrpce. Naime
  rezultat svakog pravilnog presavijanja je jednak rezanju nekog pocetnog dijela
  vrpce (kada je K manji od polovice trenutne duljine vrpce), ili rezanju
  zavrsnog dijela vrpce i okretanju vrpce (kada je K veci od polovice trenutne
  duljine).

  Dakle rjesenje ovog zadatka u svakom koraku nalazi bilo koje pravilno
  presavijanje i presavija traku sve dok daljnje presavijanje nije moguce. Kako
  bi rjesenje bilo efikasno potrebno je traziti predavijanje od kracih prema
  duzima tako da kada se potrosi puno vremena na presavijanje onda se i dosta
  trake odreze pa ostane manje posla.

  Slozenost: O(n^2)
*)

const MAX = 10000;

var
  n    : integer;
  s    : array[0..MAX-1] of char;
  l, m : integer;
  r    : array[0..MAX-1] of integer;

procedure ucitaj;
var i  : integer;
begin
  readln( n );
  for i:=0 to n-1 do
    read( s[i] );
end;

function lijevo(prvi, zadnji : integer) : integer;
var
  i, j : integer;
  ok    : boolean;
begin
  i := 1;
  while ( prvi+2*i-1 <= zadnji ) do begin
    ok := true;
    j := 0;
    for j:=0 to i-1 do
      if ( s[prvi+j] = s[prvi+2*i-1-j] ) then begin
        ok := false;
        break;
      end;

    if ( ok ) then begin
      lijevo := i;
      exit;
    end;
    i := i+1;
  end;
  lijevo := 0;
end;

function desno(prvi, zadnji : integer) : integer;
var
  i, j : integer;
  ok    : boolean;
begin
  i := 1;
  while ( prvi+2*i-1 <= zadnji ) do begin
    ok := true;
    j := 0;
    for j:=0 to i-1 do
      if ( s[zadnji-j] = s[zadnji-2*i+1+j] ) then begin
        ok := false;
        break;
      end;

    if ( ok ) then begin
      desno := i;
      exit;
    end;
    i := i+1;
  end;
  desno := 0;
end;

procedure rijesi;
var
  prvi, zadnji, k : integer;
  dalje, flip     : boolean;
begin
  m := 0;
  prvi := 0;
  zadnji := n-1;
  dalje := true;
  flip := true;

  while ( (prvi < zadnji) and dalje ) do begin
    dalje := false;
    k := lijevo( prvi, zadnji );
    if ( k <> 0 ) then begin
      dalje := true;
      if ( flip ) then
        r[m] := k
      else
        r[m] := zadnji-prvi+1-k;
      m := m+1;
      if ( 2*r[m-1] > zadnji-prvi+1 ) then flip := not flip;
      prvi := prvi + k;
      continue;
    end;

    k := desno( prvi, zadnji );
    if ( k <> 0 ) then begin
      dalje := true;
      if ( flip ) then
        r[m] := zadnji-prvi+1-k
      else
        r[m] := k;
      m := m+1;
      if ( 2*r[m-1] > zadnji-prvi+1 ) then flip := not flip;
      zadnji := zadnji - k;
    end;
  end;
  l := zadnji - prvi + 1;
end;

procedure ispisi;
var i  : integer;
begin
  writeln( l );
  writeln( m );
  for i:=0 to m-2 do
    write( r[i], ' ' );
  writeln( r[m-1] );
end;

begin
  ucitaj;
  rijesi;
  ispisi;
end.
