
/*
  Croatia 2005 / Final Exam #2
  Problem KASINO

  Primjetimo da nakon mjesanja n karata u p pretinaca po metodi opisanoj u
  zadatku dobijemo niz od n karata koji pada, pa raste tocno p puta.

  Algoritam:
  Pitamo po redu karte od 1 do n.
  Iz prethodne dvije karte pretpostavimo da li niz trenutno raste ili pada
  Ako niz trenutno pada pitamo za prvi broj manji od prethodnog koji jos nije
  pronadjen, ako raste pitamo za prvi veci broj.

  Analizirajmo gornji algoritam.
  Podijelimo cijeli niz na 2*p monotonih (rastucih ili padajucih) dijelova.
  Tada je u prvom nizu sansa za pogodak jedne karte 1/(2*p), u drugom 1/(2*p-1),
  u trecem 1/(2*p-2) ... a u zadnjem 1/1.

  Zbrajanjem dobivamo ocekivanu dobit ugrubo:
    za p=1 oko 3.50 * n kuna
    za p=2 oko 2.12 * n kuna
    za p=3 oko 1.45 * n kuna
    za p=4 oko 1.04 * n kuna
    za p=5 oko 0.76 * n kuna
*/

#include "kasinolib.h"

int x[1001];
int bio[1001];

int main( void ) {
   int n, p;
   Init( &n, &p );

   int pada = 1;
   x[1] = Igraj( 1, n );
   bio[x[1]] = 1;
   for( int i = 2; i <= n; ++i ) {
      int pitaj = x[i-1];
      while( !pada && pitaj <= n && bio[pitaj] ) pitaj++;
      if( pitaj > n ) { pada = 1; pitaj = n; }
      while( pada && pitaj >= 1 && bio[pitaj] ) pitaj--;
      if( pitaj < 1 ) { pada = 0; pitaj = 1; }
      while( !pada && pitaj <= n && bio[pitaj] ) pitaj++;

      x[i] = Igraj( i, pitaj );
      bio[x[i]] = 1;

      if( x[i] < x[i-1] ) pada = 1;
      if( x[i] > x[i-1] ) pada = 0;
   }
   return 0;
}
