
(*
  Croatia 2005 / Final Exam #2
  Problem KASINO

  Primjetimo da nakon mjesanja n karata u p pretinaca po metodi opisanoj u
  zadatku dobijemo niz od n karata koji pada, pa raste tocno p puta.

  Algoritam:
  Pitamo po redu karte od 1 do n.
  Iz prethodne dvije karte pretpostavimo da li niz trenutno raste ili pada
  Ako niz trenutno pada pitamo za prvi broj manji od prethodnog koji jos nije
  pronadjen, ako raste pitamo za prvi veci broj.

  Analizirajmo gornji algoritam.
  Podijelimo cijeli niz na 2*p monotonih (rastucih ili padajucih) dijelova.
  Tada je u prvom nizu sansa za pogodak jedne karte 1/(2*p), u drugom 1/(2*p-1),
  u trecem 1/(2*p-2) ... a u zadnjem 1/1.

  Zbrajanjem dobivamo ocekivanu dobit ugrubo:
    za p=1 oko 3.50 * n kuna
    za p=2 oko 2.12 * n kuna
    za p=3 oko 1.45 * n kuna
    za p=4 oko 1.04 * n kuna
    za p=5 oko 0.76 * n kuna
*)

uses kasinolib;

var
    n, p: Longint;
    x: array[1..1000] of Longint;
    bio: array[1..1000] of Boolean;
    pada: Boolean;
    i, pitaj: Longint;
begin
    Init(n, p);
    pada := True;
    x[1] := Igraj(1, n);
    bio[x[1]] := True;

    for i := 2 to n do
    begin
        pitaj := x[i - 1];
        while not pada and (pitaj <= n) and bio[pitaj] do Inc(pitaj);
        if pitaj > n then begin pada := True; pitaj := N end;
        while pada and (pitaj >= 1) and bio[pitaj] do Dec(pitaj);
        if pitaj < 1 then begin pada := False; pitaj := 1 end;
        while not pada and (pitaj <= n) and bio[pitaj] do Inc(pitaj);

        x[i] := Igraj(i, pitaj);
        bio[x[i]] := True;

        if x[i] < x[i - 1] then pada := True;
        if x[i] > x[i - 1] then pada := False
    end
end.
