
(*
  Croatia 2005 / Final Exam #2
  Problem POLJA

  Za pocetak postupkom sazimanja pretvorimo pocetni koordinatni sustav u novi,
  sasavljen od 2N*2N "jedinicnih" kvadrata. Primijetimo da je geometrija
  pravokutnika ocuvana, tj. ono sto je bio pravokutnik u pocetnom sustavu ostaje
  pravokutnik u novom. Ovo nam omogucava da radimo sa matricom 2N*2N u kojoj
  svaki jedinicni kvadrat pobojamo bojom pravokutnika kojem on pripada. Takoder
  moramo za svaki kvadratic zapamtiti i njegovu sirinu i visinu u pocetnom
  koordinatnom sustavu.

  Zamislimo da krenemo horizontalnom linijom od vrha matrice i liniju spustamo
  za po jedan kvadratic. U svakoj iteraciji mozemo konstruirati histogram
  kvadratica koji "lezi" na toj liniji. Ako u svakoj iteraciji nademo najveci
  jednobojni pravokutnik u trenutnom histogramu, sigurno smo nasli i ukupno
  najveci pravokutnik, jer on mora lezati na nekoj horizontalnoj liniji.

  Jedan histogram rjesavamo ovako: obradujemo stupce slijeva na desno jedan po
  jedan i odrzavamo stack (stog) mogucih rjesenja: moguce rjesenje je
  pravokutnik odreden lijevom granicom i visinom. Cilj nam je sva moguca
  rjesenja prosirivati nadesno dok je to moguce. Kad dode novi stupac
  ("trenutni"), postupamo po sljedecem:
  - ako stack nije prazan, a boja novog stupca nije jednaka onoj na stacku,
    ispraznimo stack jer rjesenja sa stacka ne mozemo vise prosiriti nadesno
    (ona sigurno zavrsavaju stupcem koji smo dodali prije trenutnog)
  - ako stack nije prazan i boja trenutnog stupca odgovara, skidamo moguca
    rjesenja sa stacka dok je trenutni stupac nizi od njih. Ocito je da se
    pravokutnik prekida ako pokusamo dodati stupac koji je nizi od pravokutnika.
  - otvaramo novo moguce rjesenje

  Vremenska slozenost sazimanja je theta(n^2) u najgorem slucaju. Nakon toga
  radimo n iteracija, a u svakoj iteraciji rjesavamo jedan histogram u
  slozenosti theta(n). Tako je ukupna vremenska slozenost algoritma u najgorem
  (a i prosjecnom) slucaju theta(n^2), kao i memorijska.
*)

const MAXN = 2500;

type llint = int64;

var n, i, j, temp, numx, numy, xx, yy, zadnjaboja : longint;
    x1, y1, x2, y2, col, h, cc: array[0..2*MAXN-1] of longint;

    x, y : array[0..MAXN*2-1] of longint;
    l1, r1, l2, r2 : longint;
    c : array[0..2*MAXN-1, 0..2*MAXN-1] of byte;

    rj : llint;

    stackx, stacky : array[0..2*MAXN] of llint;
    tx, ty : llint;
    sp : longint;

function bsearch(var a : array of longint; x, r : longint) : longint;
var l, m : longint;
begin
   l:=0;
   while l<r do
   begin
      m:=(l+r) div 2;
      if a[m]>=x then r:=m else l:=m+1;
   end;
   bsearch:=l;
end;

begin
   numx:=-1;
   numy:=-1;
   // ucitavanje i sazimanje
   readln(n);
   for i:=0 to n-1 do
   begin
      readln(x1[i], y1[i], x2[i], y2[i], col[i]);
      if x1[i] > x2[i]  then
      begin
         temp:=x1[i];
         x1[i]:=x2[i];
         x2[i]:=temp;
      end;
      if y1[i] > y2[i]  then
      begin
         temp:=y1[i];
         y1[i]:=y2[i];
         y2[i]:=temp;
      end;

      inc(numx); inc(numy);
      x[numx]:=x1[i]; y[numy]:=y1[i];

      inc(numx); inc(numy);
      x[numx]:=x2[i]; y[numy]:=y2[i];
   end;

   for i:=0 to numx do
      for j:=i+1 to numx do
         if x[i]>x[j] then
         begin
            temp:=x[i];
            x[i]:=x[j];
            x[j]:=temp;
         end;
   for i:=0 to numy do
      for j:=i+1 to numy do
         if y[i]>y[j] then
         begin
            temp:=y[i];
            y[i]:=y[j];
            y[j]:=temp;
         end;

   i:=0;
   while i<numx do
   begin
      if x[i]=x[i+1] then
      begin
         numx:=numx-1;
         for j:=i+1 to numx do x[j]:=x[j+1];
      end else i:=i+1;
   end;
   i:=0;
   while i<numy do
   begin
      if y[i]=y[i+1] then
      begin
         numy:=numy-1;
         for j:=i+1 to numy do y[j]:=y[j+1];
      end else i:=i+1;
   end;

   for i := 0 to n-1 do
   begin
      l1:=bsearch(x, x1[i], numx);
      r1:=bsearch(x, x2[i], numx);
      for xx:=l1 to r1-1 do
      begin
         l2:=bsearch(y, y1[i], numy);
         r2:=bsearch(y, y2[i], numy);
         for yy:=l2 to r2-1 do c[yy, xx] := col[i];
      end;
   end;
   // rjesavanje

   rj := 0;

   for i:=numy downto 0 do
   begin
      for j:=0 to numx do
         if c[i, j]=cc[j] then h[j]:=h[j]+y[i+1]-y[i] else
         begin
            cc[j]:=c[i, j];
            h[j]:=y[i+1]-y[i];
         end;

      zadnjaboja := -1;

      sp := 0;

      for j:=0 to numx do
      begin
         if cc[j] <> zadnjaboja then
            while sp>0 do
            begin
               dec(sp);
               if (x[j]-stackx[sp])*stacky[sp]>rj then rj:=(x[j]-stackx[sp])*stacky[sp];
            end;

         zadnjaboja := cc[j];
         if cc[j] = 0 then continue;

         tx:=x[j];
         ty:=h[j];

         while sp>0 do
         begin
            if stacky[sp-1]<h[j] then break;
            dec(sp);

            tx := stackx[sp];

            if (x[j]-stackx[sp])*stacky[sp]>rj then rj:=(x[j]-stackx[sp])*stacky[sp];
         end;
         stackx[sp]:=tx;
         stacky[sp]:=ty;
         inc(sp);
      end;
   end;

   writeln(rj);
end.
