
/*
  Croatia 2005 / Regional Competition / Juniors
  Problem ISPIT

  Opis algoritma:
  Za svakog studenta provjerimo koliko bi ukupno studenata on upoznao
  kad bi tog studenta prvog pitao.
  Provjeru radimo simulacijom: zamislimo da krenemo od zadanog
  studenta i pratimo kuda nas studenti upucuju, dok ne naletimo na
  studenta kod kojeg smo vec bili (jer bismo se tada poceli vrtjeti u
  krug bez upoznavanja novih studenata).

  Vremenska slozenost: O(N^2)
*/

#include <stdio.h>

#define MAX_STUDENATA 1000

int broj_studenata,studenti[MAX_STUDENATA + 1];
int rjesenje;

void ucitaj(void)
{
  int i;

  scanf("%d",&broj_studenata);
  for (i = 1;i <= broj_studenata;++i)
    scanf("%d",studenti + i);
}

void rijesi(void)
{
  int i,j;
  int sljedeci;
  int koliko,max_koliko;
  int bio[MAX_STUDENATA + 1];

  max_koliko = 0;
  for (i = 1;i <= broj_studenata;++i)
  {
    for (j = 1;j <= broj_studenata;++j)
      bio[j] = 0;

    bio[i] = 1;
    koliko = 1;
    sljedeci = studenti[i];
    while (1)
    {
      if (bio[sljedeci])
        break;
      bio[sljedeci] = 1;
      sljedeci = studenti[sljedeci];
      ++koliko;
    }
    if (koliko > max_koliko)
    {
      max_koliko = koliko;
      rjesenje = i;
    }
  }
}

int main(void)
{
  ucitaj();
  rijesi();
  printf("%d\n",rjesenje);

  return 0;
}
