
/*
  Croatia 2005 / Regional Competition / Juniors
  Problem ISPIT

  Opis algoritma:
  Za svakog studenta provjerimo koliko bi ukupno studenata on upoznao
  kad bi tog studenta prvog pitao.
  Provjeru radimo simulacijom: zamislimo da krenemo od zadanog
  studenta i pratimo kuda nas studenti upucuju, dok ne naletimo na
  studenta kod kojeg smo vec bili (jer bismo se tada poceli vrtjeti u
  krug bez upoznavanja novih studenata).

  Vremenska slozenost: O(N^2)
*/

#include <cstdio>
#include <vector>

using namespace std;

#define MAXN 1005

int next[MAXN];

int sim( int p )
{
   vector<int> v( MAXN, 0 );
   int ret;
   for ( ret=1; !v[p]; ++ret ) {
      v[p] = 1;
      p = next[p];
   }
   return ret;
}

int main()
{
   int n;
   scanf( "%d", &n );
   for ( int i=1; i<=n; ++i )
      scanf( "%d", &next[i] );

   int najb = -1, koji = -1;
   for ( int i=1; i<=n; ++i ) {
      int key = sim( i );
      if ( key > najb ) {
         najb = key;
         koji = i;
      }
   }
   printf( "%d\n", koji );

   return 0;
}
