
(*
  Croatia 2005 / Regional Competition / Juniors
  Problem ISPIT

  Opis algoritma:
  Za svakog studenta provjerimo koliko bi ukupno studenata on upoznao
  kad bi tog studenta prvog pitao.
  Provjeru radimo simulacijom: zamislimo da krenemo od zadanog
  studenta i pratimo kuda nas studenti upucuju, dok ne naletimo na
  studenta kod kojeg smo vec bili (jer bismo se tada poceli vrtjeti u
  krug bez upoznavanja novih studenata).
  Ovakva jednostavna simulacija dovodi nas do rjesenja slozenosti O(N^2).
  Kako oznacavamo da smo neku osobu vec posjetili, usput mozemo zapisati
  i koje je rjesenje za tu osobu, pa sljedeci put kad je budemo posjetili
  znamo koliko jos osoba cemo posjetiti nakon nje.
  Ta mala modifikacija dovodi do linearnog rjesenja.

  Vremenska slozenost: O(N)

  Napomena: Specifikacije u ovom zadatku nisu zahtijevale ovakvo linearno
  rjesenje, nego je bilo dovoljno i rjesenje kvadratne slozenosti. Primjer
  takvih kvadratnih rjesenja mozete pronaci kod rjesenja u C-u i C++-u.
*)

program ispit;
const MAXN = 1000;

var upucuje  : array[1..MAXN] of longint;
    (* upucuje[i] - osoba na koju upucuje osoba i *)
    posjetio : array[1..MAXN] of longint;
    (* posjetio[i] - broj osoba koje ce posjetiti ako pocne s i-tom *)
    n, i, p, br, max, rj, pocetakciklusa : longint;

begin
   read(n);
   for i:=1 to n do read(upucuje[i]);
   for i:=1 to n do posjetio[i]:=0;
   max:=0;
   for i:=1 to n do
   begin
      p:=i;
      br:=0;
      pocetakciklusa:=0;
      while posjetio[p]=0 do
      begin
         br:=br+1;
         posjetio[p]:=-1;
         p:=upucuje[p];
      end;
      if posjetio[p]>0 then br:=br+posjetio[p] else pocetakciklusa:=p;
      if max<br then
      begin
         max:=br;
         rj:=i;
      end;
      p:=i;
      while posjetio[p]=-1 do
      begin
         posjetio[p]:=br;
         if pocetakciklusa<>p then br:=br-1 else pocetakciklusa:=upucuje[p];
         p:=upucuje[p];
      end;
   end;
   writeln(rj);
end.
