
/*
  Croatia 2005 / Regional Competition / Juniors
  Problem KEMIJA

  Opis algoritma:
  Iz ulaznog niza znakova procitamo koliko ukupno atoma pojedine vrste
  ima u molekulama. Zatim zavrtimo tri ugnjezdjene for-petlje od 1 do
  10 i probamo naci neku trojku brojeva koja bi izjedncacili
  jednadzbu.
  Ako for-petlje ne uspiju pronaci takvu trojku brojeva, ispisujemo
  poruku o tome.
*/

#include <stdio.h>

int jednadzba[4][4];

void ucitaj(void)
{
  int i,j;
  int molekula;
  int atom = 0; // inicijalizacija samo da compiler ne bi bacao warning
  char znak;

  for (i = 1;i <= 3;++i)
    for (j = 1;j <= 3;++j)
      jednadzba[i][j] = 0;

  molekula = 1;

  while (1)
  {
    scanf("%c",&znak);
    if (znak < ' ')
      break;

    if (znak == '+')
    {
      molekula = 2;
      continue;
    }
    if (znak == '=')
    {
      molekula = 3;
      continue;
    }

    if (znak >= '2' && znak <= '9')
    {
      jednadzba[molekula][atom] += (znak - '0') - 1;
      continue;
    }

    atom = 1;
    if (znak == 'H')
      atom = 2;
    else if (znak == 'O')
      atom = 3;
    ++jednadzba[molekula][atom];
  }
}

void rijesi_i_ispisi(void)
{
  int i;
  int broj_molekula[4];
  int krivo;

  for (broj_molekula[1] = 1;broj_molekula[1] <= 10;++broj_molekula[1])
    for (broj_molekula[2] = 1;broj_molekula[2] <= 10;++broj_molekula[2])
      for (broj_molekula[3] = 1;broj_molekula[3] <= 10;++broj_molekula[3])
      {
        krivo = 0;
        for (i = 1;i <= 3;++i)
          if (broj_molekula[1] * jednadzba[1][i] +
              broj_molekula[2] * jednadzba[2][i] !=
              broj_molekula[3] * jednadzba[3][i])
          {
            krivo = 1;
            break;
          }

        if (!krivo)
        {
          printf("%d %d %d\n",broj_molekula[1],broj_molekula[2],broj_molekula[3]);
          return;
        }
      }

  printf("NEMOGUCE\n");
}

int main(void)
{
  ucitaj();
  rijesi_i_ispisi();

  return 0;
}
