
/*
  Croatia 2005 / Regional Competition / Juniors
  Problem KEMIJA

  Opis algoritma:
  Konstruiramo objekte M1, M2 i M3 (tipa 'molekula') iz ulaznog
  stringa. Zatim zavrtimo X1, X2 i X3 u for-petlji od 1 do 10 i
  probamo naci neku trojku brojeva koji zadovoljava jednadzbu
  X1*M1 + X2*M2 = X3*M3.
*/

#include <cctype>
#include <iostream>
#include <string>

using namespace std;

struct molekula {
   int c, h, o;

   molekula( int c, int h, int o ) : c(c), h(h), o(o) { }
   molekula( const string &s ) {
      int koji = 0;
      c = h = o = 0;
      for ( int i=0; i<(int)s.length(); ++i ) {
         if ( isdigit( s[i] ) ) {
            if      ( koji == 'C' ) c += s[i] - '1';
            else if ( koji == 'H' ) h += s[i] - '1';
            else if ( koji == 'O' ) o += s[i] - '1';
         }
         else {
            koji = s[i];
            if      ( koji == 'C' ) c++;
            else if ( koji == 'H' ) h++;
            else if ( koji == 'O' ) o++;
         }
      }
   }

   friend molekula operator*( const int x, const molekula &m ) {
      return molekula( x*m.c, x*m.h, x*m.o );
   }

   friend molekula operator+( const molekula &lhs, const molekula &rhs ) {
      return molekula( lhs.c+rhs.c, lhs.h+rhs.h, lhs.o+rhs.o );
   }

   friend bool operator==( const molekula &lhs, const molekula &rhs ) {
      return lhs.c == rhs.c && lhs.h == rhs.h && lhs.o == rhs.o;
   }
};

int main()
{
   string s;
   cin >> s;

   // razdvojimo string na 3 dijela
   string s1, s2, s3;
   s1 = string( s.begin(), s.begin() + s.find( '+' ) );
   s2 = string( s.begin() + s.find( '+' ) + 1, s.begin() + s.find( '=' ) );
   s3 = string( s.begin() + s.find( '=' ) + 1, s.end() );

   // konstruiramo molekule
   molekula m1( s1 ), m2( s2 ), m3( s3 );

   // trazimo rjesenje
   for ( int x1=1; x1<=10; ++x1 )
      for ( int x2=1; x2<=10; ++x2 )
         for ( int x3=1; x3<=10; ++x3 )
            if ( x1*m1 + x2*m2 == x3*m3 ) {
               cout << x1 << ' ' << x2 << ' ' << x3 << endl;
               return 0;
            }

   cout << "NEMOGUCE" << endl;

   return 0;
}
