
(*
  Croatia 2005 / Regional Competition / Seniors
  Problem KOZE

  Opis algoritma:
  Za svako polje koje dosad nismo posjetili pretpostavimo da je dio
  nekog ogradjenog prostora i napravimo flood-fill.
  U ovom rjesenju flood-fill je implementiran pomocu BFS-a
  (breadth-first search), iako smo mogli koristiti i DFS.

  Vremenska slozenost: O(R*S)
*)

program koze;
const MAXN = 500;
      MAXM = MAXN;
      MAXQ = MAXN*MAXM;

var mapa : array[0..MAXN+1, 0..MAXM+1] of char;
    n, m, i, j, x, y, brk, brv, brojvukova, brojkoza : longint;

    qx   : array[0..MAXQ] of longint;
    qy   : array[0..MAXQ] of longint;
    qp, qk : longint;

procedure push(x, y : longint);
begin
   qx[qp]:=x;
   qy[qp]:=y;
   if qp<MAXQ then qp:=qp+1 else qp:=0;
end;

procedure pop(var x, y : longint);
begin
   x:=qx[qk];
   y:=qy[qk];
   if qk<MAXQ then qk:=qk+1 else qk:=0;
end;

procedure stavi(x, y : longint);
(* koristi globalne varijable mapa, brk i brv *)
begin
   if mapa[x, y]<>'#' then
   begin
      push(x, y);
      if mapa[x, y]='v' then brv:=brv+1
		else if mapa[x, y]='k' then brk:=brk+1;
      mapa[x, y]:='#';
   end;
end;

begin
   readln(n, m);

   (* stavljamo ogradu oko cijele mape *)
   for i:=0 to n+1 do mapa[i, 0]:='#';
   for i:=0 to n+1 do mapa[i, m+1]:='#';
   for i:=0 to m+1 do mapa[0, i]:='#';
   for i:=0 to m+1 do mapa[n+1, i]:='#';

   for i:=1 to n do
   begin
      for j:=1 to m do read(mapa[i, j]);
      readln;
   end;

   qp:=0;
   qk:=0;
   brojvukova:=0;
   brojkoza:=0;

   for i:=1 to n do
      for j:=1 to m do if (mapa[i, j]='v')or(mapa[i, j]='k') then
      begin
         brk:=0;
         brv:=0;
         stavi(i, j);
         while qp<>qk do
         begin
            pop(x, y);
            stavi(x+1, y);
            stavi(x, y+1);
            stavi(x-1, y);
            stavi(x, y-1);
         end;
         if brk>brv then brv:=0 else brk:=0;
         brojkoza:=brojkoza+brk;
         brojvukova:=brojvukova+brv;
      end;
      writeln(brojkoza, ' ', brojvukova);
end.
