
/*
  Croatia 2005 / Regional Competition / Seniors
  Problem KVIZ

  Opis algoritma:
  Prema pravilima iz teksta zadatka, pazljivo generiramo sva tri hinta.
  Kod generiranja prvog hinta prebrojimo sva slova (nslova) i
  zamijenimo ih tockama. Funkcija isalpha iz biblioteke <cctype>
  provjerava je li znak slovo.
  Drugi hint generiramo tako da otkrijemo prvih round(nslova/3) slova.
  Zaokruzivanje je napravljeno pomocu cjelobrojne aritmetike kao
  (nslova + 1) div 3.
  Za treci hint otkrijemo sve samoglasnike. Medjutim, ako nismo
  otkrili nijedan (bar_jedan), otkrijemo drugu trecinu svih slova,
  slicno kao u drugom hintu.
*/

#include <cstdio>
#include <cctype>
#include <cstring>

using namespace std;

int main(void)
{
   static char s[10000], hint[10000];
   fgets( s, sizeof( s ), stdin );

   int i, nslova=0, otkrij, bar_jedan=0;

   // 1. hint
   for ( i=0; s[i] != '\0'; ++i ) {
      if ( isalpha( s[i] ) )
         hint[i] = '.', ++nslova;
      else
         hint[i] = s[i];
   }
   fputs( hint, stdout );

   // 2. hint
   otkrij = ( nslova + 1 ) / 3;
   for ( i=0; s[i] != '\0' && otkrij > 0; ++i ) {
      if ( isalnum( s[i] ) )
         hint[i] = s[i], --otkrij;
   }
   fputs( hint, stdout );

   // 3. hint
   for ( i=0; s[i] != '\0'; ++i )
      if ( hint[i] == '.' && strchr( "aeiou", tolower( s[i] ) ) != NULL )
         hint[i] = s[i], bar_jedan = 1;

   if ( !bar_jedan ) {
      otkrij = ( 2*nslova + 1 ) / 3;
      for ( i=0; s[i] != '\0' && otkrij > 0; ++i ) {
         if ( isalnum( s[i] ) )
            hint[i] = s[i], --otkrij;
      }
   }

   fputs( hint, stdout );

   return 0;
}
