
(*
  Croatia 2005 / Regional Competition / Seniors
  Problem NULE

  Opis algoritma:
  Uocimo da je broj nula na nekom putu jednak min(fak2, fak5), gdje su
  fak2 i fak5 broj faktora 2 i faktora 5 u rastavu cijene tog puta na
  faktore. Ovo nam omogucava da nadjemo rjesenje bez eksplicitnog
  racunanja cijene puta.
  Iz ovoga slijedi (a jednostavno je dokazati) da optimalan put ima
  ili najmanji moguci broj faktora 2 ili najmanji moguci broj faktora
  5 u rastavu cijene na faktore.
  A to cemo iskoristiti tako sto cemo naci dva puta, jedan s najmanjim
  mogucim brojem faktora 2, a jedan s najmanjim mogucim brojem faktora
  5 i tada je ukupno rjesenje (broj nula na kraju optimalnog puta)
  minimum faktora 2 na prvom putu i faktora 5 na drugom putu.
  Puteve nalazimo jednostavnim dinamickim programiranjem:
  faktora[x][y] =
     na_trenutnom_polju + min( faktora[x-1][y], faktora[x][y-1] )

  Vremenska slozenost: O(N^2)
*)

program nule;

const MAXN = 1000;
      NEMA = -1;

type  mat8 = array[1..MAXN, 1..MAXN] of integer;

var   t2, t5 : mat8;
      koliko : array[0..MAXN, 0..MAXN] of longint;
      n, najbolji2, najbolji5 : longint;

procedure ucitaj;
var i, j, tmp : longint;
begin
    readln(n);
    for i:=1 to n do
    begin
        for j:=1 to n do
        begin
          if j<n then read(tmp) else readln(tmp);
          if tmp=0 then
          begin
            t2[i, j]:=NEMA;
            t5[i, j]:=NEMA;
          end else
          begin
            t2[i, j]:=0;
            t5[i, j]:=0;
            while tmp mod 2=0 do
            begin
               tmp:=tmp div 2;
               t2[i, j]:=t2[i, j]+1;
            end;
            while tmp mod 5=0 do
            begin
               tmp:=tmp div 5;
               t5[i, j]:=t5[i, j]+1;
            end;
          end;
        end;
    end;
end;

function nadji(var a : mat8) : longint;
var i, j, odozgo, slijeva : longint;
begin
   for i:=0 to n do
      for j:=0 to n do koliko[i, j]:=NEMA;
   koliko[1, 0]:=0;
   koliko[0, 1]:=0;
   for i:=1 to n do
      for j:=1 to n do if a[i, j]<>NEMA then
      begin
         odozgo:=NEMA;
         slijeva:=NEMA;
         if koliko[i, j-1]<>NEMA then odozgo:=koliko[i, j-1]+a[i, j];
         if koliko[i-1, j]<>NEMA then slijeva:=koliko[i-1, j]+a[i, j];
         if (odozgo<>NEMA)and((odozgo<slijeva)or(slijeva=NEMA)) then
            koliko[i, j]:=odozgo else koliko[i, j]:=slijeva;
      end;
   nadji:=koliko[n, n];
end;

begin
    ucitaj;
    najbolji2:=nadji(t2);
    najbolji5:=nadji(t5);
    if najbolji2<najbolji5 then writeln(najbolji2) else writeln(najbolji5);
end.
