
/*
  Croatia 2005 / Regional Competition / Seniors
  Problem PISOAR

  Opis algoritma:
  Ucitamo niz nula i jedinica i na kraju tog niza dodamo L nula, za
  slucaj da je ispiranje potrebno nakon zadanog intervala.
  Zatim kreiramo string koji se sastoji od K jedinica i string koji se
  sastoji od L nula.
  Prolazimo kroz zadani interval i naizmjenicno pozivamo funkciju
  nadji(), prvo da pronadje niz od K jedinica, a zatim da pronadje niz
  od L nula. Tada slijedi ispiranje. Za pretrazivanje po stringu
  koristimo funkciju strstr().
  Ako u zadanom stringu ne postoji niz od K uzastopnih jedinica,
  ispisujemo odgovarajucu poruku.
*/

#include <stdio.h>
#include <string.h>

#define MAX_N 11000
#define MAX_KL 1000

int k,l,n;
char niz[MAX_N + 1];
char niz_jedinica[MAX_KL + 1],niz_nula[MAX_KL + 1];

void ucitaj(void)
{
  int i;

  scanf("%d%d%d",&k,&l,&n);
  scanf("%s",niz);
  for (i = n;i < n + l;++i)
    niz[i] = '0';
  niz[n + l] = '\0';
}

int nadji(int brojac,char znak)
{
  char *rezultat;

  if (znak == '1')
  {
    rezultat = strstr(niz + brojac,niz_jedinica);
    if (rezultat == NULL)
      return -1;
    return (rezultat - niz + k);
  }
  rezultat = strstr(niz + brojac,niz_nula);
  return (rezultat - niz + l);
}

void rijesi_i_ispisi(void)
{
  int i;
  int brojac;
  int bilo_ispiranje;

  for (i = 0;i < k;++i)
    niz_jedinica[i] = '1';
  niz_jedinica[k] = '\0';

  for (i = 0;i < l;++i)
    niz_nula[i] = '0';
  niz_nula[l] = '\0';

  brojac = 0;
  bilo_ispiranje = 0;
  while (1)
  {
    brojac = nadji(brojac,'1');
    if (brojac == -1)
      break;
    brojac = nadji(brojac,'0');
    printf("%d\n",brojac);
    bilo_ispiranje = 1;
  }
  if (!bilo_ispiranje)
    printf("NIKAD\n");
}

int main(void)
{
  ucitaj();
  rijesi_i_ispisi();

  return 0;
}
