
/*
  Croatia 2005 / Regional Competition / Seniors
  Problem PISOAR

  Opis algoritma:
  Stanje pisoara mozemo opisati pomocu konacnog automata sa K+L
  stanja. Neka je stanje odredjeno parom brojeva (ispred, vrijeme),
  gdje je ispred 1 ako je pisoar detektirao da je netko ispred njega.
  Tad koristimo sljedeca pravila za prijelaz iz stanja u stanje:
  (0, t) + '0' => (0, 0)
  (0, t) + '1' => (0, t+1)
  (0, K) => (1, 0)
  (1, t) + '0' => (1, t+1)
  (1, t) + '1' => (1, 0)
  (1, L) => ispiranje i prijelaz u (0, 0)
*/

#include <iostream>
#include <string>

using namespace std;

int main( void )
{
   int i, K, L, N;
   string log;

   cin >> K >> L >> N;
   cin >> log;

   // dodajmo L nula na kraj za slucaj da treba isprati nakon kraja zapisa
   log += string( L, '0' );

   int  vrijeme=0;
   int  ispred=0;               // 0 = nema nikoga, 1 = netko ispred
   bool barjednom=false;

   for ( i=0; i<(int)log.length(); ++i ) {
      if ( ispred == 0 ) {
         if ( log[i] == '0' )
            vrijeme = 0;
         else if ( ++vrijeme == K ) {
            ispred = 1;
            vrijeme = 0;
         }
      }
      else {
         if ( log[i] == '0' ) {
            if ( ++vrijeme == L ) {
               ispred = 0;
               vrijeme = 0;
               cout << i+1 << endl;
               barjednom = true;
            }
         }
         else
            vrijeme = 0;
      }
   }

   if ( !barjednom )
      cout << "NIKAD" << endl;

   return 0;
}
