
{
  Hrvatska informaticka olimpijada 2006
  Zadatak BANANA

  Za neki broj X mozemo vrlo brzo odrediti da li je moguce postici maksimalnu
  udaljenost D sa K kuna tako da D<=X.
  Binarnim pretrazivanjem po X dolazimo do rjesenja.

  Rekurzijom (funkcija nadji_udaljenosti) za svaki vrh racunamo udaljenost do
  njemu najudaljenijeg vrha koji nije blize pocetnom vrhu.
  Pomocu tih udaljenosti rekurzijom (funkcija testiraj) provjeravamo koje
  udaljenosti od pocetnog vrha je moguce postici popravljanjem cesta.

  Vazno je uociti: ako je potrebno popraviti neku cestu na putu od pocetnog
  vrha do vrha sa prevelikom udaljenoscu, onda popravak treba obaviti sto blize
  pocetnom vrhu, jer time smanjujemo udaljenosti od pocetnog vrha do svih vrhova
  nakon te ceste. Popravljanje neke druge, udaljenije ceste nikako ne moze
  dovesti do boljeg rjesenja, ali moze dovesti do losijeg.
  Funkcija testiraj(V, X) radi tako da pogleda sve susjede vrha V osim njegovog
  roditelja (onog blizem pocetnom vrhu). Ako je susjed S, duljina ceste A, a
  minimalna duljina B tada A+D[S]>X znaci da je potreban popravak. Cestu cemo
  popraviti za iznos C=min(A-B, A+D[S]-X). Ako nemamo C kuna na raspolaganju,
  prijavljujemo neuspjeh. Inace, umanjujemo iznos novaca za C i rekurzivno
  testiramo dalje: Testiraj(S, X-A+C).
}

program banana;

const MAXN = 100000;

type brid = record
                x, y, a, b : longint;
            end;

var n, r, novac : longint;
    min, max, mid, i : longint;

    e : array[1..2*MAXN-2] of brid;     { sortirana lista bridova                  }
    p : array[1..MAXN+1] of longint;    { indeksi prvog brida u listi za svaki vrh }
    d : array[1..MAXN] of longint;      { udaljenosti do najudaljenijeg vrha       }
    par : array[1..MAXN] of longint;    { roditelj vrha                            }

function nadji_udaljenosti(vrh : longint) : longint;
var max, cur, i : longint;
begin
    max := 0;
    for i:=p[vrh] to p[vrh+1]-1 do if e[i].y<>par[vrh] then
    begin
        par[e[i].y]:=vrh;
        cur := e[i].a + nadji_udaljenosti(e[i].y);
        if cur>max then max:=cur;
    end;
    d[vrh]:=max;
    nadji_udaljenosti:=max;
end;

function testiraj(vrh : longint; dalj : longint) : boolean;
var i, skrati : longint;
begin
    if (novac<0)or(dalj<0) then begin testiraj:=false; exit; end;
    for i:=p[vrh] to p[vrh+1]-1 do if (e[i].y<>par[vrh])and(e[i].a + d[e[i].y] > dalj) then
    begin
        skrati := e[i].a+d[e[i].y] - dalj;
        if e[i].a-e[i].b<skrati then skrati:=e[i].a-e[i].b;

        novac:=novac-skrati;

        if not testiraj(e[i].y,  dalj+skrati-e[i].a) then
        begin
            testiraj:=false;
            exit;
        end;
    end;
    testiraj:=true;
end;

procedure qsort(l, r : longint);
var i, j, mid : longint;
    x, y : brid;
    veci : boolean;
begin
    i:=l;
    j:=r;
    mid := (l+r) shr 1;
    x:=e[mid];
    veci := x.x>e[l].x;
    if veci=(x.x>e[r].x) then
    begin
        if veci=(e[l].x>e[r].x) then
        begin
            e[mid]:=e[l];
            e[l]:=x;
            x:=e[mid];
        end else
        begin
            e[mid]:=e[r];
            e[r]:=x;
            x:=e[mid];
        end;
    end;
    repeat
        while e[i].x<x.x do inc(i);
        while x.x<e[j].x do dec(j);
        if i<=j then
        begin
            y:=e[i];
            e[i]:=e[j];
            e[j]:=y;
            inc(i);
            dec(j);
        end;
    until i>j;
    if l<j then qsort(l,j);
    if i<r then qsort(i,r);
end;

procedure ucitaj;
var i, a, b, x, y : longint;
begin
    readln(n, r);
    for i:=1 to n-1 do
    begin
        readln(x, y, a, b);
        e[2*i-1].x:=x; e[2*i-1].y:=y; e[2*i-1].a:=a; e[2*i-1].b:=b;
        e[2*i]:=e[2*i-1]; e[2*i].x:=y; e[2*i].y:=x;
    end;
    qsort(1, 2*n-2);
    a:=0;
    for i:=1 to 2*n-2 do
    begin
        while e[i].x>a do
        begin
            a:=a+1;
            p[a]:=i;
        end;
    end;
    while n+1>a do
    begin
        a:=a+1;
        p[a]:=2*n-1;
    end;
end;

begin
    ucitaj;

    for i:=1 to n do par[i]:=0;

    max:=nadji_udaljenosti(1);
    min:=0;

    while min<max do
    begin
        mid:=(min+max) div 2;
        novac := r;
        if testiraj(1, mid) then
            max:=mid
        else
            min:=mid+1;
    end;
    writeln(min);
end.
