
{
  Hrvatska informaticka olimpijada 2006
  Zadatak KOKOS

  Potrebno je uociti da su lijeva i desna "polovica" grafa potpuno neovisne,
  tj. vrh K-tog slova smijemo spojiti sa bilo kojim vrhom (K+1)-og slova.
  Dakle, minimalan broj vrhova lijeve polovice grafa ovisi samo o prvih K
  slova zadanih rijeci (samo o lijevim polovicama rijeci).

  Minimalnu lijevu polovicu grafa gradit cemo postupnim dodavanjem polovica
  rijeci. Za prvu polu-rijec trebamo tocno K vrhova.

  Za svaku sljedecu polu-rijec potrebno je pronaci koja vec dodana polu-rijec
  joj je "najslicnija", tj. kolika je duljina najduljeg zajednickog prefiksa
  trenutne polu-rijeci i vec dodanih polu-rijeci.

  Ako je ta duljina L, tada je potrebno dodati jos K-L novih vrhova u lijevu
  polovicu grafa (jer se prvih L slova vec nalazi u grafu, iz njih se smijemo
  granati u preostalih K-L slova, a spajanje je zabranjeno).

  Prije dodavanja u graf, polu-rijeci cemo sortirati leksikografski jer parovi
  susjednih rijeci u tom poretku imaju najdulje zajednicke prefikse.

  Za desnu polovicu grafa vrijedi slican algoritam: umjesto lijevih polovica
  rijeci gledamo obrnute desne polovice rijeci, a bridove grafa usmjeravamo u
  obrnutom smjeru.
}

program kokos;

const MAXN = 10000;
      MAXK = 100;

type rijec = string[MAXK];
     lista = array[1..MAXN] of rijec;

var r : array[1..2] of lista;

    i, j, l, n, k, rj : longint;

procedure ucitaj;
var i, j : longint;
    line : string[MAXK*2];
begin
    readln(n, k);
    for i:=1 to n do
    begin
        readln(line);
        for j:=1 to k do
        begin
            r[1][i][j]:=line[j];
            r[2][i][j]:=line[2*k-j+1];
        end;
        r[1][i][0]:=char(k);
        r[2][i][0]:=char(k);
    end;
end;

{ quicksort, median of three }
procedure qsort(l, r : longint; var a : lista);
var i, j, mid : longint;
    x, y : rijec;
    veci : boolean;
begin
    i:=l;
    j:=r;
    mid := (l+r) shr 1;
    x:=a[mid];
    veci := x>a[l];
    if veci=(x>a[r]) then
    begin
        if veci=(a[l]>a[r]) then
        begin
            a[mid]:=a[l];
            a[l]:=x;
            x:=a[mid];
        end else
        begin
            a[mid]:=a[r];
            a[r]:=x;
            x:=a[mid];
        end;
    end;
    repeat
        while a[i]<x do inc(i);
        while x<a[j] do dec(j);
        if i<=j then
        begin
            y:=a[i];
            a[i]:=a[j];
            a[j]:=y;
            inc(i);
            dec(j);
        end;
    until i>j;
    if l<j then qsort(l,j,a);
    if i<r then qsort(i,r,a);
end;

begin
    ucitaj;
    qsort(1, n, r[1]);
    qsort(1, n, r[2]);

    rj:=2*k;
    for l:=1 to 2 do for i:=2 to n do
    begin
        j:=0;
        while j<k do
        begin
            if r[l][i][j+1]<>r[l][i-1][j+1] then break;
            j:=j+1;
        end;
        rj:=rj+k-j;
    end;
    writeln(rj);
end.
