
/*
  Hrvatska informaticka olimpijada 2006
  Zadatak SUPER95

  Gledamo brojeve oblika x = A * 1000^B, gdje je A cijeli broj izmedju 1 i 999, a
  B cijeli broj izmedju 0 i 3.

  Svi brojevi iz intervala [x, x+1000^B> pocinju istim slovom f(A).
  Ako je A = 1 tada je f(A) jednak 'J', 'T' ili 'M' ovisno o broju B.
*/

#include <cstdio>

using namespace std;

// prima broj 1..999 i vraca slovo
char f( int x ) {
   if( x >= 200 ) return f( x/100 );
   if( x >= 100 ) return 'S';
   if( x >= 20 ) return f( x/10 );
   if( x >= 11 ) return f( x%10 );

   if( x == 10 ) return 'D';
   if( x == 9 ) return 'D';
   if( x == 8 ) return 'O';
   if( x == 7 ) return 'S';
   if( x == 6 ) return '#';
   if( x == 5 ) return 'P';
   if( x == 4 ) return '#';
   if( x == 3 ) return 'T';
   if( x == 2 ) return 'D';
   if( x == 1 ) return 'J';
   return '@';
}

typedef long long llint;

llint pot[4] = { 1, 1000, 1000000, 1000000000 };
char slova[4] = { 'J', 'T', 'M', 'M' };

int main( void ) {
   char target;
   llint n;
   scanf( "%c %lld", &target, &n ); --n;

   try {
      for( int B = 0; B < 4; ++B ) {
         for( int A = 1; A <= 999; ++A ) {
            char slovo = f( A );
            if( A == 1 ) slovo = slova[B];

            if( slovo != target ) continue;

            if( n >= pot[B] ) n -= pot[B];
            else throw A*pot[B] + n;
         }
      }
      printf( "NEMA\n" );
   } catch( llint rjesenje ) {
      printf( "%lld\n", rjesenje );
   }
   return 0;
}
