
{
  Hrvatska informaticka olimpijada 2006
  Zadatak SUPER95

  Za svako slovo unaprijed popunimo odgovarajuce tablice (D, Je, O, M, P, S, T).
  Tablica[i] je sortirani niz brojeva s kojima moramo pomnoziti 10^i da bi
             dobili prvi broj niza od 10^i uzastopnih brojeva koji pocinju
             odgovarajucim slovom.
  Primjer: iz D[3]=(2,9,10,12,19) citamo sljedece nizove od 10^3=1000 uzastopnih
           brojeva koji pocinju slovom D:
           2000-2999, 9000-9999, 10000-10999, 12000-12999, 19000-19999

  U svim tablicama ce vrijediti:
  Tablica[A][B] * 10^A < Tablica[C][D] * 10^C, za A<C

  Trazeni N-ti broj nalazimo tako da prolaskom kroz tablicu vrlo brzo odredimo u
  kojem se intervalu brojeva nalazi, te koliko brojeva niza se nalazi u svim
  prethodnim intervalima. Ako je X pocetni broj intervala u kojem se trazeni broj
  nalazi, a u prethodnim intervalima se nalazi Y brojeva niza, tada je n-ti broj
  niza jednak X+N-Y-1.
}

program super95;

type llint = int64;
     polje = array[1..5] of longint;

const D1 : polje = (2, 9, 10, 12, 19);
      D2 : polje = (2, 9, 0, 0, 0);

var
    c : char;
    n : llint;

    D, Je, O, M, P, S, T, x : array[0..12] of polje;

    i, j : longint;
    pot : llint;

    rj : llint;

begin
    { inicijalizacija svih tablica na nulu }
    for i:=0 to 12 do for j:=1 to 5 do
    begin
        D[i][j]:=0; Je[i][j]:=0; O[i][j]:=0; M[i][j]:=0;
        P[i][j]:=0;  S[i][j]:=0; T[i][j]:=0;
    end;

    { slovo D }
    for i:=0 to 11 do if i mod 3=0 then D[i]:=D1 else D[i]:=D2;

    { slovo J }
    Je[0][1]:=1; Je[0][2]:=11; Je[3][1]:=11; Je[6][1]:=11; Je[9][1]:=11;

    { slovo M }
    M[6][1]:=1; M[9][1]:=1;

    { slovo O }
    O[0][1]:=8; O[0][2]:=18; O[1][1]:=8; O[2][1]:=8;
    for i:=3 to 11 do O[i]:=O[i-3];

    { slovo P }
    P[0][1]:=5; P[0][2]:=15; P[1][1]:=5; P[2][1]:=5;
    for i:=3 to 11 do P[i]:=P[i-3];

    { slovo T }
    for i:=0 to 11 do T[i][1]:=3;
    for i:=0 to 11 do if i mod 3=0 then T[i][2]:=13;
    T[3][1]:=1; T[3][2]:=3; T[3][3]:=13;

    { slovo S }
    for i:=0 to 11 do S[i][1]:=7;
    for i:=0 to 11 do if i mod 3=0 then S[i][2]:=17;
    for i:=0 to 11 do if i mod 3=2 then begin S[i][1]:=1; S[i][2]:=7; end;

    { ucitamo slovo, broj i odredimo koju tablicu koristimo: }
    readln(c, n);
    case c of
        'D': x:=D;
        'J': x:=Je;
        'M': x:=M;
        'O': x:=O;
        'P': x:=P;
        'S': x:=S;
        'T': x:=T;
    end;

    pot:=1; { pocetna potencija broja 10 }
    i:=0;
    j:=1;
    while x[i][j]=0 do
    begin
        i:=i+1;
        pot:=pot*10;
    end;
    while n>pot do
    begin
        n:=n-pot;
        j:=j+1;
        if (j=6)or(x[i][j]=0) then
        repeat
            pot:=pot*10;
            i:=i+1;
            j:=1;
        until (i=12)or(x[i][j]<>0);
    end;

    rj := x[i][j]*pot + n - 1;

    writeln(rj);
end.
