
{
  Hrvatska informaticka olimpijada 2006
  Zadatak TROKUT

  Neka je zadan trokut ABC, oznacimo sa 1 poluravninu
  odredjenu pravcem BC koja ne sadrzi tocku A, analogno
  oznacimo i poluravnine 2 i 3. Neka su 12, 13 i 23 presjeci
  odgovarajucih poluravnina. Ako k[X] oznacava broj tocaka u
  podrucju X onda se broj tocaka unutar trokuta ABC moze
  izraziti kao k[ABC] = N - (k[1] + k[2] + k[3] - k[12] -
  k[23] - k[13]).

      \12|
       \ |
        \|
         C
         |\    1
     2   | \
         |  \
         |   \
      ---A----B---
         |     \
      23 |      \ 13
         |  3    \

  Oznacimo l[ABC] = N - (k[1] + k[2] + k[3]). Ako su podrucja
  12, 23, i 31 prazna onda je l[ABC] = k[ABC]. Sa druge
  strane, ako ta podrucja nisu prazna onda je l[ABC] <
  k[ABC].

  Kljucna dosjetka je sljedeca: ako je trokut ABC doista
  rjesenje onda podrucja 12, 23 i 13 moraju biti prazna.
  Naime kada bi, na primjer, podrucje 12 sadrzavalo tocku D,
  tada bi trokut ABD sadrzavao trokut ABC pa samim time i
  strogo vise tocaka nego trokut ABC.

  Stoga ako nadjemo trokut takav da je l[ABC] najvece moguce,
  onda smo nasli rjesenje.

  l[ABC] za sve trokute racunamo u dva koraka. U prvom
  koraku za svaka dva vrha A i B izracunamo k[AB], broj
  tocaka koje leze 'desno' od usmjerog pravca A, B. U drugom
  koraku, za svaki pozitivno orijentirani trokut ABC
  izracunamo l[ABC] kao N - (k[AB] + k[BC] + k[CA]).

  Slozenost oba dva koraka pa tako i cijelog rjesenja je
  O(n^3) uz potrosnju O(n^2) memorije.
}

program trokut;

const MAXN = 300;

var x, y : array[1..MAXN] of longint;            { zadane tocke }
    lijevo : array[1..MAXN, 1..MAXN] of longint; { lijevo[i,j]=broj tocaka lijevo od i->j }
    duzina : array[1..MAXN, 1..MAXN] of longint; { duzina[i,j]=broj tocaka na duzini i-j  }
    n, rj, T1, T2, T3 : longint;
    i, j, k, temp : longint;
    ccw : int64;

begin
    readln(n);
    for i:=1 to n do readln(x[i], y[i]);

    for i:=1 to n do
        for j:=1 to n do if i<>j then
        begin
            lijevo[i,j]:=0; { strogo lijevo, tocke na duzini se ne broje }
            duzina[i,j]:=2; { 2 rubne tocke duzine }
            for k:=1 to n do if (k<>i)and(k<>j) then
            begin
                {  NAPOMENA: umjesto int64 za ccw se mogao koristiti
                    tip podataka double, cime se program znatno ubrza!  }
                ccw := int64(x[i])*(y[j]-y[k]) +
                       int64(x[j])*(y[k]-y[i]) +
                       int64(x[k])*(y[i]-y[j]) ;

                if ccw>0 then inc(lijevo[i,j]);

                if (ccw=0)and((x[k]>x[i])<>(x[k]>x[j]))
                          and((y[k]>y[i])<>(y[k]>y[j])) then inc(duzina[i,j]);
            end;
        end;

    rj:=0;
    for i:=1 to n do
        for j:=1 to n do if i<>j then
            for k:=1 to n do if (k<>i)and(k<>j) then
            begin
                temp := lijevo[i,j] + duzina[i,j] - lijevo[i,k] - lijevo[k,j];
                if temp>rj then
                begin
                    rj:=temp;
                    T1:=i;
                    T2:=j;
                    T3:=k;
                end;
            end;

    writeln(rj);
    writeln(T1, ' ', T2, ' ', T3);
end.
