
{
  DMIH 2006 - Prvi dan natjecanja
  Srednjoskolska skupina - I. podskupina
  Zadatak KULE

  Neka se brojevi na ploci nalaze u dvodimenzionalnom polju A[MAX][MAX].
  Za pocetak, izracunajmo sumu svakog retka odnosno svakog stupca u nizove
  Row[MAX] odnosno Col[MAX].

  Oznacimo poziciju kula na ploci s (r1,c1) i (r2,c2). Raspored dviju kula na
  ploci mozemo podijeliti u 3 slucaja:

  A) Kule su u istom retku (r1 = r2)
  B) Kule su u istom stupcu (c1 = c2)
  C) Kule su u razlicitim recima i stupcima

  Slucaj A) rjesavamo tako da odaberemo redak r, te stupce c1 i c2 na sve moguce
  nacine i direktnom formulom provjerimo koji od rasporeda daje maksimalan zbroj.
  Formula ocito glasi:
     Zbroj = Row[r] + Col[c1] + Col[c2] - 2*A[r][c1] - 2*A[r][c2]

  Slucaj B) rjesavamo analogno, a formula glasi:
     Zbroj = Col[c] + Row[r1] + Row[r2] - 2*A[r1][c] - 2*A[r2][c]

  Slucaj C) je nesto kompliciraniji.
  Promotrimo prvo kako bi glasila formula za zbroj kada bi znali konacan raspored
  dviju kula:
     Zbroj = Row[r1] + Row[r2] +                   (1)
           + Col[c1] - A[r2][c1] - 2*A[r1][c1] +   (2)
           + Col[c2] - A[r1][c2] - 2*A[r2][c2]     (3)

  (U daljnjem tekstu spominjemo dijelove formule po recima kako je gore oznaceno)

  Prvi redak formule je doprinos koji daju dva odabrana retka r1 i r2.
  Drugi redak formule je doprinos koji daje stupac u kojem se nalazi prva kula.
  Treci redak formule je doprinos koji daje stupac u kojem se nalazi druga kula.

  Primjetite da je polja (r1,c1) i (r2,c2) u svim formulama potrebno dva puta
  oduzeti jer se polja na kojima se nalaze kule ne smije ubrojiti u ukupni zbroj,
  a vec su dvaput ubrojani kroz sume Row[r1], Row[r2], Col[c1] i Col[c2].

  Odaberimo retke r1 i r2 na sve moguce nacine.
  Kako se stupac c1 u formuli pojavljuje samo u 2. retku ocito za c1 trebamo
  odabrati stupac koji maksimizira (2).
  Isto vrijedi za c2 - trebamo odabrati stupac c2 koji maksimizira (3) s tim da
  moramo uzet u obzir da c2 ne smije biti jednak c1.

  Iz gornjeg slijedi algoritam:
  Za svaki r1 od 1 do n
    Za svaki r2 od 1 do n
      Ako r1 != r2
        Odaberi c1 tako da je Col[c1] - A[r2][c1] - 2*A[r1][c1] maksimalno
        Odaberi c2!=c1 tako da je Col[c2] - A[r1][c2] - 2*A[r2][c2] maksimalno

        Provjeri je li pozicija (r1,c1) i (r2,c2) najbolja dosada

  Na prvi pogled moze se ciniti da gornji algoritam nije valjan u slucajevima
  kada kulu u retku r1 (koja ima prioritet u biranju stupca) stavimo u stupac
  gdje bi kula u retku r2 trebala biti da bi suma bila maksimalna, no i taj
  slucaj ce biti isproban u kada r1 i r2 zamijene vrijednosti jer ce tada druga
  kula imati prioritet u biranju stupca.

  Vremenska slozenost je za sva tri slucaja jednaka O(n^3).
}

program kule;

const MAX = 300;

var
   n : longint;
   A : array[1..MAX,1..MAX] of longint;
   Row : array[1..MAX] of longint;
   Col : array[1..MAX] of longint;
   i, j : longint;
   r, c : longint;
   r1, c1 : longint;
   r2, c2 : longint;
   max1 : longint;
   max2 : longint;
   tmp : longint;
   Rjesenje : longint;

begin
   readln( n );
   for i := 1 to n do begin
      for j := 1 to n do begin
         read( A[i,j] );
         Row[i] := Row[i] + A[i,j];
         Col[j] := Col[j] + A[i,j];
      end;
      readln;
   end;

   Rjesenje := 0;

   { Slucaj A) }
   for r := 1 to n do begin
      for c1 := 1 to n do begin
         for c2 := 1 to n do begin
            tmp := Row[r] + Col[c1] + Col[c2] - 2*A[r,c1] - 2*A[r,c2];
            if tmp > Rjesenje then Rjesenje := tmp;
         end;
      end;
   end;

   { Slucaj B) }
   for c := 1 to n do begin
      for r1 := 1 to n do begin
         for r2 := 1 to n do begin
            tmp := Col[c] + Row[r1] + Row[r2] - 2*A[r1,c] - 2*A[r2,c];
            if tmp > Rjesenje then Rjesenje := tmp;
         end;
      end;
   end;

   { Slucaj C) }
   for r1 := 1 to n do begin
      for r2 := 1 to n do begin
         if r1 = r2 then continue;

         c1 := -1; max1 := -1000000000;
         for c := 1 to n do begin
            tmp := Col[c] - A[r2,c] - 2*A[r1,c];
            if tmp > max1 then begin
               c1 := c; max1 := tmp;
            end;
         end;

         c2 := -1; max2 := -1000000000;
         for c := 1 to n do begin
            tmp := Col[c] - A[r1,c] - 2*A[r2,c];
            if (c <> c1) and (tmp > max2) then begin
               c2 := c; max2 := tmp;
            end;
         end;

         tmp := Row[r1] + Row[r2]
              + Col[c1] - A[r2][c1] - 2*A[r1,c1]
              + Col[c2] - A[r1][c2] - 2*A[r2,c2];
         if tmp > Rjesenje then Rjesenje := tmp;
      end;
   end;

   writeln( Rjesenje );
end.
