
/*
  DMIH 2006 - Prvi dan natjecanja
  Srednjoskolska skupina - I. podskupina
  Zadatak TURBO

  Zadatak mozemo rijesiti eksplicitnom konstrukcijom ciklusa u pomocni
  niz pri svakom prvom pritisku tipke T u nizu. Daljnjim pritiscima na
  T ispisuju se brojevi iz konstruiranog ciklusa.

  Vremenska slozenost je O(N^2), jer konstrukcija ciklusa traje O(N).
*/

#include <cstdio>
#include <vector>

using namespace std;

#define MAXK 100

char buff[32];
bool vec_bio[MAXK];

int main( void ) {
   int n;
   scanf( "%d", &n );

   vector<int> niz( n );
   for( int i = 0; i < n; ++i ) {
      scanf( "%s", buff );

      if( buff[0] == 'T' ) {
         // ulazimo u turbo-salt mod, nadi zadnje pojavljivanje kanala
         // niz[i-1], ili postavi pocetak ciklusa na prvi odabran program

         int sad;
         for( sad = i-1; sad > 0 && niz[sad-1] != niz[i-1]; --sad );

         for( int j = 1; j < MAXK; ++j ) vec_bio[j] = false;

         // konstruiraj ciklus
         vector<int> ciklus;
         for( ; sad < i; ++sad ) {
            if( vec_bio[ niz[sad] ] ) continue;

            ciklus.push_back( niz[sad] );
            vec_bio[ niz[sad] ] = true;
         }

         // dok se ucitava T, ispisuj brojeve iz konstruiranog ciklusa
         int gdje = 0;
         while( buff[0] == 'T' ) {

            printf( "%d\n", niz[i] = ciklus[gdje] );

            if( ++gdje == (int)ciklus.size() ) gdje = 0;

            if( ++i == n ) break;
            scanf( "%s", buff );
         }
      }
      sscanf( buff, "%d", &niz[i] );
   }

   return 0;
}
