
/*
  DMIH 2006 - Drugi dan natjecanja
  Srednjoskolska skupina - I. podskupina
  Zadatak KONTROLA

  Za vrijeme voznje putnike dijelimo u dvije grupe:
  A) Putnici kojima je vec pregledana karta
  B) Putnici kojima jos nije pregledana karta

  Dakle, kad kontrolor pregledava karte svi putnici tipa B postaju putnici tipa A.

  Najveci broj putnika kojima nije pregledana karta dobivamo simulirajuci
  prometovanje vlaka kroz svih N stanica, te pri svakom izlasku putnika iz vlaka
  izbacujuci prvo putnike tipa B, a tek onda putnike tipa A (ako je potrebno).

  Najmanji broj putnika kojima nije pregledana karta dobivamo na analogan nacin
  izbacujuci prvo putnike tipa A, a tek onda putnike tipa B (ako je potrebno).
*/

#include <cstdio>

#define MAX 1000
#define NAJMANJE 0
#define NAJVISE 1

int n, k;
int uslo[MAX];
int izaslo[MAX];

int simuliraj( int kako ) {
   int A = 0; // putnici kojima je pregledana karta
   int B = 0; // putnici kojima jos nije pregledana karta
   int C = 0; // putnici koji su izasli bez pregleda (rezultat)
   int x;     // koliko ce putnika tipa A izaci na slijedecoj stanici
   int y;     // koliko ce putnika tipa B izaci na slijedecoj stanici

   for( int i = 0; i < n; ++i ) {

      if( kako == NAJMANJE ) {
         x = izaslo[i] <? A;
         y = izaslo[i] - x;
      } else {
         y = izaslo[i] <? B;
         x = izaslo[i] - y;
      }

      // izlaze van
      A -= x;
      B -= y;
      C += y;

      // ulaze unutra
      B += uslo[i];

      // je li dosao kontrolor
      if( i%k == 0 ) {
         A += B;
         B = 0;
      }
   }

   return C;
}

int main( void ) {
   scanf( "%d%d", &n, &k );
   for( int i = 0; i < n; ++i ) scanf( "%d%d", &izaslo[i], &uslo[i] );

   printf( "%d %d\n", simuliraj(NAJMANJE), simuliraj(NAJVISE) );

   return 0;
}
