
{
  DMIH 2006 - Drugi dan natjecanja
  Srednjoskolska skupina - I. podskupina
  Zadatak KONTROLA

  Za vrijeme voznje putnike dijelimo u dvije grupe:
  A) Putnici kojima je vec pregledana karta
  B) Putnici kojima jos nije pregledana karta

  Dakle, kad kontrolor pregledava karte svi putnici tipa B postaju putnici tipa A.

  Najveci broj putnika kojima nije pregledana karta dobivamo simulirajuci
  prometovanje vlaka kroz svih N stanica, te pri svakom izlasku putnika iz vlaka
  izbacujuci prvo putnike tipa B, a tek onda putnike tipa A (ako je potrebno).

  Najmanji broj putnika kojima nije pregledana karta dobivamo na analogan nacin
  izbacujuci prvo putnike tipa A, a tek onda putnike tipa B (ako je potrebno).
}

program kontrola;

const MAX = 1000;
const NAJMANJE = 0;
const NAJVISE = 1;

var
   n, k : longint;
   uslo, izaslo : array[1..MAX] of longint;
   i : longint;

function min( a, b : longint ) : longint;
begin
   if a < b then min := a else min := b;
end;

function simuliraj( kako : longint ) : longint;
var
   A, B, C : longint;
   x : longint; { koliko ce putnika tipa A izaci na slijedecoj stanici }
   y : longint; { koliko ce putnika tipa B izaci na slijedecoj stanici }
   i : longint;
begin
   A := 0; { putnici kojima je pregledana karta }
   B := 0; { putnici kojima jos nije pregledana karta }
   C := 0; { putnici koji su izasli bez pregleda (rezultat) }

   for i := 1 to n do begin

      if kako = NAJMANJE then begin
         x := min( izaslo[i], A );
         y := izaslo[i] - x;
      end else begin
         y := min( izaslo[i], B );
         x := izaslo[i] - y;
      end;

      { izlaze van }
      A := A - x;
      B := B - y;
      C := C + y;

      { ulaze unutra }
      B := B + uslo[i];

      { je li dosao kontrolor }
      if (i-1) mod k = 0 then begin
         A := A + B;
         B := 0;
      end;
   end;

   simuliraj := C;
end;

begin
   readln( n, k );
   for i := 1 to n do readln( izaslo[i], uslo[i] );

   writeln( simuliraj(NAJMANJE), ' ', simuliraj(NAJVISE) );
end.
