
/*
  DMIH 2006 - Drugi dan natjecanja
  Srednjoskolska skupina - I. podskupina
  Zadatak STOLNI

  Zadatak rjesavamo simulirajuci putanju lopte, te u svakom stupcu trazimo
  pomak rucke s igracima tako da na poziciji kojom prolazi lopta nema igraca.

  Pomak rucke mozemo traziti tako da je micemo prema gore sve dok mozemo ili
  dok ne naidjemo na pomak koji nam odgovara, a zatim isto to radimo u smjeru
  prema dolje.

  Najjednostavniji nacin da to napravimo je pomocu dvije funkcije
     int gore( int stupac ) i
     int dolje( int stupac )
  koje pomicu dani stupac u zeljenom smjeru, te vracaju 0 ako se rucka ne moze
  dalje pomicati u tom smjeru, a 1 ako je pomak izvrsen.
*/

#include <cstdio>

#define MAX 100

int R, S;
char stol[MAX][MAX+1];

int gore( int stupac ) {
   if( stol[0][stupac] != '.' ) return 0;

   for( int redak = 0; redak < R-1; ++redak )
      stol[redak][stupac] = stol[redak+1][stupac];
   stol[R-1][stupac] = '.';

   return 1;
}

int dolje( int stupac ) {
   if( stol[R-1][stupac] != '.' ) return 0;

   for( int redak = R-1; redak > 0; --redak )
      stol[redak][stupac] = stol[redak-1][stupac];
   stol[0][stupac] = '.';

   return 1;
}

int main( void ) {
   scanf( "%d%d", &R, &S );
   for( int r = 0; r < R; ++r ) scanf( "%s", stol[r] );

   int r = 0;      // redak u kojem se nalazi loptica
   while( stol[r][0] != 'L' ) ++r;
   int delta = -1; // smjer u kojem se lopta trenutno krece

   for( int s = 1; s < S; ++s ) {

      // pomicemo lopticu
      if( r == 0 ) delta = 1;
      if( r == R-1 ) delta = -1;
      r += delta;

      // pomicemo rucku prema gore
      while( stol[r][s] != '.' && gore( s ) );

      // pomicemo rucku prema dolje
      while( stol[r][s] != '.' && dolje( s ) );

      stol[r][s] = 'L';
   }

   for( int r = 0; r < R; ++r ) printf( "%s\n", stol[r] );

   return 0;
}
