
{
  DMIH 2006 - Prvi dan natjecanja
  Srednjoskolska skupina - II. podskupina
  Zadatak MARATON

  Ako zamislimo rjesenje koje simulira nogometni maraton utakmicu po utakmicu
  primjetiti cemo da su jedini podatci koji nas u nekom trenutku zanimaju:
  A) redni broj tima koji je upravo usao na teren
  B) redni broj tima koji je od prije na terenu (kao pobjednik)

  Vidimo da ta dva podatka (nazovimo ih stanjem) jedinstveno odredjuju pobjednika
  te utakmice kao i redni broj tima koji treba uci na teren umjesto porazog tima,
  tj. stanje koje slijedi nakon trenutnoga.

  Kako je ukupni broj razlicitih stanja ogranicen, to znaci da ce maraton uci u
  ciklus - odredjen slijed utakmica ce se poceti ponavljati i ponavljati ce se
  do kraja turnira.

  Buduci da su dva podatka u stanju ograniceni brojem N, stanja ce se definitivno
  poceti ponavljati nakon N*N utakmica.

  Gornje zakljucke mozemo iskoristiti kako bismo ubrzali nas program tako da
  nakon detekcije ciklusa ubrojimo ishode iz utakmica unutar ciklusa odgovarajuci
  broj puta i na taj nacin smanjimo broj X.
}

const MAXN = 1000;

type vector = array[1..MAXN] of int64;

var
   N, i : longint;
   tablica : array[1..MAXN, 1..MAXN] of char;
   P1 : longint; { tim koji je od prije na terenu }
   P2 : longint; { tim koji je zadnji dosao na teren }
   brojac : longint; { broj odigranih utakmica }
   zadnja : array[1..MAXN, 1..MAXN] of longint; { kada su timovi zadnji puta igrali }
   X, ciklus, broj : int64;
   rjesenje, tmp : vector;

procedure dodaj( var A, B : vector; C : int64 );
var
   i : integer;
begin
   for i := 1 to N do A[i] := A[i] + B[i] * C;
end;

function slijedeci( x : longint ) : longint;
begin
   x := x + 1;
   if x > N then x := 1;
   slijedeci := x;
end;

procedure simuliraj( broj_utakmica : longint; var ret : vector );
var
   i : longint;
   P3 : longint;

begin
   for i := 1 to N do ret[i] := 0;

   while broj_utakmica > 0 do begin
      broj_utakmica := broj_utakmica - 1;

      zadnja[P1, P2] := brojac;
      brojac := brojac + 1;

      { nadji tim P3 koji igra slijedecu utakmicu }
      P3 := slijedeci( P2 );
      while (P3 = P1) or (P3=P2) do
         p3 := slijedeci( P3 );

      if tablica[P1, P2] = '0' then P1 := P2; { P2 je pobjedio P1, pa ostaje na terenu }

      P2 := P3; { novi tim je P3 }

      ret[P1] := ret[P1] + 1;
      ret[P2] := ret[P2] + 1;
   end;
end;

begin
   readln( N, X );
   for i := 1 to N do readln( tablica[i] );

   for i := 1 to N do rjesenje[i] := 0;

   if X > 0 then begin { prvu utakmicu igraju timovi 0 i 1 }
      P1 := 1;
      P2 := 2;
      rjesenje[P1] := 1;
      rjesenje[P2] := 1;
      X := X - 1;
   end;

   if X > N*N then begin { sigurno postoji ciklus }
      { udji u ciklus }
      simuliraj( N*N, tmp );
      dodaj( rjesenje, tmp, 1 );

      X := X - N*N;

      { izracunaj duljinu ciklusa i zbroji ga 'broj' puta }
      ciklus := brojac - zadnja[P1, P2];
      broj := X div ciklus;

      simuliraj( ciklus, tmp );
      dodaj( rjesenje, tmp, broj );

      X := X - broj * ciklus;
   end;

   simuliraj( X, tmp );
   dodaj( rjesenje, tmp, 1 ); { zbroji ono sto je ostalo }

   for i := 1 to N do begin
      if i > 1 then write( ' ' );
      write( rjesenje[i] );
   end;
   writeln;
end.
