
{
  DMIH 2006 - Drugi dan natjecanja
  Srednjoskolska skupina - II. podskupina
  Zadatak GRADILISTE

  Za kran kazemo da je dostupan ako je moguce prenijet teret od ulaza gradilista
  do bilo koje tocke unutar njegovog dohvata.

  Za dva krana kazemo da su povezani ako se kruznice koje opisuju njihove
  dohvate sjeku u barem jednoj tocki. Izracunavanje dostupnosti kranova svodi
  se na pronalazak povezanih komponenti unutar grafa u kojem kranovi
  predstavljaju cvorove, a njihova povezanost bridove.

  Dakle, svi kranovi koji su u istoj povezanoj komponenti kao i neki kran koji
  dohvaca ulaz gradilista su dostupni.

  Nakon sto pronadjemo sve dostupne kranove jedino sto nam preostaje je za svako
  odrediste provjeriti je li ono unutar dohvata bilo kojeg dostupnog krana.
}

const MAX = 100;

type
   tocka = record
      x : real;
      y : real;
   end;
   kruznica = record
      S : tocka;
      R : real;
   end;

var
   n, m : longint;
   kran : array[1..MAX] of kruznica;
   dostupan : array[1..MAX] of boolean;
   X, Y : real;
   i, j : longint;
   ok : boolean;
   ulaz, odrediste : tocka;

function udalj( A, B : tocka ) : real;
begin
   udalj := sqrt( (A.x-B.x)*(A.x-B.x) + (A.y-B.y)*(A.y-B.y) );
end;

procedure dfs( i : longint );
var
   j : longint;
begin
   if dostupan[i] = true then exit;
   dostupan[i] := true;

   for j := 1 to n do
      if udalj( kran[i].S, kran[j].S ) <= kran[i].R + kran[j].R then
         dfs( j );
end;

begin
   readln( X, Y );

   ulaz.x := X/2;
   ulaz.y := 0;

   readln( n );
   for i := 1 to n do
      readln( kran[i].S.x, kran[i].S.y, kran[i].R );

   for i := 1 to n do
      if udalj( kran[i].S, ulaz ) <= kran[i].R then
         dfs( i );

   readln( m );
   for i := 1 to m do begin
      readln( odrediste.x, odrediste.y );

      ok := false;
      for j := 1 to n do
         if dostupan[j] = true then
            if udalj( kran[j].S, odrediste ) <= kran[j].R then
               ok := true;

      if ok = true then writeln( 'DA' ) else writeln( 'NE' );
   end;
end.
