
{
  DMIH 2006 - Drugi dan natjecanja
  Srednjoskolska skupina - II. podskupina
  Zadatak KAOS

  Neka je niz X sortirani niz rijeci, a niz Y sortirani niz obrnutih rijeci.

  Dodijelimo svakoj rijeci dva broja x i y koji oznacavaju njenu poziciju unutar
  nizova X i Y.

  Tada mozemo reci da se rijeci A i B ne podnose ako je x(A) < x(B) i y(B) < y(A).

  Obradjujemo rijeci redom po y i ubacujemo jednu po jednu u odgovarajucu
  strukturu. Za svaku rijec racunamo s koliko rijeci koje smo dosad obradili se
  ona ne podnosi. Kako trenutna rijec ima najveci y dosad, to trebamo pronaci
  one rijeci koje imaju veci x.

  Struktura u koju cemo ubacivati rijeci mora dakle podrzavati slijedece
  operacije:

  1) Ubacivanje cijelog broja x
  2) Odgovor na pitanje koliko ima brojeva vecih od x unutar strukture

  Postoji vise struktura koje podrzavaju ove operacije efikasno, a mi cemo
  koristiti tzv. segmentirano polje poznatije kao logaritamska struktura.

  Ako je T(x) neki niz cijelih brojeva, tada segmentirano polje S(x) na svakom
  polju pamti sumu niza T u intervalu <x-lobit(x), x]. Gdje je lobit(x) najveca
  potencija broja 2 s kojom je broj x djeljiv.

  Na taj nacin mozemo ubaciti broj i odgovoriti na pitanje u O(log N), Pa je
  ukupna vremenska slozenost algoritma O(N * log N).

  Detalje o samoj strukturi mozete naci u kodu.
}

program kaos;

const MAX = 100000;

var
   loga : array[1..MAX] of longint;

   function lobit( x : longint ) : longint;
begin
   lobit := x and -x;
end;

function pitaj( x : longint ) : longint;
var
   ret : longint;
begin
   ret := 0;
   while x > 0 do begin
      ret := ret + loga[x];
      x := x - lobit(x);
   end;
   pitaj := ret;
end;

procedure ubaci( x : longint );
begin
   while x <= MAX do begin
      loga[x] := loga[x] + 1;
      x := x + lobit(x);
   end;
end;

type
   rijec = record
      s : string;
      x : longint;
   end;

var
   n : longint;
   dict : array[1..MAX] of rijec;
   ret : int64;
   i : longint;

procedure qsort( l, r : longint );
var i, j, mid : longint;
    x, y : rijec;
    veci : boolean;
begin
    i := l;
    j := r;
    mid := (l+r) div 2;

    x := dict[mid];
    veci := x.s > dict[l].s;
    if veci = (x.s > dict[r].s) then begin
       if veci = (dict[l].s > dict[r].s) then begin
          dict[mid] := dict[l];
          dict[l] := x;
          x := dict[mid];
       end else begin
          dict[mid] := dict[r];
          dict[r] := x;
          x := dict[mid];
       end;
    end;
    repeat
       while dict[i].s < x.s do i := i + 1;
       while x.s < dict[j].s do j := j - 1;
       if i <= j then
       begin
          y := dict[i];
          dict[i] := dict[j];
          dict[j] := y;

          i := i + 1;
          j := j - 1;
       end;
    until i > j;
    if l < j then qsort( l, j );
    if i < r then qsort( i, r );
end;

procedure reverse( var s : string );
var
   i, k : longint;
   c : char;
begin
   k := length( s );
   for i := 1 to k div 2 do begin
      c := s[i];
      s[i] := s[k-i+1];
      s[k-i+1] := c;
   end;
end;

begin
   readln( n );

   for i := 1 to n do
      readln( dict[i].s );

   qsort( 1, n );

   for i := 1 to n do dict[i].x := n-i+1;

   for i := 1 to n do reverse( dict[i].s );

   qsort( 1, n );

   ret := 0;
   for i := 1 to n do begin
      ret := ret + pitaj( dict[i].x );
      ubaci( dict[i].x );
   end;

   writeln( ret );
end.
