
{
  DMIH 2006 - Drugi dan natjecanja
  Srednjoskolska skupina - II. podskupina
  Zadatak KUTIJE

  Tvrdnje iz zadatka koje govore kada su kuglice slozene nam zapravo kazu da
  kuglice moraju biti rasporedjene tako da su na pocetku sve crne, a na kraju
  bijele kuglice ili na pocetku sve bijele, a na kraju crne kuglice.

  Rijesit cemo oba slucaja i ispisati ono rjesenje koje se sastoji od manje
  koraka.

  Pretpostavimo bez gubitka opcenitosti da rjesavamo problem gdje zelimo bijele
  kuglice na pocetku, a crne na kraju.

  Taj problem mozemo rijesiti slijedecim 'pohlepnim' algoritmom.

  Ponavljamo ova 4 koraka sve dok kuglice nisu slozene:
  1. Idemo slijeva nadesno i uzmimamo prve dvije crne kuglice na koje naletimo
  2. Pomicemo se na najdesniju kutiju koja sadrzi bijelu kuglicu
  3. Idemo sdesna nalijevo i mijenjamo crne kuglice za prve bijele na koje naletimo
  4. I dalje idemo nalijevo i ubacujemo bijele kuglice u praznine.

  Gornji algoritam je ocito valjan (rjesava zadani problem), ali i optimalan sto
  je manje ocito. Dokaz optimalnosti je prekompliciran da bi se ovdje iznjeo i
  nije potreban za rjesavanje zadatka.

  Dovoljno se upitati: "ionako jednom moramo otici po najudaljenije kuglice koje
  nisu na pravim mjestima, pa zasto ne odmah?"
}

program kutije;

const MAXN = 500;

type
   par = record
      B, C : longint;
   end;
   vector = record
      n : longint;
      a : array[1..100000] of string;
   end;

type niz = array[1..MAXN] of par;

var
   n, i : longint;
   kuglice : niz;
   rjesenje1, rjesenje2 : vector;
   buff : string;
   bijelu : string;
   crnu : string;
   ulaz : array[1..2000] of char;
   p : par;
   cntB, cntC, tmp : longint;

procedure push_back( var R : vector; s : string );
begin
   R.n := R.n + 1;
   R.a[R.n] := s;
end;

{ stavlja bijele na pocetak, a crne na kraj. granica je broj bijelih kutija }
procedure solve( kuglice : niz; granica : longint; var ret : vector );
var
   dizalica : par;
   i, left, right : longint;
begin
   ret.n := 0;
   dizalica.B := 0; dizalica.C := 0;

   i := 1; left := 1; right := n;

   { jedna faza se sastoji od cetiri koraka }
   while true do begin

      { trazimo najlijeviju kutiju s crnom i najdesniju s bijelom unutra }
      while (left <= granica) and (kuglice[left].C = 0) do
         left := left + 1;

      while (right > granica) and (kuglice[right].B = 0) do
         right := right - 1;

      if left > granica then break; { znaci da smo gotovi }

      { 1. idemo slijeva nadesno do granice... i uzimamo crne }
      while i <= granica do begin
         while (kuglice[i].C > 0) and (dizalica.C < 2) do begin
            kuglice[i].C := kuglice[i].C - 1;
            dizalica.C := dizalica.C + 1;
            push_back( ret, 'UZMI ' + crnu );
         end;
         push_back( ret, 'DESNO' );
         i := i + 1;
      end;

      { 2. idemo od granice do najdesnije kuglice koja ima bijelu }
      while i < right do begin
         push_back( ret, 'DESNO' );
         i := i + 1;
      end;

      { 3. idemo sdesna nalijevo do granice... i mjenjamo crne za bijele }
      while i > granica do begin
         while (kuglice[i].B > 0) and (dizalica.C > 0) do begin
            kuglice[i].C := kuglice[i].C + 1;
            dizalica.C := dizalica.C - 1;
            push_back( ret, 'SPUSTI ' + crnu );

            kuglice[i].B := kuglice[i].B - 1;
            dizalica.B := dizalica.B + 1;
            push_back( ret, 'UZMI ' + bijelu );
         end;
         push_back( ret, 'LIJEVO' );
         i := i - 1;
      end;

      { 4. idemo od granice prema lijevo i punimo rupe bijelima }
      while i >= left do begin
         while kuglice[i].B + kuglice[i].C < 2 do begin
            kuglice[i].B := kuglice[i].B + 1;
            dizalica.B := dizalica.B - 1;
            push_back( ret, 'SPUSTI ' + bijelu );
         end;
         if i = left then break;
         push_back( ret, 'LIJEVO' );
         i := i - 1;
      end;
   end;
end;

procedure output( var R : vector );
var
   i : longint;
begin
   for i := 1 to R.n do
      writeln( R.a[i] );
end;

begin
   readln( n );
   readln( ulaz );

   cntB := 0;
   cntC := 0;
   for i := 1 to n do begin
      p.B := 0;
      p.C := 0;

      if ulaz[i*3-2] = 'B' then p.B := p.B + 1 else p.C := p.C + 1;
      if ulaz[i*3-1] = 'B' then p.B := p.B + 1 else p.C := p.C + 1;
      kuglice[i] := p;

      cntB := cntB + p.B;
      cntC := cntC + p.C;
   end;

   { probaj s bijelima na pocetku }
   bijelu := 'BIJELU';
   crnu := 'CRNU';
   solve( kuglice, cntB div 2, rjesenje1 );

   { pobojaj crne u bijele, a bijele u crne }
   for i := 1 to n do begin
      tmp := kuglice[i].B;
      kuglice[i].B := kuglice[i].C;
      kuglice[i].C := tmp;
   end;

   { probaj s crnima na pocetku }
   bijelu := 'CRNU';
   crnu := 'BIJELU';
   solve( kuglice, cntC div 2, rjesenje2 );

   { ispisi krace rjesenje }
   if rjesenje1.n < rjesenje2.n then
      output( rjesenje1 )
   else
      output( rjesenje2 );
end.
