
/*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - I. podskupina
  Zadatak ALARM
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar

  Opis algoritma:

  Pretpostavimo da na mobitelu utipkamo znamenke A, B, C i D.

  Za pocetak trebamo provjeriti hoce li se utipkavanjem
  pretpostavljene kombinacije na ekranu prikazati trazeno vrijeme, a
  to ce se dogoditi ukoliko je (10*A+B) mod 24 = zadani_sati te
  (10*C+D) mod 60 = zadane_minute.

  Kako mogucih kombinacija znamenaka ima dovoljno malo (10^4 = 10000),
  mozemo razmotriti sve kombinacije te odabrati onu s najmanjim
  trudom.

  Efikasniji pristup razmatra samo kombinacije koje daju trazeno
  vrijeme. Konkretno, to su kombinacije u kojima su upisani sati broj
  oblika zadani_sati+24*k, a minute oblika zadane_minute+60*m.

  Donji kod pokazuje efikasnije rjesenje. Pametnim redoslijedom petlji
  se nalazi najmanje rjesenje kad ih postoji vise, bez posebne
  provjere.
*/

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

int calc_trud(int a, int b, int c, int d)
{
   static const int poz[][2] = {
      { 3, 1 }, { 0, 0 }, { 0, 1 }, { 0, 2 }, { 1, 0 },
      { 1, 1 }, { 1, 2 }, { 2, 0 }, { 2, 1 }, { 2, 2 },
   };

   return
      abs(poz[b][0] - poz[a][0]) + abs(poz[b][1] - poz[a][1]) +
      abs(poz[c][0] - poz[b][0]) + abs(poz[c][1] - poz[b][1]) +
      abs(poz[d][0] - poz[c][0]) + abs(poz[d][1] - poz[c][1]);
}

int main()
{
   int zadani_sati, zadane_minute;
   int k, m;
   int best_trud=INT_MAX, best_sati=-1, best_minute=-1;

   scanf("%d:%d", &zadani_sati, &zadane_minute);

   for (k=0; zadani_sati+24*k < 100; ++k)
      for (m=0; zadane_minute+60*m < 100; ++m) {
         int sati = zadani_sati + 24*k;
         int minute = zadane_minute + 60*m;
         int trud = calc_trud(sati/10, sati%10, minute/10, minute%10);

         if (trud < best_trud) {
            best_trud = trud;
            best_sati = sati;
            best_minute = minute;
         }
      }

   printf("%02d:%02d\n", best_sati, best_minute);

   return 0;
}
