
(*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - I. podskupina
  Zadatak ALARM
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar, Ivan Sikiric

  Opis algoritma:

  Pretpostavimo da na mobitelu utipkamo znamenke A, B, C i D.

  Za pocetak trebamo provjeriti hoce li se utipkavanjem
  pretpostavljene kombinacije na ekranu prikazati trazeno vrijeme, a
  to ce se dogoditi ukoliko je (10*A+B) mod 24 = zadani_sati te
  (10*C+D) mod 60 = zadane_minute.

  Kako mogucih kombinacija znamenaka ima dovoljno malo (10^4 = 10000),
  mozemo razmotriti sve kombinacije te odabrati onu s najmanjim
  trudom.

  Efikasniji pristup razmatra samo kombinacije koje daju trazeno
  vrijeme. Konkretno, to su kombinacije u kojima su upisani sati broj
  oblika zadani_sati+24*k, a minute oblika zadane_minute+60*m.

  Donji kod pokazuje efikasnije rjesenje. Pametnim redoslijedom petlji
  se nalazi najmanje rjesenje kad ih postoji vise, bez posebne
  provjere.

  Posto su ulaz i izlaz u obliku "sati:minute", lakse nam je koristiti
  scanf/printf funkcije iz C-a nego C++-ove streamove.
*)

program alarm;

const
    (* pozicije znamenki *)
    znam : array[0..9, 1..2] of longint =
        ( (3,1),(0,0),(0,1),(0,2),(1,0),(1,1),(1,2),(2,0),(2,1),(2,2) );

    (* ostale inicijalizirane varijable *)
    naj_trud : longint = 1000;
    naj_sat  : longint = -1;
    naj_min  : longint = -1;

var (* varijable *)
    ulaz : string[5];
    k, m, ul_sat, ul_min, sat, min, trud : longint;

function racunaj_trud(a, b, c, d : longint) : longint;
begin
    racunaj_trud :=
        abs(znam[a,1]-znam[b,1])+abs(znam[a,2]-znam[b,2])+
        abs(znam[b,1]-znam[c,1])+abs(znam[b,2]-znam[c,2])+
        abs(znam[c,1]-znam[d,1])+abs(znam[c,2]-znam[d,2]);
end;

begin
    (* pocinje ucitavanje ulaza *)
    readln(ulaz);
    ul_sat:=0;
    ul_min:=0;
    k:=1;
    while ulaz[k]<>':' do
      begin
        ul_sat:=ul_sat*10+ord(ulaz[k])-ord('0');
        k:=k+1;
      end;
    for m:=k+1 to length(ulaz) do
      begin
        ul_min:=ul_min*10+ord(ulaz[m])-ord('0');
      end;
    (* gotovo ucitavanje ulaza *)

    (* pocinje racun *)
    k:=0;
    while ul_sat+24*k<100 do
      begin
        m:=0;
        while ul_min+60*m<100 do
          begin
            sat  := ul_sat + 24*k;
            min  := ul_min + 60*m;
            trud := racunaj_trud(sat div 10, sat mod 10, min div 10, min mod 10);
            if trud<naj_trud then
              begin
                 naj_trud := trud;
                 naj_sat  := sat;
                 naj_min  := min;
              end;
            m:=m+1;
          end;
        k:=k+1;
    end;
    (* gotov racun *)

    (* ispis... *)
    if naj_sat<10 then write(0);
    write(naj_sat,':');
    if naj_min<10 then write(0);
    writeln(naj_min);
end.
