
/*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - I. podskupina
  Zadatak KASKADE
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar

  Opis algoritma:

  Zadatak rjesavamo u dva koraka. U prvom koraku na temelju pocetnog
  prikaza ekrana odredimo sirinu, visinu te naziv svakog prozora.
  U drugom koraku slazemo prozore na ekran kako je opisanu u zadatku.

  Na pocetnom ekranu gornji lijevi kut prozora mozemo pronaci koristeci
  sljedeci kriterij: na odredjenoj poziciji se nalazi znak '+', neposredno
  dolje se nalazi znak '|' i neposredno desno se nalazi znak '-', te takodjer
  vrijedi da desno od tog '+'-a, prvi znak koji nije '-' je nuzno
  '|'. Visinu, odnosno sirinu, prozora odredimo tako da nadjemo sljedeci
  '+' dolje, odnosno desno.

  Nakon sortiranja po imenu, prozore direktno crtamo na ekran od
  najudaljenijeg (u prvom redu) prema najblizem. Moramo paziti i da
  popunimo unutrasnjost svakog prozora znakovima '.' kako bi prekrili
  prozore ispod.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX 100

struct prozor
{
        int vis;
        int sir;
        int dulj;
        char ime[MAX+1];
};

int n, m;
char e[MAX][MAX+1];

int broj;
struct prozor p[MAX];

void citaj_ulaz (void)
{
        int i;

        scanf("%d %d", &n, &m);
        for (i=0; i<n; i++)
                scanf("%s", e[i]);
}

void odredi_prozor (int x, int y)
{
        int i;

        /* odredi da li je ovo gornji lijevi rub prozora */
        if (e[x][y]!='+') return ;
        if (e[x][y+1]!='-') return ;
        if (e[x+1][y]!='|') return ;

        i=1;
        while (e[x][y+i]=='-')
                i++;
        if (e[x][y+i]!='|') return ;

        /* odredi sirinu */
        p[broj].sir=1;
        while (e[x][y+p[broj].sir]!='+')
                p[broj].sir++;

        /* odredi visinu */
        p[broj].vis=1;
        while (e[x+p[broj].vis][y]!='+')
                p[broj].vis++;

        /* odredi naziv */
        i=y+1;
        while (e[x][i]!='|')
                i++;
        i++;

        p[broj].dulj=0;
        while (e[x][i]!='|')
                p[broj].ime[p[broj].dulj++]=e[x][i++];
        p[broj].ime[p[broj].dulj]=0;

        broj++;
}

void nadji_sve_prozore (void)
{
        int i, j;

        broj=0;
        for (i=0; i<n-1; i++)
                for (j=0; j<m-1; j++)
                        odredi_prozor(i, j);
}

int cmp (const void *a, const void *b)
{
        struct prozor *aa=(struct prozor *) a;
        struct prozor *bb=(struct prozor *) b;
        return strcmp(aa->ime, bb->ime);
}

void ispisi_rjesenje (void)
{
        int i, j, k;
        int start;

        /* sortiraj prozore */
        qsort(p, broj, sizeof p[0], cmp);

        /* isprazni ekran */
        for (i=0; i<n; i++)
                for (j=0; j<m; j++)
                        e[i][j]='.';

        /* nacrtaj prozore */
        for (i=0; i<broj; i++)
        {
                /* uglovi */
                e[i][i]=e[i+p[i].vis][i]=e[i][i+p[i].sir]=e[i+p[i].vis][i+p[i].sir]='+';

                /* vodoravni rubovi */
                for (j=1; j<p[i].sir; j++)
                        e[i][i+j]=e[i+p[i].vis][i+j]='-';

                /* okomiti rubovi */
                for (j=1; j<p[i].vis; j++)
                        e[i+j][i]=e[i+j][i+p[i].sir]='|';

                /* naziv */
                start=(p[i].sir-p[i].dulj+1)/2;
                e[i][i+start-1]=e[i][i+start+p[i].dulj]='|';
                for (j=0; j<p[i].dulj; j++)
                        e[i][i+start+j]=p[i].ime[j];

                /* unutrasnjost */
                for (j=1; j<p[i].vis; j++)
                        for (k=1; k<p[i].sir; k++)
                                e[i+j][i+k]='.';
        }

        /* ispisi ekran */
        for (i=0; i<n; i++)
                printf("%s\n", e[i]);
}

int main (void)
{
        citaj_ulaz();
        nadji_sve_prozore();
        ispisi_rjesenje();

        return 0;
}
