
(*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - I. podskupina
  Zadatak KASKADE
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar, Ivan Sikiric

  Opis algoritma:

  Program se odvija u sljedecim koracima:
  1. Ucitamo sve ulazne podatke u matricu.
  2. Nadjemo sve prozore, odredimo im sirinu, visinu i naslov. Usput brisemo
     sve prozore iz matrice (dovoljno je brisati samo rubove, jer je
     unutrasnjost prazna). Sad je matrica prazna (sadrzi samo tocke).
  3. Sortiramo sve prozore po naslovu (bilo koji algoritam sortiranja je dobar)
  4. Iscrtavamo sve prozore u matricu (oprez: potrebno je crtati i unutrasnjost
     prozora kako bismo prebrisali dijelove ostalih prozora koji su "ispod")
  5. Ispisujemo sadrzaj matrice na ekran.

  Slozenost rjesenja je O(N^3)
*)

program kaskade;

const MAXN = 100;
      MAXM = 100;
      MAXP = 100;

type Tnaslov = string[10];
type Tprozor = record
            naslov : Tnaslov;
            sir, vis : longint;
     end;

var a : array[1..MAXN+MAXN, 1..MAXM+MAXM] of char;
    p : array[1..MAXP] of Tprozor;
    temp : Tprozor;
    n, m, np, i, j, k : longint;

begin
    (* ucitavanje... *)
    readln(n, m);
    for i:=1 to n do
      begin
        for j:=1 to m do read(a[i, j]);
        readln;
      end;
    (* ...ucitavanje *)

    (* trazenje prozora... *)
    np := 0;
    for i:=1 to n do
      for j:=1 to m do if a[i, j]='+' then
        begin
            np:=np+1;
            (* trazimo sirinu... *)
            for k:=j+1 to m do if a[i, k]='+' then
              begin
                p[np].sir := k-j+1;
                break;
              end;
            (* trazimo visinu... *)
            for k:=i+1 to n do if a[k, j]='+' then
              begin
                p[np].vis := k-i+1;
                break;
              end;
            (* spremamo naslov... *)
            p[np].naslov := '';
            k:=j+1;
            while a[i, k]<>'|' do k:=k+1;
            k:=k+1;
            while a[i, k]<>'|' do
              begin
                p[np].naslov := p[np].naslov + a[i, k];
                k:=k+1;
              end;
            (* jos preostaje prebrisati prozor... *)
            for k:=1 to p[np].sir do
              begin
                a[i, j+k-1] := '.';
                a[i+p[np].vis-1, j+k-1] := '.';
              end;
            for k:=1 to p[np].vis do
              begin
                a[i+k-1, j] := '.';
                a[i+k-1, j+p[np].sir-1] := '.';
              end;
            (* ...prozor je prebrisan *)
        end;
    (* ...trazenje prozora *)

    (* sortiranje prozora... *)
    for i:=1 to np do
        for j:=i+1 to np do
          if p[i].naslov>p[j].naslov then
            begin
                temp := p[i];
                p[i] := p[j];
                p[j] := temp;
            end;
    (* ...sortiranje prozora *)

    (* iscrtavanje prozora... *)
    for k:=1 to np do
      begin
        (* vodoravne crtice... *)
        for i:=1 to p[k].sir-2 do
          begin
            a[k, k+i]:='-';
            a[k+p[k].vis-1, k+i]:='-';
          end;
        (* naslov... *)
        j:=(p[k].sir-length(p[k].naslov)) div 2;
        a[k, k+j-1]:='|';
        a[k, k+j+length(p[k].naslov)]:='|';
        for i:=1 to length(p[k].naslov) do a[k, k+j-1+i]:=p[k].naslov[i];
        (* okomite crtice... *)
        for i:=1 to p[k].vis-2 do
          begin
            a[k+i, k]:='|';
            a[k+i, k+p[k].sir-1]:='|';
          end;
        (* kutovi... *)
        a[k, k]:='+';
        a[k, k+p[k].sir-1]:='+';
        a[k+p[k].vis-1, k]:='+';
        a[k+p[k].vis-1, k+p[k].sir-1]:='+';
        (* sredina... *)
        for i:=1 to p[k].vis-2 do
            for j:=1 to p[k].sir-2 do a[k+i, k+j]:='.';
    end;
    (* ...iscrtavanje prozora *)

    (* ispis podataka... *)
    for i:=1 to n do
      begin
        for j:=1 to m do write(a[i, j]);
        writeln;
      end;
    (* ...ispis podataka *)
end.
