
(*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - I. podskupina
  Zadatak TOPLISTA
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar, Ivan Sikiric

  Opis algoritma:

  Cilj nam je u zadatku izvuci sto vise informacija iz ulaza. Jedna
  stvar koju mozemo primijetiti je da, ako se neki pojam pojavljuje u
  izjavi oblika "od B", tada se on implicitno nalazi i u prvih B+1,
  B+2 itd.

  Na osnovu toga prepoznajemo da se pojam sigurno nalazi na mjestu X
  samo ako su nam poznati svi pojmovi koji se nalaze u prvih X-1
  mjesta (ali ne nuzno i njihov redoslijed).

  Ovu tvrdnju je lako provjeriti: ako znamo da se neki pojam nalazi
  medu prvih X, a znamo tocno X-1 pojmova koji su sigurno ispred
  njega, tada se on mora nalaziti na poziciji X.

  Suprotno, ako nam nije poznato tocno X-1 pojmova koji su sigurno
  ispred nekog pojma, tada se taj pojam moze naci na barem dva mjesta
  (s obzirom na ulaz) pa ne mozemo biti sigurni u njegovu poziciju.

  Slozenosti donje implementacije dominira ucitavanje, za koje je
  potrebno O(N*R) operacija sa stringovima, gdje je N broj izjava, a R
  broj razlicith pojmova koji se pojavljuje u izjavama. Ucitavanje bi
  se moglo ubrzati koristenjem naprednijih struktura podataka (vidi
  C++ rjesenje).

  Slijedi sortiranje u slozenosti O(N log N), a odredivanje pozicija
  traje O(N).
*)

const MAXN = 1000;
      MAXLEN = 30;
      n : longint = 0;

type Time = string[MAXLEN];

var  imena : array[0..MAXN-1] of Time;
     najprije : array[0..MAXN-1] of longint;
     i, j, a, b, nizjava, poz, temp : longint;
     sortirano : array[0..MAXN-1] of longint;
     pojam : Time;
     z : char;

function nadji : longint;
var i : longint;
begin
    for i:=0 to n-1 do if imena[i]=pojam then
      begin
        nadji:=i;
        exit;
      end;
    nadji:=-1;
end;

begin
   read(nizjava);

   for i:=0 to nizjava-1 do
     begin
       readln;
       read(a, z, z, z, z, b, z); (* a_od_b_ *)
       for j:=0 to a-1 do
         begin
           pojam:='';
           read(z);
           while z<>' ' do
             begin
               pojam:=pojam+z;
               if eoln(input) then z:=' ' else read(z);
             end;
           poz := nadji;
           if poz=-1 then
             begin
               poz := n;
               n:=n+1;
               imena[poz]:=pojam;
               najprije[poz]:=b;
             end
           else
             if ( b < najprije[poz] ) then najprije[poz] := b;
         end;
     end;

    for i:=0 to n-1 do sortirano[i]:=i;
    for i:=0 to n-2 do
      for j:=i+1 to n-1 do
        if najprije[sortirano[i]]>najprije[sortirano[j]] then
          begin
            temp:=sortirano[i];
            sortirano[i]:=sortirano[j];
            sortirano[j]:=temp;
          end;

    for i:=0 to n-1 do
      begin
        if ( i = 0 ) or ( najprije[ sortirano[i] ] <> najprije[ sortirano[i-1] ] ) then
          begin
            if ( najprije[ sortirano[i] ]-1 = i ) then
              begin
                writeln(najprije[sortirano[i]], ' ', imena[sortirano[i]]);
              end;
          end;
      end;

end.
