
/*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - II. podskupina
  Zadatak OSMOSMJERKA
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar

  Opis algoritma:

  Zbog malih ogranicenja na velicine u ulazu dovoljno je provjeriti,
  za svaku poziciju, svaki od osam smjerova i svaku trazenu rijec,
  nalazi li se rijec na poziciji, gledajaci u odabranom smjeru. U
  posebnoj matrici pamtimo koja su slova iskoristena te na kraju redom
  ispisemo sva slova koja nisu nijednom iskoristena.

  Isprobavanje u svih osam smjerova mozemo uciniti sa osam blokova
  koda, pri cemu su moguce copy-paste greske. Sigurniji i kraci
  pristup koristi pomake dx i dy (vidi kod).

  Slozenost algoritma je O(N^2*slova), gdje je 'slova' zbroj duljina
  svih trazenih rijeci.
*/

#include <stdio.h>
#include <string.h>

#define MAXN   10
#define MAXLEN 20

int pocne( char osmo[MAXN][MAXN+1], int n, int y, int x, int dy, int dx, const char *rijec )
{
   int i, len = strlen( rijec );

   for ( i=0; i<len; ++i ) {
      if ( y < 0 || y >= n ||
           x < 0 || x >= n ||
           osmo[y][x] != rijec[i] )
         return 0;

      y += dy;
      x += dx;
   }

   return 1;
}

void oznaci( char kamo[MAXN][MAXN+1], int y, int x, int dy, int dx, int len )
{
   int i;
   for ( i=0; i<len; ++i ) {
      kamo[y][x] = 1;
      y += dy;
      x += dx;
   }
}

int main()
{
   int i, n, y, x;
   static char osmo[MAXN][MAXN+1];
   int nrijeci;
   static char potroseno[MAXN][MAXN+1];

   scanf( "%d", &n );
   for ( i=0; i<n; ++i )
      scanf( "%s", osmo[i] );

   scanf( "%d", &nrijeci );

   memset( potroseno, sizeof potroseno, 0 );
   for ( i=0; i<nrijeci; ++i ) {
      static char rijec[MAXLEN+1];
      int y, x, dy, dx;
      scanf( "%s", rijec );

      for ( y=0; y<n; ++y )
         for ( x=0; x<n; ++x )
            for ( dy=-1; dy<=1; ++dy )
               for ( dx=-1; dx<=1; ++dx )
                  if ( dy != 0 || dx != 0 )
                     if ( pocne( osmo, n, y, x, dy, dx, rijec ) )
                        oznaci( potroseno, y, x, dy, dx, strlen( rijec ) );
   }

   for ( y=0; y<n; ++y )
      for ( x=0; x<n; ++x )
         if ( !potroseno[y][x] )
            printf( "%c", osmo[y][x] );
   printf( "\n" );

   return 0;
}
