
/*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - II. podskupina
  Zadatak OSMOSMJERKA
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar

  Opis algoritma:

  Zbog malih ogranicenja na velicine u ulazu dovoljno je provjeriti,
  za svaku poziciju, svaki od osam smjerova i svaku trazenu rijec,
  nalazi li se rijec na poziciji, gledajaci u odabranom smjeru. U
  posebnoj matrici pamtimo koja su slova iskoristena te na kraju redom
  ispisemo sva slova koja nisu nijednom iskoristena.

  Isprobavanje u svih osam smjerova mozemo uciniti sa osam blokova
  koda, pri cemu su moguce copy-paste greske. Sigurniji i kraci
  pristup koristi pomake dx i dy (vidi kod).

  Slozenost algoritma je O(N^2*slova), gdje je 'slova' zbroj duljina
  svih trazenih rijeci.
*/

#include <iostream>
#include <string>
#include <vector>

using namespace std;

bool pocne( const vector<string> &osmo, int y, int x, int dy, int dx, const string &s )
{
   int len = s.length();

   for ( int i=0; i<len; ++i ) {
      if ( y < 0 || y >= (int)osmo.size() ||
           x < 0 || x >= (int)osmo[y].size() ||
           osmo[y][x] != s[i] )
         return false;

      y += dy;
      x += dx;
   }

   return true;
}

void oznaci( vector<vector<char> > &kamo, int y, int x, int dy, int dx, int len )
{
   for ( int i=0; i<len; ++i ) {
      kamo[y][x] = true;
      y += dy;
      x += dx;
   }
}

int main()
{
   int n;
   cin >> n;

   vector<string> osmo( n );
   for ( int i=0; i<n; ++i )
      cin >> osmo[i];

   int nrijeci;
   cin >> nrijeci;

   vector<vector<char> > potroseno( n, vector<char>( n, false ) );
   for ( int i=0; i<nrijeci; ++i ) {
      string rijec;
      cin >> rijec;

      for ( int y=0; y<n; ++y )
         for ( int x=0; x<n; ++x )
            for ( int dy=-1; dy<=1; ++dy )
               for ( int dx=-1; dx<=1; ++dx )
                  if ( dy != 0 || dx != 0 )
                     if ( pocne( osmo, y, x, dy, dx, rijec ) )
                        oznaci( potroseno, y, x, dy, dx, rijec.length() );
   }

   for ( int y=0; y<n; ++y )
      for ( int x=0; x<n; ++x )
         if ( !potroseno[y][x] )
            cout << osmo[y][x];
   cout << endl;

   return 0;
}
