
(*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - II. podskupina
  Zadatak OSMOSMJERKA
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar, Ivan Sikiric

  Opis algoritma:

  Zbog malih ogranicenja na velicine u ulazu dovoljno je provjeriti,
  za svaku poziciju, svaki od osam smjerova i svaku trazenu rijec,
  nalazi li se rijec na poziciji, gledajaci u odabranom smjeru. U
  posebnoj matrici pamtimo koja su slova iskoristena te na kraju redom
  ispisemo sva slova koja nisu nijednom iskoristena.

  Isprobavanje u svih osam smjerova mozemo uciniti sa osam blokova
  koda, pri cemu su moguce copy-paste greske. Sigurniji i kraci
  pristup koristi pomake dx i dy (vidi kod).

  Slozenost algoritma je O(N^2*slova), gdje je 'slova' zbroj duljina
  svih trazenih rijeci.
*)

program osmosmjerka;

const MAXN   = 10;

var i, j, x, y, dx, dy, n, nrijeci : longint;
    osmo     : array[-MAXN..2*MAXN, -MAXN..2*MAXN] of char;
    slobodno : array[-MAXN..2*MAXN, -MAXN..2*MAXN] of boolean;
    redak    : string[MAXN];
    ok : boolean;

begin
    for y:=-MAXN to 2*MAXN do
      for x:=-MAXN to 2*MAXN do
        begin
            osmo[y, x]:='?';
            slobodno[y, x]:=true;
        end;

    readln(n);
    for y:=1 to n do
      begin
        readln(redak);
        for x:=1 to length(redak) do osmo[y,x]:=redak[x];
      end;
    readln(nrijeci);
    for i:=1 to nrijeci do
      begin
        readln(redak);
        for y:=1 to n do
            for x:=1 to n do
                for dx:=-1 to 1 do
                    for dy:=-1 to 1 do
                        if (dy<>0)or(dx<>0) then
                          begin
                            ok:=true;
                            for j:=0 to length(redak)-1 do if osmo[y+dy*j, x+dx*j]<>redak[j+1] then
                              begin
                                ok:=false;
                                break;
                              end;
                            if ok then for j:=0 to length(redak)-1 do slobodno[y+dy*j, x+dx*j]:=false;
                          end;
      end;

    for y:=1 to n do
        for x:=1 to n do
            if slobodno[y,x] then write(osmo[y,x]);
    writeln;
end.
