/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  1. dan natjecanja
  Zadatak GULIVER
*/

#include <algorithm>
#include <cstdio>
#include <deque>

using namespace std;

#define MAX 1000

typedef pair<int,int> par;

char a[MAX][MAX+1];
int dist[MAX][MAX+1];

const int dr[8] = { -1, -1, 0, 1, 1, 1, 0, -1 };
const int dc[8] = { 0, 1, 1, 1, 0, -1, -1, -1 }; 

const int inf = 1000000000;

int main( void ) {
   int n, m;
   scanf( "%d%d", &n, &m ); n -= 2;
   scanf( "%*s" );
   for( int i = 0; i < n; ++i ) 
      scanf( "%s", a[i] );
   scanf( "%*s" );
   
   for( int i = 0; i < n; ++i ) 
      for( int j = 0; j < m; ++j ) 
         dist[i][j] = inf;

   deque<par> Q;
   for( int r = 0; r < n; ++r ) 
      if( a[r][0] == '.' ) {
         dist[r][0] = 1;
         Q.push_back( par(r,0) );
      } else {
         dist[r][0] = 0;
         Q.push_front( par(r,0) );
      }
   
   int ret = inf;
   
   while( !Q.empty() ) {
      int r = Q.front().first;
      int c = Q.front().second;
      Q.pop_front();

      if( c == m-1 ) ret <?= dist[r][c];

      for( int d = 0; d < 8; ++d ) {
         int rr = r+dr[d];
         int cc = c+dc[d];
         if( rr < 0 || rr >= n ) continue;
         if( cc < 0 || cc >= m ) continue;

         if( a[rr][cc] == '.' ) {
            if( dist[rr][cc] <= dist[r][c] + 1 ) continue;
            if( dist[rr][cc] >= inf ) Q.push_back( par(rr,cc) );
            dist[rr][cc] = dist[r][c] + 1;
         } else {
            if( dist[rr][cc] <= dist[r][c] + 0 ) continue;
            if( dist[rr][cc] >= inf ) Q.push_front( par(rr,cc) );
            dist[rr][cc] = dist[r][c] + 0;
         }
      }
   }

   printf( "%d\n", ret );
   
   return 0;
}
