/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  2. dan natjecanja
  Zadatak KARTA

  Pomocni program za provjeru ispravnosti rjesenja - na komandnoj
  liniji potrebno je napisati ulaznu datoteku, datoteku s sluzbenim
  rjesenjem i datoteku s natjecateljskim rjesenjem.
*/

#include <algorithm>
#include <cassert>
#include <fstream>
#include <iostream>
#include <map>
#include <string>
using namespace std;

typedef pair<string,string> par;

map<string, pair<string,string> > sluzb;
map<string, pair<string,string> > natj; 

int main( int argc, char *argv[] )
{
   if ( argc != 4 ) {
      printf( "Primjer koristenja: check.exe karta.in.1 karta.out.1 moje.out\n" );
      return 1;
   }

   ifstream finput( argv[1] );
   ifstream fsluzb( argv[2] );
   ifstream fnatj( argv[3] );

   if ( !(!finput.fail() && !fsluzb.fail() && !fnatj.fail()) ) {
      printf( "Ne mogu otvoriti sve datoteke!\n" );
      return 1;
   }

   string a, b, c;

   while( fsluzb >> a >> b >> c ){
      sluzb[c] = par(a,b);
      if ( !(fnatj >> a >> b >> c) ) {
         printf( "Program nije ispisao rjesenje u zadanom obliku.\n" );
         return 1;
      }
      natj[c] = par(a,b);
   }
   if ( fnatj >> a ) {
      printf( "Program je ispisao neocekivano mnogo podataka na standardni izlaz!\n" );
      return 1;
   }

   for( map<string,pair<string,string> >::iterator it = sluzb.begin(); it != sluzb.end(); ++it ) {
      c = it->first;
      a = it->second.first;
      b = it->second.second;

      if( !natj.count( c ) ) {
         printf( "Program nije ispisao podatke o gradu %s!\n", c.c_str() );
         return 1;
      }
      string a2 = natj[c].first;
      string b2 = natj[c].second;
      
      if( a2 != a || b2 != b ) {
         string nat;
         if( a2.length() > 15 ) {
            nat += a2.substr(0, 15) + "(...)";
         } else {
            nat += a2;
         }
         nat += " ";
         if( b2.length() > 15 ) {
            nat += b2.substr(0, 15) + "(...)";
         } else {
            nat += b2;
         }
         nat += " " + c;
         
         string slu = a + " " + b + " " + c;

         printf( "Program je ispisao %s, a tocno je %s!\n", nat.c_str(), slu.c_str() );
         return 1;         
      }
   }

   printf( "Tocno rjesenje!\n" );
   return 0;
}
