/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  2. dan natjecanja
  Zadatak KARTA
*/

#include <cctype>
#include <cstdio>
#include <queue>

#define MAX 50

using namespace std;

int R, S;
char a[MAX][MAX+1];
int b[MAX][MAX];

int n;
int r[MAX*MAX], s[MAX*MAX], tip[MAX*MAX];
int par[MAX*MAX];
vector<int> adj[MAX*MAX];
int degree[MAX*MAX];

int main( void ) {
   scanf( "%d%d", &R, &S );
   for( int i = 0; i < R; ++i ) {
      scanf( "%s", a[i] );
      for( int j = 0; j < S; ++j ) {
         if( a[i][j] == '.' ) {
            b[i][j] = -1; 
         } else {
            r[n] = i; s[n] = j; tip[n] = isupper(a[i][j]);
            b[i][j] = n++;
            if( isupper(a[i][j]) ) 
               for( ; j+1 < S && isupper(a[i][j+1]); ++j )
                  b[i][j+1] = b[i][j];
         }
      }
   }

   for( int i = 0; i < n; ++i ) {
      par[i] = -1;
      if( tip[i] ) continue;
      for( int dr = -1; dr <= 1; ++dr ) 
         for( int ds = -1; ds <= 1; ++ds ) {
            int rr = r[i] + dr;
            int ss = s[i] + ds;
            if( rr < 0 || rr >= R ) continue;
            if( ss < 0 || ss >= S ) continue;
            if( b[rr][ss] == -1 ) continue;
            if( !tip[b[rr][ss]] ) continue;
            if( ds != -1 && b[rr][ss] == b[rr][ss-1] ) continue;
            adj[b[r[i]][s[i]]].push_back( b[rr][ss] ); ++degree[b[r[i]][s[i]]];
            adj[b[rr][ss]].push_back( b[r[i]][s[i]] ); ++degree[b[rr][ss]];
         }
   }

   queue<int> solo;
   for( int i = 0; i < n; ++i ) 
      if( degree[i] == 1 )
         solo.push( i );

   for( ; !solo.empty(); solo.pop() ) {
      int x = solo.front(), y; 
      
      if( par[x] != -1 ) continue;
      
      for( vector<int>::iterator it = adj[x].begin(); it != adj[x].end(); ++it ) 
         if( par[*it] == -1 )
            y = *it;

      par[x] = y;
      par[y] = x;

      for( vector<int>::iterator it = adj[y].begin(); it != adj[y].end(); ++it ) 
         if( par[*it] == -1 ) 
            if( --degree[*it] == 1 ) 
               solo.push( *it );
   }

   for( int i = 0; i < n; ++i ) 
      if( !tip[i] ) {
         printf( "%d %d ", r[i]+1, s[i]+1 );
         for( int rr = r[par[i]], ss = s[par[i]]; ss < S && isupper(a[rr][ss]); ++ss )
            printf( "%c", a[rr][ss] );
         printf( "\n" );
      }
   

   return 0;
}
