/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  2. dan natjecanja
  Zadatak SLIKA
*/

#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

char slika[1000][1001];
int MAX[2][1000][10]; // dimenzije dobrih kvadrata

int main ( void )
{
	int N, K;
	cin >> N >> K;
	for (int r = 0; r < N; r++)
	{
		scanf ("%s", slika[r]);
		for (int s = 0; s < N; s++)
			if (slika[r][s] == '.')
				slika[r][s] = '0';
	}

	// za svaku boju odreujemo najljeviji, najdesniji, najdonji i najgornji pixel te boje
	vector<int> minR(K+1, N+1), maxR(K+1, -1), minS(K+1, N+1), maxS(K+1, -1);
	for (int r = 0; r < N; r++)
		for (int s = 0; s < N; s++)
		{
			if (r < minR[slika[r][s]-'0']) minR[slika[r][s]-'0'] = r;
			if (r > maxR[slika[r][s]-'0']) maxR[slika[r][s]-'0'] = r;
			if (s < minS[slika[r][s]-'0']) minS[slika[r][s]-'0'] = s;
			if (s > maxS[slika[r][s]-'0']) maxS[slika[r][s]-'0'] = s;
		}

	// dinamika za "dobre kvadrate"
	int tren = 1, preth = 0;
	vector<int> maxZ (K+1, 0);
	for (int r = 0; r < N; r++)
	{
		tren = !tren; // trenutni redak (r)
		preth = !preth; // prethodni redak (r-1)

		for (int s = 0; s < N; s++)
			for (int z = 1; z <= K; z++)
			{
				if (s == 0) // poseban slucaj: prvi stupac u redu
				{
					if (z <= slika[r][s]-'0')
						MAX[tren][0][z] = 1;
					else
						MAX[tren][0][z] = 0;
				}
				else // rekurzivna formula
				{
					if (z <= slika[r][s]-'0')
						MAX[tren][s][z] = 1 + min(min(MAX[tren][s-1][z], MAX[preth][s-1][z]), MAX[preth][s][z]);
					else
						MAX[tren][s][z] = 0;
				}

				// da li je ovaj "dobri kvadrat" najvei dosad?
				// da li se unutar njega nalaze sve znamenke z?
				if 
				(
					r - MAX[tren][s][z] + 1 <= minR[z] && maxR[z] <= r &&
					s - MAX[tren][s][z] + 1 <= minS[z] && maxS[z] <= s &&
					maxZ[z] < MAX[tren][s][z]
				)
					maxZ[z] = MAX[tren][s][z];
			}
	}

	// ispis
	for (int z = 1; z <= K; z++)
		if (maxR[z] == -1) // nema nijedne znamenke z?
			cout << "1 " << maxZ[z] << endl;
		else
			cout << max(maxR[z]-minR[z]+1, maxS[z]-minS[z]+1) << " " << maxZ[z] << endl;

	return 0;
}
