/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  1. dan natjecanja
  Zadatak KOLICA
*/

#include <cstdio>
#include <cstring>
#include <cstdlib>

using namespace std;

#define MAX 500

const int inf = 1000000000;

char smjer[10];
int n;
int x[MAX], y[MAX], d[MAX];
enum Stanje { Ziv, Mrtav, Umire } stanje[MAX];

const int dx[4] = { -1, 0, 1, 0 };
const int dy[4] = { 0, 1, 0, -1 }; 

int dist( int x1, int y1, int x2, int y2 ) {
   return abs(x1-x2) + abs(y1-y2);
}

int calc_delta() {
   int ret = inf;
   for( int i = 0; i < n; ++i ) {
      if( stanje[i] == Mrtav ) continue;
      for( int j = i+1; j < n; ++j ) {
         if( stanje[j] == Mrtav ) continue;
         
         if( dist( x[i], y[i], x[j], y[j] ) <= dist( x[i]+dx[d[i]], y[i]+dy[d[i]], x[j]+dx[d[j]], y[j]+dy[d[j]] ) ) continue;

         if( x[i] == x[j] || y[i] == y[j] ) ret <?= dist( x[i], y[i], x[j], y[j] ) / 2;
         if( abs(x[i]-x[j]) == abs(y[i]-y[j]) ) ret <?= abs(x[i]-x[j]);
      }
   }
   return ret;
}

void pomakni( int t ) {
   for( int i = 0; i < n; ++i ) {
      x[i] += dx[d[i]]*t;
      y[i] += dy[d[i]]*t;
   }
}

void sudari() {
   for( int i = 0; i < n; ++i ) {
      if( stanje[i] == Mrtav ) continue;
      for( int j = i+1; j < n; ++j ) {
         if( stanje[j] == Mrtav ) continue;
         
         if( x[i] == x[j] && y[i] == y[j] ) {
            stanje[i] = Umire;
            stanje[j] = Umire;
         }
      }
   }

   for( int i = 0; i < n; ++i ) 
      if( stanje[i] == Umire )
         stanje[i] = Mrtav;
}

int main( void ) {
   scanf( "%d", &n );
   for( int i = 0; i < n; ++i ) {
      scanf( "%d%d%s", &x[i], &y[i], smjer ); 
      if( !strcmp( smjer, "lijevo" ) ) d[i] = 0;
      if( !strcmp( smjer, "gore" ) ) d[i] = 1;
      if( !strcmp( smjer, "desno" ) ) d[i] = 2;
      if( !strcmp( smjer, "dolje" ) ) d[i] = 3;
      x[i] *= 2;
      y[i] *= 2;
   }

   for( ;; ) {
      int delta = calc_delta();
      if( delta == inf ) break;

      pomakni( delta );
      sudari();
   }

   int nema = 1;
   for( int i = 0; i < n; ++i ) {
      if( stanje[i] == Ziv ) {
         nema = 0;
         printf( "%d\n", i+1 );
      }
   }
   if( nema ) printf( "nema\n" );

   return 0;
}
