(*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  1. dan natjecanja
  Zadatak KOLICA
*)

program kolica;

type
   stanje_tip = (ZIV, MRTAV, UMIRE);

const
   MAX                          = 500;
   INF                          = 1000000000;
   dx  : array[1..4] of longint = (-1, 0, 1, 0);
   dy  : array[1..4] of longint = (0, 1, 0, -1);

var
   smjer    : string;
   n        : longint;
   x, y, d  : array[1..MAX] of longint;
   stanje   : array[1..MAX] of stanje_tip;
   delta, i : longint;
   nema     : boolean;

function dist(x1, y1, x2, y2 : longint):longint;
begin
   dist := abs(x1-x2) + abs(y1-y2);
end;

function min(a, b : longint):longint;
begin
   if a < b then min := a else min := b;
end;

function calc_delta:longint;
var
   i, j, ret : longint;
begin
   ret := INF;
   for i:=1 to n do begin
      if stanje[i] = MRTAV then continue;

      for j:=i+1 to n do begin
         if stanje[j] = MRTAV then continue;

         if dist(x[i], y[i], x[j], y[j]) <= dist(x[i]+dx[d[i]], y[i]+dy[d[i]], x[j]+dx[d[j]], y[j]+dy[d[j]]) then
            continue;

         if (x[i] = x[j]) or (y[i] = y[j]) then
            ret := min(ret, dist(x[i], y[i], x[j], y[j]) div 2);
         if abs(x[i]-x[j]) = abs(y[i]-y[j]) then
            ret := min(ret, abs(x[i]-x[j]));
      end;
   end;
   calc_delta := ret;
end;

procedure pomakni(t : longint);
begin
   for i:=1 to n do begin
      x[i] := x[i] + t*dx[d[i]];
      y[i] := y[i] + t*dy[d[i]];
   end;
end;

procedure sudari;
var i, j : longint;
begin
   for i:=1 to n do begin
      if stanje[i] = MRTAV then continue;

      for j:=i+1 to n do begin
         if stanje[j] = MRTAV then continue;

         if (x[i] = x[j]) and (y[i] = y[j]) then begin
            stanje[i] := UMIRE;
            stanje[j] := UMIRE;
         end;
      end;
   end;

   for i:=1 to n do begin
      if stanje[i] = UMIRE then
         stanje[i] := MRTAV;
   end;
end;

begin
   readln(n);
   for i:=1 to n do begin
      readln(x[i], y[i], smjer);
      if smjer = ' lijevo' then d[i] := 1
      else if smjer = ' gore' then d[i] := 2
      else if smjer = ' desno' then d[i] := 3
      else if smjer = ' dolje' then d[i] := 4;
      x[i] := x[i]*2;
      y[i] := y[i]*2;
      stanje[i] := ZIV;
   end;

   while true do begin
      delta := calc_delta();
      if delta = INF then break;

      pomakni(delta);
      sudari();
   end;

   nema := true;
   for i:=1 to n do begin
      if stanje[i] = ZIV then begin
         nema := false;
         writeln(i);
      end;
   end;
   if nema then writeln('nema');
end.
