/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  2. dan natjecanja
  Zadatak BINGO
*/

#include <algorithm>
#include <cstdio>
using namespace std;

#define MAXN  4
#define MAXN2 (MAXN*MAXN)
#define MAXD  10000

int n;                   // Dimenzija kartice
int memo[1<<MAXN2];      // Najveci broj bodova ako su bitmaskom
                         // reprezentirani vec postavljeni brojevi
int valskup[1<<MAXN2];   // Koliko vrijedi N brojeva u bitmaski
                         // koje odlucimo staviti u jedan red

void biraj_n( const int *begin, const int *end, int koliko, int mask, int **kamo )
{
   // Bira 'koliko' elemenata iz [begin, end) na sve moguce nacine i
   // stavlja u niz na koji pokazuje 'kamo'
   if ( koliko == 0 ) {
      **kamo = mask;
      (*kamo)++;
      return;
   }
   
   for ( const int *it=begin; it!=end; ++it ) {
      // Izabiremo element *it, jos koliko-1
      biraj_n( it+1, end, koliko-1, mask|(1<<*it), kamo );
   }
}

int rek( int dubina,            // Koji red postavljamo
         int mask               // Koji brojevi su vec iskoristeni
         )
{
   if ( dubina == n ) {
      // Dosli smo do kraja, ne mozemo vise dobiti bodova
      return 0;
   }
   if ( memo[mask] != -1 ) {
      // U ovom stanju smo vec bili i znamo rezultat
      return memo[mask];
   }
   int &ret = memo[mask];
   ret = 0;

   // Jedan element je siguran, ovaj cudan izraz bira najnizi bit u
   // 'mask' koji je u jedinici. Npr za mask=12 vraca 4.
   int siguran = ~mask & -~mask;

   // Osim njega, u trenutni red smiju ici svi elementi koji vec nisu
   // postavljeni (sto nam govori bitmaska 'mask'); stavljamo ih u niz
   // 'smiju'
   int smiju[MAXN2], *end = smiju;
   for ( int i=0; i<n*n; ++i )
      if ( (1<<i) != siguran && (~mask & (1<<i)) )
         *(end++) = i;

   // Od tih koji 'smiju', izaberi n-1 element na sve moguce nacine i
   // odgovarajuce bitmaske stavi u niz 'podskupovi'
   int podskupovi[1000], *kraj = podskupovi;
   biraj_n( smiju, end, n-1, 0, &kraj );

   // Probaj svaki podskup (skupa sa elementom 'siguran') staviti u
   // trenutni red i vidi koliko se isplati
   for ( const int *p=podskupovi; p<kraj; ++p ) {
      ret = max( ret, valskup[ *p+siguran ] + rek( dubina+1, mask+*p+siguran ) );
   }
   return ret;
}

int main()
{
   int d;
   static int niz[MAXD];

   scanf( "%d%d", &n, &d );
   for ( int i=0; i<d; ++i ) {
      scanf( "%d", &niz[i] );
      --niz[i];
   }

   // tmpval = vrijednost svake varijacije od N brojeva (poredak bitan)
   // valskup = vrijednost svake kombinacije od N brojeva (najbolje od svih varijacija)
   static int tmpval[MAXN2*MAXN2*MAXN2*MAXN2]; 
   for ( int i=n-1; i<d; ++i ) {
      int h = 0;
      int mask = 0;
      for ( int j=i-(n-1); j<=i; ++j ) {
         h = n*n*h + niz[j];
         mask |= 1<<niz[j];
      }
      valskup[mask] = max( valskup[mask], ++tmpval[h] );
   }

   memset( memo, -1, sizeof memo );
   printf( "%d\n", rek(0, 0) );

   return 0;
}
