(*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  2. dan natjecanja
  Zadatak BINGO
*)

program bingo;

const
   MAXN  = 4;
   MAXN2 = MAXN*MAXN;
   MAXD  = 10000;

var
   (* Dimenzija kartice *)
   n       : longint;
   (* Najveci broj bodova ako su bitmaskom reprezentirani vec postavljeni brojevi *)
   memo    : array[0..1 shl MAXN2] of longint;
   (* Koliko vrijedi N brojeva u bitmaski koje odlucimo staviti u jedan red *)
   valskup : array[0..1 shl MAXN2] of longint;

procedure biraj_n(var arr                        : array of longint;
                      ibegin, iend, koliko, mask : longint;
                  var kamo                       : array of longint;
                  var kolikogenerirao            : longint );
var i : longint;
begin
   (* Bira 'koliko' elemenata iz arr[begin..end] na sve moguce nacine i
    * stavlja u niz na koji pokazuje 'kamo' *)

   if koliko = 0 then begin
      kamo[kolikogenerirao] := mask;
      kolikogenerirao := kolikogenerirao + 1;
      exit;
   end;

   for i := ibegin to iend do begin
      biraj_n(arr, i+1, iend, koliko-1, mask or (1 shl arr[i]), kamo, kolikogenerirao);
   end;
end;

function rek(dubina,        (* Koji red postavljamo *)
             mask : longint (* Koji brojevi su vec iskoristeni *)
             )    : longint;
var
   ret, x, siguran, i : longint;
   smiju              : array[0..MAXN2] of longint;
   kolikosmiju        : longint;
   podskupovi         : array[0..1000] of longint;
   kolikopodskup      : longint;
begin
   if dubina = n then begin
      (* Dosli smo do kraja, ne mozemo vise dobiti bodova *)
      rek := 0;
      exit;
   end;

   if memo[mask] <> -1 then begin
      (* U ovom stanju smo vec bili i znamo rezultat *)
      rek := memo[mask];
      exit;
   end;

   ret := 0;

   (* Jedan element je siguran, ovaj cudan izraz bira najnizi bit u
    * 'mask' koji je u jedinici. Npr za mask=12 vraca 4. *)
   siguran := (not mask) and -(not mask);

   (* Osim njega, u trenutni red smiju ici svi elementi koji vec nisu
    * postavljeni (sto nam govori bitmaska 'mask'); stavljamo ih u niz
    * 'smiju' *)
   kolikosmiju := 0;
   for i:=0 to n*n-1 do
      if ((1 shl i) <> siguran) and ((mask and (1 shl i)) = 0) then begin
         smiju[kolikosmiju] := i;
         kolikosmiju := kolikosmiju + 1;
      end;

   (* Od tih koji 'smiju', izaberi n-1 element na sve moguce nacine i
    * odgovarajuce bitmaske stavi u niz 'podskupovi' *)
   kolikopodskup := 0;
   biraj_n(smiju, 0, kolikosmiju-1, n-1, 0, podskupovi, kolikopodskup);

   (* Probaj svaki podskup (skupa sa elementom 'siguran') staviti u
    * trenutni red i vidi koliko se isplati *)
   for i:=0 to kolikopodskup-1 do begin
      x := valskup[ podskupovi[i]+siguran ] + rek( dubina+1, mask+podskupovi[i]+siguran );
      if x > ret then ret := x;
   end;

   memo[mask] := ret;
   rek := ret;
end;

var
   d             : longint;
   niz           : array[1..MAXD] of longint;
   i, j, h, mask : longint;
   tmpval        : array[0..MAXN2*MAXN2*MAXN2*MAXN2] of longint;

begin
   readln(n, d);
   for i:=1 to d do begin
      readln(niz[i]);
      niz[i] := niz[i]-1;
   end;
   
   (* tmpval = vrijednost svake varijacije od N brojeva (poredak bitan)
    * valskup = vrijednost svake kombinacije od N brojeva (najbolje od svih varijacija) *)

   for i:=n to d do begin
      h := 0;
      mask := 0;
      for j:=i-n+1 to i do begin
         h := n*n*h + niz[j];
         mask := mask or (1 shl niz[j]);
      end;
      tmpval[h] := tmpval[h] + 1;
      if tmpval[h] > valskup[mask] then
         valskup[mask] := tmpval[h];
   end;

   for i:=0 to (1 shl MAXN2) do
      memo[i] := -1;
   writeln( rek(0, 0) );
end.
