/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  2. dan natjecanja
  Zadatak LIJEN
*/

#include <cstdio>

const int inf = 1000000000;
struct rijec { int duljina, binarniZapis; };

int brojJedinica[4096];
int vrijeme[13][4096];

int N, L;
rijec rjecnik[2000], p;
char buff[13];

int main ( void )
{
	for (int i = 0; i < 4096; ++i)
		if (i % 2 == 1)
			brojJedinica[i] = 1 + brojJedinica[i/2];
		else
			brojJedinica[i] = brojJedinica[i/2];

	scanf ("%d", &N);

	// ucitavanje i spremanje rijeci u rjecnik
	for (int i = 0; i < N; ++i)
	{
		scanf ("%s", buff);
		for (p.duljina = p.binarniZapis = 0; buff[p.duljina] != '\0'; ++p.duljina)
			if (buff[p.duljina] == '.')
				p.binarniZapis = 2 * p.binarniZapis;
			else
				p.binarniZapis = 2 * p.binarniZapis + 1;

		vrijeme[p.duljina][p.binarniZapis] = inf;
		rjecnik[i] = p;
	}

	// gledamo sve moguce rijeci p (tj. njihove bin.zapise) duljine <=12 znakova
	for (p.duljina = 1; p.duljina <= 12; ++p.duljina)
		for (p.binarniZapis = 0; p.binarniZapis < (1<<p.duljina); ++p.binarniZapis)
		{
			// cijena samo rijeci p
			int cost = p.duljina + brojJedinica[p.binarniZapis];

			int best_razlika = inf, best_koji = -1, best_koliko = 0;
			for (int i = 0; i < N; ++i) // gledamo sve rijeci iz rjecnika
			{
				if (p.duljina != rjecnik[i].duljina) continue;

				// u koliko se bin. znamenki razlikuje rjecnik[i] od p?
				int razlika = brojJedinica[p.binarniZapis ^ rjecnik[i].binarniZapis]; // xor
				if (razlika < best_razlika)
				{
					best_razlika = razlika;
					best_koji = i;
					best_koliko = 1;
				}
				else if (razlika == best_razlika)
					++best_koliko; // koliko ima rijeci koje se razlikuju u tocno toliko bin.znamenki
			}

			// moze li se p jednoznacno dekodirati u neku rijec iz rjecnika i je li p najbolja dosad za tu rijec?
			if (best_koliko == 1 && cost < vrijeme[rjecnik[best_koji].duljina][rjecnik[best_koji].binarniZapis])
				vrijeme[rjecnik[best_koji].duljina][rjecnik[best_koji].binarniZapis] = cost;
		}

	// duljina trajanja slanja poruke = suma duljine trajanja slanja svake njezine rijeci
	int rjesenje = 0;
	scanf ("%d", &L);
	for (int i = 0; i < L; ++i)
	{
		scanf ("%s", buff);

		for (p.duljina = p.binarniZapis = 0; buff[p.duljina] != '\0'; ++p.duljina)
			if (buff[p.duljina] == '.')
				p.binarniZapis = 2 * p.binarniZapis;
			else
				p.binarniZapis = 2 * p.binarniZapis + 1;

		rjesenje += vrijeme[p.duljina][p.binarniZapis];
	}

	printf ("%d\n", rjesenje);

	return 0;
}
