#include <cmath>
#include <cstdio>

#define MAX 100000

char tipka[MAX+1];

const int dx[8] = { 0, -1, -1, -1, 0, 1, 1, 1 };
const int dy[8] = { 1, 1, 0, -1, -1, -1, 0, 1 }; 

struct tocka { int x, y; };

double dist( const tocka &A, const tocka &B ) {
   return sqrt( (double)(A.x-B.x)*(A.x-B.x) + (double)(A.y-B.y)*(A.y-B.y) );
}

struct histogram {
   int koliko[8];

   tocka zbroji_vektore( tocka pocetna ) {
      tocka T = pocetna;
      for( int i = 0; i < 8; ++i ) {
         T.x += koliko[i] * dx[i];
         T.y += koliko[i] * dy[i];
      }
      return T;
   }
};

histogram operator + ( const histogram &A, const histogram &B ) {
   histogram C;
   for( int i = 0; i < 8; ++i ) C.koliko[i] = A.koliko[i] + B.koliko[i];
   return C;
}

histogram operator * ( const histogram &A, int K ) {
   histogram C;
   for( int i = 0; i < 8; ++i ) C.koliko[(i+K)%8] = A.koliko[i];
   return C;
}

int n;
tocka majmun, banana;
histogram prefix[MAX+1];
histogram suffix[MAX+1];
histogram nula, sjever;

int main( void ) {
   scanf( "%d%d%d%d", &majmun.x, &majmun.y, &banana.x, &banana.y );
   scanf( "%d ", &n );
   gets( tipka );
   for( int i = 0; i < n; ++i ) tipka[i] -= '0';

   for( int i = 0; i < 8; ++i ) nula.koliko[i] = 0;
   sjever = nula; 
   sjever.koliko[0] = 1;
   prefix[0] = nula; 
   suffix[n] = nula;

   histogram kamo = sjever;
   for( int i = 0; i < n; ++i ) prefix[i+1] = prefix[i] + (kamo = kamo * tipka[i]);
   for( int i = n-1; i >= 0; --i ) suffix[i] = (sjever + suffix[i+1]) * tipka[i];

   double ret = 1e10;
   for( int i = 0; i < n; ++i ) 
      for( int smjer = 0; smjer < 8; ++smjer ) 
         ret <?= dist( banana, (prefix[i] + (sjever + suffix[i+1]) * smjer).zbroji_vektore( majmun ) );

   printf( "%.10lf\n", ret );

   return 0;
}
