program majmun;

type
   tocka = record
      x, y : longint;
   end;
   histogram = array[0..7] of longint;  
  
var
   n : longint;
   tipka : array[1..100000] of integer;
   znak : char;
   monkey, banana, t : tocka;
   prefix : array[0..100000] of histogram;
   suffix : array[0..100000] of histogram;
   nula, sjever, kamo : histogram;
   i, smjer : longint;
   d, ret : real;

const dx : array[0..7] of integer = ( 0, -1, -1, -1, 0, 1, 1, 1 );
const dy : array[0..7] of integer = ( 1, 1, 0, -1, -1, -1, 0, 1 );

function dist( A, B : tocka ) : real;
begin
   dist := sqrt( real(A.x-B.x)*real(A.x-B.x) + real(A.y-B.y)*real(A.y-B.y) );
end;

function hodaj( pocetna : tocka; koliko : histogram ) : tocka;
var
   i : longint;
begin   
   hodaj := pocetna;
   for i := 0 to 7 do begin
      hodaj.x := hodaj.x + koliko[i] * dx[i];
      hodaj.y := hodaj.y + koliko[i] * dy[i];
   end;
end;

function zbroji( A, B : histogram ) : histogram;
var
   i : longint;
begin
   for i := 0 to 7 do zbroji[i] := A[i] + B[i];
end;

function rotiraj( A : histogram; K : longint ) : histogram;
var
   i : longint;
begin
   for i := 0 to 7 do rotiraj[(i+K) mod 8] := A[i];
end;

begin
   readln( monkey.x, monkey.y, banana.x, banana.y );
   readln( n );
   for i := 1 to n do begin
      read( znak );
      tipka[i] := ord( znak ) - ord( '0' );
   end;
   readln;   

   for i := 0 to 7 do nula[i] := 0;
   sjever := nula; 
   sjever[0] := 1;
   prefix[0] := nula; 
   suffix[n] := nula;

   kamo := sjever;
   for i := 1 to n do begin
      kamo := rotiraj( kamo, tipka[i] );
      prefix[i] := zbroji( prefix[i-1], kamo );
   end;
   for i := n downto 1 do begin
      suffix[i-1] := rotiraj( zbroji(sjever, suffix[i]), tipka[i] );
   end;

   ret := 1000000000;
   for i := 1 to n do
      for smjer := 0 to 7 do begin
         d := dist( banana, hodaj( monkey, zbroji( prefix[i-1], rotiraj( zbroji(sjever, suffix[i]), smjer ) ) ) );
         if d < ret then ret := d;
      end;

   writeln( ret:6:6 );
end.
