#include <algorithm>
#include <cstdio>
#include <set>

using namespace std;

#define MAXN 100000

int n;
struct daska {
   int active;
   int x1, x2, y;
   void load() {
      scanf( "%d%d%d", &x1, &x2, &y );
      x2 += x1;
      active = 0;
   }
} a[MAXN];

struct cmp {
   bool operator () ( daska *A, daska *B ) {
      if( A->y != B->y ) return A->y > B->y;
      if( A->x2 != B->x2 ) return A->x2 > B->x2;
      return A->x1 < B->x1;
   }
} CMP;

struct event {
   int x, tip;
   daska *d;
} E[2*MAXN];
bool operator < ( const event &A, const event &B ) {
   if( A.x != B.x ) return A.x < B.x;
   if( A.tip != B.tip ) return A.tip > B.tip;
   return CMP( A.d, B.d );
} 

int main( void ) {
   scanf( "%d", &n );
   for( int i = 0; i < n; ++i ) {
      a[i].load();

      E[2*i+0].x = a[i].x1; E[2*i+0].tip =  1; E[2*i+0].d = &a[i];
      E[2*i+1].x = a[i].x2; E[2*i+1].tip = -1; E[2*i+1].d = &a[i];
   }

   sort( E, E+2*n );
   
   set<daska *, cmp> vidljivi, nevidljivi;
   for( event *e = E, *f; e < E+2*n; e = f ) {
      for( f = e; f < E+2*n && f->x == e->x; ++f ) {
         if( f->tip == -1 ) {
            if( f->d->active ) vidljivi.erase( f->d );
            else nevidljivi.erase( f->d );
         } else {
            nevidljivi.insert( f->d );         
         }      
      }

      if( nevidljivi.empty() ) continue;
      if( !vidljivi.empty() && (*vidljivi.begin())->y >= (*nevidljivi.begin())->y ) continue;
      
      (*nevidljivi.begin())->active = 1;
      vidljivi.insert( *nevidljivi.begin() );
      nevidljivi.erase( nevidljivi.begin() );
   }

   int ret = 0;
   for( int i = 0; i < n; ++i ) ret += a[i].active;
   printf( "%d\n", ret );
   for( int i = 0; i < n; ++i ) if( a[i].active ) printf( "%d ", i+1 );
   printf( "\n" );

   return 0;
}
