program dvapravca;

const MAXN = 2000;

type CompareFunction = function(pa, pb : Pointer) : integer;

procedure swap(var a, b : pointer); var t : pointer; begin t := a; a := b; b := t; end;
procedure swap(var a, b : longint); var t : longint; begin t := a; a := b; b := t; end;

procedure qsort(var arr : array of Pointer; l, r: longint; cmp : CompareFunction);
var x, y : longint;
    mid  : pointer;
begin
    if r-l < 2 then exit;
    if r-l = 2 then begin
        if cmp(arr[l+1], arr[l]) < 0 then swap(arr[l], arr[l+1]);
        exit;
    end;

    mid := arr[(l+r) div 2];
    y := l;

    for x:=l to r-1 do  (* sve strogo manje stavi na pocetak *)
        if cmp( arr[x], mid) < 0 then begin
            swap(arr[x], arr[y]);
            inc(y);
        end;

    qsort(arr, l, y, cmp); (* sortiraj sve strogo manje *)

    for x:=y to r-1 do (* sve jednake stavi poslije ovih manjih *)
        if cmp(arr[x], mid) = 0 then begin
            swap(arr[x], arr[y]);
            inc(y);
        end;

    qsort(arr, y, r, cmp); (* sortiraj sve strogo vece *)
end;
                
type
   PPoint = ^Point;
   Point  = 
   record 
      x, y, pos : longint;
      color     : char;
   end;         

type
   PSegment = ^Segment;
   Segment  =
   record
      A, B   : PPoint;
      dx, dy : longint;
   end;

type node =
   record
      left, right, best : longint;
      full              : boolean;
   end;

function cmp_point(pa, pb : Pointer) : integer;
var
   a, b : Point;
begin
   a := PPoint(pa)^; b := PPoint(pb)^;
   if      a.x < b.x then cmp_point := -1
   else if a.x > b.x then cmp_point := 1
   else if a.y < b.y then cmp_point := -1
   else if a.y > b.y then cmp_point := 1
   else cmp_point := 0;
end;

function cmp_segment(pa, pb : Pointer) : integer;
var
   a, b           : Segment;
   cross1, cross2 : int64;
begin
   a := PSegment(pa)^; b := PSegment(pb)^;
   cross1 := int64(a.dy)*b.dx;
   cross2 := int64(a.dx)*b.dy;
   if      cross1 < cross2 then cmp_segment := -1
   else if cross1 > cross2 then cmp_segment := 1
   else cmp_segment := 0;
end;

procedure conditional_set(var kamo : longint; uvjet : boolean; a, b : longint);
begin if uvjet then kamo := a else kamo := b; end;

function max(a, b : longint) : longint;
begin if a >= b then max := a else max := b; end;

var
   P, Ptmp         : array[1..MAXN] of Point;
   S, Stmp         : array[1..MAXN*MAXN div 2] of Segment;
   ptr             : array[1..MAXN*MAXN div 2] of pointer;
   tree            : array[0..(1 shl 13)] of node;
   n, m, i, j, ret : longint;
   sp              : char;
   seg             : Segment;

procedure tree_update(i, lo, hi, x : longint; val : boolean);
var intnotval : longint;
begin
   if (x < lo) or (x >= hi) then exit;
   if hi-lo = 1 then begin
      if val then intnotval := 0 else intnotval := 1;
      tree[i].left  := intnotval;
      tree[i].right := intnotval;
      tree[i].best  := intnotval;
      tree[i].full  := not val;
   end else begin
      tree_update(2*i, lo, (lo+hi) div 2, x, val);
      tree_update(2*i+1, (lo+hi) div 2, hi, x, val);

      tree[i].full := tree[2*i].full and tree[2*i+1].full;
      conditional_set(tree[i].left, tree[2*i].full, tree[2*i].left + tree[2*i+1].left, tree[2*i].left);
      conditional_set(tree[i].right, tree[2*i+1].full, tree[2*i+1].right + tree[2*i].right, tree[2*i+1].right);
      tree[i].best := max(tree[2*i].right + tree[2*i+1].left, max(tree[2*i].best, tree[2*i+1].best));
   end;
end;

begin
   m := 0;
   read(n);
   for i:=1 to n do read(P[i].x, P[i].y, sp, P[i].color);

   for i:=1 to n do begin Ptmp[i] := P[i]; ptr[i] := @Ptmp[i]; end;
   qsort(ptr, 0, n, @cmp_point);
   for i:=1 to n do P[i] := PPoint(ptr[i])^;

   for i:=1 to n do begin
      P[i].pos := i;
      tree_update(1, 1, n+1, i, P[i].color = 'B');
   end;

   for i:=1 to n do
      for j:=i+1 to n do begin
         seg.A := @P[i];
         seg.B := @P[j];
         seg.dx := P[j].x - P[i].x;
         seg.dy := P[j].y - P[i].y;
         inc(m);
         S[m] := seg;
      end;

   for i:=1 to m do begin Stmp[i] := S[i]; ptr[i] := @Stmp[i]; end;
   qsort(ptr, 0, m, @cmp_segment);
   for i:=1 to m do S[i] := PSegment(ptr[i])^;

   ret := tree[1].best;

   i := 1;
   while i <= m do begin
      j := i;
      while (j <= m) and (cmp_segment(@S[i], @S[j]) >= 0) do begin
         swap(S[j].A^.pos, S[j].B^.pos);
         tree_update(1, 1, n+1, S[j].A^.pos, S[j].A^.color = 'B');
         tree_update(1, 1, n+1, S[j].B^.pos, S[j].B^.color = 'B');
         inc(j);
      end;
      ret := max(ret, tree[1].best);
      i := j;
   end;
   writeln(ret);
end.
