#include <iostream>
using namespace std;

const int MAXN = 1000;
int N;
int x1[MAXN+1], y1[MAXN+1], x2[MAXN+1], y2[MAXN+1];
bool bio[MAXN+1];

bool sijeku_se(int r1, int r2) {
   return
      max(x1[r1], x1[r2]) <= min(x2[r1], x2[r2]) &&
      max(y1[r1], y1[r2]) <= min(y2[r1], y2[r2]);
}

bool strogo_unutar(int r1, int r2) {
   return
      x1[r1] > x1[r2] && x2[r1] < x2[r2] &&
      y1[r1] > y1[r2] && y2[r1] < y2[r2];
}

bool mogu_odjednom(int r1, int r2) {
   return sijeku_se(r1, r2) && !strogo_unutar(r1, r2) && !strogo_unutar(r2, r1);
}

void dfs(int a) {
   if ( bio[a] ) return;
   bio[a] = 1;

   for ( int b=0; b<N; ++b ) {
      if ( mogu_odjednom(a, b) ) {
         dfs(b);
      }
   }
}

int main() {
   cin >> N;
   for ( int i=0; i<N; ++i ) {
      cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
   }

   // Dodaj lazni pravokutnik (0, 0)-(0, 0).
   x1[N] = y1[N] = x2[N] = y2[N] = 0;
   ++N;

   int komponenata = 0;
   for ( int i=0; i<N; ++i ) {
      if ( !bio[i] ) {
         dfs(i);
         ++komponenata;
      }
   }
   cout << komponenata-1 << endl;

   return 0;
}
