program logo;

const MAXN = 1000;

var
   N, i, komponenata : longint;
   x1, y1, x2, y2    : array[1..MAXN+1] of longint;
   bio               : array[1..MAXN+1] of boolean;

function max(a, b : longint) : longint; begin if a >= b then max := a else max := b; end;
function min(a, b : longint) : longint; begin if a <= b then min := a else min := b; end;

function sijeku_se(r1, r2 : longint) : boolean;
begin
   sijeku_se :=
      (max(x1[r1], x1[r2]) <= min(x2[r1], x2[r2])) and
      (max(y1[r1], y1[r2]) <= min(y2[r1], y2[r2]));
end;

function strogo_unutar(r1, r2 : longint) : boolean;
begin
   strogo_unutar :=
      (x1[r1] > x1[r2]) and (x2[r1] < x2[r2]) and
      (y1[r1] > y1[r2]) and (y2[r1] < y2[r2]);
end;

function mogu_odjednom(r1, r2 : longint) : boolean;
begin
   mogu_odjednom :=
      sijeku_se(r1, r2) and
      not strogo_unutar(r1, r2) and
      not strogo_unutar(r2, r1);
end;

procedure dfs(a : longint);
var b : integer;
begin
   if bio[a] then exit;
   bio[a] := true;

   for b:=1 to N do
      if mogu_odjednom(a, b) then
         dfs(b);
end;

begin
   read(N);
   for i:=1 to N do
      read(x1[i], y1[i], x2[i], y2[i]);

   (* Dodaj lazni pravokutnik (0, 0)-(0, 0). *)
   N := N+1;
   x1[N] := 0; y1[N] := 0; x2[N] := 0; y2[N] := 0;

   komponenata := 0;
   for i:=1 to N do begin
      if not bio[i] then begin
         dfs(i);
         komponenata := komponenata + 1;
      end;
   end;

   writeln(komponenata-1);
end.
