#include <algorithm>
#include <cstdio>
#include <cstring>

#define MAX 1501

using namespace std;

const int oo = 1000000000;

int R, S;
int memo[MAX][MAX];
int sum_apples[MAX][MAX];
int sum_bananas[MAX][MAX];

int rec( int r, int s ) {
   if( r > R ) return -oo;
   if( s > S ) return -oo;
   if( r == R && s == S ) return 0;

   int &ret = memo[r][s];
   if( ret != -1 ) return ret;
   
   ret = 0;
   ret = max( ret, rec( r, s+1 ) + sum_bananas[r-1][s+1] );
   ret = max( ret, rec( r+1, s ) + sum_apples[r+1][s-1] );
   ret = max( ret, rec( r+1, s+1 ) + sum_bananas[r][s+1] + sum_apples[r+1][s] );

   return ret;
}

int main( void ) {
   scanf( "%d%d", &R, &S );
   for( int r = 1; r <= R; ++r ) {
      for( int s = 1; s <= S; ++s ) {
         char tip;
         int number;
         scanf( " %c%d", &tip, &number );

         int apples = 0, bananas = 0;
         if( tip == 'A' ) apples = number; else bananas = number;
         
         sum_apples[r][s] = sum_apples[r][s-1] + apples;
         sum_bananas[r][s] = sum_bananas[r-1][s] + bananas;
      }
   }
   memset( memo, -1, sizeof memo );
   printf( "%d\n", rec( 1, 1 ) );
   return 0;
}
