#include <algorithm>
#include <cstdio>

using namespace std;

const int MAXN = 300000;
const int MAXM = 1000000;

struct point { 
   int index;
   int x, y;
   int x1, x2;
} P[MAXN];
bool cmp_x( const point &A, const point &B ) { 
   if( A.x != B.x ) return A.x < B.x; 
   return A.y < B.y;
}
bool cmp_y( const point &A, const point &B ) { 
   if( A.y != B.y ) return A.y < B.y; 
   return A.x < B.x;
}

struct event { 
   int tip;
   int tocka;
   int y, x1, x2;
} E[3*MAXN];

bool operator < ( const event &A, const event &B ) {
   if( A.y != B.y ) return A.y < B.y;
   return A.tip > B.tip;
}
 
int M, N;

int ret[MAXN];
int loga[MAXM];

inline void loga_add( int X ) {
   for( int x = X; x < M; x += x&-x ) ++loga[x];
}
inline int loga_query( int X ) {
   int ret = 0;
   for( int x = X; x > 0; x -= x&-x ) ret += loga[x];
   return ret;
}

int main( void ) {
   scanf( "%d%d", &M, &N );
   for( int i = 0; i < N; ++i ) {
      P[i].index = i;
      scanf( "%d%d", &P[i].x, &P[i].y );

      E[i].tip = 0;
      E[i].tocka = i;
      E[i].x1 = E[i].x2 = P[i].x; E[i].y = P[i].y;
   }

   sort( P, P+N, cmp_y ); 

   for( int i = 0; i < N; ++i ) {
      P[i].x1 = (i ==  0  || P[i-1].y != P[i].y) ? 0 : P[i-1].x;
      P[i].x2 = (i == N-1 || P[i+1].y != P[i].y) ? M : P[i+1].x;
   }

   sort( P, P+N, cmp_x ); 

   for( int i = 0; i < N; ++i ) {
      event e1, e2;
      e1.tip = -1; e1.tocka = P[i].index; e1.x1 = P[i].x1; e1.x2 = P[i].x2-1;
      e2.tip =  1; e2.tocka = P[i].index; e2.x1 = P[i].x1; e2.x2 = P[i].x2-1;
      
      e1.y = (i ==  0  || P[i-1].x != P[i].x) ? 0 : P[i-1].y;
      e2.y = (i == N-1 || P[i+1].x != P[i].x) ? M : P[i+1].y;

      E[N+2*i+0] = e1;
      E[N+2*i+1] = e2;
   }

   sort( E, E+3*N );

   for( int i = 0; i < 3*N; ++i ) {
      if( E[i].tip == -1 ) ret[E[i].tocka] -= loga_query(E[i].x2) - loga_query(E[i].x1);
      if( E[i].tip ==  0 ) loga_add(E[i].x1);
      if( E[i].tip ==  1 ) ret[E[i].tocka] += loga_query(E[i].x2) - loga_query(E[i].x1);
   }

   for( int i = 0; i < N; ++i ) printf( "%d\n", ret[i] );

   return 0;
}
