program pcelice;

const 
   MAXM = 1000000;
   MAXN = 300000;

(* Genericki sort *)

type CompareFunction = function(pa, pb : Pointer) : integer;         

procedure swap(var a, b : pointer); var t : pointer; begin t := a; a := b; b := t; end;

procedure qsort(var arr : array of Pointer; l, r: longint; cmp : CompareFunction);
var x, y : longint;
    mid  : pointer;
begin
    if r-l < 2 then exit;
    if r-l = 2 then begin
        if cmp(arr[l+1], arr[l]) < 0 then swap(arr[l], arr[l+1]);
        exit;
    end;

    mid := arr[(l+r) div 2];
    y := l;

    for x := l to r-1 do  (* sve strogo manje stavi na pocetak *)
        if cmp( arr[x], mid) < 0 then begin
            swap(arr[x], arr[y]);
            inc(y);
        end;

    qsort(arr, l, y, cmp); (* sortiraj sve strogo manje *)

    for x:=y to r-1 do (* sve jednake stavi poslije ovih manjih *)
        if cmp(arr[x], mid) = 0 then begin
            swap(arr[x], arr[y]);
            inc(y);
        end;

    qsort(arr, y, r, cmp); (* sortiraj sve strogo vece *)
end;

(* Tipovi podataka - tocke i dogadaji *)

type TPoint = record
   index, x, y, x1, x2 : longint;
end;
type PPoint = ^TPoint;

function cmp_x(pa, pb : Pointer) : integer;
var
   a, b : TPoint;
begin
   a := PPoint(pa)^; b := PPoint(pb)^;
   if      a.x < b.x then cmp_x := -1
   else if a.x > b.x then cmp_x := 1
   else if a.y < b.y then cmp_x := -1
   else if a.y > b.y then cmp_x := 1
   else cmp_x := 0;
end;

function cmp_y(pa, pb : Pointer) : integer;
var
   a, b : TPoint;
begin
   a := PPoint(pa)^; b := PPoint(pb)^;
   if      a.y < b.y then cmp_y := -1
   else if a.y > b.y then cmp_y := 1
   else if a.x < b.x then cmp_y := -1
   else if a.x > b.x then cmp_y := 1
   else cmp_y := 0;
end;

type TEvent = record
   tip, tocka, y, x1, x2 : longint;
end;
type PEvent = ^TEvent;

function cmp_event(pa, pb : Pointer) : integer;
var
   a, b : TEvent;
begin
   a := PEvent(pa)^; b := PEvent(pb)^;
   if      a.y   < b.y   then cmp_event := -1
   else if a.y   > b.y   then cmp_event := 1
   else if a.tip > b.tip then cmp_event := -1
   else if a.tip < b.tip then cmp_event := 1
   else cmp_event := 0;
end;

(* Logaritamska *)

var 
   M    : longint;
   loga : array[1..MAXM] of longint;

procedure loga_add(X : longint);
begin
   while X <= M do begin
      inc(loga[X]);
      X := X + (X and -X);
   end;
end;

function loga_query(X : longint) : longint;
var ret : longint;
begin
   ret := 0;
   while X > 0 do begin
      ret := ret + loga[X];
      X := X - (X and -X);
   end;
   loga_query := ret;
end;

(* Glavni program *)

var
   N, i    : longint;
   P, Ptmp : array[1..MAXN] of TPoint;
   E, Etmp : array[1..3*MAXN] of TEvent;
   e1, e2  : TEvent;
   ptr     : array[1..3*MAXN] of pointer;
   rez     : array[1..MAXN] of longint;

begin
   read(M, N);
   for i:=1 to N do begin
      P[i].index := i;
      read(P[i].x, P[i].y);
      rez[i] := 0;
      
      E[i].tip := 0;
      E[i].tocka := i;
      E[i].x1 := P[i].x;
      E[i].x2 := P[i].x;
      E[i].y  := P[i].y;
   end;
   
   for i:=1 to N do begin Ptmp[i] := P[i]; ptr[i] := @Ptmp[i]; end;
   qsort(ptr, 0, N, @cmp_y);
   for i:=1 to N do P[i] := PPoint(ptr[i])^;

   for i:=1 to N do begin
      P[i].x1 := 0; P[i].x2 := M;
      if (i > 1) and (P[i-1].y = P[i].y) then P[i].x1 := P[i-1].x;
      if (i < N) and (P[i+1].y = P[i].y) then P[i].x2 := P[i+1].x;
   end;
   
   for i:=1 to N do begin Ptmp[i] := P[i]; ptr[i] := @Ptmp[i]; end;
   qsort(ptr, 0, N, @cmp_x);
   for i:=1 to N do P[i] := PPoint(ptr[i])^;
   
   for i:=1 to N do begin
      e1.tip := -1; e1.tocka := P[i].index; e1.x1 := P[i].x1; e1.x2 := P[i].x2-1;
      e2.tip :=  1; e2.tocka := P[i].index; e2.x1 := P[i].x1; e2.x2 := P[i].x2-1;
      
      e1.y := 0; e2.y := M;
      if (i > 1) and (P[i-1].x = P[i].x) then e1.y := P[i-1].y;
      if (i < N) and (P[i+1].x = P[i].x) then e2.y := P[i+1].y;
      
      E[N-1+2*i] := e1;
      E[N  +2*i] := e2;
   end;

   for i:=1 to 3*N do begin Etmp[i] := E[i]; ptr[i] := @Etmp[i]; end;
   qsort(ptr, 0, 3*N, @cmp_event);
   for i:=1 to 3*N do E[i] := PEvent(ptr[i])^;
   
   for i:=1 to 3*N do begin
      if E[i].tip = -1 then 
         rez[E[i].tocka] := rez[E[i].tocka] - loga_query(E[i].x2) + loga_query(E[i].x1);
      if E[i].tip = 0 then
         loga_add(E[i].x1);
      if E[i].tip = 1 then
         rez[E[i].tocka] := rez[E[i].tocka] + loga_query(E[i].x2) - loga_query(E[i].x1);
   end;
   
   for i:=1 to N do writeln(rez[i]);
end.
