#include <algorithm>
#include <climits>
#include <cstring>
#include <iostream>
using namespace std;

const int MAXN = 250;
const int INF = INT_MAX / 2;

int N, K;
bool bio[MAXN][MAXN+1][2][2][2];
int memo[MAXN][MAXN+1][2][2][2];
int val[MAXN][MAXN+1];

int calc(int red, int zadnji, bool lijevo, bool desno, bool gore) {
   if ( lijevo && desno ) return -INF;
   if ( red == N ) return gore ? -INF : 0;

   int &ret = memo[red][zadnji][lijevo][desno][gore];
   if ( bio[red][zadnji][lijevo][desno][gore] ) return ret;
   bio[red][zadnji][lijevo][desno][gore] = 1;

   ret = -INF;
   for ( int a=0; a<=N-K; ++a ) {
      bool spojen = max(a, zadnji) <= min(a+K-1, zadnji+K-1);

      ret = max(ret, (val[red][a+K] - val[red][a] +
                      calc(red+1, a,
                           a==0   || (spojen && lijevo),
                           a+K==N || (spojen && desno),
                           red==0 || (spojen && gore)
                           )));
   }
   return ret;
}

int main() {
   cin >> N >> K;
   for ( int i=0; i<N; ++i ) {
      val[i][0] = 0;
      for ( int j=1; j<=N; ++j ) {
         cin >> val[i][j];
         val[i][j] += val[i][j-1];
      }
   }

   memset(bio, 0, sizeof bio);
   cout << calc(0, 0, 0, 0, 0) << endl;

   return 0;
}
