program mikro;

const
   MAXN                       = 5000;
   MAXT                       = 2000001;
   DX: array[1..8] of integer = (-1, 0, 1, 1, 1, 0, -1, -1);
   DY: array[1..8] of integer = (1, 1, 1, 0, -1, -1, -1, 0);

type bakterija = record
   x, y, dx, dy : longint;
end;            

function max(a, b : longint) : longint; begin if a > b then max := a else max := b; end;
function abs(a : longint) : longint; begin if a >= 0 then abs := a else abs := -a; end;
                 
function vrijeme_susreta(b1, b2 : bakterija) : longint;
var
   d1, d2, t : longint;
begin
   d1 := max(abs(b1.x-b2.x), abs(b1.y-b2.y));
   d2 := max(abs(b1.x+b1.dx-b2.x-b2.dx),
             abs(b1.y+b1.dy-b2.y-b2.dy));

   if (d2 >= d1) or (d1 mod (d1-d2) <> 0) then begin
      vrijeme_susreta := -1;
      exit;
   end;
      
   t := d1 div (d1-d2);
   if (b1.x + t*b1.dx = b2.x + t*b2.dx) and
      (b1.y + t*b1.dy = b2.y + t*b2.dy) then
      vrijeme_susreta := t
   else
      vrijeme_susreta := -1;
end;

var
   n, i, j, t, smjer  : longint;
   bakterije          : array[1..MAXN] of bakterija;
   cookie, rang       : array[0..MAXT] of integer;
   NOWCOOKIE          : longint = 0;
   max_rang, min_time : longint;

begin
   read(n);
   for i:=1 to n do begin
      read(bakterije[i].x, bakterije[i].y, smjer);
      bakterije[i].dx := DX[smjer];
      bakterije[i].dy := DY[smjer];
   end;

   max_rang := 0; min_time := 0;
   for i:=1 to n do begin
      inc(NOWCOOKIE);
      for j:=i+1 to n do begin
         t := vrijeme_susreta(bakterije[i], bakterije[j]);
         if t = -1 then continue;
         
         if cookie[t] <> NOWCOOKIE then begin
            cookie[t] := NOWCOOKIE;
            rang[t] := 2;
         end else inc(rang[t]);

         if (rang[t] > max_rang) or
            (rang[t] = max_rang) and (t < min_time) then begin
            max_rang := rang[t];
            min_time := t;
         end;
      end;
   end;
   writeln(max_rang);
   writeln(min_time);
end.
