program stakor;

const
   oo        = 1000000000;
   MAXN      = 100;
   MAXK      = 10;
   MAXP      = 1000000;
   MAXRUBOVA = 4*(MAXK-1);
   BIJELO    = 'w';
   CRVENO    = 'r';

const
   dr: array[0..3] of longint = (-1, 0, 1, 0);
   ds: array[0..3] of longint = (0, 1, 0, -1);

var
   N, K, P, i, j    : longint;
   dno              : array[0..MAXN, 0..MAXN] of char;
   dist             : array[0..MAXN, 0..MAXN, 0..MAXRUBOVA, 0..MAXRUBOVA] of longint;
   unutar           : array[0..MAXK, 0..MAXK] of char;
   bfs_dist         : array[0..MAXK, 0..MAXK] of longint;
   qhead, qtail     : longint;
   queue_r, queue_s : array[0..MAXK*MAXK] of longint;
   rubova           : longint;
   rub_r, rub_s     : array[0..MAXRUBOVA] of longint;
   rub              : array[0..3, 0..MAXK] of longint;
   indeks           : array[0..MAXK, 0..MAXK] of longint;
   R, S             : longint;
   potezi           : array[0..MAXP] of char;

function smjer(c : char) : longint;
begin
   if      c = 'U' then smjer := 0
   else if c = 'R' then smjer := 1
   else if c = 'D' then smjer := 2
   else if c = 'L' then smjer := 3;
end;

procedure generiraj_rubove;
var r, s : longint;
begin
   rubova := 0;
   for r:=0 to K-1 do begin
      for s:=0 to K-1 do begin
         if (r > 0) and (r < K-1) and (s > 0) and (s < K-1) then begin
            indeks[r, s] := -1;
         end else begin
            rub_r[rubova] := r;
            rub_s[rubova] := s;
            indeks[r, s] := rubova; inc(rubova);
         end;
      end;
   end;

   for s:=0 to K-1 do rub[0, s] := indeks[0, s];
   for r:=0 to K-1 do rub[1, r] := indeks[r, K-1];
   for s:=0 to K-1 do rub[2, s] := indeks[K-1, s];
   for r:=0 to K-1 do rub[3, r] := indeks[r, 0];
end;

procedure bfs(r0, s0, out0, out1, out2 : longint);
var
   r, s, d, rr, ss, i : longint;
begin
   for r:=0 to K-1 do begin
      for s:=0 to K-1 do 
         bfs_dist[r, s] := oo;
   end;
   
   qhead := 0; qtail := 0;
   
   if unutar[r0, s0] = BIJELO then bfs_dist[r0, s0] := 0;
   queue_r[qtail] := r0;
   queue_s[qtail] := s0;
   inc(qtail);

   while qhead <> qtail do begin
      r := queue_r[qhead];
      s := queue_s[qhead];
      inc(qhead);

      for d:=0 to 3 do begin
         rr := r+dr[d];
         ss := s+ds[d];
         if (rr < 0) or (rr >= K) then continue;
         if (ss < 0) or (ss >= K) then continue;
         if unutar[rr, ss] = CRVENO then continue;
         if bfs_dist[rr, ss] <= bfs_dist[r, s] + 1 then continue;
         bfs_dist[rr, ss] := bfs_dist[r, s] + 1;

         queue_r[qtail] := rr;
         queue_s[qtail] := ss;
         inc(qtail);
      end;
   end;

   for i:=0 to rubova-1 do begin
      dist[out0, out1, out2, i] := bfs_dist[rub_r[i], rub_s[i]];
   end;
end;

procedure generiraj_distove;
var r0, s0, r, s, i : longint;
begin
   for r0:=0 to N-K do
      for s0:=0 to N-K do begin
         for r:=0 to K-1 do 
            for s:=0 to K-1 do
               unutar[r, s] := dno[r0+r, s0+s];

         for i:=0 to rubova-1 do
            bfs(rub_r[i], rub_s[i], r0, s0, i);
      end;
end;

function rijesi : longint;
var
   dp                       : array[0..1, 0..MAXK] of longint;
   curr, next, t            : longint;
   curr_indeks, next_indeks : array[0..MAXK] of longint;
   x, pp, d, ret            : longint;
begin
   curr := 0;
   next := 1;
   curr_indeks := rub[smjer(potezi[0])];

   for i:=0 to K-1 do begin
      if dno[R+rub_r[curr_indeks[i]], S+rub_s[curr_indeks[i]]] = BIJELO then
         dp[curr, i] := 0
      else
         dp[curr, i] := oo;
   end;

   for pp:=0 to P-1 do begin
      d := smjer(potezi[pp]);
      next_indeks := rub[d];

      for i:=0 to K-1 do dp[next, i] := oo;

      for i:=0 to K-1 do
         for j:=0 to K-1 do begin
            x := dp[curr, i] + dist[R, S, curr_indeks[i], next_indeks[j]];
            if x < dp[next, j] then dp[next, j] := x;
         end;

      R := R + dr[d];
      S := S + ds[d];

      for i:=0 to K-1 do begin
         inc(dp[next, i]);
         if dno[R+rub_r[next_indeks[i]], S+rub_s[next_indeks[i]]] = CRVENO then
            dp[next, i] := oo; 
      end;

      t := curr; curr := next; next := t;
      curr_indeks := next_indeks;
   end;

   ret := oo;
   for i:=0 to K-1 do begin
      if dp[curr, i] < ret then ret := dp[curr, i];
   end;
   rijesi := ret;
end;

begin
   readln(N, K);
   for i:=0 to N-1 do begin
      for j:=0 to N-1 do
         read(dno[i, j]);
      readln;
   end;

   generiraj_rubove;
   generiraj_distove;
   readln(R, S); dec(R); dec(S);
   readln(P);
   for i:=0 to P-1 do read(potezi[i]);

   writeln(rijesi);
end.
