// O(N * logN * T * logT)

#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 2001
#define TMAX 1001
#define INF 30000

vector<int> sons[NMAX], vec[NMAX];
vector<pair<int, int> > vsons;
char blocked[NMAX][TMAX];
short int Tmin[NMAX][NMAX + TMAX];
short int tmom[NMAX + TMAX];
int tata[NMAX];
int i, j, k, N, T;

void df(int i)
{
    int k, t, t1, K, fst, lst, tli, tls, tmid, ok, pozli, pozls, pozmid, pozok, pmax, s;
    
    sons[i].clear();
    for (k = 0; k < vec[i].size(); k++)
	if (vec[i][k] != tata[i])
	    sons[i].push_back(vec[i][k]);
    
    K = sons[i].size();
    
    if (K == 0) // i is a leaf
    {
	for (t = 0; t <= T + N; t++)
	    Tmin[i][t] = t; 
    }
    else // i has several sons
    {
	for (k = 0; k < K; k++)
	{
	    //fprintf(stderr, "calling: %d -> %d\n", i, sons[i][k]);
	    tata[sons[i][k]] = i;
	    df(sons[i][k]);
	}
	
	t = 0;
	
	fst = 1; lst = 0;
	tmom[lst] = 0;

	//fprintf(stderr, "i=%d, K=%d\n", i, K);
	
	while (t <= T + N)
	{
	    if (t > T)
	    {
		Tmin[i][t] = Tmin[i][t - 1] + 1;
		t++;
		continue;
	    }
	    
	    for (t1 = tmom[lst] + 1; t1 <= T + N && lst - fst + 1 < K; t1++)
		if ((t1 - 1 >= T) || (!blocked[i][t1 - 1]))
		{
		    lst++;
		    tmom[lst] = t1;
		}
	    
	    /*
	    printf("i=%d, t=%d:", i, t);
	    for (k = fst; k <= lst; k++)
		printf("%d ", tmom[i][k]);
	    printf("\n");
	    */
	    	
	    //fprintf(stderr, "%d,%d\n", i, t);
		
	    // compute Tmin[i][t]
	    Tmin[i][t] = INF;
	    
	    tli = t; tls = T + N;
	    
	    while (tli <= tls)
	    {
		tmid = (tli + tls) >> 1;
		
		// feasibility test
		
		vsons.clear();
		for (k = 0; k < K; k++)
		{
		    // find the latest moment such that Tmin[kth son][moment] <= tmid
		    pozli = fst; pozls = lst; pozok = -1;
		    
		    while (pozli <= pozls)
		    {
			pozmid = (pozli + pozls) >> 1;
			
			if (Tmin[sons[i][k]][tmom[pozmid]] <= tmid)
			    pozok = pozmid,
			    pozli = pozmid + 1;
			else
			    pozls = pozmid - 1;
		    }
		    
		    vsons.push_back(make_pair(pozok, sons[i][k]));
		}

		// sort the sons (in increasing order of latest moments)		
		sort(vsons.begin(), vsons.end());
		
		ok = 1;
		for (k = 0; k < K; k++)
		{
		    pmax = vsons[k].first;
		    s = vsons[k].second;
		    
		    //fprintf(stderr, "i=%d, t=%d -> son %d: pmax=%d, s=%d (fst=%d, lst=%d, tmid=%d)\n", i, t, k + 1, pmax, s, fst, lst, tmid);
		    
		    if (pmax < fst + k)
		    {
			// the son cannot be assigned to any time moment
			ok = 0;
			break;
		    }
		}
		
		if (ok)
		    Tmin[i][t] = tmid,
		    tls = tmid - 1;
		else
		    tli = tmid + 1;
	    }
	
	    // move to the next time moment
	    if ((t + 1) == tmom[fst])
		fst++;
		
	    t++;	
	}	
    }
}

int main()
{
    freopen("tcast.in", "r", stdin);
    
    scanf("%d %d", &N, &T);
    
    for (k = 1; k < N; k++)
    {
	scanf("%d %d", &i, &j);
	vec[i].push_back(j);
	vec[j].push_back(i);
    }
    
    for (i = 1; i <= N; i++)
    {
	for (j = 0; j < T; j++)
	    scanf("%d", &blocked[i][j]);
	
	blocked[i][T] = 0;
	/*
	for (j = T; j <= T + N; j++)
	    blocked[i][j] = 0;
	*/
    }
    
    df(1);

    fprintf(stderr, "%d\n", Tmin[1][0]);

    freopen("tcast.out", "w", stdout);
    printf("%d\n", Tmin[1][0]);    

/*
    for (i = 1; i <= N; i++)
    {
	for (j = 0; j <= T; j++)
	    printf("%d ", Tmin[i][j]);
	printf("\n");
    }
*/        
    return 0;
}
