// O(N * T)

#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 2001
#define TMAX 1001
#define INF 30000

vector<int> vec[NMAX], sons[NMAX];
int tata[NMAX], vsons[NMAX + TMAX];
char blocked[NMAX][TMAX];
short int Tmin[NMAX][NMAX + TMAX];
short int tmom[NMAX + TMAX], lmom[NMAX];
int i, j, k, N, T;

void df(int i)
{
    int k, t, t1, K, fst, lst, tmid, ok, pmax, s;
    
    //fprintf(stderr, "df(%d)\n", i);
    
    sons[i].clear();
    for (k = 0; k < vec[i].size(); k++)
	if (vec[i][k] != tata[i])
	    sons[i].push_back(vec[i][k]);
    
    K = sons[i].size();
    
    if (K == 0) // i is a leaf
    {
	for (t = 0; t <= T + N; t++)
	    Tmin[i][t] = t; 
    }
    else // i has several sons
    {
	for (k = 0; k < K; k++)
	{
	    //fprintf(stderr, "calling: %d -> %d\n", i, sons[i][k]);
	    tata[sons[i][k]] = i;
	    df(sons[i][k]);
	    lmom[k] = 0;
	}
	
	t = 0;
	
	fst = 1; lst = 0;
	tmom[lst] = 0;

	//fprintf(stderr, "i=%d, K=%d\n", i, K);
	tmid = 0;
	
	while (t <= T + N)
	{
	    if (t > T)
	    {
		Tmin[i][t] = Tmin[i][t - 1] + 1;
		t++;
		continue;
	    }
	        
	    for (t1 = tmom[lst] + 1; t1 <= T + N && lst - fst + 1 < K; t1++)
		if (((t1 - 1) >= T) || (!blocked[i][t1 - 1]))
		{
		    lst++;
		    tmom[lst] = t1;
		}
	    
	    /*
	    printf("i=%d, t=%d:", i, t);
	    for (k = fst; k <= lst; k++)
		printf("%d ", tmom[i][k]);
	    printf("\n");
	    */
	    	
	    //fprintf(stderr, "%d,%d\n", i, t);
		
	    // compute Tmin[i][t]
	    Tmin[i][t] = INF;
	    
	    while (1)
	    {
		// feasibility test
		
		for (k = 0; k < K; k++)
		{
		    // find the latest moment such that Tmin[kth son][moment] <= tmid
		    
		    if (lmom[sons[i][k]] < fst)
			lmom[sons[i][k]] = fst;
		
		    while (lmom[sons[i][k]] <= lst && Tmin[sons[i][k]][tmom[lmom[sons[i][k]]]] <= tmid)
			lmom[sons[i][k]]++;

		    lmom[sons[i][k]]--;
		}
		    
		//fprintf(stderr, "-- %d,%d\n", i, t);

		// sort the sons (in increasing order of latest moments) - like a count sort		
		for (k = fst - 1; k <= lst; k++)
		    vsons[k] = 0;
		    
		for (k = 0; k < K; k++)
		    vsons[lmom[sons[i][k]]]++;
		
		ok = 1;
		k = fst;
		
		for (pmax = fst - 1; pmax <= lst && ok; pmax++)
		    for (s = vsons[pmax]; s > 0; s--)    
			if (pmax < k)
			    ok = 0;
			else
			{
			    //fprintf(stderr, "i=%d: k=%d, pmax=%d (t=%d, tmid=%d, fst=%d, lst=%d, ok=%d)\n", i, k, pmax, t, tmid, fst, lst, ok);
			    k++;
			}
			
		if (ok)
		{
		    Tmin[i][t] = tmid;
		    break;
		}
		else
		    tmid++;
	    }
	
	    // move to the next time moment
	    if ((t + 1) == tmom[fst])
		fst++;
		
	    t++;	
	}	
    }
}

int main()
{
    freopen("tcast.in", "r", stdin);
    
    scanf("%d %d", &N, &T);
    
    for (k = 1; k < N; k++)
    {
	scanf("%d %d", &i, &j);
	vec[i].push_back(j);
	vec[j].push_back(i);
    }
    
    for (i = 1; i <= N; i++)
    {
	for (j = 0; j < T; j++)
	    scanf("%d", &blocked[i][j]);
	    
	blocked[i][T] = 0;
    }
    
    df(1);

    fprintf(stderr, "%d\n", Tmin[1][0]);

    freopen("tcast.out", "w", stdout);
    printf("%d\n", Tmin[1][0]);    

/*
    for (i = 1; i <= N; i++)
    {
	for (j = 0; j <= T; j++)
	    printf("%d ", Tmin[i][j]);
	printf("\n");
    }
*/
        
    return 0;
}
