#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 2001
#define TMAX 1001
#define INF 30000

vector<int> vec[NMAX], sons[NMAX];
vector<pair<int, int> > vsons;
char blocked[NMAX][NMAX + TMAX];
short int Tmin[NMAX][NMAX + TMAX];
short int tmom[NMAX][NMAX + TMAX];
int tata[NMAX];
int i, j, k, N, T, maxsons;

void df(int i)
{
    int k, t, t1, K, fst, lst, Tmax, s;
    
    sons[i].clear();
    for (k = 0; k < vec[i].size(); k++)
	if (vec[i][k] != tata[i])
	    sons[i].push_back(vec[i][k]);
    
    K = sons[i].size();
    
    if (K == 0) // i is a leaf
    {
	for (t = 0; t <= T; t++)
	    Tmin[i][t] = t; 
    }
    else // i has several sons
    {
	for (k = 0; k < K; k++)
	{
	    //fprintf(stderr, "calling: %d -> %d\n", i, sons[i][k]);
	    tata[sons[i][k]] = i;
	    df(sons[i][k]);
	}
	
	t = 0;
	
	fst = 1; lst = 0;
	tmom[i][lst] = 0;
	
	while (t <= T - K)
	{
	    for (t1 = tmom[i][lst] + 1; t1 <= T && lst - fst + 1 < K; t1++)
		if (!blocked[i][t1 - 1])
		{
		    lst++;
		    tmom[i][lst] = t1;
		}
	    
	    /*
	    printf("i=%d, t=%d:", i, t);
	    for (k = fst; k <= lst; k++)
		printf("%d ", tmom[i][k]);
	    printf("\n");
	    */
	    	
	    //fprintf(stderr, "%d,%d\n", i, t);
		
	    // compute Tmin[i][t]
	    Tmin[i][t] = t;

	    // choose a simple ordering of the sons (greedy-like)
	    
	    vsons.clear();
	    for (k = 0; k < K; k++)
		vsons.push_back(make_pair(0, sons[i][k]));

	    for (t1 = fst; t1 <= lst; t1++)
	    {
		Tmax = 0;
		s = -1;
		
		for (k = 0; k < K; k++)
		    if (!vsons[k].first && Tmin[vsons[k].second][tmom[i][t1]] > Tmax)
			Tmax = Tmin[vsons[k].second][tmom[i][t1]],
			s = k;
			
		vsons[s].first = 1;
		if (Tmax > Tmin[i][t])
		    Tmin[i][t] = Tmax;
	    }
	
	    // move to the next time moment
	    if ((t + 1) == tmom[i][fst])
		fst++;
		
	    t++;	
	}
	
	for (t = T - K + 1; t <= T; t++)
	    Tmin[i][t] = INF;
    }
}

int main()
{
    freopen("tcast.in", "r", stdin);
    
    scanf("%d %d", &N, &T);
    
    for (k = 1; k < N; k++)
    {
	scanf("%d %d", &i, &j);
	vec[i].push_back(j);
	vec[j].push_back(i);
    }
    
    for (i = 1; i <= N; i++)
    {
	for (j = 0; j < T; j++)
	    scanf("%d", &blocked[i][j]);
    
	for (j = T; j <= N + T; j++)
	    blocked[i][j] = 0;
    }
        
    T += N;

    df(1);

    fprintf(stderr, "%d\n", Tmin[1][0]);

    freopen("tcast.out", "w", stdout);
    printf("%d\n", Tmin[1][0]);
    
    maxsons = 0;
    for (i = 1; i <= N; i++)
	if (sons[i].size() > maxsons)
	    maxsons = sons[i].size();
    
    fprintf(stderr, "max #sons=%d\n", maxsons);
    
    /*
    for (i = 1; i <= N; i++)
    {
	for (j = 0; j <= T; j++)
	    printf("%d ", Tmin[i][j]);
	printf("\n");
    }
    */
    
    return 0;
}
