#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

#define MAXN 805
#define MAXV 100005
#define sx first
#define sy second

int N, M, D;
int x[MAXN][MAXN], p[MAXN * MAXN], nr[MAXN * MAXN];
int sol[MAXN][MAXN];

vector< pair<int, int> > v[MAXV];

const int dx[4] = {-1, 0, 1, 0};
const int dy[4] = {0, 1, 0, -1};

inline int codif( int x, int y )
{
	return x * M + y;
}

inline int getSet( int x )
{
	if (p[x] == x)
		return x;
	return p[x] = getSet( p[x] );
}

inline void unite( int x, int y )
{
	x = getSet(x);
	y = getSet(y);

	if (x == y)
		return;

	if (rand() % 2)
		p[x] = y,
		nr[y] += nr[x];
	else
		p[y] = x,
		nr[x] += nr[y];
}

inline void Insert( int X, int Y, int lim )
{
	int codifXY = codif(X, Y);
	for (int k = 0; k < 4; k++)
	{
		int _X = X + dx[k], _Y = Y + dy[k];

		if (_X < 0 || _X >= N || _Y < 0 || _Y >= M)
			continue;
		if (x[_X][_Y] >= lim)
			unite( codifXY, codif(_X, _Y) );
	}
}

int main()
{
	srand( time(0) );
	freopen("mexc.in", "rt", stdin);
	freopen("mexc.out", "wt", stdout);

	scanf("%d %d %d", &N, &M, &D);
	int Max = -1;
	for (int i = 0; i < N; i++)
		for (int j = 0; j < M; j++)
		{
			scanf("%d", x[i] + j);
			v[ x[i][j] ].push_back( make_pair(i, j) );
			if (x[i][j] > Max)
				Max = x[i][j];

			int COD = codif(i, j);
			p[COD] = COD;
		}
	
	for (int i = Max; i > Max - D && i >= 0; i--)
		for (size_t a = 0; a < v[i].size(); a++)
			Insert( v[i][a].sx, v[i][a].sy, Max - D + 1 );

	for (int Val = Max; Val >= 0; Val--)
	{
		for (size_t a = 0; a < v[Val].size(); a++)
			nr[ getSet( codif( v[Val][a].sx, v[Val][a].sy ) ) ]++;

		if (Val - D >= 0)
			for (size_t a = 0; a < v[Val - D].size(); a++)
				Insert( v[Val - D][a].sx, v[Val - D][a].sy, Val - D );

		for (size_t a = 0; a < v[Val].size(); a++)
			sol[ v[Val][a].sx ][ v[Val][a].sy ] = nr[ getSet( codif( v[Val][a].sx, v[Val][a].sy ) ) ];
	}

	for (int i = 0; i < N; i++)
	{
		for (int j = 0; j + 1 < M; j++)
			printf("%d ", sol[i][j]);
		printf("%d\n", sol[i][M - 1]);
	}
	
	return 0;
}
