#include <cstdio>
#include <vector>

using namespace std;

#define MAXN 2048
#define MAXT 1024

int N, T;
char busy[MAXN][MAXT];
int bst[MAXN][MAXT];

vector<int> con[MAXN];
vector<int> tcst;

#define tcst(i) tcst[ tcst.size() - (i) - 1 ]

int _MAX, _K, _T;
int l[MAXN << 1], r[MAXN << 1];
char used[MAXN << 1];
inline int PairUp( int k )
{
	if (used[k])
		return 0;
	used[k] = 1;

	for (int t = 0; t < (int)con[_K].size(); t++)
	{
		int tmp;
		if (tcst(t) >= T)
			tmp = T - 1;
		else
			tmp = tcst(t);
		if (tcst(t) - _T + bst[ con[_K][k] ][ tmp + 1 ] + 1 > _MAX)
			continue;

		if (r[t] == -1 || PairUp( r[t] ))
		{
			l[k] = t;
			r[t] = k;
			return 1;
		}
	}
	
	return 0;
}

inline int isOk( int k, int Max, int T )
{
	_K = k;
	_MAX = Max;
	_T = T;

	memset( l, -1, sizeof(l) );
	memset( r, -1, sizeof(r) );
	for (int done = 0; !done; )
	{
		done = 1;
		memset( used, 0, sizeof(used) );
		for (size_t i = 0; i < con[k].size(); i++)
			if (l[i] == -1 && PairUp(i))
				done = 0;
	}

	int Nr = 0;
	for (size_t i = 0; i < con[k].size(); i++)
		if (l[i] != -1)
			Nr++;

	return (Nr == (int)con[k].size());
}

inline void dfs( int k, int p )
{
	vector<int> :: iterator it;
	for (it = con[k].begin(); it != con[k].end(); it++)
	{
		if (*it == p)
			swap( *it, con[k][ con[k].size() - 1 ] );

		if (*it != p)
			dfs( *it, k );
	}
	if (k != 1)
		con[k].pop_back();

	tcst.clear();
	for (int t = T + con[k].size(); t > T; t--)
		tcst.push_back(t);
	for (int t = T; t >= 0; t--)
	{
		if (busy[k][t])
		{
			bst[k][t] = bst[k][t + 1] + 1;
			continue;
		}
		tcst.push_back(t);
		
		int rez = -1, step = 2048;
		for (; step; step >>= 1)
			if (!isOk(k, rez + step, t))
				rez += step;

		bst[k][t] = rez + 1;
	}
}

int main()
{
	freopen("tcast.in", "rt", stdin);
	freopen("tcast.out", "wt", stdout);

	scanf("%d %d", &N, &T);
	for (int i = 0; i < N - 1; i++)
	{
		int a, b;
		scanf("%d %d", &a, &b);
		
		con[a].push_back(b);
		con[b].push_back(a);
	}

	for (int i = 1; i <= N; i++)
		for (int j = 0; j < T; j++)
		{
			int val;
			scanf("%d", &val);
			busy[i][j] = (val == 1);
		}

	dfs(1, 0);
	printf("%d\n", bst[1][0]);
	
	return 0;
}

