#include <cstdio>
#include <queue>

#define MAXN 801

#define ff first
#define ss second

using namespace std;

int N, M, D, Z, Ret;
int A[MAXN][MAXN], U[MAXN][MAXN], Rez[MAXN][MAXN];

const int dx[] = {-1, 1,  0, 0};
const int dy[] = { 0, 0, -1, 1};

queue < pair <int, int> > Q;

void ReadData()
{
    freopen("mexc.in", "rt", stdin);

    scanf("%d %d %d", &N, &M, &D);

    int i, j;
    for(i=1; i<=N; ++i)
        for(j=1; j<=M; ++j)
        {
            scanf("%d", &A[i][j]);
            Rez[i][j] = -1;
        }

    fclose(stdin);
}

void Bf(int x, int y)
{
    pair <int, int> p, np;
    p.ff = x;
    p.ss = y;

    U[x][y] = Z;
    Ret = 1;

    Q.push(p);

    while(Q.empty() == false)
    {
        p = Q.front();
        Q.pop();

        int i;
        for(i=0; i<4; ++i)
        {
            np.ff = p.ff + dx[i];
            np.ss = p.ss + dy[i];

            if(np.ff >= 1 && np.ff <= N && np.ss >= 1 && np.ss <= M && U[np.ff][np.ss] != Z && A[x][y] <= (A[np.ff][np.ss] + D))
            {
                Q.push(np);
                U[np.ff][np.ss] = Z;
                
                if(A[x][y] <= A[np.ff][np.ss])
                    ++ Ret;
            }
        }
    }
}

void Fill(int x, int y, int val)
{
    pair <int, int> p, np;
    p.ff = x;
    p.ss = y;

    Q.push(p);

    Rez[x][y] = Ret;

    while(Q.empty() == false)
    {
        p = Q.front();
        Q.pop();

        int i;
        for(i=0; i<4; ++i)
        {
            np.ff = p.ff + dx[i];
            np.ss = p.ss + dy[i];

            if(np.ff >= 1 && np.ff <= N && np.ss >= 1 && np.ss <= M && A[np.ff][np.ss] == val && Rez[np.ff][np.ss] == -1)
            {
                Rez[np.ff][np.ss] = Ret;
                Q.push(np);
            }
        }
    }
}

void Solve()
{
    int i, j;

    for(i=1; i<=N; ++i)
        for(j=1; j<=M; ++j)
            if(Rez[i][j] == -1)
            {
                ++ Z;
                Bf(i, j);
                Fill(i, j, A[i][j]);
            }
}

void Write()
{
    freopen("mexc.out", "wt", stdout);

    int i, j;
    for(i=1; i<=N; ++i)
    {
        for(j=1; j<=M; ++j)
            printf("%d ", Rez[i][j]);

        printf("\n");
    }

    fclose(stdout);
}

int main()
{
    ReadData();
    Solve();
    Write();

    return 0;
}

