#include <iostream>
#include <cstring>

using namespace std;

const int dir[4][2] = {
	{-1, 0},
	{1, 0},
	{0, -1},
	{0, 1}
};

int N, M, D;
int A[802][802];
int nd1[802][802];

int nd2[802][802];
int done[802][802];

int q[802*802];
int begq, endq;
bool inq[802][802];
bool checked[802][802];

void printmat(int A[802][802], FILE *f)
{
	for (int i(1); i <= N; ++i) {
		for (int j(1); j <= M; ++j)
			fprintf(f, "%d ", A[i][j]);
		fprintf(f, "\n");;
	}
}

void calc_num_paths(int nd[802][802], int x, int y) 
{
	memset(inq, 0, sizeof(inq));
	memset(checked, 0, sizeof(checked));
	begq = endq = 0;

	q[endq++] = x*1000 + y;
	inq[x][y] = true;

	while (begq < endq) {
		int cx = q[begq] / 1000;
		int cy = q[begq] % 1000;
		//cout << "Checking: " << cx << " " << cy << endl;

		for (int d(0); d < 4; ++d) {
			int i = cx + dir[d][0];
			int j = cy + dir[d][1];

			if (A[i][j] >= A[x][y] - D)
				if (!inq[i][j] && !checked[i][j]) {
					q[endq++] = i*1000 + j;
					inq[i][j] = true;
				}
		}
		
		if (A[cx][cy] >= A[x][y])
			++nd[x][y];
		inq[cx][cy] = false;
		checked[cx][cy] = true;
		++begq;
	}
}

void brute_paths(int nd[802][802])
{
	for (int i(1); i <= N; ++i)
		for (int j(1); j <= M; ++j)
			calc_num_paths(nd, i, j);
}

void calc_num_paths_extra_check(int nd[802][802], int x, int y) 
{
	memset(inq, 0, sizeof(inq));
	memset(checked, 0, sizeof(checked));
	begq = endq = 0;

	q[endq++] = x*1000 + y;
	inq[x][y] = true;

	while (begq < endq) {
		int cx = q[begq] / 1000;
		int cy = q[begq] % 1000;
		//cout << "Checking: " << cx << " " << cy << endl;

		for (int d(0); d < 4; ++d) {
			int i = cx + dir[d][0];
			int j = cy + dir[d][1];

			if (A[i][j] >= A[x][y] - D)
				if (!inq[i][j] && !checked[i][j]) {
					q[endq++] = i*1000 + j;
					inq[i][j] = true;
				}
		}
		
		if ((A[cx][cy] == A[x][y]) && (done[cx][cy])) {
			nd[x][y] = nd[cx][cy];
			//cout << "Short!" << endl;
			break;
		}
		if (A[cx][cy] >= A[x][y])
			++nd[x][y];
		inq[cx][cy] = false;
		checked[cx][cy] = true;
		++begq;
	}
}

void norep_paths(int nd[802][802])
{
	for (int i(1); i <= N; ++i)
		for (int j(1); j <= M; ++j) {
			calc_num_paths_extra_check(nd, i, j);
			done[i][j] = true;
		}
}

int main(int argc, char *argv[])
{
	FILE *fi = fopen("mexc.in", "r");
	fscanf(fi, "%d %d %d", &N, &M, &D);
	for (int i(0); i <= N+1; ++i)
		A[i][0] = A[i][M+1] = -200000;
	for (int i(0); i <= M+1; ++i)
		A[0][i] = A[N+1][i] = -200000;
	for (int i(1); i <= N; ++i)
		for (int j(1); j <= M; ++j)
			fscanf(fi, "%d", &A[i][j]);
	fclose(fi);

	/*printmat(A, stdout);
	cout << endl;*/

	//brute_paths(nd1);
	
	/*printmat(nd1, stdout);
	cout << endl;*/

	norep_paths(nd2);

	FILE *fo = fopen("mexc.out", "w");
	printmat(nd2, fo);
	fclose(fo);
	
	return 0;
}

