#include <stdio.h>
#include <stdlib.h>

#define tata(x) (x>>1)
#define st(x) (x<<1)
#define dr(x) ((x<<1)|1)
#define N 100

//sa imi bag picioarele in ele de heapuri

int b[N+1];
int n, s;
int h[N+1]; //heap
int lungime_heap; //lungimea heapului
int borcan_de_baza;

void schimba(int& a, int& b)
{
	int aux = a;
	a = b;
	b = aux;
}

void coboara_in_heap(int x)
{
	//vreau sa il cobor in heap pe x
	//voi gasi minimul dintre x, st(x), dr(x)
	int idmin = x;
	if(b[h[x]] > b[h[st(x)]] && st(x) <= lungime_heap) idmin = st(x);
	if(b[h[idmin]]>b[h[dr(x)]] && dr(x) <=lungime_heap) idmin = dr(x);
	if(idmin != x)
	{
		schimba(h[idmin], h[x]);
		coboara_in_heap(idmin);
    }
}

void urca_in_heap(int x)
{
	if(x != 1)
	{
		if(b[h[tata(x)]] > b[h[x]])
		{
        	schimba(h[x], h[tata(x)]);
			urca_in_heap(tata(x));
		}
	}
}


void citeste()
{
	freopen("borcane.in", "r", stdin);
	scanf("%d\n", &n);
	int i;
	for(i=1;i<=n;++i)
 	{
		scanf("%d", &b[i]);
		s += b[i];
    }
	fclose(stdin);
}

int alege_borcan_de_baza()
{
	int IDmin, gasit = 0, i;
	if(s & 1) //asta inseamna ca e impar
	{
		//aleg ca borcan de baza cel mai mic borcan care
		//respecta regula impusa de paritatea sumei

		//aici aleg cel mai mic borcan impar
		for(i=1;i<=n && (!gasit);++i)
		{
			if( b[i] & 1) //daca borcanu' e impar
			{
            	IDmin = i;
				gasit = 1;
			}
		}
		for(i=IDmin+1;i<=n;++i)
        	if(b[IDmin] > b[i] && (b[i] & 1))
				IDmin = i;
	}
	else
	{
		for(i=1;i<=n && (!gasit);++i)
		{
			if( (b[i] & 1) == 0) //daca borcanu' e par
			{
            	IDmin = i;
				gasit = 1;
			}
		}
		for(i=IDmin+1;i<=n;++i)
        	if(b[IDmin] > b[i] && ((b[i] & 1)==0))
				IDmin = i;

	}
	return IDmin;
}

void creaza_heap(int bb) //borcan de baza, pe ala nu il mai bagam in heap ca acolo strangem bomboanele
{
	int i;

	for(i=1;i<=n;++i)
	{
		if(i==bb) continue;
        //nu e borcan de baza
		h[++lungime_heap] = i;
		urca_in_heap(lungime_heap);
	}
}

void scade_in_heap(int scad)
{
	if(scad == 0) return;
	int i;
	for(i=1;i<=lungime_heap;++i) b[h[i]] -= scad;
	for(i=1;i<lungime_heap;++i)
    	printf("%d %d %d\n", h[i], h[i+1], borcan_de_baza);
    printf("%d %d %d\n", h[1], h[lungime_heap], borcan_de_baza);
}

void scade_in_heap_p2()
{
	int i;
	for(i=3;i<lungime_heap;++i)
	{
    	printf("%d %d %d\n", h[i], h[i+1], borcan_de_baza);
		b[h[i]]--;
		b[h[i+1]]--;
	}
	printf("%d %d %d\n", h[1], h[3], borcan_de_baza);
	printf("%d %d %d\n", h[2], h[lungime_heap], borcan_de_baza);
	b[h[1]]--;
	b[h[2]]--;
	b[h[3]]--;
	b[h[lungime_heap]]--;
}

void scoate_din_heap(int x)
{
	schimba(h[x], h[lungime_heap]);
	--lungime_heap;
	coboara_in_heap(1);
}

void termina_jmecher(int p)
{
	//caut primul borcan care are 0
	int id1 = 0, g = 0;

	while(!g)
	{
		++id1;
		if(b[id1]==0) g = 1;
	}
	g = 0;
	int id2 = id1;
	while(!g)
	{
    	++id2;
		if(b[id2]==0) g = 1;
	}
	
	//am doua borcane pe care le pot folosi drept manevra

	while(b[p] >= 3)
	{
		printf("%d %d %d\n", borcan_de_baza, p, id1);
		printf("%d %d %d\n", p, id1, borcan_de_baza);
		printf("%d %d %d\n", p, id1, borcan_de_baza);
		b[p] -= 3;
	}
	if(b[p]==0) return;
	//acum b[p] == 1 sau == 2
	int k = borcan_de_baza;

	if(b[p]==1)
	{
		//fac o trecere din starea cu 2 in cea cu 1
		printf("%d %d %d\n", k, p, id1);
		schimba(p, id1);
	}
	//am ajuns in starea p == 2
	printf("%d %d %d\n", k, p, id1);
	printf("%d %d %d\n", k, p, id2);
	printf("%d %d %d\n", id1, id2, k);
	printf("%d %d %d\n", id1, id2, k);
	
}

void rezolva()
{
	int hmin, scad, i;
	freopen("borcane.out", "w", stdout);
	borcan_de_baza = alege_borcan_de_baza();
	
	//printf("%d\n", borcan_de_baza);
	creaza_heap(borcan_de_baza);

	int gasit;
	
	while(lungime_heap >= 3)
	{
    	hmin = b[h[1]];
		scad = hmin;
		if(hmin % 2 == 1) --scad;
		scade_in_heap(scad); //structura heap nu se schimba

		while(b[h[1]]==0 && lungime_heap) scoate_din_heap(1);
		//scot toate 0 din heap


        gasit = 1;
        while(gasit)
		{
        	gasit = 0;
			if(b[h[1]]==1 && b[h[2]]==1)
			{
            	printf("%d %d %d\n", h[1], h[2], borcan_de_baza);
				scoate_din_heap(1);
				scoate_din_heap(1);
				gasit = 1;
			}
			if(b[h[1]]==1 && b[h[3]]==1)
			{
				printf("%d %d %d\n", h[1], h[3], borcan_de_baza);
				scoate_din_heap(1);
				scoate_din_heap(1);
				gasit = 1;
			}
		}
		//exista 2 posibilitati aici:
		//in b[h[1]] sa am 1 sau o alta valoare
		//daca am 1 atunci scad "dubios"
		//altfel reiau while-ul mare

		if(lungime_heap < 3) break; //chestia care urmeaza nu
						//e testata pe lh < 4, asadar mai bine nu riscam
		
		if(b[h[1]]==1)
		{
        	scade_in_heap_p2();
			scoate_din_heap(1);
		}
	}
    //cu siguranta daca am ajuns in acest loc lungimea heapului ai ajuns
	//mai mica decat 3, adica e 1 sau 2.
	//oare ce sa mai fac daca lungime_heap < 4?
	//2 secunde sa scriu si eu cate ceva pe ciorna poate iese...

	//daca e 1.
	if(lungime_heap==1)
	{
    	termina_jmecher(h[1]);
	}
	if(lungime_heap == 2)
	{
		int p1 = h[1], p2 = h[2];
		for(i=1;i<=b[p1];++i)
		{
        	printf("%d %d %d\n", p1, p2, borcan_de_baza);
		}

		b[p2] -= b[p1];
		b[p1] = 0;
		if(b[p2]) //doar daca mai sunt bomboane pe acolo
			termina_jmecher(p2); //deoarece cica e mai mare
	}
	//printf("0 0 0\n");
	fclose(stdout);
}

int main()
{
	citeste();
	rezolva();
	return 0;
}
