#include <cstdio>

#include <queue>
using namespace std;

const int NMAX = 815;
const int di[] = {-1, +0, +1, +0};
const int dj[] = {+0, +1, +0, -1};

bool Found[NMAX][NMAX];
int Height[NMAX][NMAX], Reachable[NMAX][NMAX];
queue<pair<int, int> > Q;
int n, m, d;

void breadthFirst(int si, int sj) {
	int i, j, k;
	pair<int, int> curr;
	for (i = 0; i < m; ++ i)
		for (j = 0; j < n; ++ j)
			Found[i][j] = false;
	Found[si][sj] = true;
	for (Q.push(make_pair(si, sj)); Q.empty() == false; Q.pop()) {
		curr = Q.front();
		for (k = 0; k < 4; ++ k) {
			i = curr.first + di[k];
			j = curr.second + dj[k];
			if (Found[i][j] == false && Height[i][j] >= Height[si][sj] - d) {
				Found[i][j] = true;
				Q.push(make_pair(i, j));
				if (Height[i][j] >= Height[si][sj])
					++ Reachable[si][sj];
			}
		}
	}
}

int main() {
	freopen("mexc.in", "r", stdin);
	freopen("mexc.out", "w", stdout);
	
	scanf("%d %d %d", &m, &n, &d);
	int i, j;
	for (i = 0; i < m; ++ i)
		for (j = 0; j < n; ++ j)
			scanf("%d ", &Height[i][j]);
	
	for (i = 0; i < m; ++ i)
		for (j = 0; j < n; ++ j) {
			Reachable[i][j] = 1;
			breadthFirst(i, j);
		}
		
	for (i = 0; i < m; ++ i) {
		for (j = 0; j < n; ++ j)
			printf("%d ", Reachable[i][j]);
		printf("\n");
	}

	return 0;
}

