#include<cstdio>
#include<cstring>

#define INPUT "mexc.in"
#define OUTPUT "mexc.out"
#define CL(x) memset(x, 0, sizeof(x));
#define NMAX 805
#define INFI 100005

typedef struct Que
{
  long x; long y;
};

Que Queue[ NMAX * NMAX ];
Que D;
int N, M;
long X, Minim, Maxim;
long PStart, PFin, NR;
long A[ NMAX ][ NMAX ], Used[ NMAX ][ NMAX ], Util[ NMAX ][ NMAX ];

void ReadValues()
{
  int i, j;

  scanf("%d %d %ld", &N, &M, &X);

  Minim = INFI;
  Maxim = -INFI;

  for(i = 1; i <= N; ++i)
    for(j = 1; j <= M; ++j)
    {
      scanf("%ld", &A[ i ][ j ]);
      Minim = (A[ i ][ j ] < Minim ) ? A[ i ][ j ] : Minim;
      Maxim = (A[ i ][ j ] > Maxim ) ? A[ i ][ j ] : Maxim;
    }
}

long BFS(int I, int J)
{
  NR = 0;

  CL(Queue);
  CL(Used);  

  Queue[ 1 ].x = I;
  Queue[ 1 ].y = J;

  PStart = 1;
  PFin = 1;
  Used[ I ][ J ] = 1;
  NR = 0;

  while(PStart <= PFin)
  {
    D = Queue[ PStart ];
    if(A[ I ][ J ] <= A[ D.x ][ D.y ])
      ++NR;
  
    if(!Used[ D.x - 1 ][ D.y ] && A[ D.x - 1 ][ D. y ] >= A[ I ][ J ] - X && D.x - 1 >= 1)
    {
      Used[ D.x - 1 ][ D.y ] = 1;
      ++PFin;
      Queue[ PFin ].x = D.x - 1;
      Queue[ PFin ].y = D.y;
    }
    if(!Used[ D.x + 1 ][ D.y ] && A[ D.x + 1 ][ D. y ] >= A[ I ][ J ] - X && D.x + 1 <= N)
    {
      Used[ D.x + 1 ][ D.y ] = 1;
      ++PFin;
      Queue[ PFin ].x = D.x + 1;
      Queue[ PFin ].y = D.y;
    }
    if(!Used[ D.x ][ D.y - 1 ] && A[ D.x ][ D. y - 1 ] >= A[ I ][ J ] - X && D.y - 1 >= 1)
    {
      Used[ D.x ][ D.y - 1 ] = 1;
      ++PFin;
      Queue[ PFin ].x = D.x;
      Queue[ PFin ].y = D.y - 1;
    }
    if(!Used[ D.x ][ D.y + 1 ] && A[ D.x ][ D. y + 1 ] >= A[ I ][ J ] - X && D.y + 1 <= M)
    {
      Used[ D.x ][ D.y + 1 ] = 1;
      ++PFin;
      Queue[ PFin ].x = D.x;
      Queue[ PFin ].y = D.y + 1;
    }

    ++PStart;
  }

  return NR;
}

void SolveFunction()
{
  int i,j;

  for(i = 1; i <= N; ++i)
    for(j = 1; j <= M; ++j)
    {
      Util[ i ][ j ] = (A[ i ][ j ] == Maxim ) ? 1 : Util[ i ][ j ];    
      Util[ i ][ j ] = (A[ i ][ j ] == Minim ) ? N * M : Util[ i ][ j];
    }

  for(i = 1; i <= N; ++i)
    for(j = 1; j <= M; ++j)
      if(!Util[ i ][ j ])
      {
        if(A[ i ][ j ] == A[ i - 1][ j ] || A[ i ][ j ] == A[ i ][ j - 1])
          Util[ i ][ j ] = (A[ i ][ j ] == A[ i - 1 ][ j ]) ? Util[ i - 1 ][ j ] : Util[ i ][ j - 1 ];
        else
          Util[ i ][ j ] = BFS(i,j);
      }
}

int main()
{
  freopen(INPUT, "r", stdin); freopen(OUTPUT, "w", stdout);

  ReadValues();

  SolveFunction();

  for(int i = 1; i <= N; ++i)
  {
    for(int j = 1; j <= M; ++j)
      printf("%ld ", Util[ i ][ j ]);
    printf("\n");
  }

  fclose(stdin); fclose(stdout);

  return 0;
}
