#include <cstdio>
#include <cstring>
#include <cmath>
#include <queue>
using namespace std;

#define _name_ "borcane"
#define FIN _name_".in"
#define FOUT _name_".out"
#define MAXN 101
#define temp() (lib ? lib->x : -1)

int n, A[MAXN], sum = 0;
char buf[100];

struct Foo {
	bool operator() (const int &a, const int &b) {
		return A[a] < A[b];
	}
};

priority_queue<int, vector<int>, Foo> C;

struct item { int x; item *l, *r; } *lib, *Free[MAXN];

inline void add(int a) {
	if (Free[a]) return;
	item *p = new item;
	*p = (item) { a, 0, lib };
	if (lib) lib->l = p;
	lib = p;
	Free[a] = p;
}

void dbg() {
	for (int i = 1; i <= n; ++i)
		if (A[i]) fprintf(stderr, "%d ", A[i]);
	fprintf(stderr, "\n");
}

inline void give(int a, int b, int dest, int count) {
	sprintf(buf, "%d %d %d\n", a, b, dest);
	for (int i = 0; i < count; ++i)
		fputs(buf, stdout);
	// now do the magic..
	if (Free[dest]) { // it is free
		// unfree
		if (Free[dest]->l) Free[dest]->l->r = Free[dest]->r;
		if (Free[dest]->r) Free[dest]->r->l = Free[dest]->l;
      if (lib == Free[dest]) lib = Free[dest] -> r;
		delete Free[dest];
		Free[dest] = 0;
	}
	A[a] -= count; A[b] -= count;
	A[dest] += 2*count;
	if (A[a] == 0) add(a);
	if (A[b] == 0) add(b);
	//dbg();
}

// A[a] == 2, A[b] > 2
void fazacu2(int a, int b) {
	int c, d;
	give(a, b, c = temp(), 1);
	// a -> 1, b -> b-1, c -> 2
	give(a, b, d = temp(), 1);
	give(c, d, b, 2);
}

void solveala()
{
	int dest = C.top(); C.pop();
	int c, a, b;
	// sa ramanem cu doar 2 borcane...
	while (C.size() > 1) { // mai am mai mult de 1 borcane in plus
	   	a = C.top(); C.pop();
		b = C.top(); C.pop();
		give(a, b, dest, A[b]);
		if (A[a] > 0) C.push(a);
		// pac, si am scapat de inca un borcan
	}
	//dbg();
	if (C.size() == 0) return; // mai avem doar 1 borcan, deci am term
	a = C.top(); b = dest;
	// x,2 => x-1,1,2 => x-2,2,2 => x+2,0,0 (4 pasi)
	// x,1 => x-1,2 => ce e mai sus (5 pasi)
	// x,y; 2 >y>x => 1) count=round(x/3)
   while (A[a]) {
	if (A[a] > A[b])
		a = (a^b) ^ (b=a);
	if (A[a] == A[b]) {
		give(a, b, temp(), A[a]);
	}
	else if (A[a] == 1) {
		give(a, b, c=temp(), 1); a = c;
	}
	else if (A[a] == 2) {
		fazacu2(a, b);
	}
	else if (A[a] > 2) {
		give(a, b, c = temp(), (int) round(A[a]/3.0));
		give(a, c, b, min(A[a], A[c]));
		if (A[a] == 0) a = c;
      if (A[a] == 0) break;
		// ramane a,b (A[a] <= 1)
		give(a,b,c=temp(), 1); a = c;
		fazacu2(a, b);
	}
   }
}

void citeala()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT,"w",stdout);
	scanf("%d", &n);
	for (int i = 1; i <= n; ++i) {
		scanf("%d", A+i);
		if (A[i] == 0) {
			add(i);
			continue;
		}
		sum += A[i];
		C.push(i);
	}
}

int main()
{
	citeala();
	solveala();
	return 0;
}
