#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 808;
const int VMAX = 100001;
const int ND = 4;
const int dx[] = {-1, 1, 0, 0};
const int dy[] = {0, 0, -1, 1};

typedef pair <int, int> PII;
#define x first
#define y second
#define MP make_pair
#define PB push_back

int N, M, D, MX;
int A[NMAX][NMAX];
vector <PII> G[VMAX], V[VMAX];
PII P[NMAX][NMAX];
int T[NMAX][NMAX], R[NMAX][NMAX];

void read(void) {
	FILE *fin = fopen("mexc.in", "rt");
	int i, j;

	fscanf(fin, " %d %d %d", &N, &M, &D);

	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j) {
			fscanf(fin, " %d", A[i] + j);
			V[ A[i][j] ].PB( MP(i, j) );
			MX = max(MX, A[i][j]);
			P[i][j] = MP(i, j);
		}
	
	for (i = 0; i < N; ++i)
		for (j = 0; j < M; ++j)	
			G[ min(MX, A[i][j] + D) ].PB( MP(i, j) );

	fclose(fin);
}

PII parinte(PII p) {
	if (P[p.x][p.y] != p)
		P[p.x][p.y] = parinte(P[p.x][p.y]);
	return P[p.x][p.y];
}

void unite(PII u, PII v) {
	u = parinte(u);
	v = parinte(v);

	if (u == v) return;

	if (T[u.x][u.y] > T[v.x][v.y])
		P[v.x][v.y] = u, T[u.x][u.y] += T[v.x][v.y];
	else
		P[u.x][u.y] = v, T[v.x][v.y] += T[u.x][u.x];
}

void solve(void) {
	int i, j, d, t;
	PII u, v;

	for (i = MX; i >= 0; --i) {
		d = G[i].size();

		for (j = 0; j < d; ++j) {
			u = G[i][j];
			for (t = 0; t < ND; ++t) {
				v = MP(u.x + dx[t], u.y + dy[t]);

				if (v.x < 0 || v.x >= N) continue;
				if (v.y < 0 || v.y >= M) continue;
				if (A[v.x][v.y] < A[u.x][u.y]) continue;
				
				unite(u, v);
			}
		}

		d = V[i].size();
		for (j = 0; j < d; ++j) {
			u = V[i][j];
			v = parinte(u);
			++T[v.x][v.y];
		}
		for (j = 0; j < d; ++j) {
			u = V[i][j];
			v = parinte(u);
			R[u.x][u.y] = T[v.x][v.y];
		}
	}
}

void write(void) {
	FILE *fout = fopen("mexc.out", "wt");
	int i, j;

	for (i = 0; i < N; ++i) {
		for (j = 0; j < M; ++j)
			fprintf(fout, "%d ", R[i][j]);
		fprintf(fout, "\n");
	}

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}
