#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define PB push_back

const int INF = 0x3f3f3f3f;
const int NMAX = 2048;
const int TMAX = 1024;

int N, T;
vector <int> G[NMAX];
int V[NMAX][TMAX], B[NMAX][NMAX];
int DP[NMAX][TMAX + NMAX];
int AIB[NMAX], L[NMAX], C[NMAX];

void read(void) {
	FILE *fin = fopen("tcast.in", "rt");
	int i, j, u, v;

//	printf("%d\n", sizeof(V) + sizeof(B) + sizeof(DP));

	fscanf(fin, " %d %d", &N, &T);

	for (i = 1; i < N; ++i) {
		fscanf(fin, " %d %d", &u, &v);

		G[u].PB(v);
		G[v].PB(u);
	}

	for (i = 1; i <= N; ++i)
		for (j = 0; j < T; ++j)
			fscanf(fin, " %d", V[i] + j);

	fclose(fin);
}

inline void next(int k, int &t) {
	if (t <= T) t = V[k][t];
}

void update(int p, int L, int v) {
	for (; p <= L; p += p & ~(p-1))
		AIB[p] += v;
}

int query(int p) {
	int s;

	for (s = 0; p; p -= p & ~(p-1))
		s += AIB[p];
	
	return s;
}

int DFS(int k, int t, int a) { // a is for ancestor
//	printf("call %d %d %d\n", k, t, a);
	if (G[k].size() == 1) return t;
	if (DP[k][t] != 0) return DP[k][t];

//	printf("%d %d %d\n", k, t, a);
	int i, j, M = G[k].size(), st = 0, dr = 0, p, mij;

	for (i = 0; i < M; ++i)
		if (G[k][i] != a) 
			for (j = 1 , next(k, (p = t)); j < M; ++j, next(k, ++p))
				DFS(G[k][i], p+1, k);

//	printf("pentru %d, %d: ", k, t);
	for (i = 1, next(k, (j = t)); i < M; ++i, next(k, ++j))
//		printf("%d ", j + 1),
		L[i] = j+1;
//	printf("\n");

	for (i = 0, p = 0; i < M; ++i) {
		if (G[k][i] == a) continue;
		++p;
		for (j = 1; j < M; ++j)
			B[p][j] = DFS(G[k][i], L[j], k);
			
		st = max(st, B[p][1]);
		dr = max(dr, B[p][M-1]);
	}

//	if (M == 2) return DP[k][t] = st;

	while (st <= dr) {
		mij = (st + dr) >> 1;
//		printf("%d %d %d\n", st, dr, mij);

		for (i = 1; i < M; ++i) {
			C[i] = upper_bound(B[i]+1, B[i]+M, mij) - B[i] - 1;
//			printf("%d ", C[i]);
			j = query(C[i]);
			if (j >= C[i]) break;
			update(C[i], M+1, 1);
		}
//		printf("\n");

//		printf("i=%d\n", i);
		if (i < M) 
			st = mij+1;
		else
			DP[k][t] = mij, dr = mij-1; 

		for (--i; i; --i) update(C[i], M+1, -1);
	}

//	printf("%d %d => %d\n", k, t, DP[k][t]);
	return DP[k][t];
} 

void write(void) {
	FILE *fout = fopen("tcast.out", "wt");
	int i, j;

	for (i = 1; i <= N; ++i) {
		V[i][T+1] = T+1;
		for (j = T; j >= 0; --j)
			if (V[i][j])
				V[i][j] = V[i][j+1];
			else
				V[i][j] = j;
	}

//	printf("%d %d\n", V[1][0], V[1][1]);

	G[1].PB(0);
	fprintf(fout, "%d\n", DFS(1, 0, 0));

	fclose(fout);
}

int main(void) {
	
	read();

	write();

	return 0;
}
