#include <stdio.h>
#include <algorithm>
#include <queue>
#include <vector>

#define nmax 2048
#define tmax 1024
#define pb push_back
#define inf 0x3f3f3f3f

using namespace std;

int n, t, n1, n2, cucare;
int a[nmax][tmax];
int c[nmax][4000];
int v[nmax];
vector <int> e[nmax];
vector <int> times, cuplat;
vector < vector <int> > costuri;

void dfs(int x)
{
	v[x] = 1;
	vector <int> r;
	int grad = 0;
	for(int i = 0; i < (int)e[x].size(); i++)
		if(!v[e[x][i]]) 
		{
			dfs(e[x][i]), grad++;
			r.pb(e[x][i]);
		}

	if(grad == 0)
	{
		for(int j = 0; j <= t + n + 10; j++) c[x][j] = j;
		return ;
	}

	costuri.resize(grad);
	for(int i = 0; i < grad; i++)
		costuri[i].resize(grad);

	deque <int> times;
	for(int j = t + n + 10; j >= 0; j--)
	{
		if(j == t + n + 10)
			for(int k = 0; k < grad; k++) times.push_back(j + k);
		else if(!a[x][j]) times.push_front(j);
		while((int)times.size() > grad) times.pop_back();

		if(j == t + n + 10) c[x][j] = inf;
		else c[x][j] = c[x][j + 1];

		for(int k = 0; k < grad; k++)
			for(int i = 0; i < (int)r.size(); i++) 
				costuri[i][k] = c[r[i]][times[k] + 1];

		int first = 0, last = inf, middle = 0, rez = 0, ok;
		while(first <= last)
		{

			middle = (first + last) / 2;
			ok = 1;
			cuplat.clear();
			cuplat.resize(grad);
			for(int i = 0; i < grad; i++)
			{
				cucare = -1;
				for(int k = 0; k < grad; k++)
					if(!cuplat[k] && costuri[i][k] <= middle && (cucare == -1 || costuri[i][k] >= costuri[i][cucare])) cucare = k;
				if(cucare == -1) 
				{
					ok = 0;
					break;
				}
				cuplat[cucare] = 1;
			}

			if(ok) rez = middle, last = middle - 1;
			else first = middle + 1;
		}

		c[x][j] = rez;
	}
}

int main()
{
	freopen("tcast.in", "r", stdin);
	freopen("tcast.out", "w", stdout);

	scanf("%d%d", &n, &t);
	for(int i = 1; i < n; i++) 
	{
		scanf("%d%d", &n1, &n2);
		e[n1].pb(n2);
		e[n2].pb(n1);
	}

	for(int i = 1; i <= n; i++)
		for(int j = 0; j < t; j++)
			scanf("%d", &a[i][j]);

	dfs(1);
	printf("%d\n", c[1][0]);

	return 0;
}
