#include <cstdio>
#include <queue>
#include <algorithm>
#include <ctime>
using namespace std;

const char iname[] = "mexc.in";
const char oname[] = "mexc.out";

#define FOR(i, a, b)  for (int i = (a); i < (b); ++ i)
#define MAXN  800

int A[MAXN][MAXN], N, M, D;

bool B[MAXN][MAXN];

int dx[] = {-1, 0, +1, 0}, dy[] = {0, +1, 0, -1};

queue <pair <int, int> > Q;


void read_in(void)
{
    FILE *fi = fopen(iname, "r");

    fscanf(fi, "%d %d %d\n", &N, &M, &D);
    FOR (i, 0, N) FOR (j, 0, M)
        fscanf(fi, "%d", &A[i][j]);
    fclose(fi);
}

int work(int isrc, int jsrc)
{
    memset(B, 0, sizeof(B));
    Q.push(make_pair(isrc, jsrc));
    B[isrc][jsrc] = true;
    
    while (!Q.empty()) {
        int x = Q.front().first;
        int y = Q.front().second;
        Q.pop();
        FOR (i, 0, 4) {
            int xi = x + dx[i];
            int yi = y + dy[i];
            if (0 <= xi && xi < N && 0 <= yi && yi < M)
                if (A[xi][yi] >= A[isrc][jsrc] - D)
                   if (!B[xi][yi]) {
                      B[xi][yi] = true;
                      Q.push(make_pair(xi, yi));
                   }
        }
    }
    int cnt = 0;
    FOR (i, 0, N) FOR (j, 0, M)
        if (B[i][j] && A[i][j] >= A[isrc][jsrc])
            cnt ++;

    return cnt;
}

int main(void)
{
    read_in();

    FILE *fo = fopen(oname, "w");
    
    FOR (i, 0, N) {
        FOR (j, 0, M)
            fprintf(fo, "%d ", work(i, j));
        fprintf(fo, "\n");
    }

    fclose(fo);
    return 0;
}
