#include <stdio.h>

int N, v[128];

inline void move(int x, int y, int z)
{                
	printf("%d %d %d\n", x, y, z);
	--v[x]; --v[y]; v[z] += 2; 
}

int get_free(int x, int y)
{
	if (x > 1 && y > 1)
		return 1;
	if (x == 1)
	{
		if (y > 2)
			return 2;
		return 3;
	}
	if (x > 2)
		return 2;
	return 3;	
}

int finish(void)
{
	int i, nr = 0;

	for (i = 1; i <= N; ++i)
		nr += (v[i] > 0);
	return (nr == 1);
}

void case1(int target)
{
	int i, j, free;

	for (i = 1; i <= N; ++i)
	{
		if (i == target || !v[i]) continue;

		for (j = i+1; j <= N; ++j)
			if (v[j] && target != j)
				break;
		if (j > N)
			return;
		free = get_free(i, j);

		for (; v[i] > 1; ) // finalul se mareste cu 2, restul neschimbate
		{
			move(i, j, free);
			move(i, free, j);
			move(j, free, target);
		}
	}
}

void case2(int target)
{
	int i, j;

	// suntem in cazul 1 .. 1 .. 1 ... ... X ... , X >= 1 - grupam cate de 2 de 1
 	for (i = 1; i <= N; ++i)
	{
		if (i == target || v[i] != 1) continue;
		for (j = i+1; j <= N; ++j)
			if (v[j] == 1 && j != target)
				break;
		if (j > N)
			return;
		move(i, j, target);
	}
}

void case3(void)
{
	int i, j = 0, fr;

	for (i = 1; i < N && !j; ++i)
		if (v[i])
			break;
	fr = get_free(i, N);

	move(i, N, fr);
	move(fr, i, N);
}

void case4(int target)
{
	int i, is, free;

	// suntem in cazul 1 ... X ... , X > 1 - scapam de gramada cu X
	for (is = 0, i = 1; i <= N && !is; ++i)
		if (v[i] > 1 && i != target)
			is = i;
	for (i = 1; i <= N; ++i)
		if (v[i] == 1 && i != target)
			break;
	free = get_free(i, is);
	for (; v[is] > 1; )
	{
		move(is, i, free);
		move(is, free, i);
		move(i, free, target);
	}
    if (v[is] == 1)
    {
        for (i = 1; i <= N; ++i)
            if (i != is && v[i] == 1)
               break;
        move(i, is, target);
    }
}

void case5(int target)
{
	int i, j, k, p;

	// suntem in cazul in care avem 1 FINAL - punem gramada cu 1 in borcanul final din 7 mutari
	for (i = 1; i <= N; ++i)
		if (v[i] == 1)
			break;
	for (p = 1, j = k = 0; p <= N; ++p)
	{
		if (v[p] || p == target) continue;
		if (!j) j = p;
		else if (!k) k = p;
		else break;
	}

	move(i, target, k);
	move(k, target, j);
	move(j, target, i);
	move(i, k, j);
	move(j, i, k);
	move(j, k, target);
	move(j, k, target);
}

int main(void)
{
	int i, j, k;

	freopen("borcane.in", "r", stdin);
	freopen("borcane.out", "w", stdout);
	
	scanf("%d", &N);
	for (i = 1; i <= N; ++i)
		scanf("%d", &v[i]);

	if (finish())
		return 0;
	case1(N);
	if (finish())
		return 0;
	case2(N);

	if (finish())
		return 0;
	for (i = 1, j = k = 0; i <= N; ++i)
	{
                if (v[i] == 1)
                        j = 1;
                if (v[i] > 1)
                        k = 1;
	}
	if (!j && k) // avem o singura gramada X > 1 si targetul N
	{
		case3();
	    case4(N);
	}
	else if (j && k)
		case4(N);

	if (finish())
		return 0;
	// avem o singura gramada cu 1 si starea finala
	for (i = 1; i <= N; ++i)
		if (v[i] > 1)
			break;
	case5(i);

	return 0;
}

