#include <stdio.h>
#include <algorithm>

using namespace std;

#define NMax 805

typedef struct { int tip, timp, nod; } event;

int M, N, D, Res[NMax][NMax], tata[NMax*NMax], rang[NMax*NMax], rosu[NMax*NMax], val[NMax*NMax];
char color[NMax*NMax];
event E[NMax*NMax*2]; int nr_ev;

int cmp_event(const event &a, const event &b)
{
	if (a.timp != b.timp)
		return a.timp < b.timp;
	return a.tip > b.tip;
}

void uneste(int x, int y)
{
	if (rang[x] < rang[y])
		tata[x] = y, rosu[y] += rosu[x];
	else
	{
		tata[y] = x;
		rosu[x] += rosu[y];
		rang[x] += (rang[x] == rang[y]);
	}
}

int find_multime(int x)
{
	if (x != tata[x])
		tata[x] = find_multime(tata[x]);
	return tata[x];
}

void join_set(int x, int y)
{
	int i1 = find_multime(x);
	int i2 = find_multime(y);

	if (i1 != i2)
		uneste(i1, i2);		
}


int main(void)
{
	int i, j, x, l, c;

	freopen("mexc.in", "r", stdin);
	freopen("mexc.out", "w", stdout);

	scanf("%d %d %d", &M, &N, &D);
	for (i = 1; i <= M; ++i)
		for (j = 1; j <= N; ++j)
		{
			scanf("%d", &x);
         		val[(i-1)*N+j] = x;
			++nr_ev; E[nr_ev].tip = 1; E[nr_ev].timp = x+D; E[nr_ev].nod = (i-1)*N+j;
			++nr_ev; E[nr_ev].tip = 2; E[nr_ev].timp = x; E[nr_ev].nod = (i-1)*N+j;	
		}
	sort(E+1, E+nr_ev+1, cmp_event);

	for (i = 1; i <= M*N; ++i)
		rang[i] = 1, tata[i] = i;

	for (i = nr_ev; i; --i)
	{
		color[E[i].nod] = 1;
		if (E[i].tip == 1) // coloram cu negru
		{
			if (E[i].nod > N && color[E[i].nod-N]) // mergem in sus
				join_set(E[i].nod, E[i].nod-N);
			if (E[i].nod + N <= M*N && color[E[i].nod+N]) // mergem in jos
				join_set(E[i].nod, E[i].nod+N);
			if (N > 1 && E[i].nod % N != 1 && color[E[i].nod-1]) // mergem la dreapta
				join_set(E[i].nod, E[i].nod-1);
			if (N > 1 && E[i].nod % N && color[E[i].nod+1]) // mergem la stanga
				join_set(E[i].nod, E[i].nod+1);
			continue;
		}

		// coloram cu rosu si vedem cate sunt cu rosu in multimea noastra
      		for (j = i; E[i].tip == 2 && val[E[i].nod] == val[E[j].nod]; --i)
      		{
         		x = find_multime(E[i].nod);
         		rosu[x]++;
      		}
	   	for (++i; j >= i; --j)
      		{
            		x = find_multime(E[j].nod);
			(E[j].nod % N) ? (l = E[j].nod / N + 1) : (l = E[j].nod / N);
			(E[j].nod % N) ? (c = E[j].nod % N) : (c = N);
			Res[l][c] = rosu[x];
      		}
	} 

	for (i = 1; i <= M; ++i)
	{
		for (j = 1; j < N; ++j)
			printf("%d ", Res[i][j]);
		printf("%d\n", Res[i][N]);
	}

	return 0;
}

