#include <cstdio>
#include <string>

#define FL

#define fin  "mexc.in"
#define fout "mexc.out"

const int Nmax = 801;
const int Max  = 100200;

const int deltax[] = { -1, 0, 1,  0 };
const int deltay[] = {  0, 1, 0, -1 };

int N,M,D;
int map[Nmax][Nmax],ret[Nmax][Nmax];

void readdata()
{
	int i,j;

	freopen(fin,"r",stdin);
#ifdef FL
	freopen(fout,"w",stdout);
#endif

	scanf("%d%d%d",&N,&M,&D);

	for ( i = 1; i <= N; ++i )
	{
		for ( j = 1; j <= M; ++j )
			scanf("%d",&map[i][j]);
	}
}

void bfs(int startx,int starty)
{
	int i,j,x,y,dr,qx[Nmax*Nmax],qy[Nmax*Nmax];
	int cnt,curr;
	char viz[Nmax][Nmax];

	dr = 1;
	cnt = 1;
	qx[ 1 ] = startx;
	qy[ 1 ] = starty;

	memset(viz,0,sizeof(viz));
	
	viz[startx][starty] = 1;
	
	curr = map[startx][starty] - D;

	for ( i = 1; i <= dr; ++i )
	{
		x = qx[i];
		y = qy[i];
	
		for ( j = 0; j < 4; ++j )
		{
			x = qx[i] + deltax[j];
			y = qy[i] + deltay[j];
			if ( x > 0 && y > 0 && x <= N && y <= M && !viz[x][y] && map[x][y] >= curr )
			{
				++dr;
				qx[dr] = x; qy[dr] = y;
				viz[x][y] = 1;
				if ( map[x][y] >= map[startx][starty] )
					++cnt;
			}
		}
	}

	for ( i = 1; i <= N; ++i )
	for ( j = 1; j <= M; ++j )
		if ( map[i][j] == map[startx][starty] && viz[i][j] )
			ret[i][j] = cnt;
}

void solve()
{
	int i,j;


	for ( i = 1; i <= N; ++i )
		for ( j = 1; j <= M; ++j )
			if ( !ret[i][j] )
				bfs(i,j);

	for ( i = 1; i <= N; ++i )
	{
		for ( j = 1; j <= M; ++j )
			printf("%d ", ret[i][j]);
		printf("\n");
	}
}

int main()
{
	readdata();
	solve();
	return 0;
}
