#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>

using namespace std;

#define pb push_back

#define pii pair< int, int >
#define ppii pair< int, pii >
#define fi first
#define se second
#define mp(X,Y) make_pair((X),(Y))

#define ALL(C) C.begin(), C.end()

#define TR(C,it) \
	for( typeof(C.begin()) it = C.begin(); it != C.end(); it++ )

#define NX 2048
#define TX 1024
#define LSZ (1<<13)

int N, T;
int vdg[ NX ], tdg[ NX ], deg[ NX ], pi[ NX ];
int c[ NX ][ NX + TX ];
char line[ LSZ ];

bool rep[ NX ][ NX ];

vector< int > G[ NX ];
pair< int, pii > tvec[ NX * TX ];

struct cmp {
	bool operator() ( const ppii &x, const ppii &y ) const {
		return x.fi > y.fi;
	}
};

void cit() {
	int i, j, u, v;
	
	scanf( "%d %d ", &N, &T );
	for( i = 1; i < N; i++ ) {
		scanf( "%d %d ", &u, &v );
		G[u].pb( v ), G[v].pb( u );
		deg[u]++, deg[v]++;
	}
	for( i = 1; i <= N; i++ ) {
		fgets( line, LSZ, stdin );
		for( j = 0; j < T; j++ )
			rep[i][j] = (bool) (line[ 2*j ] - '0');
	}
}

void DFS( int u ) {
	TR( G[u], v )
		if( pi[*v] == 0 )
			pi[*v] = u, DFS( *v );
}

int solve( int x, int y ) {
	if( c[x][y] >= 0 )
		return c[x][y];
	if( deg[x] == 1 && pi[x] > 0 )
		return ( c[x][y] = y );

	int nv, i, t, vt, tt, ok, cnt;
	
	nv = deg[x]; if( pi[x] > 0 ) nv--;
	
	for( t = y, i = 0; i < nv; t++, i++ ) {
		while( t < T && rep[x][t] ) t++;
		TR( G[x], v ) if( *v != pi[x] )
			solve( *v, t+1 );
	}

	cnt = 0;
/*
	memset( vdg, 0, sizeof( vdg ) );
	memset( tdg, 0, sizeof( tdg ) );
*/

	for( t = y, i = 0; i < nv; t++, i++ ) {
		while( t < T && rep[x][t] ) t++;
		TR( G[x], v ) if( *v != pi[x] )
			vdg[ *v ]=0, tdg[ t ]=0;
	}

	for( t = y, i = cnt = 0; i < nv; t++, i++ ) {
		while( t < T && rep[x][t] ) t++;
		TR( G[x], v ) if( *v != pi[x] ) {
			tvec[ cnt++ ] = mp( c[*v][t+1], mp( *v, t ) );
			vdg[ *v ]++, tdg[ t ]++;
		}
	}
	sort( tvec, tvec + cnt, cmp() );
	for( ok = 1, i = 0; ok; i++ ) {
		vt = tvec[i].se.fi;
		tt = tvec[i].se.se;
		if( vdg[ vt ] > 1 && tdg[ tt ] > 1 )
			vdg[ vt ]--, tdg[ tt ]--;
		else
			ok = 0;
	}
	return ( c[x][y] = tvec[i-1].fi );
}

void rez() {
	pi[1] = -1; DFS( 1 );
	memset( c, -1, sizeof( c ) );
	printf( "%d\n", solve( 1, 0 ) );
}

int main() {
	freopen( "tcast.in", "r", stdin );
	freopen( "tcast.out", "w", stdout );

	cit();
	rez();

	return 0;
}

