#include <cstdio>
#include <queue>

using namespace std;

#define MAXN 32

int N, M, K;
char m[MAXN][MAXN], need[MAXN][MAXN];
char used[MAXN];
queue<int> Q;

inline void bfs( int k )
{
	need[k][k] = 1;
	for (Q.push(k); !Q.empty(); Q.pop())
	{
		int i = Q.front();
		for (int j = 1; j <= N; j++)
			if (m[i][j] && !need[k][j])
				need[k][j] = 1,
				Q.push(j);
	}
}

int NR = 0;

inline void back( int k, int l )
{
	if (k == K)
	{
		int OK = 1;
		for (int i = 1; i <= N && OK; i++)
		{
			if (!used[i])
				continue;
			for (int j = 1; j <= N && OK; j++)
				if (need[i][j] && !used[j])
					OK = 0;
		}

		if (OK)
			NR++;
		return;
	}

	for (int i = l + 1; i <= N - (K - k) + 1; i++)
		used[i] = 1,
		back(k + 1, i),
		used[i] = 0;
}

int main()
{
	freopen("dep.in", "rt", stdin);
	freopen("dep.out", "wt", stdout);

	scanf("%d %d %d", &N, &M, &K);
	for (int i = 0; i < M; i++)
	{
		int X, Y;
		scanf("%d %d", &X, &Y);
		m[X][Y] = 1;
	}
	for (int i = 1; i <= N; i++)
		bfs(i);

	back(0, 0);
	printf("%d\n", NR);
	
	return 0;
}
