#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXN 100005
#define MAXV 1000005

#define X first
#define Y second

int N;
vector< pair<int, int> > pct;
vector<int> xs;
int aibMin[MAXN], aibMax[MAXN];

inline void update( int poz, int val )
{
	for (poz++; poz < MAXN; poz += (poz ^ (poz - 1)) & poz)
	{
		if (val < aibMin[poz])
			aibMin[poz] = val;
		if (val > aibMax[poz])
			aibMax[poz] = val;
	}
}

inline void query( int poz, int &MIN, int &MAX )
{
	MIN = 0x3f3f3f3f;
	MAX = -1;
	for (poz++; poz; poz &= (poz - 1))
	{
		if (aibMin[poz] < MIN)
			MIN = aibMin[poz];
		if (aibMax[poz] > MAX)
			MAX = aibMax[poz];
	}
}

inline int find( int val )
{
	int rez = -1, step = (1 << 16);
	for (; step; step >>= 1)
		if (rez + step < (int)xs.size() && xs[rez + step] <= val)
			rez += step;
	return rez;
}

int main()
{
	freopen("dist.in", "rt", stdin);
	freopen("dist.out", "wt", stdout);

	scanf("%d", &N);
	for (int i = 0; i < N; i++)
	{
		int X, Y;
		scanf("%d %d", &X, &Y);
		pct.push_back( make_pair(X, Y) );
		xs.push_back(X);
	}

	sort( xs.begin(), xs.end() );
	xs.resize( unique( xs.begin(), xs.end() ) - xs.begin() );

	sort( pct.begin(), pct.end() );
	
	memset( aibMin, 0x3f, sizeof(aibMin) );
	memset( aibMax, -1, sizeof(aibMax) );
	int MAX = -1;
	for (size_t k = 0; k < pct.size(); k++)
	{
		update( find( pct[k].X ), pct[k].Y );

		int rez = 0, step = (1 << 21);
		for (; step; step >>= 1)
		{
			rez += step;
			int pozX = find( pct[k].X - rez );
			int minY, maxY;
			query( pozX, minY, maxY );

			if (pct[k].Y - minY < rez && maxY - pct[k].Y < rez)
				rez -= step;
		}

		if (rez > MAX)
			MAX = rez;
	}

	printf("%d\n", MAX);
	
	return 0;
}
