#include <iostream>
#include <cmath>
#include <cstdlib>
using namespace std;

#define _name_ "dist"
#define FIN _name_".in"
#define FOUT _name_".out"
#define MAXN 100000

#define dist(a,b) min(abs(P[a].x - P[b].x),\
		abs(P[a].y - P[b].y))

int n;
int D[MAXN];
struct pct { int x, y; } P[MAXN];

inline int min(int &a, int &b) {
	return a < b ? a : b;
}

void brut()
{
	int i, j, max = 0;
	for (i = 0; i < n; ++i) {
		for (j = 0; j < n; ++j) {
			if (dist(i, j) > max) max = dist(i, j);
		}
	}
	printf("%d\n", max);
	exit(0);
}

void solveala()
{
	int i, j, rez = 0;
	if (n == 2) {
		printf("%d\n", dist(0,1));
		return;
	}
	if (n <= 1000)
		brut();
	else {
		int lim = 100000;
		for (i = 0; i < lim; ++i) {
			int a = random() % n, b = random() % n;
			//if (a == b) { --i; continue; }
			if (dist(a,b) > rez)
				rez = dist(a, b);
		}
		printf("%d\n", rez);
	}
}

void citeala()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT,"w",stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d %d", &P[i].x, &P[i].y);
	}
}

int main()
{
	srandom(time(0));
	citeala();
	solveala();
	return 0;
}
