#include <algorithm>
#include <cstdio>
using namespace std;
#define mp make_pair
#define x first
#define y second
#define MAX_N 100100
typedef pair<int,int> ii;

ii reper, P[MAX_N];
int i, n, j, dm;

int mic(ii a, ii b) {
	return ( a.y<b.y ) || (a.y==b.y && a.x<b.x);
}
struct comp {
	long long dist(ii A) {
		long long x = A.x-reper.x;
		long long y = A.y-reper.y;
		return x*x+y*y;
	}
	int operator()(ii A, ii B) {
		int x1 = A.x - reper.x;
		int y1 = A.y - reper.y;
		int x2 = B.x - reper.x;
		int y2 = B.y - reper.y;
		long long a = (long long)x1*y2;
		long long b = (long long)x2*y1;
		if ( a==b )
			return dist(A) < dist(B);
		return a > b;
	}
};
int H[MAX_N], v;

bool val( ii A, ii B, ii C ) {
	long long x1 = B.x - A.x;
	long long x2 = C.x - A.x;
	long long y1 = B.y - A.y;
	long long y2 = C.y - A.y;
	return x1 * y2 <= x2 * y1;
}

void hull( int r ) {
	reper = P[r];
	swap(P[0], P[r]);
	sort(P+1, P+n, comp());
	H[0] = 0, H[1] = 1, H[2] = 2, v = 2;
	for ( i=3; i<n; ++i ) {
		while ( val(P[H[v-1]], P[H[v]], P[i]) && v>1 )
			--v;
		H[ ++v ] = i;
	}
}

int dist(ii A, ii B) {
	int x, y;
	x = A.x - B.x;
	y = A.y - B.y;
	x = max(x, -x);
	y = max(y, -y);
	return x<y ? x : y;
}
void brut() {
	/* pot optimiza facand doar pe convex hull */
	int i,j,dm=0;
	for ( i=0; i<n; ++i )
		for (j=i+1; j<n; ++j ) {
			dm = max(dm, dist(P[i], P[j]));
		}
	printf("%d\n", dm);
}
int main() {
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);
	scanf("%d", &n);
	reper = mp(0x3f3f3f3f, 0x3f3f3f3f);
	int r = 0;
	for (i=0; i<n; ++i) {
		int x, y;
		scanf("%d %d", &x, &y);
		P[i] = mp(x, y);
		if ( mic(P[i], P[r]) ) r =i;
	}
	if ( n==2 ) {
		int x, y;
		x = P[0].x - P[1].x;
		y = P[0].y - P[1].y;
		x = max(x, -x);
		y = max(y, -y);
		dm = max(dm, x<y ? x : y);
		printf("%d\n", dm);		
		return 0;
	}


	if ( n<=800 ) {
		brut();
		return 0;
	}

	hull( r );
	for ( i=0; i<=v; ++i )
		for ( j=i+1; j<=v; ++j ) {
			dm = max(dm, dist( P[H[i]], P[H[j]] ) );
		}
	printf("%d\n", dm);
	return 0;
}
