#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

#define FIN "dist.in"
#define FOUT "dist.out"
#define MAX_N 100005
#define MAX_L 6005
#define eps 0.000001
#define ar1 4
#define ar2 10000

typedef struct point
{
   int x, y;
   double p;
};

point A[MAX_N + 5];
point S[MAX_L];

unsigned char V[MAX_N];

int N;
int BEST;

struct cmp
{
       bool operator () (const point &a, const point &b) const
                {
                     if (double(b.p - a.p) < eps) return 0;
                     return 1;
                }
};

     inline int MIN(int a, int b)
     {
        if (a < b) return a; else return b;
     }

     inline int dist (int i, int j)
     {
        return MIN (abs(S[i].x - S[j].x), abs (S[i].y - S[j].y));
     }


     void readdata ()
     {
         int i, j;
         scanf ("%d\n", &N);
         for (i = 1; i <= N; ++i)
         {
              scanf ("%d %d", &A[i].x, &A[i].y);
              if (A[i].x) A[i].p = (double) ((double)A[i].y / (double)A[i].x);
         }
     }

     inline double fnc(double a, double b)
     {
        if (a - b > eps) return (a - b); else return (b - a);
     }

     inline int IN(double a, double b, int L1, int L2)
     {
          int ret = 1;
          if (a < double(L1) || b > (double) L2) ret = 0;
          return ret;
     }

     int ok (double a, double b)
     {
          int ret = 1;
          if (IN(a, b, -2, 2))
             if (fnc(a, b) > ar1) ret = 0;
          if (!IN(a, b, -2, 2))
             if (fnc(a, b) > ar2) ret = 0;
          
          return ret;
     }

     void combine (int H)
     {
        int i, j;
        for (i = 1; i <= H; ++i)
           for (j = i + 1; j <= H; ++j)
           {
                int min = dist (i, j);
                if (min > BEST) BEST = min;
           }
     }

     void solve ()
     {
         int i, j;

         for (i = 1; i <= N; ++i)
         if (V[i] != 1)
         {
            //  printf ("%lf\n", A[i].p);
              int li, lf, ct = 0;
              li = i - 1, lf = i + 1;
              
              S[++ct] = A[i];
              V[i] = 1;

              while (li-- > 0 && ok ((double)A[i].p, (double)A[li].p) && ct < MAX_L)
                 if (V[li] != 1)  S[++ct] = A[li], V[li] = 1;
              while (lf++ <= N && ok ((double)A[i].p, (double)A[lf].p) && ct < MAX_L)
                 if (V[lf] != 1)  S[++ct] = A[lf], V[lf] = 1;

              if (lf > i) i = lf;
              combine (ct);
         }
     }

     int main ()
     {
         freopen (FIN, "r", stdin);
         freopen (FOUT, "w", stdout);

         readdata ();
         sort (A + 1, A + N + 1, cmp());
         
      //    for (int i = 1; i <= N; ++i) printf ("%d %d %lf\n", A[i].x, A[i].y, A[i].p);
         
         solve ();
         printf ("%d\n", BEST);

         return 0;
     }

