#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;

struct pc {

                int x,y;
};

#define MAX 100005
#define INF 0x3f3f3f3f

pc sirx[MAX];
int vmin[MAX], vmax[MAX];

inline int min(int a, int b)
{
        return a<b ? a : b;
}

inline int max ( int a, int b)
{
        return a>b ? a : b;
}

int N, rez;

int cmpx ( const pc &a, const pc &b)
{
        return a.x < b.x;
}

inline int ab( int a)
{
        return a >= 0 ? a : -a;
}


inline int dist( pc &a, pc &b)
{
        return ab(a.x-b.x) < ab(a.y-b.y) ? ab(a.x-b.x) : ab(a.y-b.y);
}


void build()
{
        vmax[0] = vmin[0] = sirx[0].y;
        for (int i = 1; i<N; i++)
        {
                vmax[i] = max(vmax[i-1], sirx[i].y);
                vmin[i] = min(vmin[i-1], sirx[i].y);
        }
}


int calc(int dist)
{
        int poz = 0;
        for ( int i = 0; i<N; ++i)
        {
                pc aux;
                aux.x = sirx[i].x - dist;
                int ymax, ymin;
                pc *px;

                while ( poz < N && sirx[poz].x <= aux.x ) poz++;

                //px = upper_bound(sirx, sirx+i, aux, cmpx);
                //poz = px - sirx;
                if ( poz>0 && sirx[poz-1].x <= aux.x )
                {

                        ymax = vmax[poz-1];
                        ymin = vmin[poz-1];
                
                        if ( abs(ymax-sirx[i].y) >= dist )
                                return 1;
                        if ( abs(sirx[i].y - ymin) >= dist )
                               return 1;
                }
        }
        return 0;
}
                

int bsearch()
{
        int a=0,b=2000005,c; //!!!!!!!!!!!!!!!!!!!!!!!1

        while ( a <= b)
        {
                int c = (a+b) >> 1;
                if ( calc(c) )
                {
                        rez = c;
                        a = c+1;
                }
                else
                        b = c -1;
        }
}

int main()
{

        freopen("dist.in", "r", stdin);
        freopen("dist.out", "w", stdout);

        scanf("%d\n", &N);
        for ( int i = 0; i<N; i++)
        {
                int x,y;
                scanf("%d %d", &sirx[i].x, &sirx[i].y);

        }

        sort (sirx, sirx+N, cmpx);

        build();

        bsearch();

        printf("%d\n", rez);

        return 0;
}


