#include<stdio.h>
#include<math.h>
#define Nmax 100010

int N;
struct nod{int x,y;} P[Nmax], IC[Nmax];

int hull[Nmax], Nhull=0, NIC=0;
char viz[Nmax];

int min(int a,int b){
    if(a<0) a=-a;
    if(b<0) b=-b;

    if(a<b)
        return a;
    return b;
}

int calc(int i,int j,int k){
    long long A,B,C,R;
    A = P[k].y - P[i].y;
    B = P[i].x - P[k].x;
    C = A*(long long)P[i].x + B*(long long)P[i].y; C=-C;

    R = A*(long long)P[j].x + B*(long long)P[j].y + C;

    if(R < 0)
        return -1;
    if(R > 0)
        return 1;
    return 0;
}

int main(){

    FILE *fin = fopen("dist.in","r");
    FILE *fout = fopen("dist.out","w");

    fscanf(fin,"%d",&N);
    for(int i=1;i<=N;i++)
        fscanf(fin,"%d%d",&P[i].x,&P[i].y);

    //sortarea
    for(int i=1;i<=N;i++){
        int j = i;
        while(j/2 && (P[j/2].x < P[j].x || (P[j/2].x==P[j].x && P[j/2].y < P[j].y)) ){
            nod aux = P[j/2];P[j/2] = P[j];P[j] =aux;
            j>>=1;
        }
    }

    int cate = N;
    while(cate > 1){
        nod aux = P[1]; P[1] = P[cate]; P[cate] = aux;
        cate--;

        int j = 1;
        while(1){
            int k = j<<1;
            if(k>cate) break;
            if(k+1<=cate && (P[k+1].x > P[k].x || (P[k+1].x == P[k].x && P[k+1].y > P[k].y) ) ) k++;
            if(P[j].x > P[k].x || (P[j].x == P[k].x && P[j].y > P[k].y) ) break;

            aux = P[j]; P[j] = P[k]; P[k] = aux;
            j = k;
        }
    }

    //hull
    Nhull = 2;
    hull[1] = 1; hull[2] = 2;
    viz[1] = viz[2] = 1;

    for(int i=3;i<=N;i++){
        //incerc sa bag i
        while(Nhull >= 2 && calc(hull[Nhull-1], hull[Nhull], i) < 0){
            viz[hull[Nhull]] = 0;
            Nhull --;
        }

        hull[++Nhull] = i;
        viz[i] = 1;
    }

    for(int i=N; i; i--)
        if(viz[i]==0){
            while(Nhull >= 2 && calc(hull[Nhull-1], hull[Nhull], i) < 0){
                viz[hull[Nhull]] = 0;
                Nhull --;
            }

            hull[++Nhull] = i;
            viz[i] = 1;
        }

    while(Nhull > 3 && calc(hull[Nhull-1], hull[Nhull], 1) < 0){
        viz[hull[Nhull]] = 0;
        Nhull--;
    }

    //salvare prima infasuratoare
    for(int i=1;i<=Nhull;i++)
        IC[i] = P[hull[i]];
    NIC = Nhull;

    //a doua infasuratoare
    int M=0;
    for(int i=1;i<=N;i++)
        if(viz[i]==0)
            P[++M] = P[i];
        else
            viz[i] = 0;
    N = M;


    Nhull = 2;
    hull[1] = 1; hull[2] = 2;
    viz[1] = viz[2] = 1;

    for(int i=3;i<=N;i++){
        //incerc sa bag i
        while(Nhull >= 2 && calc(hull[Nhull-1], hull[Nhull], i) < 0){
            viz[hull[Nhull]] = 0;
            Nhull --;
        }

        hull[++Nhull] = i;
        viz[i] = 1;
    }

    for(int i=N; i; i--)
        if(viz[i]==0){
            while(Nhull >= 2 && calc(hull[Nhull-1], hull[Nhull], i) < 0){
                viz[hull[Nhull]] = 0;
                Nhull --;
            }

            hull[++Nhull] = i;
            viz[i] = 1;
        }

    while(Nhull > 3 && calc(hull[Nhull-1], hull[Nhull], 1) < 0){
        viz[hull[Nhull]] = 0;
        Nhull--;
    }

    for(int i=1;i<=Nhull;i++)
        IC[++NIC] = P[hull[i]];
/*
    //a treia infasuratoare
    M=0;
    for(int i=1;i<=N;i++)
        if(viz[i]==0)
            P[++M] = P[i];
        else
            viz[i] = 0;
    N = M;

    Nhull = 2;
    hull[1] = 1; hull[2] = 2;
    viz[1] = viz[2] = 1;

    for(int i=3;i<=N;i++){
        //incerc sa bag i
        while(Nhull >= 2 && calc(hull[Nhull-1], hull[Nhull], i) < 0){
            viz[hull[Nhull]] = 0;
            Nhull --;
        }

        hull[++Nhull] = i;
        viz[i] = 1;
    }

    for(int i=N; i; i--)
        if(viz[i]==0){
            while(Nhull >= 2 && calc(hull[Nhull-1], hull[Nhull], i) < 0){
                viz[hull[Nhull]] = 0;
                Nhull --;
            }

            hull[++Nhull] = i;
            viz[i] = 1;
        }

    while(Nhull > 3 && calc(hull[Nhull-1], hull[Nhull], 1) < 0){
        viz[hull[Nhull]] = 0;
        Nhull--;
    }

    for(int i=1;i<=Nhull;i++)
        IC[++NIC] = P[hull[i]];
*/

    //verificare bruta
    
    int sol = -1;
    for(int i=1;i<=NIC;i++)
        for(int j=1;j<=NIC;j++){
            int dist = min(IC[i].x - IC[j].x, IC[i].y - IC[j].y);
            if(dist > sol)
                sol = dist;
        }

    fprintf(fout,"%d\n",sol);

    fclose(fin);
    fclose(fout);
    return 0;


}

