#include <cstdio>
#include <cstdlib>
#include <cstring>

const int NMAX = 260;
const int MOD = 666013;

int N, M, K, NS;
int A[NMAX], B[NMAX];
bool G[NMAX][NMAX], T[NMAX][NMAX], IN[NMAX], U[NMAX];
int C[NMAX], V[NMAX], P[NMAX], ST[NMAX];
int W[NMAX][NMAX], Q[NMAX];

void read(void) {
	FILE *fin = fopen("dep.in", "rt");
	int i, u, v;

	fscanf(fin, " %d %d %d", &N, &M, &K);

	for (i = 0; i < M; ++i)
		fscanf(fin, " %d %d", &u, &v), G[u][v] = true;

	for (i = 1; i <= N; ++i)
		P[i] = i;

	fclose(fin);
}

int parinte(int k) {
	if (P[k] != k)
		P[k] = parinte(P[k]);
	return P[k];
}

void unite(int u, int v) {
	u = parinte(u); v = parinte(v);
	if (u == v) return;
	if (rand() & 1)
		P[u] = v;
	else
		P[v] = u;
}

void DFS(int k, int t) {
	if (V[k] == t && U[k]) {
		while (parinte( ST[NS] ) != parinte(k))
			unite(ST[NS--], k);
			
		return;
	}
	if (V[k]) return;

	ST[++NS] = k;
	V[k] = t;
	U[k] = true;

	int i;
	for (i = 1; i <= N; ++i)
		if (G[k][i])
			DFS(i, t);
	
	if (ST[NS] == k) --NS;
	U[k] = false;
}

void update(int v, int w) {
	int i;

	for (i = 0; i <= K - v; ++i)
		B[i + v] = (B[i + v] + (long long)w * A[i]) % MOD;
}

void go(int k) {
	int i, j, t;

	W[k][ C[k] ] = 1;
	for (i = 1; i <= N; ++i) {
		if (!T[k][i]) continue;
		go(i);

		memset(Q, 0x00, sizeof(Q));
		for (j = 1; j <= K; ++j)
			for (t = 1; j + t <= K; ++t)
				Q[j + t] = (Q[j + t] + (long long) W[k][j] * W[i][t]) % MOD;

		for (j = 1; j <= K; ++j)
			W[k][j] = (W[k][j] + Q[j]) % MOD;
	}
}

void solve(void) {
	int i, j, p, t;

	for (i = 1; i <= N; ++i)
		if (!V[i])
			DFS(i, i);
	
	for (i = 1; i <= N; ++i) {
		p = parinte(i);
		++C[p];
		
		for (j = 1; j <= N; ++j) {
			t = parinte(j);
			if (G[i][j] && t != p) {
				T[ parinte(j) ][p] = true;
				IN[p] = true;
			}
		}
	}
/*
	for (i = 1; i <= N; ++i)
		printf("%d(%d, %d) ", parinte(i), C[parinte(i)], IN[parinte(i)]);
	printf("\n");

	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= N; ++j)
			printf("%d ", T[i][j]);
		printf("\n");
	}
*/
	memset(V, 0x00, sizeof(V));
	B[0] = A[0] = 1;
	for (i = 1; i <= N; ++i) {
		p = parinte(i);
		if (V[p] || IN[p]) continue;
		V[p] = 1;

		go(p);

		for (j = 1; j <= K; ++j)
			update(j, W[p][j]);

		memcpy(A, B, sizeof(A));
	}
/*
	for (i = 1; i <= N; ++i) {
		for (j = 1; j <= K; ++j)
			printf("%d ", W[i][j]);
		printf("\n");
	}
*/
}

void write(void) {
	FILE *fout = fopen("dep.out", "wt");

	fprintf(fout, "%d\n", A[K]);

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}
