#include <cstdio>
#include <algorithm>

using namespace std;

struct coor {
	int x, y;

	coor (int _x = 0, int _y = 0) : x(_x), y(_y) {}
	bool operator<(const coor &p) const {
		return (x < p.x) || (x == p.x && y > p.y);
	}

};

int dist(const coor &a, const coor &b) {
	return min( abs(a.x - b.x), abs(a.y - b.y) );
}

const int NMAX = 1 << 17;

int N, NS, REZ;
coor A[NMAX], ST[NMAX], V;

void read(void) {
	FILE *fin = fopen("dist.in", "rt");
	int i;

	fscanf(fin, " %d", &N);

	for (i = 0; i < N; ++i)
		fscanf(fin, " %d %d", &A[i].x, &A[i].y);

	fclose(fin);
}

int seek(int st, int dr) {
	if (st + 8 >= dr) {
		int ret = 0, i;

		for (i = st; i <= dr; ++i)
			ret = max(ret, dist(V, ST[i]));

		return ret;
	}

	int i, j;
	i = (2 * st + dr) / 3;
	j = (st + 2 * dr) / 3;

	if (dist(V, i) > dist(V, j))
		return seek(st, j);
	return seek(i, dr);
}

void get(void) {
	int i;

	ST[0] = A[0]; NS = 1;
	for (i = 1; i < N; ++i) {
		V = A[i];
		REZ = max(REZ, seek(0, NS - 1));
		if (A[i].y > ST[NS-1].y)
			ST[NS++] = A[i];
	}
}

void solve(void) {
	int i;

	sort(A, A + N);
	
	get();

	for (i = 0; i < N; ++i)
		A[i] = coor(-A[i].x, -A[i].y);
	reverse(A, A + N);

	get();
	
	for (i = 0; i < N; ++i)
		A[i].x = -A[i].x;
	
	sort(A, A + N);

	get();

	for (i = 0; i < N; ++i)
		A[i] = coor(-A[i].x, -A[i].y);
	reverse(A, A + N);

	get();

}

void write(void) {
	FILE *fout = fopen("dist.out", "wt");
	
	fprintf(fout, "%d\n", REZ);

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}
