#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define nm 100100
#define mm 300000
#define xx first
#define yy second
#define inf 1000100

int n, h[mm], sol;
vector< pair< pair<int, int>, pair<int, int> > > v;

inline int modul(int a)
{
	if (a < 0)
		return -a;
	return a;
}

inline int minim(int a, int b)
{
	if (a < b)
		return a;
	return b;
}

inline int maxim(int a, int b)
{
	if (a > b)
		return a;
	return b;
}

void update(int pos, int val)
{
	pos += (1 << 17) - 1;

	while (pos && h[pos] < val) {
		h[pos] = val;
		pos /= 2;
	}
}

int query(int nod, int st, int dr, int x, int y)
{
	int mid = (st + dr) / 2;
	
	if (x > y)
		return 0;
	
	if (x == st && y == dr)
		return h[nod];

	if (y <= mid)
		return query(nod * 2, st, mid, x, y);
		
	if (x > mid)
		return query(nod * 2 + 1, mid + 1, dr, x, y);
		
	return maxim(query(nod * 2, st, mid, x, mid), query(nod * 2 + 1, mid + 1, dr, mid + 1, y));
}

int comp1(pair< pair<int, int>, pair<int, int> > a, pair< pair<int, int>, pair<int, int> > b)
{
	return a.first.xx < b.first.xx;
}

int comp2(pair< pair<int, int>, pair<int, int> > a, pair< pair<int, int>, pair<int, int> > b)
{
	return a.first.yy < b.first.yy;
}

int comp3(pair< pair<int, int>, pair<int, int> > a, pair< pair<int, int>, pair<int, int> > b)
{
	return a.first.xx - a.first.yy < b.first.xx - b.first.yy;
}

int comp4(pair< pair<int, int>, pair<int, int> > a, pair< pair<int, int>, pair<int, int> > b)
{
	return a.first.xx + a.first.yy < b.first.xx + b.first.yy;
}

int main()
{
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	scanf("%d ", &n);

	for (int i = 0; i < n; ++i) {
		int x, y;
		
		scanf("%d%d", &x, &y);

		v.push_back(make_pair(make_pair(x, y), make_pair(0, 0)));
	}

	if (n <= 1000) {
		for (int i = 0; i < n; ++i)
			for (int j = i + 1; j < n; ++j) {
				int tmp = minim(modul(v[i].first.xx - v[j].first.xx), modul(v[i].first.yy - v[j].first.yy));
				
				if (sol < tmp)
					sol = tmp;
			}

		printf("%d\n", sol);

		return 0;
	}

	sol = 0;

	sort(v.begin(), v.end(), comp1);

	for (int i = 0; i < n; ++i)
		v[i].second.xx = i + 1;

	sort(v.begin(), v.end(), comp2);

	for (int i = 0; i < n; ++i)
		v[i].second.yy = i + 1;

	sort(v.begin(), v.end(), comp3);

	for (int i = 0; i < n; ++i) {
		int tmp = query(1, 1, 131072, v[i].second.yy + 1, n);

		if (tmp > v[i].first.xx + inf && sol < tmp - v[i].first.xx - inf)
			sol = tmp - v[i].first.xx - inf;

		update(v[i].second.yy, v[i].first.xx + inf);
	}

	memset(h, 0, sizeof(h));

	for (int i = n - 1; i >= 0; --i) {
		int tmp = query(1, 1, 131072, v[i].second.xx + 1, n);

		if (tmp > v[i].first.yy + inf && sol < tmp - v[i].first.yy - inf)
			sol = tmp - v[i].first.yy - inf;

		update(v[i].second.xx, v[i].first.yy + inf);
	}

	memset(h, 0, sizeof(h));

	sort(v.begin(), v.end(), comp4);

	for (int i = 0; i < n; ++i) {
		int tmp = query(1, 1, 131072, 1, v[i].second.yy - 1);

		if (tmp > v[i].first.xx + inf && sol < tmp - v[i].first.xx - inf)
			sol = tmp - v[i].first.xx - inf;

		update(v[i].second.yy, v[i].first.xx + inf);
	}

	memset(h, 0, sizeof(h));

	for (int i = n - 1; i >= 0; --i) {
		int tmp = query(1, 1, 131072, v[i].second.xx + 1, n);

		if (tmp > inf - v[i].first.yy && sol < tmp - inf + v[i].first.yy)
			sol = tmp - inf + v[i].first.yy;

		update(v[i].second.xx, inf - v[i].first.yy);
	}

	printf("%d\n", sol);

	return 0;
}
