#include <cstdio>
#include <algorithm>

using namespace std;

#define Nmax 100015
#define Vmax 2000015
#define pii pair<int, int>
#define x first
#define y second

int n, ymax;
pii sir[Nmax];
int aib[Vmax];

void citire()
{
	int i;

	scanf("%d\n", &n);
	for (i = 1; i <= n; ++i)
		scanf("%d %d\n", &sir[i].x, &sir[i].y);
}

void update(int pos, int add)
{
	while (pos <= ymax)
	{
		aib[pos] += add;
		pos += (pos ^ (pos - 1)) & pos;
	}
}

int query(int pos)
{
	int ret = 0;
	
	while (pos > 0)
	{
		ret += aib[pos];
		pos -= (pos ^ (pos - 1)) & pos;
	}

	return ret;
}

int works(int d)
{
	int i, last = 1;

	for (i = 1; i <= n; ++i)
	{
		while (last < i && sir[i].x - sir[last].x >= d)
		{
			update(sir[last].y, 1);
			++last;
		}

		if (sir[i].y - d >= 1 && query(sir[i].y - d))
		{
			for (i = 1; i < last; ++i)
				update(sir[i].y, -1);
			return 1;
		}
		if (sir[i].y + d - 1 <= ymax && last - query(sir[i].y + d - 1) - 1 > 0)
		{
			for (i = 1; i < last; ++i)
				update(sir[i].y, -1);
			return 1;
		}
	}

	for (i = 1; i < last; ++i)
		update(sir[i].y, -1);
	
	return 0;
}

void solve()
{
	int i, sol, step, ymin = 1;

    for (i = 1; i <= n; ++i)
		ymin = min(ymin, sir[i].y);

	for (i = 1; i <= n; ++i)
	{
		sir[i].y += - ymin + 1;
		ymax = max(ymax, sir[i].y);
	}

	sort(sir+1, sir+n+1);

	for (step = 1; step < Vmax; step <<= 1);
	for (sol = 0; step; step >>= 1)
		if (sol + step < ymax && works(sol + step))
			sol += step;

	printf("%d\n", sol);
}

int main()
{
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	citire();
	solve();

	return 0;
}
