#include <stdio.h>
#include <math.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX (1<<17)
#define INF 666000666
#define pb push_back
#define mp make_pair
#define ff first
#define ss second

vector<pair<int, int> > Dif;
int N, X[NMAX], Y[NMAX], T[2*NMAX], P, Q;
int norm[NMAX], Dmaxx[NMAX], Dmaxy[NMAX], Min;

void read()
{
        int i;

        scanf("%d", &N);

        for (i = 0; i < N; i++) scanf("%d %d", X+i, Y+i);
}

void init()
{
        int i;
        
        Dif.clear();
        for (i = 0; i < NMAX; i++) norm[i] = 0;
        for (i = 2*NMAX-1; i >= 0; i--) T[i] = INF;
}

void update(int x, int y)
{
        int nod = NMAX+x, l;

        T[nod] = y;

        while (nod>1)
        {
                nod = nod>>1;
                l = nod<<1;
                T[nod] = T[l];
                if (T[l]>T[l+1]) T[nod] = T[l+1];
        }
}

void query(int p, int q, int nod)
{
        int md = (p+q)>>1, l = nod<<1;

        if (P <= p && q <= Q)
        {
                if (T[nod]<Min) Min = T[nod];
                return;
        }

        if (p>=q) return;

        if ( (p <= P && P <= q)||(p <= Q && Q <= q) )
        {
                query(p,md,l);
                query(md+1,q,l+1);
        }
}

void solvex()
{
        int i, n=0, j, pct;

        init();

        for (i = 0; i < N; i++)
                Dif.pb(mp(abs(X[i]-Y[i]),i));

        sort(Dif.begin(),Dif.end());

        norm[0] = ++n;
        for (i = 1; i < N; i++)
                if (Dif[i].ff!=Dif[i-1].ff) norm[i] = ++n;
                else norm[i] = norm[i-1];

        update(norm[N-1],X[ Dif[N-1].ss ]);

        for (i = N-2; i >= 0; i--)
        {
                pct = Dif[i].ss;
                P = norm[i]; Q = N;
                Min = INF;
                query(0,NMAX-1,1);
                Dmaxx[ pct ] = X[ pct ]-Min;
                if (Dmaxx[ pct ]<0) Dmaxx[ pct ] = -Dmaxx[ pct ];
                update(norm[i],X[ pct ]);
        }
        n = 0;
}

void solvey()
{
        int i, n=0, pct;

        init();

        for (i = 0; i < N; i++)
                Dif.pb(mp(abs(X[i]-Y[i]),i));

        sort(Dif.begin(),Dif.end());

        norm[0] = ++n;
        for (i = 1; i < N; i++)
                if (Dif[i].ff!=Dif[i-1].ff) norm[i] = ++n;
                else norm[i] = norm[i-1];

        update(norm[N-1],Y[ Dif[N-1].ss ]);

        for (i = N-2; i >= 0; i--)
        {
                pct = Dif[i].ss;
                P = norm[i]; Q = N;
                Min = INF;
                query(0,NMAX-1,1);
                Dmaxy[ pct ] = Y[ pct ]-Min;
                if (Dmaxy[ pct ]<0) Dmaxy[ pct ] = -Dmaxy[ pct ];
                update(norm[i], Y[ pct ]);
        }
        n = 0;
}

void solvex2()
{
        int i, n=0, j, pct;

        init();

        for (i = 0; i < N; i++)
                Dif.pb(mp(X[i]-Y[i],i));

        sort(Dif.begin(),Dif.end());

        norm[0] = ++n;
        for (i = 1; i < N; i++)
                if (Dif[i].ff!=Dif[i-1].ff) norm[i] = ++n;
                else norm[i] = norm[i-1];

        update(norm[N-1],X[ Dif[N-1].ss ]);

        for (i = N-2; i >= 0; i--)
        {
                pct = Dif[i].ss;
                P = norm[i]; Q = N;
                Min = INF;
                query(0,NMAX-1,1);
                Dmaxx[ pct ] = X[ pct ]-Min;
                if (Dmaxx[ pct ]<0) Dmaxx[ pct ] = -Dmaxx[ pct ];
                update(norm[i],X[ pct ]);
        }

        init();

        for (i = 0; i < N; i++)
                Dif.pb(mp(Y[i]-X[i],i));

        sort(Dif.begin(),Dif.end());

        norm[0] = ++n;
        for (i = 1; i < N; i++)
                if (Dif[i].ff!=Dif[i-1].ff) norm[i] = ++n;
                else norm[i] = norm[i-1];

        update(norm[0],X[ Dif[0].ss ]);

        for (i = 1; i < N; i++)
        {
                pct = Dif[i].ss;
                P = 1; Q = norm[i];
                Min = INF;
                query(0,NMAX-1,1);
                Dmaxx[ pct ] = X[ pct ]-Min;
                if (Dmaxx[ pct ]<0) Dmaxx[ pct ] = -Dmaxx[ pct ];
                update(norm[i],X[ pct ]);
        }
}

void solvey2()
{
        int i, n=0, pct;

        init();

        for (i = 0; i < N; i++)
                Dif.pb(mp(X[i]-Y[i],i));

        sort(Dif.begin(),Dif.end());

        norm[0] = ++n;
        for (i = 1; i < N; i++)
                if (Dif[i].ff!=Dif[i-1].ff) norm[i] = ++n;
                else norm[i] = norm[i-1];

        update(norm[N-1],Y[ Dif[N-1].ss ]);

        for (i = N-2; i >= 0; i--)
        {
                pct = Dif[i].ss;
                P = norm[i]; Q = N;
                Min = INF;
                query(0,NMAX-1,1);
                Dmaxy[ pct ] = Y[ pct ]-Min;
                if (Dmaxy[ pct ]<0) Dmaxy[ pct ] = -Dmaxy[ pct ];
                update(norm[i], Y[ pct ]);
        }
        init();

        for (i = 0; i < N; i++)
                Dif.pb(mp(Y[i]-X[i],i));

        sort(Dif.begin(),Dif.end());

        norm[0] = ++n;
        for (i = 1; i < N; i++)
                if (Dif[i].ff!=Dif[i-1].ff) norm[i] = ++n;
                else norm[i] = norm[i-1];

        update(norm[0],Y[ Dif[0].ss ]);

        for (i = 1; i < N; i++)
        {
                pct = Dif[i].ss;
                P = 1; Q = norm[i];
                Min = INF;
                query(0,NMAX-1,1);
                Dmaxy[ pct ] = Y[ pct ]-Min;
                if (Dmaxy[ pct ]<0) Dmaxy[ pct ] = -Dmaxy[ pct ];
                update(norm[i], Y[ pct ]);
        }
}

void solve()
{
        int i, best;

        solvex();
        solvey();

        for (i = 0; i < N; i++)
                if (Dmaxx[i]>Dmaxy[i]) Dmaxx[i] = Dmaxy[i];

        for (i = 0; i < N; i++)
                if (Dmaxx[0]<Dmaxx[i]) Dmaxx[0] = Dmaxx[i];

        best = Dmaxx[0];

        for (i = 0; i < N; i++) Dmaxx[i] = Dmaxy[i] = 0;

        solvex2();
        solvey2();

        for (i = 0; i < N; i++)
                if (Dmaxx[i]>Dmaxy[i]) Dmaxx[i] = Dmaxy[i];

        for (i = 0; i < N; i++)
                if (Dmaxx[0]<Dmaxx[i]) Dmaxx[0] = Dmaxx[i];

        if (best>Dmaxx[0]) Dmaxx[0] = best;
}

void brut()
{
        int i, j, x, y, dmax = 0;

        for (i = 0; i < N; i++)
                for (j = 0; j < i; j++)
                {
                        x = X[i]-X[j];
                        if (x<0) x = -x;
                        y = Y[i]-Y[j];
                        if (y<0) y = -y;
                        if (x>y) x = y;
                        if (dmax<x) dmax = x;
                }
                
        printf("%d\n", dmax);
}

void write()
{
        printf("%d\n", Dmaxx[0]);
}

int main()
{
        freopen("dist.in", "r", stdin);
        freopen("dist.out", "w", stdout);

        read();
        if (N<=2000)
        {
                brut();
                return 0;
        }
        solve();
        write();

        return 0;
        
}

