#include <stdio.h>
#include <algorithm>

using namespace std;

#define minim(a, b) ((a < b) ? a : b)
#define maxim(a, b) ((a > b) ? a : b)
#define INF 999999999
#define PII pair<int, int>
#define x first
#define y second
#define NMax 100005

int N, dif[NMax], sum[NMax], js, jd, bst;
PII v[NMax];
int A1[NMax], A2[NMax], A3[NMax], A4[NMax];

int BS(int *X, int nr, int val)
{
	int l, r, m;

	for (l = 1, r = nr; l <= r; )
	{
		m = (l + r) / 2;
		if (X[m] < val) l = m+1;
		else if (X[m] > val) r = m-1;
		else return m;
	}
	return 0;
}

inline void update1(int x, int val)
{
	for (; x <= N; x += x^(x-1)&x)
		A1[x] = minim(A1[x], val);
}

inline void update2(int x, int val)
{
	for (; x <= N; x += x^(x-1)&x)
		A2[x] = minim(A2[x], val);
}

inline void update3(int x, int val)
{
	for (; x <= N; x += x^(x-1)&x)
		A3[x] = minim(A3[x], val);
}

inline void update4(int x, int val)
{
	for (; x <= N; x += x^(x-1)&x)
		A4[x] = maxim(A4[x], val);
}

inline int query1(int x)
{
	int r = INF;

	for (; x; x -= x^(x-1)&x)
		r = minim(r, A1[x]);
	return r;
}

inline int query2(int x)
{
	int r = INF;

	for (; x; x -= x^(x-1)&x)
		r = minim(r, A2[x]);
	return r;
}

inline int query3(int x)
{
	int r = INF;

	for (; x; x -= x^(x-1)&x)
		r = minim(r, A3[x]);
	return r;
}

inline int query4(int x)
{
	int r = -INF;

	for (; x; x -= x^(x-1)&x)
		r = maxim(r, A4[x]);
	return r;
}

int main(void)
{
	int i, s, d, c1, c2, c3, c4;

	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	scanf("%d", &N);
	for (i = 1; i <= N; ++i)
	{
		scanf("%d %d", &v[i].x, &v[i].y);
		dif[i] = v[i].x - v[i].y;
		sum[i] = v[i].x + v[i].y;
	}
	sort(v+1, v+N+1);

	sort(dif+1, dif+N+1);
	for (jd = 1, i = 2; i <= N; ++i)
		if (dif[jd] != dif[i])
			dif[++jd] = dif[i];
	sort(sum+1, sum+N+1);
	for (js = 1, i = 2; i <= N; ++i)
		if (sum[js] != sum[i])
			sum[++js] = sum[i];

	for (i = 1; i <= N; ++i)
		A1[i] = A2[i] = A3[i] = INF, A4[i] = -INF;

	for (i = 1; i <= N; ++i)
	{
		d = BS(dif, jd, v[i].x - v[i].y);
		s = BS(sum, js, v[i].x + v[i].y);
		
		c1 = query1(N-d+1);
		c2 = query2(d);
		c3 = query3(N-s+1);
		c4 = query4(s);
		bst = maxim(bst, maxim(v[i].x-c1, v[i].y-c2));
		bst = maxim(bst, maxim(v[i].x-c3, c4-v[i].y));		

		update1(N-d+1, v[i].x);
		update2(d, v[i].y);
		update3(N-s+1, v[i].x);
		update4(s, v[i].y);
	}

	printf("%d\n", bst);

	return 0;
}

