# include <stdio.h>
# include <stdlib.h>

const long int MAXN=256;
const long int MODULO=666013;

typedef struct NOD{long int inf;NOD *next;};
typedef struct LISTA{NOD *prim,*ultim;};
LISTA ladiac[MAXN+1],ladiacb[MAXN+1];

long int n,m,k,grad[MAXN+1],heap[MAXN+1],indexheap[MAXN+1],heaplen,nrm[MAXN+1][MAXN+1],grade[MAXN+1];

void add(LISTA &l,long int nod)
{
NOD *p=(NOD*)malloc (sizeof(NOD));
(*p).next=NULL;(*p).inf=nod;
if (l.prim==NULL)
	{
	l.prim=l.ultim=p;
	}
else
	{
	(*l.ultim).next=p;
	l.ultim=p;
	}
}

void citire()
{
FILE *f=fopen("dep.in","r");
fscanf(f,"%ld%ld%ld",&n,&m,&k);
long int i,aa,bb;
for (i=1;i<=m;i++)
	{
	fscanf(f,"%ld%ld",&aa,&bb);
	//va trebui sa stiu care sunt nodurile de care nu depinde nimeni
	//adica nodurile cu grad intern 0
	//va trebui apoi sa stiu care sunt nodurile de care depinde un nod,
	//adica muchiile directe. Sa vedem ce putem face.
	add(ladiac[aa],bb);
	add(ladiacb[bb],aa);
	}
fclose(f);
}

void calculeaza_grade()
{
NOD *p;
long int i;
for (i=1;i<=n;i++)
	{
	p=ladiac[i].prim;
	while (p)
		{
		grad[(*p).inf]++;
		grade[i]++;
		p=(*p).next;
		}
	}
}

//////////////
// HEAP
//////////////

void rise_heap(long int i)
{
long int aux;
while (i/2&&grad[heap[i/2]]>grad[heap[i]])
	{
	aux=heap[i];heap[i]=heap[i/2];heap[i/2]=aux;
	indexheap[heap[i]]=i;
	indexheap[heap[i/2]]=i/2;
	i/=2;
	}
}

void submerge_heap(long int i)
{
long int aux,min;
do
	{
	min=i;
	if (2*i<=heaplen&&grad[heap[min]]>grad[heap[2*i]]) min=2*i;
	if (2*i+1<=heaplen&&grad[heap[min]]>grad[heap[2*i+1]]) min=2*i+1;
	if (i==min) break;
	aux=heap[i];heap[i]=heap[min];heap[min]=aux;
	indexheap[heap[i]]=i;indexheap[heap[min]]=min;
	i=min;
	}
while (1);
}

void insert_heap(long int nod)
{
heap[++heaplen]=nod;
indexheap[heap[heaplen]]=heaplen;
rise_heap(heaplen);
}

long int extract_heap()
{
long int sol=heap[1];
heap[1]=heap[heaplen];heap[heaplen]=0;indexheap[sol]=0;indexheap[heap[1]]=1;
heaplen--;
submerge_heap(1);

NOD *p;
p=ladiac[sol].prim;
while (p)
	{
	grad[(*p).inf]--;
	rise_heap(indexheap[(*p).inf]);
	p=(*p).next;
	}
return sol;
}

/////////
// CALCULELE
/////////

//dinamica

void update(long int d, long int s)
{
nrm[d][0]=1;
nrm[s][0]=1;
long int sol[MAXN+1]={0},i,j;
sol[0]=1;
for (i=0;i<=n;i++)
	for (j=0;j<=n;j++)
		if ((i||j)&&(i+j<=k))
			{
			sol[i+j]+=nrm[s][i]*nrm[d][j];
			sol[i+j]%=MODULO;
			}
for (i=1;i<=n;i++)
	nrm[d][i]=sol[i];
}

long int sel[MAXN+1];

void calculeaza()
{
long int i,nod,qwd;
NOD *p;
for (i=1;i<=n;i++) nrm[i][0]=1;
for (i=1;i<=n;i++)
	{
	nod=extract_heap();
	//tebuiesc nodurile INVERSE, adica cei care au depins de el.
	p=ladiacb[nod].prim;
	while (p)
		{
		grade[(*p).inf]--;
		if (sel[(*p).inf]==0)
			{
			sel[(*p).inf]=1;
			//sa vedem cum facem update-ul.
			update(nod,(*p).inf);
			}
		p=(*p).next;
		}
	for (qwd=n;qwd>=1;qwd--) nrm[nod][qwd]=nrm[nod][qwd-1];
	}
}

void scrie(long int sol)
{
FILE *g=fopen("dep.out","w");
fprintf(g,"%ld\n",sol);
fclose(g);
}

long int vb[MAXN+1],solutie;

long int verifica_solutia()
{
long int sel[MAXN+1]={0};
long int i;
NOD *p;
for (i=1;i<=k;i++) sel[vb[i]]=1;
for (i=1;i<=k;i++)
	{
	p=ladiac[vb[i]].prim;
	while (p)
		{
		if (sel[(*p).inf]==0) return 0;
		p=(*p).next;
		}
	}
return 1;
}

void back(long int pos, long int begin)
{
long int i;
for (i=begin;i<=n;i++)
	{
	vb[pos]=i;
	if (pos<k) back(pos+1,i+1);
	else if (pos==k) solutie+=verifica_solutia();
	vb[pos]=0;
	}
}

int main()
{
citire();
if (n<=15)
	{
	back(1,1);
	scrie(solutie);
	return 0;
	}
//depisteaza_cicluri_si_refa_graful();
//facem dinamica. asta inseamna sa stiu nodurile care au grad intern 0.
calculeaza_grade();
//punem nodurile intr_un heap dupa grade()
//trebuiesc toate nodurile bagate in heap
long int i;
for (i=1;i<=n;i++) insert_heap(i);
//acuma trebuiesc tot scoase si facute dinamicile, si la sfarsit updatata
//dinamica si pentru solutie
//calculeaza_grade_e();
calculeaza();
for (i=1;i<=n;i++)
	if (ladiac[i].prim==NULL)
		update(0,i);
scrie(nrm[0][k]);
return 0;
}
