#include <stdio.h>
#include <stdlib.h>

#define P1 17
#define P2 9997
#define D 400
#define NMAX 5001

#define hash_func(x,y) (((x) * P1 + (y)) % P2)

typedef struct hash_entry 
{ long vi; 
  long vj; 
  char len; 
  struct hash_entry* next;
}* phash_entry;

phash_entry hash[P2], haux;
long v[NMAX], R, vprev;
int i, j, k, h, N, l, lmax, hidx;

int main()
{
    int T;
    
    freopen("subgeom.in", "r", stdin);
    freopen("subgeom.out", "w", stdout);

    scanf("%d", &T);
    
    while (T--)
    {
	// read input data
	scanf("%d", &N);
	for (i = 1; i <= N; i++)
	    scanf("%d", &v[i]);
	    
	// reinitialize hash
	for (h = 0; h < P2; h++)
	    hash[h] = NULL;

	// dynamic programming
	for (lmax = 1, i = 2; i <= N; i++)
	    for (j = i - 1; j >= 1 && j >= i - D; j--)
		if (v[i] % v[j] == 0 && v[i] > v[j])
		{
		    R = v[i] / v[j];
		    l = 1;
		    
		    if (v[j] % R == 0)
		    {
			vprev = v[j] / R;
			
			hidx = hash_func(v[j], vprev);
			haux = hash[hidx];
			
			while (haux != NULL)
			{
			    if (haux->vi == v[j] && haux->vj == vprev)
			    {
				l = haux->len;
				break;
			    }
			    
			    haux = haux -> next;
			}
		    }
		    
		    l++;
		    haux = (phash_entry) malloc(sizeof(struct hash_entry));
		    haux->vi = v[i];
		    haux->vj = v[j];
		    haux->len = l;
		    hidx = hash_func(v[i], v[j]);
		    
		    haux->next = hash[hidx];
		    hash[hidx] = haux;
		    
		    if (l > lmax)
			lmax = l;
		}

	// clear hash
	for (h = 0; h < P2; h++)
	    while (hash[h] != NULL)
	    {
		haux = hash[h];
		hash[h] = hash[h]->next;
		free(haux);
	    } 
	    
	//fprintf(stderr, "%d\n", lmax);
	printf("%d\n", lmax);
    }

    return 0;
}