#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NMAX 5001
#define RMAX 320

long v[NMAX], s[NMAX];
short int pidx[NMAX], lastpoz[NMAX];
char best[NMAX];
int i, j, k, M, N, lmax;
long R, vaux, vaux2;

void quick_sort(int li, int ls, long *vv);
inline int idx(long value);

int main()
{
    int te, T;
    
    freopen("subgeom.in", "r", stdin);
    freopen("subgeom.out", "w", stdout);

    scanf("%d", &T);
    
    srand(7827);
    
    for (te = 1; te <= T; te++)
    {
        scanf("%d", &N);
	for (i = 1; i <= N; i++)
	{
    	    scanf("%ld", &v[i]);
	    s[i] = v[i];
	}
    	
	// sorteaza valorile din vectorul s
	quick_sort(1, N, s);

	// elimina duplicatele
	M = 1;
	for (i = 2; i <= N; i++)
	    if (s[i] > s[i - 1])
		s[++M] = s[i];
	
	for (i = 1; i <= N; i++)
	    pidx[i] = idx(v[i]);
	
	/*
	fprintf(stderr, "%d: ", T);
	for (i = 1; i <= M; i++)
	    fprintf(stderr, " %d", s[i]);
	fprintf(stderr, "\n");
	*/
	
	// cauta lungimea maxima a unei progresii
	lmax = 1;
	
	for (R = 2; R < RMAX; R++)
	{
	    // fixeaza ratia R
	    memset(lastpoz, 0, sizeof(lastpoz));

	    best[1] = 1;
	    lastpoz[pidx[1]] = 1;
	
	    for (i = 2; i <= N; i++)
	    {
		best[i] = 1;

		if (v[i] % R > 0)
		    best[i] = 1;
		else
		{
		    vaux = v[i] / R;
		    k = idx(vaux);
		
		    if (k > 0 && lastpoz[k] > 0 && best[lastpoz[k]] + 1 > best[i])
			best[i] = best[lastpoz[k]] + 1; 
		}
	    
		if (best[i] > lmax)
		    lmax = best[i];

		lastpoz[pidx[i]] = i;
	    }
	}
	
	if (lmax == 1)
	{
	    // mai trebuie sa cautam progresii cu o ratie >= RMAX (care au lungime maxim 2)
	    memset(lastpoz, 0, sizeof(lastpoz));	
	
	    lastpoz[pidx[1]] = 1;
	
	    for (i = 2; i <= N && lmax == 1; i++)
	    {
		for (vaux = 1; vaux * vaux <= v[i] && lmax == 1; vaux++)
		{
		    k = idx(vaux);
		    if (k > 0 && lastpoz[k] > 0 && vaux < v[i])
			lmax = 2;
		    /*
		    vaux2 = v[i] / vaux;    
		    k = idx(vaux2);
		    if (k > 0 && lastpoz[k] > 0 && vaux2 < v[i])
			lmax = 2;
		    */
		}
	    
		lastpoz[pidx[i]] = i;
	    }        
	}
	
	//fprintf(stderr, "%d\n", lmax);    
	printf("%d\n", lmax);	
    }
    
    return 0;
}

void quick_sort(int li, int ls, long *vv)
{
    long pivot;
    int left, right, poz;
    
    if (li > ls)
	return;
    
    // gaseste un pivot (random)
    pivot = vv[li + (rand() % (ls - li + 1))];

    // sorteaza dupa pivot (cele mai mici decat pivotul in stanga, cele mai mari decat pivotul in dreapta)
    left = li;
    for (poz = li; poz <= ls; poz++)
    {
	if (vv[poz] < pivot)
	{
	    vaux = vv[left];
	    vv[left] = vv[poz];
	    vv[poz] = vaux;
	    left++;
	}
    }
    
    right = ls;
    for (poz = ls; poz >= li; poz--)
    {
	if (vv[poz] > pivot)
	{
	    vaux = vv[right];
	    vv[right] = vv[poz];
	    vv[poz] = vaux;
	    right--;
	}
    }
        
    quick_sort(li, left - 1, vv);
    quick_sort(right + 1, ls, vv);
}

inline int idx(long value)
{
    int li = 1, ls = M, mid;
    
    while (li <= ls)
    {
	mid = (li + ls) >> 1;
	
	if (s[mid] == value)
	    return mid;
	else
	if (s[mid] < value)
	    li = mid + 1;
	else
	    ls = mid - 1;
    }
    
    return 0;
}
