//Memoization optimized
//Code by Patcas Csaba
#include <fstream>
#include <vector>
#include <map>
#include <algorithm>
#include <numeric>
#include <iostream>

using namespace std;

int n,m, debt[21], sum, bitcount[1<<20];
vector < vector <pair <int, int> > > father;
vector <vector <int> > memo;
vector <int> sum1,sum2;
vector <pair <int,int> > Left,Right;
vector <pair <pair<int,int>, int> > solution;

void read_data()
{
	ifstream fin("datorii.in");
	fin>>n>>m;
	memset(debt,0,sizeof(debt));
	for (int q=0;q<m;++q)
	{
		int x,y,z;
		fin>>x>>y>>z;
		debt[x]+=z;
		debt[y]-=z;
	}
	fin.close();
}

void debug()
{
 cout<<"Left = ";
 for (int q=0;q<Left.size();++q) cout<<Left[q].first<<" ";
 cout<<endl;
 cout<<"Right = ";
 for (int q=0;q<Right.size();++q) cout<<Right[q].first<<" ";
 cout<<endl;
}

void build()
{
	sum=0;
	for (int q=1;q<=n;++q)
		if (debt[q]>0) 
		{
			Left.push_back(make_pair(debt[q],q));
			sum+=debt[q];
		}
		else if (debt[q]<0) Right.push_back(make_pair(-debt[q],q));
	sort(Left.begin(),Left.end());
	sort(Right.begin(),Right.end());
        debug();
	int i=0,j=0;
	while (i<Left.size() && j<Right.size())
	{
		if (Left[i].first<Right[j].first) ++i;
		else if (Left[i].first>Right[j].first) ++j;
		else
		{
			solution.push_back(make_pair(make_pair(Left[i].second,Right[j].second),Left[i].first));
			Left.erase(Left.begin()+i);
			Right.erase(Right.begin()+j);
		}
	}
        debug();
}

int go(int mask1, int mask2)
{
	int &ref=memo[mask1][mask2];
	if (ref!=-1) return ref;
	ref=0x7fffffff;
        int firstLeft=0,firstRight=0;
        while ((mask1&(1<<firstLeft))==0) ++firstLeft;
        while ((mask2&(1<<firstRight))==0) ++firstRight;
        int lastLeft=Left.size(),lastRight=Right.size();
        while ((mask1&(1<<lastLeft))==0) --lastLeft;
        while ((mask2&(1<<lastRight))==0) --lastRight;
	for (int q=1;q<(1<<(lastLeft-firstLeft+1));++q)
	{
                int qq=q<<firstLeft;
		if ((mask1&qq)!=qq) continue;
		for (int w=1;w<(1<<(lastRight-firstRight+1));++w)
		{
                        int ww=w<<firstRight;
			if ((mask2&ww)!=ww) continue;
			if (sum1[qq]!=sum2[ww]) continue;
			int aux=go(mask1^qq,mask2^ww)+bitcount[qq]+bitcount[ww]-1;
			if (ref>aux)
			{
				ref=aux;
				father[mask1][mask2]=make_pair(qq,ww);
			}
		}
	}
	return ref;
}

void solve()
{
	bitcount[0]=0;
	for (int q=1;q<(1<<20);++q) bitcount[q]=bitcount[q>>1]+(q&1);
	memo.resize(1<<Left.size(), vector <int> (1<<Right.size(),-1));
	father.resize(1<<Left.size(), vector <pair <int, int> > (1<<Right.size()));
	sum1.resize(1<<Left.size());
	sum2.resize(1<<Right.size());
	for (int q=0;q<(1<<Left.size());++q)
		for (int w=0;w<Left.size();++w)
			if (q&(1<<w)) sum1[q]+=Left[w].first;
	for (int q=0;q<(1<<Right.size());++q)
		for (int w=0;w<Right.size();++w)
			if (q&(1<<w)) sum2[q]+=Right[w].first;
	memo[0][0]=0;
	int x=(1<<Left.size())-1, y=(1<<Right.size())-1;
	go(x,y);
	while (x)
	{
		int i=father[x][y].first, j=father[x][y].second;
		for (int q=0;q<Left.size();++q)
		{
			if (!(i&(1<<q))) continue;
			for (int w=0;w<Right.size();++w)
			{
				if (Right[w].first==0 || !(j&(1<<w))) continue;
				int aux=min(Left[q].first,Right[w].first);
				solution.push_back(make_pair(make_pair(Left[q].second,Right[w].second),aux));
				Left[q].first-=aux;
				Right[w].first-=aux;
				if (!Left[q].first) break;
			}
		}
		x^=i;
		y^=j;
	}
}

void write_data()
{
	ofstream fout("datorii.out");
	fout<<solution.size()<<" "<<sum<<endl;
	for (int q=0;q<solution.size();++q) fout<<solution[q].first.first<<" "<<solution[q].first.second<<" "<<solution[q].second<<endl;
	fout.close();
}

int main()
{
 cout<<"Start"<<endl;
	read_data();
	build();
	solve();
	write_data();
	return 0;
}

