#include <cstdio>
#include <cstring>

#define Nmax 104
#define Lmax 304

int Na,Nb,i,j, min,nr;
int LA[Nmax],LB[Nmax],L;
char A[Nmax][Lmax];
char B[Nmax][Lmax];
char S[Lmax];

int T[Lmax];

void prefix()
{
 int k,i;
 k=-1;
 T[0]=-1;
 for (i=1;i<L;++i)
     {
      while (k>=0 && S[k+1]!=S[i])
        k=T[k];
      if (S[k+1]==S[i]) ++k;
      T[i]=k;
     }
}

int kmpA(int who)
{
 int k,i;
 k=-1;
 for (i=0;i<LA[who];++i)
    {
     while (k>=0 && S[k+1]!=A[who][i])
        k=T[k];
     if (S[k+1]==A[who][i]) ++k;
     if (k+1==L)
        return 1;        
    }
 return -1;
}

int kmpB(int who)
{
 int k,i;
 k=-1;
 for (i=0;i<LB[who];++i)
    {
     while (k>=0 && S[k+1]!=B[who][i])
        k=T[k];
     if (S[k+1]==B[who][i]) ++k;
     if (k+1==L)
        return 1;        
    }
 return -1;
}


void solve()
{
 int i,j,k;
 int ok;
 
 for (i=0;i<LA[min];++i)
    for (j=i;j<LA[min];++j)
        {
         memcpy(S,A[min]+i,(j-i+2)*sizeof(char) );
         L=j-i+1;
         prefix();
         ok=1;
         for (k=1;k<=Na;++k)
            if (kmpA(k)==-1) { ok=0;break; }
         if (!ok) continue;
         for (k=1;k<=Nb;++k)
            if (kmpB(k)!=-1) { ok=0;break; }
         nr+=ok;
        }
}

int main()
{
 freopen("sub.in","r",stdin);
 freopen("sub.out","w",stdout);
 scanf("%d\n",&Na);
 min=1;
 for (i=1;i<=Na;++i)
    {
     scanf("%s\n",&A[i]);
     LA[i]=strlen(A[i]);
     if (LA[i]<LA[min]) min=i;
    }
 scanf("%d",&Nb);
 for (i=1;i<=Nb;++i)
    {
     scanf("%s\n",&B[i]);
     LB[i]=strlen(B[i]);
    }

 solve();

 printf("%d\n",nr);
 fclose(stdout);

 return 0;
}
