#include <cstdio>
#include <cstring>

const int MMAX = 512;
const int NMAX = 128;

int N, M, R;
int A[MMAX][MMAX], P[NMAX][NMAX];
bool G[2][MMAX][MMAX];
int T[NMAX], prefix[NMAX];

void read(void) {
	FILE *fin = fopen("tetris.in", "rt");
	int i, j;

	fscanf(fin, " %d", &M);

	for (i = 0; i < M; ++i)
		for (j = 0; j < M; ++j)
			fscanf(fin, " %d", A[i] + j);
	
	fscanf(fin, " %d", &N);

	for (i = 0; i < N; ++i)
		for (j = 0; j < N; ++j)
			fscanf(fin, " %d", P[i] + j);

	fclose(fin);
}

void calculeaza_prefix(void) {
	int i, j;

	prefix[0] = prefix[1] = 0;
	j = 0;
	for (i = 1; i + 1 < N; ++i) {
		while (j > 0 && T[i] != T[j]) j = prefix[j];
		
		if (T[j] == T[i]) ++j;

		prefix[i + 1] = j;
	}
}

void solve(void) {
	if (N == 1) {
		R = M * M;
		return;
	}

	int i, j, k, t, t1, q, v, p;

	for (i = 0; i < N; ++i) {
		t = i & 1; t1 = t ^ 1;
		memset(G[t], 0x00, sizeof(G[t]));
		
		for (j = 1; j < N; ++j)
			T[j-1] = P[i][j] - P[i][j-1];

		calculeaza_prefix();
		
		for (j = i; j < M; ++j) {
			q = 0;
			
			for (k = 1; k < M; ++k) {
				v = A[j][k-1] - A[j][k];

				while (q > 0 && T[q] != v) q = prefix[q];

				if (T[q] == v) ++q;

				if (q + 1 == N) {
					p = k - N + 1;
					if (i == 0 || (G[t1][j-1][p] && 
					A[j-1][p] + P[i-1][0] == A[j][p] + P[i][0]))
						G[t][j][p] = true;
					
					q = prefix[q];
				}
			}
		}
/*
		for (j = 0; j < M; ++j) {
			for (k = 0; k < M; ++k)
				printf("%d ", G[t][j][k]);
			printf("\n");
		}
		printf("\n");
*/			
		
	}

	for (i = 0; i < M; ++i)
		for (j = 0; j < M; ++j)
			if (G[(N-1) & 1][i][j])
				++R;
}

void write(void) {
	FILE *fout = fopen("tetris.out", "wt");

	fprintf(fout, "%d\n", R);

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}
