#include <cstdio>
#include <bitset>

using namespace std;

#define Nmax 512

int n, m;
int mat[Nmax][Nmax];
int mat0[Nmax][Nmax];
int sir[Nmax];
int c[Nmax][Nmax];
int c0[Nmax][Nmax];
int p[Nmax];
int ok[Nmax][Nmax];
int h[Nmax][Nmax];
char s[Nmax * 16], *buf;

int get()
{
	int ret = 0;

	while (*buf == ' ') ++buf;
	while ('0' <= *buf && *buf <= '9')
	{
		ret = ret * 10 + *buf - '0';
		++buf;
	}

	return ret;
}

void citire()
{
	int i, j;

	scanf("%d\n", &m);
	for (i = 1; i <= m; ++i)
	{
		fgets(s, Nmax * 16, stdin);
		buf = s;

		for (j = 1; j <= m; ++j)
			mat[i][j] = get();
	}

	scanf("%d\n", &n);
	for (i = 1; i <= n; ++i)
		for (j = 1; j <= n; ++j)
			scanf("%d", &c[i][j]);
}

void pref(int ind)
{
	int i, k = 0;

	p[1] = 0;
	for (i = 2; i < n; ++i)
	{
		while (k > 0 && c[ind][i] != c[ind][k + 1]) k = p[k];
		if (c[ind][i] == c[ind][k + 1]) ++k;
		p[i] = k;
	}
}

void kmp(int ind1, int ind2)
{
	int i, k = 0, lin = ind1 - ind2 + 1, col;

	for (i = 1; i < m; ++i)
	{
		col = i - (n - 1) + 1;

		while (k > 0 && mat[ind1][i] != c[ind2][k + 1]) k = p[k];
		if (mat[ind1][i] == c[ind2][k + 1]) ++k;
		if (k == n - 1)
		{
			if (lin > 0 && c0[ind2][1] + mat0[ind1][col] == h[lin][col])
				++ok[lin][col];
			k = p[k];
		}
	}
}

void solve()
{
	int i, j, k, sol = 0;

    if (n == 1)
	{
		printf("%d\n", m * m);
		return;
	}
	
    for (i = 1; i <= m; ++i)
		for (j = 1; j < m; ++j)
			h[i][j] = mat[i][j] + c[1][1];
	
	memcpy(mat0, mat, sizeof(mat));
	memcpy(c0, c, sizeof(c));
	
	for (i = 1; i <= n; ++i)
	{
		for (j = n; j >= 2; --j)
			c[i][j] -= c[i][j - 1];
		for (j = 1; j < n; ++j)
			c[i][j] = - c[i][j + 1];
	}

	for (i = 1; i <= m; ++i)
	{
		for (j = m; j >= 2; --j)
			mat[i][j] -= mat[i][j - 1];
		for (j = 1; j < m; ++j)
			mat[i][j] = mat[i][j + 1];
	}

	for (k = 1; k <= n; ++k)
	{
		pref(k);
		for (i = 1; i <= m; ++i)
			kmp(i, k);
	}   

	for (i = 1; i <= m; ++i)
		for (j = 1; j < m; ++j)
			if (ok[i][j] == n) ++sol;
	printf("%d\n", sol);
}

int main()
{
	freopen("tetris.in", "r", stdin);
	freopen("tetris.out", "w", stdout);

	citire();
	solve();

	return 0;
}
