#include <cstdio>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

#define MAXN 128
#define MAXL 305
#define MAXT 60500
#define MAXlogT 16

int Na, Nb;
unsigned short lenA[MAXN], slenA[MAXN];
short word[MAXT];
char used[MAXN];

string S; int SZ;

char tmp[MAXL];

unsigned short gr[MAXlogT + 1][MAXT], ord[MAXT], aux[MAXT];

unsigned short lcprmq[MAXlogT + 1][MAXT], lg[MAXT];

inline int cmp( int a, int b )
{
	return aux[a] < aux[b];
}

inline int lcp( int a, int b )
{
	int step = MAXlogT, len = 0;
	for (; step >= 0; step--)
	{
		if (a + (1 << step) - 1 < SZ && b + (1 << step) - 1 < SZ && gr[step][a] == gr[step][b])
			a += (1 << step),
			b += (1 << step),
			len += (1 << step);
	}

	return len;
}

inline void precalcLCPRMQ()
{
	for (int i = 0; i + 1 < SZ; i++)
		lcprmq[0][i] = lcp( ord[i], ord[i + 1] );
	
	for (int k = 1; k <= MAXlogT; k++)
		for (int i = 0; i + 1 < SZ; i++)
			lcprmq[k][i] = min( lcprmq[k - 1][i], lcprmq[k - 1][i + (1 << k - 1)] );

	lg[1] = 0;
	for (int i = 2, j = 0; i < MAXT; i++)
	{
		if (1 << (j + 1) == i)
			j++;
		lg[i] = j;
	}
}

inline int lcpRMQ( int a, int b )
{
	if (a == b)
		return SZ - a;
	int pa = gr[MAXlogT][a], pb = gr[MAXlogT][b];
	if (pb < pa)
		swap(a, b),
		swap(pa, pb);
	
	int len = (pb - pa);		//min pa, ..., pb - 1
	return min( lcprmq[ lg[len] ][ pa ], lcprmq[ lg[len] ][ pb - (1 << lg[len]) ] );
}

inline int lcpbr( int a, int b )
{
	int len = 0;
	for (; a < SZ && b < SZ && S[a] == S[b]; a++, b++)
		len++;
	return len;
}

inline int getWord( int poz )
{
	poz++;
	if (poz > slenA[Na - 1])
		return -1;
	
	int w = lower_bound( slenA, slenA + Na, poz ) - slenA;
	if (poz - slenA[w] == 0)
		return -1;
	return w;
}

int main()
{
	freopen("sub.in", "rt", stdin);
	freopen("sub.out", "wt", stdout);

	scanf("%d", &Na);
	for (int i = 0; i < Na; i++)
	{
		scanf(" %s", tmp);
		S += string(tmp) + (char)('z' + i + 1);
		
		lenA[i] = strlen(tmp) + 1;
		slenA[i] = lenA[i];
		if (i)
			slenA[i] += slenA[i - 1];
	}
	scanf("%d", &Nb);
	for (int i = 0; i < Nb; i++)
	{
		scanf(" %s", tmp);
		S += string(tmp) + (char)('a' - 1);
	}
	
	SZ = (int)S.size();
	for (int i = 0; i < SZ; i++)
		aux[i] = gr[0][i] = S[i] - 'a' + 1,
		ord[i] = i;
	sort( ord, ord + SZ, cmp );

	for (int k = 1; k <= MAXlogT; k++)
	{
		for (int l = 0; l < SZ; )
		{
			int r = l;
			for (; r < SZ && gr[k - 1][ ord[l] ] == gr[k - 1][ ord[r] ]; r++)
			{
				if (ord[r] + (1 << k - 1) >= SZ)
					aux[ ord[r] ] = 0;
				else
					aux[ ord[r] ] = gr[k - 1][ ord[r] + (1 << k - 1) ];
			}

			sort( ord + l, ord + r, cmp );
		
			l = r;
		}

		int cur = 0;
		gr[k][ ord[0] ] = 0;
		for (int i = 1; i < SZ; i++)
		{
			if (gr[k - 1][ ord[i] ] != gr[k - 1][ ord[i - 1] ] || aux[ ord[i] ] != aux[ ord[i - 1] ])
				cur++;
			gr[k][ ord[i] ] = cur;
		}
	}
	
	precalcLCPRMQ();
	for (int i = 0; i < SZ; i++)
		word[i] = getWord(i);

	int NR = 0;
	for (int len = 1; len <= 300; len++)
	{
		int cont = 0;
		for (int l = 0; l < SZ; )
		{
			if (SZ - ord[l] < len)
			{
				l++;
				continue;
			}

			int r, haveB = 0, nrA = 0;
		
			for (r = l; lcpRMQ( ord[l], ord[r] ) >= len; r++)
			{
				int w = word[ ord[r] ];
				if (w == -1)
					haveB = 1;
				else
					if (!used[w])
						nrA++,
						used[w] = 1;
			}
			r--;
			for (int k = l; k <= r; k++)
			{
				int w = word[ ord[k] ];
				if (w != -1)
					used[w] = 0;
			}

			if (nrA == Na && !haveB)
				NR++;
			if (nrA == Na)
				cont = 1;
			l = r + 1;
		}
		if (!cont)
			break;
	}
	printf("%d\n", NR);

	return 0;
}
