#include <cstdio>
#include <vector>

using namespace std;

#define MAXM 512
#define MAXN 128

int M, N;
int m[MAXM][MAXM], p[MAXN][MAXN];
int colm[MAXM], colp[MAXN];

int pi[MAXM], piPRow[MAXN][MAXN];

char matchCol[MAXM][MAXM];
int matchLine[MAXM];

inline void prefix( int pi[], int s[], int N )
{
	int k = -1;
	
	pi[0] = -1;
	for (int i = 1; i < N; i++)
	{
		for (; k > -1 && s[k + 1] != s[i]; )
			k = pi[k];
		if (s[k + 1] == s[i])
			k++;

		pi[i] = k;		
	}
}

vector<int> match;
inline void kmp( int a[], int N, int b[], int M, int pi[] )
{
	match.clear();
	int k = -1;

	for (int i = 0; i < N; i++)
	{
		if (k + 1 >= M)
			k = pi[k];

		for (; k > -1 && a[i] != b[k + 1]; )
			k = pi[k];
		if (a[i] == b[k + 1])
			k++;
		
		if (k == M - 1)
			match.push_back(i - M + 1);
	}
}

int main()
{
	freopen("tetris.in", "rt", stdin);
	freopen("tetris.out", "wt", stdout);

	scanf("%d", &M);
	for (int i = 0; i < M; i++)
		for (int j = 0; j < M; j++)
			scanf("%d ", m[i] + j);

	scanf("%d", &N);
	for (int i = 0; i < N; i++)
		for (int j = 0; j < N; j++)
			scanf("%d ", p[i] + j);

	for (int i = 0; i < N - 1; i++)
		colp[i] = p[i][0] - p[i + 1][0];
	prefix( pi, colp, N - 1 );
	for (int i = 0; i < M; i++)
	{
		for (int j = 0; j < M - 1; j++)
			colm[j] = m[j + 1][i] - m[j][i];
		kmp( colm, M - 1, colp, N - 1, pi );

		for (size_t k = 0; k < match.size(); k++)
			matchCol[ match[k] ][i] = 1;
	}

	for (int i = 0; i < N; i++)
	{
		for (int j = 0; j < N - 1; j++)
			p[i][j] = p[i][j] - p[i][j + 1];
		p[i][N - 1] = 0;
		
		prefix( piPRow[i], p[i], N - 1 );
	}
	for (int i = 0; i < M; i++)
	{
		for (int j = 0; j < M; j++)
			m[i][j] = m[i][j + 1] - m[i][j];
		m[i][M - 1] = 0;
	}
	
	int NR = 0;
	for (int i = 0; i + N - 1 < M; i++)
	{
		memset( matchLine, 0, sizeof( matchLine ) );
		for (int j = 0; j < N; j++)
		{
			kmp( m[i + j], M - 1, p[j], N - 1, piPRow[j] );
			for (size_t k = 0; k < match.size(); k++)
				matchLine[ match[k] ]++;
		}

		for (int j = 0; j < M - 1; j++)
			if (matchLine[j] == N && matchCol[i][j])
				NR++;
	}
	printf("%d\n", NR);

	return 0;
}
