#include <cstdio>
#include <map>
#include <utility>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

const char *IN  = "datorii.in";
const char *OUT = "datorii.out";

typedef pair<unsigned int, unsigned int> C;
typedef map<C, unsigned int> M;
typedef vector<vector<unsigned int> > M2;

unsigned int find_nregali(M &datorii, M2 &datorii_la, unsigned int de_la, unsigned int valoare, unsigned int initial, vector<unsigned int> &out);
void simplifica (M &datorii, M2 &datorii_la);

//#define DBGCODE

#ifdef DBGCODE
#include <iterator>
#define AFIS(x) copy( (x) .begin() , (x).end(), ostream_iterator<unsigned int>(cout, "\n")); cout <<"\n========="<<endl;
void AFISDAT(M &d)
{
	for (M::const_iterator it=d.begin(); it != d.end(); ++it)
		printf("%u -> %u : %u\n", it->first.first, it->first.second, it->second);
	printf("=======================\n");
	fflush(stdout);
}
#endif

int main (void)
{
	freopen(IN, "r", stdin);
	freopen(OUT, "w+", stdout);

	unsigned int nrElevi, nrDatorii;
	scanf("%u %u\n", &nrElevi, &nrDatorii);

	M datorii;
	M2 datorii_la; datorii_la.resize(nrElevi);
	for (unsigned int i=0; i<nrDatorii; ++i) {
		unsigned int p1, p2, v;
		scanf("%u %u %u\n", &p1, &p2, &v);
		datorii.insert( make_pair( make_pair(p1-1,p2-1), v ) );
		datorii_la[p1-1].push_back(p2-1);
		
	}
#ifdef DBGCODE
	AFISDAT(datorii);
#endif
	simplifica(datorii, datorii_la);
#ifdef DBGCODE
	AFISDAT(datorii);
#endif
	
	for (unsigned int de_la=0; de_la<nrElevi; ++de_la) {
		unsigned int nrEgali;
		for (vector<unsigned int>::const_iterator iter = datorii_la[de_la].begin();
				iter != datorii_la[de_la].end(); ++iter) {
#ifdef DBGCODE
			printf("Incepem cu %u\n", de_la); fflush(stdout);
#endif
			unsigned int val = datorii[make_pair(de_la,*iter)];
			if (val==0) continue;
			vector<unsigned int> op; op.reserve(nrDatorii);
			nrEgali = find_nregali(datorii, datorii_la, *iter, val, *iter, op);
#ifdef DBGCODE
			AFIS(op);
#endif
			//prima operatie e de_la->*iter
			//a doua op e *iter->op[0]
			//..
			//=> de_la->op[last] = val
			if (nrEgali>0) {
				datorii[make_pair(de_la, op.back())] += val;
				datorii[make_pair(de_la, *iter)] = 0;
#ifdef DBGCODE
				printf("%u->%u=0\n",de_la,*iter);
#endif
				unsigned int prev = *iter;
				for (vector<unsigned int>::const_iterator it=op.begin();
						it != op.end(); ++it) {
					datorii[make_pair(prev, *it)] = 0;
#ifdef DBGCODE
					printf("%u->%u=0\n",prev,*it);
#endif
					prev = *it;
				}
			}
		}
	}
	simplifica(datorii, datorii_la);

	unsigned int nrOp=0, sumaOp=0;
	for (M::const_iterator iter = datorii.begin();
			iter != datorii.end(); ++iter) {
		if (iter->second != 0) {
			++nrOp;
			sumaOp += iter->second;
		}
	}
#ifdef DBGCODE
	AFISDAT(datorii);
#endif
	printf("%u %u\n", nrOp, sumaOp);

	for (M::const_iterator iter = datorii.begin();
			iter != datorii.end(); ++iter) {
		if (iter->second != 0)
			printf("%u %u %u\n", iter->first.first+1, iter->first.second+1,iter->second);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}


unsigned int find_nregali (M &datorii, M2 &datorii_la, unsigned int de_la, unsigned int valoare, unsigned int initial, vector<unsigned int> &out)
{
	unsigned int maxret=0;
	bool gasitmax=false;
	vector<unsigned int> crtout = out;
	for (vector<unsigned int>::const_iterator iter = datorii_la[de_la].begin();
			iter != datorii_la[de_la].end(); ++iter) {
		if (datorii[make_pair(de_la,*iter)] == valoare && find(crtout.begin(),crtout.end(),*iter) == crtout.end()) {
			crtout.push_back(*iter);
			if (*iter != initial) {
				unsigned int crt = 1+find_nregali(datorii,datorii_la,*iter,valoare, initial, crtout);
				if (!gasitmax || crt>maxret) {
					gasitmax=true;
					maxret=crt;
					out=crtout;
				}
			}
		}
	}
	return maxret;
}

void simplifica (M &datorii, M2 &datorii_la)
{
	for (M::iterator iter=datorii.begin(); iter != datorii.end(); ++iter) {
		if (iter->second == 0) continue;
		if (iter->first.first < iter->first.second) {
			M::iterator f = datorii.find( make_pair(iter->first.second, iter->first.first) );
			if (f != datorii.end()) {
				if (iter->second < f->second)
				{f->second -= iter->second; iter->second=0;}
				else {iter->second -= f->second; f->second=0; }
			}
		}
		else if (iter->first.first == iter->first.second)
			iter->second = 0;
	}
}

