#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <set>

using namespace std;

#define ll long long
#define MOD1 666013
#define MOD2 1047893
#define MOD3 1130511
#define PII pair< pair<int, int>, int >
#define x first.first
#define y first.second
#define z second

typedef char sir[312];

int Na, Nb, LA[128], LB[128], cnt;
sir A[128], B[128];
PII list[128][312], comun[312], secv[312]; int valid[312], nrc, nrs;
set<PII> mult;
int put1 = 1, put2 = 1, put3 = 1;

inline void get_common(int lung, sir X, int ln, int tip)
{
	int i, cod;
	set<PII>::iterator it;

	for (i = 0, cod = 0; i < ln; ++i)
	{
		cod = (cod * 26 + (X[i]-'a')) % MOD1;
		if (i >= lung)
		{
			cod -= (put1 * (X[i-lung]-'a')) % MOD1;
			if (cod < 0) cod += MOD1;
		}
		if (i >= lung-1)
			secv[i-lung+1].x = cod;
	}

	for (i = 0, cod = 0; i < ln; ++i)
	{
		cod = (cod * 26 + (X[i]-'a')) % MOD2;
		if (i >= lung)
		{
			cod -= (put2 * (X[i-lung]-'a')) % MOD2;
			if (cod < 0) cod += MOD2;
		}
		if (i >= lung-1)
			secv[i-lung+1].y = cod;
	}

	for (i = 0, cod = 0; i < ln; ++i)
	{
		cod = (cod * 26 + (X[i]-'a')) % MOD3;
		if (i >= lung)
		{
			cod -= (put3 * (X[i-lung]-'a')) % MOD3;
			if (cod < 0) cod += MOD3;
		}
		if (i >= lung-1)
			secv[i-lung+1].z = cod;
	}
	
	if (tip == 2) // eliminam cele care exista
	{
		for (i = 0; i <= ln-lung; ++i)
		{
			it = mult.find(secv[i]);
			if (it != mult.end())
				mult.erase(it);
		}
		return ;
	}

	mult.clear();
	for (i = 0; i <= ln-lung; ++i)
		mult.insert(secv[i]);
	if (!tip)
	{
		for (it = mult.begin(), nrc = 0; it != mult.end(); ++it, ++nrc)
			comun[nrc] = *it,
			valid[nrc] = 1;
		return ;
	}
	for (i = 0; i < nrc; ++i)
	{
		if (!valid[i]) continue;
		if (mult.find(comun[i]) == mult.end())
			valid[i] = 0;
	}
}

int main(void)
{
	int i, j, mx = 300;

	freopen("sub.in", "r", stdin);
	freopen("sub.out", "w", stdout);

	scanf("%d", &Na);
	for (i = 1; i <= Na; ++i)
	{
		scanf("%s", A[i]);
		LA[i] = strlen(A[i]);
		if (LA[i] < mx)
			mx = LA[i];
	}
	scanf("%d", &Nb);
	for (i = 1; i <= Nb; ++i)
	{
		scanf("%s", B[i]);
		LB[i] = strlen(B[i]);
	}

	for (i = 1; i <= mx; ++i)
	{
		// obtinem secventele comune
		nrc = 0;
		put1 = (put1 * 26) % MOD1;
		put2 = (put2 * 26) % MOD2;
		put3 = (put3 * 26) % MOD3;
		get_common(i, A[1], LA[1], 0);
		for (j = 2; j <= Na; ++j)
			get_common(i, A[j], LA[j], 1);

		mult.clear();
		for (j = 0; j < nrc; ++j)
			if (valid[j])
				mult.insert(comun[j]);

		// luam toate secventele din B
		for (j = 1; j <= Nb; ++j)
			get_common(i, B[j], LB[j], 2);

		// numaram
		cnt += mult.size();
	}

	printf("%d\n", cnt);

	return 0;
}

