#include <stdio.h>
#include <algorithm>

using namespace std;

#define PII pair< pair<int, int>, int >
#define x first.first
#define y first.second
#define z second
#define ll long long
#define MOD1 666013
#define MOD2 1047511
#define MOD3 1132919

int M, N, D[512][512], C[128][128], cnt, p1 = 1, p2 = 1, p3 = 1;
PII HASH[512][512], cod_mat[512];
short int vert[512][512];

void get_codes(int lin)
{
	int i, cod;

	for (i = 1, cod = 0; i < M; ++i)
	{
		cod = ((ll)cod * 20001 + D[lin][i]) % MOD1;
		if (i >= N+1)
		{
			cod -= ((ll)p1 * D[lin][i-N]) % MOD1;
			if (cod < 0) cod += MOD1;
		}
		if (i >= N)
			HASH[lin][i-N+1].x = cod;
	}
	for (i = 1, cod = 0; i < M; ++i)
	{
		cod = ((ll)cod * 20001 + D[lin][i]) % MOD2;
		if (i >= N+1)
		{
			cod -= ((ll)p2 * D[lin][i-N]) % MOD2;
			if (cod < 0) cod += MOD2;
		}
		if (i >= N)
			HASH[lin][i-N+1].y = cod;
	}
	for (i = 1, cod = 0; i < M; ++i)
	{
		cod = ((ll)cod * 20001 + D[lin][i]) % MOD3;
		if (i >= N+1)
		{
			cod -= ((ll)p3 * D[lin][i-N]) % MOD3;
			if (cod < 0) cod += MOD3;
		}
		if (i >= N)
			HASH[lin][i-N+1].z = cod;
	}
}

int main(void)
{
	int i, j, k, ok;

	freopen("tetris.in", "r", stdin);
	freopen("tetris.out", "w", stdout);

	scanf("%d", &M);
	for (i = 1; i <= M; ++i)
		for (j = 1; j <= M; ++j)	
			scanf("%d", &D[i][j]);
	scanf("%d", &N);
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j)
			scanf("%d", &C[i][j]);
	if (N == 1)
	{
		printf("%d\n", M * M);
		return 0;
	}

	for (i = 1; i <= M; ++i)
		for (j = 1; j <= N; ++j)
			HASH[i][j].x = HASH[i][j].y = HASH[i][j].z = -1;

	for (i = 1; i < M; ++i)
		for (j = 1; j <= M; ++j)
			vert[i][j] = D[i][j]-D[i+1][j];
	for (i = 1; i <= M; ++i)
	{
		for (j = 1; j < M; ++j)
			D[i][j] = D[i][j+1]-D[i][j]+10000;
		D[i][M] = 0;
	}
   
	for (i = 1; i <= N; ++i)
		for (j = 1; j < N; ++j)
			cod_mat[i].x = ((ll)cod_mat[i].x * 20001 + (C[i][j]-C[i][j+1]+10000)) % MOD1,
			cod_mat[i].y = ((ll)cod_mat[i].y * 20001 + (C[i][j]-C[i][j+1]+10000)) % MOD2,
			cod_mat[i].z = ((ll)cod_mat[i].z * 20001 + (C[i][j]-C[i][j+1]+10000)) % MOD3;

	for (i = 1; i < N; ++i)
		p1 = ((ll)p1 * 20001) % MOD1,
		p2 = ((ll)p2 * 20001) % MOD2,
		p3 = ((ll)p3 * 20001) % MOD3;

	--N;
	for (i = 1; i <= M; ++i)
		get_codes(i);

	for (i = 1; i <= M-N; ++i)
		for (j = 1; j <= M-N; ++j)
		{
			for (k = 0, ok = 1; k <= N && ok; ++k)
				if (cod_mat[k+1] != HASH[i+k][j])
					ok = 0;
			if (ok) // verificam si diferentele verticale
			{
				for (k = 1; k <= N && ok; ++k)
					if (C[k+1][1]-C[k][1] != vert[i+k-1][j])
						ok = 0;
			}	
			
			cnt += ok;
		}

	printf("%d\n", cnt);

	return 0;
}

