#include <cstdio>
#include <cstring>
#include <vector>

using namespace std;

struct TrieNode
{
	TrieNode* vecini[2];
	int cati[2];
};

TrieNode* arb[1<<17];

#define left i*2
#define right i*2+1
#define mid (li+ls)/2


#define BIT (type>>i)%2
TrieNode* V[17];
void PushTree(TrieNode* node,int type,int nr,int p)
{
	V[16]=node;
	V[16]->cati[p]+=nr;

	for (int i=15;i>=0;i--)
	{
		if (node->vecini[BIT] == NULL)
		{
			TrieNode* newnode = new TrieNode;

			memset(newnode,0,sizeof(TrieNode));

			node->vecini[BIT] = newnode;
		}
		V[i]=node->vecini[BIT];	
		V[i]->cati[p]+=nr;
		node = V[i];
	}
}

void QuerryNode(TrieNode* node,int type,int* unu,int* doi)
{
	for (int i=15;i>=0;i--)
	{
		if (node->vecini[BIT] == NULL)
		{
			TrieNode* newnode = new TrieNode;

			memset(newnode,0,sizeof(TrieNode));

			node->vecini[BIT] = newnode;
		}
		V[i]=node->vecini[BIT];	
		node = V[i];
	}

	*unu = V[0]->cati[0];
	*doi = V[0]->cati[1];
}

void update(int i,int li,int ls,int x,int nr,int t,int p)
{
	if (arb[i] == NULL)
	{
		arb[i]=new TrieNode;
		memset(arb[i],0,sizeof(TrieNode));
	}

	PushTree(arb[i],t,nr,p);

	if (li==x&&ls==x)
		return;

	if (x<=mid) update(left,li,mid,x,nr,t,p);
	else update(right,mid+1,ls,x,nr,t,p);
}


void querry(int i,int li,int ls,int x,int* unu,int *doi,int type)
{
	if (li==x&&ls==x)
	{
		QuerryNode(arb[i],type,unu,doi);
		return;
	}

	if (x<=mid) querry(left,li,mid,x,unu,doi,type);
	else querry(right,mid+1,ls,x,unu,doi,type);
}
vector<TrieNode*> inter_node;
#define MAX(a,b) ((a)>(b)?(a):(b))
#define MIN(a,b) ((a)<(b)?(a):(b))
void GetInterNodes(int i,int li,int ls,int x,int y)
{
	if (li>ls)
		printf ("");
	if (li==x&&ls==y)
	{
		inter_node.push_back(arb[i]);
		return;
	}

	if (x<=mid) GetInterNodes(left,li,mid,x,MIN(mid,y));
	if (y>mid) GetInterNodes(right,mid+1,ls,MAX(x,mid+1),y);
}

int n,m,t;
int querry_es(int a,int b,int col,int number)
{
	inter_node.clear();
	GetInterNodes(1,1,n,a,b);

	int rez=0;
	for (int i=15;i>=0;i--)
	{
		int sum=0;
		for (int i=0;i<inter_node.size();i++)
			if (inter_node[i]&&inter_node[i]->vecini[0])
				sum+=inter_node[i]->vecini[0]->cati[col];
		
		int x=0;
		if (sum< number) number-=sum,rez+=1<<i,x=1;
		else x=0;

		for (int i=0;i<inter_node.size();i++)
			if (inter_node[i])
				inter_node[i]=inter_node[i]->vecini[x];
	}
	return rez;
}


int main()
{
	FILE *fin=fopen ("kinder.in","r");
	FILE *fout= fopen ("kinder.out","w");
	fscanf (fin,"%d%d%d",&n,&m,&t);

	while (t--)
	{
		int op;
		fscanf (fin,"%d",&op);
		int a,b,c,d;
		switch (op)
		{
		case 1:
			fscanf (fin,"%d%d%d%d",&a,&b,&c,&d);
			update(1,1,n,a,d,b,c);
			break;
		case 2:
			fscanf (fin,"%d%d",&a,&b);
			int unu,doi;
			querry(1,1,n,a,&unu,&doi,b);
			//scadem
			update(1,1,n,a,-unu,b,0);
			update(1,1,n,a,-doi,b,1);
			//adunam
			update(1,1,n,a,doi,b,0);
			update(1,1,n,a,unu,b,1);
			break;
		default:
			if (op!=3) 
				printf ("");
			int p,x;
			fscanf (fin,"%d%d%d%d",&a,&b,&p,&x);
			fprintf (fout,"%d\n",querry_es(a,b,p,x));
			break;
		}
	}

	fclose (fin);fclose (fout);

	return 0;
}