#include <stdio.h>

#define NMAX 2010

int T1[NMAX], T2[NMAX], d[NMAX], v[NMAX], vmax[NMAX][3];
int i, j, k, N, vbest, ts1, tf1, ts2, tf2;

int main()
{
	freopen("senzori.in", "r", stdin);	

	scanf("%d", &N);

	for (i = 1; i <= N; i++)
		scanf("%d %d %d %d", &T1[i], &T2[i], &d[i], &v[i]);

	// dynamic programming
	vmax[1][0] = vmax[1][1] = v[1];
	vmax[1][2] = 0;

	for (i = 2; i <= N; i++)
	{
		// 1. compute vmax[i][0] = the maximum value if the transfer interval starts at T1[i]

		vmax[i][0] = v[i] + vmax[i - 1][2];
		
		ts1 = T1[i];
		tf1 = T1[i] + d[i];

		// case 1.1
		ts2 = T1[i - 1];
		tf2 = T1[i - 1] + d[i - 1];

		if (!(
			   ((ts1 <= ts2) && (ts2 < tf1)) ||
			   ((ts1 < tf2) && (tf2 <= tf1)) ||
			   ((ts2 <= ts1) && (ts1 < tf2)) ||
			   ((ts2 < tf1) && (tf1 <= tf2))
		     )
		   )
		{
			if (vmax[i - 1][0] + v[i] > vmax[i][0])
				vmax[i][0] = vmax[i - 1][0] + v[i];
		}

		// case 1.2
		tf2 = T2[i - 1];
		ts2 = T2[i - 1] - d[i - 1];

		if (!(
			   ((ts1 <= ts2) && (ts2 < tf1)) ||
			   ((ts1 < tf2) && (tf2 <= tf1)) ||
			   ((ts2 <= ts1) && (ts1 < tf2)) ||
			   ((ts2 < tf1) && (tf1 <= tf2))
		     )
		   )
		{
			if (vmax[i - 1][1] + v[i] > vmax[i][0])
				vmax[i][0] = vmax[i - 1][1] + v[i];
		}

		// 2. compute vmax[i][1] = the maximum value if the transfer interval ends at T2[i]

		vmax[i][1] = v[i] + vmax[i - 1][2];
		
		tf1 = T2[i];
		ts1 = T2[i] - d[i];

		// case 2.1
		ts2 = T1[i - 1];
		tf2 = T1[i - 1] + d[i - 1];

		if (!(
			   ((ts1 <= ts2) && (ts2 < tf1)) ||
			   ((ts1 < tf2) && (tf2 <= tf1)) ||
			   ((ts2 <= ts1) && (ts1 < tf2)) ||
			   ((ts2 < tf1) && (tf1 <= tf2))
		     )
		   )
		{
			if (vmax[i - 1][0] + v[i] > vmax[i][1])
				vmax[i][1] = vmax[i - 1][0] + v[i];
		}

		// case 2.2
		tf2 = T2[i - 1];
		ts2 = T2[i - 1] - d[i - 1];

		if (!(
			   ((ts1 <= ts2) && (ts2 < tf1)) ||
			   ((ts1 < tf2) && (tf2 <= tf1)) ||
			   ((ts2 <= ts1) && (ts1 < tf2)) ||
			   ((ts2 < tf1) && (tf1 <= tf2))
		     )
		   )
		{
			if (vmax[i - 1][1] + v[i] > vmax[i][1])
				vmax[i][1] = vmax[i - 1][1] + v[i];
		}

		// 3. compute vmax[i][2] = the maximum value if the sensor i does not send any data
		
		vmax[i][2] = vmax[i - 1][0];

		if (vmax[i - 1][1] > vmax[i][2])
			vmax[i][2] = vmax[i - 1][1];

		if (vmax[i - 1][2] > vmax[i][2])
			vmax[i][2] = vmax[i - 1][2];
	}

	vbest = vmax[N][0];

	if (vmax[N][1] > vbest)
		vbest = vmax[N][1];

	if (vmax[N][2] > vbest)
		vbest = vmax[N][2];

	fprintf(stderr, "%d\n", vbest);
	freopen("senzori.out", "w", stdout);
	printf("%d\n", vbest);

	return 0;
}