// O(N*TMAX)
// S[i][t] = the maximum profit obtained considering the sensors 1,..,i and the time interval available for scheduling sensor i is [0,t]
// F[i][t] = the maximum profit obtained considering the sensors 1,..,i and the time interval available for scheduling sensor i is [t,T]

#include <stdio.h>

#define NMAX 2010
#define TMAX 2010

int T1[NMAX], T2[NMAX], d[NMAX], v[NMAX];
int S[2][TMAX], F[2][TMAX];
int i, j, k, t, N, T, c, a, s;

int main()
{
	freopen("senzori.in", "r", stdin);

	scanf("%d", &N);
	T = 0;

	for (i = 1; i <= N; i++)
	{
		scanf("%d %d %d %d", &T1[i], &T2[i], &d[i], &v[i]);
		if (T2[i] > T)
			T = T2[i];
	}

	c = a = 0;
	for (t = 0; t <= T; t++)
		S[c][t] = F[c][t] = 0;

	// dynamic programming: O(N*TMAX)

	for (i = 1, c = 1 - c; i <= N; i++, a = c, c = 1 - c)
	{
		S[c][0] = F[c][T] = S[a][T];

		for (t = 1; t <= T; t++)
		{
			// compute S[c][t]
			S[c][t] = S[c][t - 1];

			if (t <= T2[i] && t - d[i] >= T1[i])
			{
				s = S[a][t - d[i]];
				if (F[a][t] > s)
					s = F[a][t];

				if (s + v[i] > S[c][t])
					S[c][t] = s + v[i];
			}
		}

		for (t = T-1; t >= 0; t--)
		{
			// compute F[c][t]
			F[c][t] = F[c][t + 1];

			if (t >= T1[i] && t + d[i] <= T2[i])
			{
				s = S[a][t];
				if (F[a][t + d[i]] > s)
					s = F[a][t + d[i]];

				if (s + v[i] > F[c][t])
					F[c][t] = s + v[i];
			}
		}
	}

	fprintf(stderr, "%d\n", S[a][T]);
	freopen("senzori.out", "w", stdout);
	printf("%d\n", S[a][T]);

	return 0;
}
