#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <vector>
#include <algorithm>
using namespace std;

#define MAXN 100100
#define pb push_back
#define INF -1000000000

int N, C[MAXN], A[MAXN][4];
int L0[MAXN], R0[MAXN], L[MAXN][2], R[MAXN][2], viz[MAXN];
vector<int> G[MAXN], G2[MAXN];

void solve(int x)
{
    int i, j, k, v, ret, val, best, m1, m2, SIZE;

    for(i = 0; i < G[x].size(); i++) solve(G[x][i]);
    
    if(G[x].size() == 0) // frunza
    {
        A[x][0] = A[x][1] = C[x], A[x][2] = A[x][3] = INF; return ;
    }

    // A[x][0] - un singur drum
    for(best = INF, i = 0; i < G[x].size(); i++)
        best = max(best, A[ G[x][i] ][0]);
    for(m1 = m2 = INF, i = 0; i < G[x].size(); i++)
     if(A[ G[x][i] ][1] > m1) m2 = m1, m1 = A[ G[x][i] ][1];
     else m2 = max(m2, A[ G[x][i] ][1]);
     
    A[x][0] = max(best, m1+m2+C[x]);
    
    // A[x][1] - un singur drum incepe in x
    for(best = INF, i = 0; i < G[x].size(); i++)
        best = max(best, C[x]+A[ G[x][i] ][1]);
    A[x][1] = best;
    A[x][0] = max(A[x][0], best);

    // A[x][2] = 2 drumuri, unul incepe in x
    for(best = INF, i = 0; i < G[x].size(); i++)
        best = max(best, A[ G[x][i] ][2]),
        best = max(best, A[ G[x][i] ][0]);
    A[x][2] = C[x]+best;

    SIZE = G[x].size(), R[SIZE+1][0] = R[SIZE+1][1] = INF;
    L[0][0] = L[0][1] = INF;
    for(i = SIZE; i >= 1; i--)
    {
        R[i][0] = max(R[i+1][0], A[ G[x][i-1] ][1]);
        R[i][1] = max(R[i+1][1], A[ G[x][i-1] ][1]+R[i+1][0]);
    }
    for(i = 1; i <= SIZE; i++)
    {
        L[i][0] = max(L[i-1][0], A[ G[x][i-1] ][1]);
        L[i][1] = max(L[i-1][1], A[ G[x][i-1] ][1]+L[i-1][0]);
    }
    for(L0[0] = INF, i = 1; i <= SIZE; i++)
        L0[i] = max(L0[i-1], A[ G[x][i-1] ][0]);
    for(R0[SIZE+1] = INF, i = SIZE; i >= 1; i--)
        R0[i] = max(R0[i+1], A[ G[x][i-1] ][0]);
        
    for(best = INF, i = 1; i <= SIZE; i++)
        best = max(best, C[x]+A[G[x][i-1]][1]+max(R0[i+1], L0[i-1]));
    A[x][2] = max(A[x][2], best);

    // A[x][3] = 2 drumuri
    A[x][3] = A[x][2];
    for(i = 0; i < SIZE; i++) A[x][3] = max(A[x][3], A[G[x][i]][3]);
    for(m1 = m2 = INF, i = 0; i < SIZE; i++)
     if(A[G[x][i]][0] > m1) m2 = m1, m1 = A[G[x][i]][0];
     else m2 = max(m2, A[G[x][i]][0]);
    A[x][3] = max(A[x][3], m1+m2);

    for(best = INF, i = 1; i <= SIZE; i++)
        best = max(best, C[x]+A[G[x][i-1]][2]+max(L[i-1][0], R[i+1][0]));
    A[x][3] = max(A[x][3], best);

    for(best = INF, i = 1; i <= SIZE; i++)
    {
        val = max(L[i-1][1], R[i+1][1]);
        val = max(val, L[i-1][0]+R[i+1][0])+C[x];
        best = max(best, A[G[x][i-1]][0]+val);
    }
    A[x][3] = max(A[x][3], best);
    for(i = 0; i < 4; i++) A[x][i] = max(A[x][i], INF);
}

void dfs(int x)
{
    int i;
    for(viz[x] = 1, i = 0; i < G2[x].size(); i++)
     if(!viz[G2[x][i]])
        G[x].pb(G2[x][i]), dfs(G2[x][i]);
}

void read_and_solve(void)
{
    int i, j, k, a, b;

    scanf("%d\n", &N);
    for(i = 1; i <= N; i++) scanf("%d", &C[i]), G[i].clear(), G2[i].clear();
    for(i = 1; i < N; i++)
        scanf("%d %d", &a, &b), G2[a].pb(b), G2[b].pb(a);

    memset(viz, 0, sizeof(viz));
    dfs(1);
    solve(1);

    printf("%d\n", A[1][3]);
}

int main(void)
{
    freopen("turism.in", "rt", stdin);
    freopen("turism.out", "wt", stdout);

    int start = clock();

    int teste = 12;
    
    while(teste--)
        read_and_solve();

    int end = clock();

    fprintf(stderr, "%lf\n", (double)(end-start)/CLOCKS_PER_SEC);
    
    return 0;
}





    




