#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define maxn 50010
#define pb push_back
#define maxx 131072
#define maxl 2
#define LSB(x) (x&(x-1))^x

int n, m, T, l, sol;
int X, Y, col, V;
char tip[maxn];
int q1[maxn], q2[maxn], q3[maxn], q4[maxn];
vector <int> a[maxx];
int len[maxx];
vector <int> v;
vector <int> aib[maxl][maxx];
vector <int> b[maxl][maxn];

int search(int nod, int x)
{
	int front = 0, middle, back = len[nod]-1, rez = -1;

	while (front<=back)
	{
		middle = (front+back)/2;

		if (a[nod][middle] <= x) 
		{
			rez = middle;
			front = middle+1;
		}
		else back = middle-1;
	}

	return rez;
}

void updateAIB(int nod, int col, int x, int v)
{
	x++;
	for (; x<=len[nod]; x += LSB(x)) aib[col][nod][x-1] += v;
}

int queryAIB(int nod, int col, int x)
{
	x++;
	int rez = 0;

	for (; x; x -= LSB(x)) rez += aib[col][nod][x-1];

	return rez;
}

void update(int p, int r, int nod)
{
	if (p<r)
	{
		int q = (p+r)/2;
		
		if (X<=q) update(p, q, nod*2);
		else update(q+1, r, nod*2+1);
	}

	int aux = search(nod, Y);
	if (aux == -1) printf("crapa1\n");
	else updateAIB(nod, col, aux, V);
}

int query(int p, int r, int nod)
{
	if (X <= p && r <= Y)
	{
		int aux = search(nod, V);
		return queryAIB(nod, col, aux);
	}
	else {
		     int q = (p+r)/2, rez = 0;
			 if (X <= q) rez = query(p, q, nod*2);
			 if (Y > q) rez += query(q+1, r, nod*2+1);

			 return rez;
		 }
}

int main()
{
	freopen("kinder.in", "r", stdin);
	freopen("kinder.out", "w", stdout);

	scanf("%d %d %d ", &n, &T, &m);

	int i, j, k, aux;

	for (i=1; i<=m; i++)
	{
		scanf("%c %d %d ", &tip[i], &q1[i], &q2[i]);
		if (tip[i] != '2') scanf("%d %d ", &q3[i], &q4[i]);
	}

	for (l=1; l<n; l<<=1);

	for (i=1; i<=m; i++)
		if (tip[i] == '1') a[l+q1[i]-1].pb(q2[i]);

	for (i=1; i<=n; i++) 
	{
		len[i+l-1] = a[i+l-1].size();
		sort(a[i+l-1].begin(), a[i+l-1].end());

		vector <int> ().swap(v);

		if (len[i+l-1] > 0) v.pb(a[i+l-1][0]);

		for (j=0; j+1<len[i+l-1]; j++)
			if (a[i+l-1][j] != a[i+l-1][j+1]) v.pb(a[i+l-1][j+1]);

		a[i+l-1] = v;
		len[i+l-1] = v.size();
		a[i+l-1].reserve(len[i+l-1]);

		for (j=0; j<maxl; j++) 
		{
			aib[j][i+l-1].reserve(len[i+l-1]);
			aib[j][i+l-1].resize(len[i+l-1]);
			b[j][i].reserve(len[i+l-1]);
			b[j][i].resize(len[i+l-1]);
		}
	}

	//build

	for (i=l-1; i>0; i--) 
	{
		j = k = 0;

		while (j<len[i*2] && k<len[i*2+1]) 
			if (a[i*2][j] < a[i*2+1][k]) a[i].pb(a[i*2][j++]);
			else a[i].pb(a[i*2+1][k++]);

		while (j<len[i*2]) a[i].pb(a[i*2][j++]);
		while (k<len[i*2+1]) a[i].pb(a[i*2+1][k++]);

		len[i] = a[i].size();

		vector <int> ().swap(v);

		if (len[i] > 0) v.pb(a[i][0]);

		for (j=0; j+1<len[i]; j++)
			if (a[i][j] != a[i][j+1]) v.pb(a[i][j+1]);

		a[i] = v;
		len[i] = v.size();
		a[i].reserve(len[i]);
		for (j=0; j<maxl; j++) 
		{
			aib[j][i].reserve(len[i]);
			aib[j][i].resize(len[i]);
		}
	}

	for (i=1; i<=m; i++)
	{
		if (tip[i] == '1') 
		{
			X = q1[i];
			Y = q2[i];
			col = q3[i];
			V = q4[i];

			update(1, l, 1);

			aux = search(l+X-1, Y);
			b[col][X][aux] += V;
		}

		if (tip[i] == '2')
		{
			X = q1[i];
			Y = q2[i];

			aux = search(l+X-1, Y);
			V = b[1][X][aux] - b[0][X][aux];
			b[1][X][aux] -= V;
			b[0][X][aux] += V;
			col = 0;

			update(1, l, 1);

			V = -V;
			col = 1;
			update(1, l, 1);
		}

		if (tip[i] == '3')
		{
			int front = 1, middle, back = T;
			sol = 0;

			X = q1[i];
			Y = q2[i];
			col = q3[i];

			while (front <= back)
			{
				middle = (front+back)/2;

				V = middle;

				if (query(1, l, 1) >= q4[i])
				{
					back = middle-1;
					sol = middle;
				}
				else front = middle+1;
			}

			printf("%d\n", sol);
		}
	}

	return 0;
}
