#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define PB push_back
#define ALL(X) (X).begin(), (X).end()

struct quest {
	int t, a, b, c, d;
};

const int NMAX = 1 << 16;

int N, M, NQ;
quest Q[NMAX];
vector <int> CG[NMAX];
vector <int> AIB[NMAX << 1][2], T[NMAX << 1];
int C, TIP, NR, COL, CNT[2], ST, DR;

void read(void) {
	FILE *fin = fopen("kinder.in", "rt");
	int i;

	fscanf(fin, " %d %d %d", &N, &M, &NQ);

	for (i = 0; i < NQ; ++i) {
		fscanf(fin, " %d", &Q[i].t);

		if (Q[i].t == 1 || Q[i].t == 3)
			fscanf(fin, " %d %d %d %d", &Q[i].a, &Q[i].b, &Q[i].c, &Q[i].d);
		else
			fscanf(fin, " %d %d", &Q[i].a, &Q[i].b);

		if (Q[i].t == 1)
			CG[Q[i].a].PB( Q[i].b );
	}

	fclose(fin);
}

void build(int i, int st, int dr) {
	if (st == dr) {
		T[i] = CG[st];
		sort(ALL(T[i]));
		T[i].erase(unique(ALL(T[i])), T[i].end());

		AIB[i][0].resize( T[i].size() + 1 );
		AIB[i][1].resize( T[i].size() + 1 );

		return;
	}

	int is, mij;
	is = i << 1;
	mij = (st + dr) >> 1;

	build(is, st, mij);
	build(is|1, mij+1, dr);

	T[i].resize( T[is].size() + T[is|1].size() );

	merge(ALL(T[is]), ALL(T[is|1]), T[i].begin());
	T[i].erase(unique(ALL(T[i])), T[i].end());

	AIB[i][0].resize( T[i].size() + 1 );
	AIB[i][1].resize( T[i].size() + 1 );
}

int get_pos(vector <int> &T, int v) {
	return upper_bound(ALL(T), v) - T.begin();
}

void update_AIB(vector <int> &A, int p, int v) {
	for (; p < (int) A.size(); p += p & ~(p-1))
		A[p] += v;
}

int query_AIB(vector <int> &A, int p) {
	int r;

	for (r = 0; p > 0; p -= p & ~(p-1))
		r += A[p];

	return r;
}

void update(int i, int st, int dr) {

	update_AIB(AIB[i][COL], get_pos(T[i], TIP), NR);
	
	if (st == dr) return;

	int is, mij;
	is = i << 1;
	mij = (st + dr) >> 1;

	if (C <= mij)
		update(is, st, mij);
	else
		update(is|1, mij+1, dr);
}

void change(int i, int st, int dr) {
	int p = get_pos(T[i], TIP);

	if (st == dr) {
		CNT[0] = query_AIB(AIB[i][0], p) - query_AIB(AIB[i][0], p - 1);
		CNT[1] = query_AIB(AIB[i][1], p) - query_AIB(AIB[i][1], p - 1);
	}
	
	if (st < dr) {
		int is, mij;

		is = i << 1;
		mij = (st + dr) >> 1;

		if (C <= mij)
			change(is, st, mij);
		else
			change(is|1, mij+1, dr);
	}
	

	update_AIB(AIB[i][0], p, -CNT[0]);
	update_AIB(AIB[i][1], p, -CNT[1]);

	update_AIB(AIB[i][1], p, CNT[0]);
	update_AIB(AIB[i][0], p, CNT[1]);

}

int query(int i, int st, int dr) {
	if (ST <= st && dr <= DR) 
		return query_AIB(AIB[i][COL], get_pos(T[i], TIP));

	int is, mij, ret = 0;
	is = i << 1;
	mij = (st + dr) >> 1;

	if (ST <= mij)
		ret += query(is, st, mij);
	if (mij < DR)
		ret += query(is|1, mij+1, dr);
	
	return ret;
}

void solve(void) {
	FILE *fout = fopen("kinder.out", "wt");
	int i, val, st, dr, mij, ans;

	build(1, 1, N);

	for (i = 0; i < NQ; ++i) {
		if (Q[i].t == 1) {
			C = Q[i].a; NR = Q[i].d; TIP = Q[i].b; COL = Q[i].c;

			update(1, 1, N);
		} else if (Q[i].t == 2) {
			C = Q[i].a; TIP = Q[i].b;
			change(1, 1, N);
		} else {
			ST = Q[i].a; DR = Q[i].b; COL = Q[i].c; val = Q[i].d;

			st = 1; dr = M; ans = -1;
			while (st <= dr) {
				mij = (st + dr) >> 1;

				TIP = mij;
				if (query(1, 1, N) >= val)
					ans = mij, dr = mij-1;
				else
					st = mij+1;
			}

			fprintf(fout, "%d\n", ans);
		}
	}

	fclose(fout);
}

int main(void){
	
	read();

	solve();

	return 0;
}
