#include <cstdio>
#include <algorithm>

using namespace std;

const int NMAX = 2048;

int N, TMAX, R;
int T1[NMAX], T2[NMAX], D[NMAX], V[NMAX];
int DP[2][NMAX], MS[NMAX], MD[NMAX], B[NMAX];

void read(void) {
	FILE *fin = fopen("senzori.in", "rt");
	int i;

	fscanf(fin, " %d", &N);

	for(i = 1; i <= N; ++i)
		fscanf(fin, " %d %d %d %d", T1 + i, T2 + i, D + i, V + i),
		TMAX = max(TMAX, T2[i]);

	fclose(fin);

}

void solve(void) {
	int i, j, t, t1, v;

	for (i = 1; i <= N; ++i) {
		t = i & 1; t1 = t ^ 1;

		MS[0] = DP[t1][0];
		for (j = 1; j <= TMAX; ++j)
			MS[j] = max(MS[j-1], DP[t1][j]);

		for (j = TMAX; j >= 0; --j)
			MD[j] = max(MD[j+1], DP[t1][j]);

		B[i] = MD[0];
		for (j = 0; j <= TMAX; ++j)
			DP[t][j] = MD[0];

		for (j = T1[i]; j <= T2[i] - D[i]; ++j) {
			v = B[i-1];
			if (j - D[i-1] >= 0) v = max(v, MS[j - D[i-1]]);
			if (j + D[i] <= TMAX) v = max(v, MD[j + D[i]]);
			v += V[i];

			DP[t][j] = max(DP[t][j], v);
			R = max(R, v);
		}
	}
}

void write(void) {
	FILE *fout = fopen("senzori.out", "wt");

	fprintf(fout, "%d\n", R);

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}
