#include <cstdio>
#include <vector>
#include <cstring>
#include <algorithm>

using namespace std;

typedef pair <int, int> PII;
#define x first
#define y second
#define PB push_back
#define MP make_pair

const int NMAX = 1 << 17;
const int NTESTE = 12;

int N, C[NMAX];
vector <int> G[NMAX];
bool found, W[NMAX];
int T, R;

void read(FILE *fin) {
	int i, u, v;

	fscanf(fin, " %d", &N);

	for (i = 1; i <= N; ++i)
		fscanf(fin, " %d", C + i);

	for (i = 1; i < N; ++i) {
		fscanf(fin, " %d %d", &u, &v);
		G[u].PB(v);
		G[v].PB(u);
	}
}

void DFS1(int k, int t, int f) {
	if (k == f) {
		found = true;
		return;
	}
	vector <int> :: iterator p;

	for (p = G[k].begin(); p != G[k].end(); ++p) {
		if (*p == t) continue;
		DFS1(*p, k, f);
		if (found) {
			T += C[k];
			W[k] = true;
			return;
		}
	}
}

int DFS2(int k, int t) {
	if (W[k]) return 0;
	vector <int> :: iterator p;
	int mx = 0;

	for (p = G[k].begin(); p != G[k].end(); ++p) {
		if (*p == t) continue;
		mx = max(mx, DFS2(*p, k));
	}

	return mx + C[k];
}

void solve(void) {
	int i, j, k;

	R = 0;
	for (i = 1; i <= N; ++i)
		for (j = i + 1; j <= N; ++j) {
			memset(W, 0x00, sizeof(W));
			found = false; T = C[j]; W[j] = true;
			DFS1(i, 0, j);
			R = max(R, T);

			for (k = 1; k <= N; ++k)
				if (!W[k]) {
					int v = T + DFS2(k, 0);
					if (v > R)
						R = v;
				}
		}
}

void write(FILE *fout) {
	int i;

	for (i = 1; i <= N; ++i)
		vector <int> ().swap( G[i] );

	fprintf(fout, "%d\n", R);
}

int main(void) {
	FILE *fin = fopen("turism.in", "rt");
	FILE *fout = fopen("turism.out", "wt");
	int i;

	for (i = 0; i < NTESTE; ++i) {
	
		read(fin);

		solve();

		write(fout);
	}

	fclose(fin);
	fclose(fout);

	return 0;
}
