#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 50010

int N, M, T;

vector <int> tip_p[NMAX];
vector <int> aint1[2][NMAX];

vector <int> aint[NMAX];

vector <int> aib[2][NMAX];

void make_arb(int x, int y, int q)
{
	if (x == y) aint[q] = tip_p[y];
	else {
		// trebuie sa merge-ui

		int f1 = q << 1, f2 = f1 + 1, mij = (x + y) >> 1, i, j, ni, nj;

		make_arb(x, mij, f1);
		make_arb(mij + 1, y, f2);

		ni = aint[f1].size(); nj = aint[f2].size();

		for (i = 0, j = 0; i < ni || j < nj; )
			if (i < ni) {
				if (j < nj) {
					if (aint[f1][i] == aint[f2][j]) {
						aint[q].push_back(aint[f1][i]);
						i++; j++;
					} else
					if (aint[f1][i] < aint[f2][j]) {
						aint[q].push_back(aint[f1][i]);
						i++;
					} else
					if (aint[f1][i] > aint[f2][j]) {
						aint[q].push_back(aint[f2][j]);
						j++;
					}
				} else {
					aint[q].push_back(aint[f1][i]);
					i++;
				}
			} else {
				aint[q].push_back(aint[f2][j]);
				j++;
			}
	}

	int n = aint[q].size();
	aib[0][q].reserve(n + 3);
	aib[1][q].reserve(n + 3);

	for (int i = 0; i < n + 3; i++) aib[0][q][i] = aib[1][q][i] = 0;
}

int srch(vector <int> &a, int na, int val)
{
	int x = -1, step;

	for (step = 1; step <= na; step <<= 1);

	for (; step; step >>= 1)
		if (x + step < na && a[x + step] <= val) x += step;

	return x + 1;
}

inline int lsb(int x) { return (x & (x - 1) ^ x); }

void updateaib(vector <int> &aib, int naib, int poz, int val)
{
	while (poz <= naib) {
		aib[poz] += val;
		poz += lsb(poz);
	}
}

int queryaib(vector <int> &aib, int poz)
{
	int rez = 0;

	while (poz) {
		rez += aib[poz];
		poz -= lsb(poz);
	}

	return rez;
}

void update(int e, int x, int y, int q, int poz, int val, int nr)
{
	if (x != y) {
		int mij = (x + y) >> 1;

		if (poz <= mij) update(e, x, mij, q << 1, poz, val, nr);
		else update(e, mij + 1, y, (q << 1) + 1, poz, val, nr);
	}

	int n = aint[q].size();
	int w = srch(aint[q], n, val);

	updateaib(aib[e][q], n, w, nr);
}

int rez;
void query(int e, int x, int y, int q, int a, int b, int lim)
{
	if (a <= x && y <= b) {
		int w = srch(aint[q], aint[q].size(), lim);
		rez += queryaib(aib[e][q], w);
		return;
	}

	int mij = (x + y) >> 1;

	if (a <= mij) query(e, x, mij, q << 1, a, b, lim);
	if (b > mij) query(e, mij + 1, y, (q << 1) + 1, a, b, lim);
}

int main()
{
	int c, t, p, nr, a, b, x, i, op, n, j;
	
	freopen("kinder.in", "r", stdin);
	freopen("kinder.out", "w", stdout);

	scanf("%d %d %d", &N, &M, &T);

	for (i = 1; i <= T; i++) {
		scanf("%d", &op);

		if (op == 1) {
			scanf("%d %d %d %d", &c, &t, &p, &nr);

			tip_p[c].push_back(t);
		}

		if (op == 2) scanf("%d %d", &c, &t);
	
		if (op == 3) scanf("%d %d %d %d", &a, &b, &p, &x);
	}

	for (i = 1; i <= N; i++) {
		sort(tip_p[i].begin(), tip_p[i].end());
		tip_p[i].resize( unique(tip_p[i].begin(), tip_p[i].end()) - tip_p[i].begin());

		n = tip_p[i].size();
		aint1[0][i].reserve(n + 3);
		aint1[1][i].reserve(n + 3);
		for (j = 0; j < n + 3; j++) aint1[0][i][j] = aint1[1][i][j] = 0;
	}

	make_arb(1, N, 1);

	rewind(stdin);

	scanf("%d %d %d", &N, &M, &T);

	int stepmax;
	for (stepmax = 1; stepmax <= M; stepmax <<= 1); stepmax >>= 1;

	int q, k, step;
	for (i = 1; i <= T; i++) {
		scanf("%d", &op);

		if (op == 1) {
			scanf("%d %d %d %d", &c, &t, &p, &nr);

			update(p, 1, N, 1, c, t, nr);

			q = srch(tip_p[c], tip_p[c].size(), t);
			aint1[p][c][q] += nr;
		}

		if (op == 2) {
			scanf("%d %d", &c, &t);
			q = srch(tip_p[c], tip_p[c].size(), t);

			update(0, 1, N, 1, c, t, aint1[1][c][q] - aint1[0][c][q]);
			update(1, 1, N, 1, c, t, aint1[0][c][q] - aint1[1][c][q]);
			
			swap(aint1[0][c][q], aint1[1][c][q]);
		}

		if (op == 3) {
			scanf("%d %d %d %d", &a, &b, &p, &k);

			step = stepmax; x = 0;

			for (; step; step >>= 1)
				if (x + step <= M) {
					rez = 0;
					query(p, 1, N, 1, a, b, x + step);
					if (rez < k) x += step;
				}

			printf("%d\n", x + 1);			
		}
	}

return 0;
}

