#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXN 50005
#define MAXM 50005
#define MAXT 65536

#define ALL(x) (x).begin(), (x).end()
#define FOR(i, a, b) for (int i = (a); i < (int)(b); ++i)
#define FORI(it, v) for (__typeof( (v).begin() ) it = (v).begin(); it != (v).end(); ++it)

int N, M, T;
vector< vector<int> > op;
vector<int> typesC[MAXN];

vector<int> types[MAXT], number[MAXT][2], aib[MAXT][2];

inline void aibAdd( vector<int> &aib, int poz, int val )
{
	for (poz++; poz < (int)aib.size(); poz += (poz ^ (poz - 1)) & poz)
		aib[poz] += val;
}

inline int aibQuery( vector<int> &aib, int poz )
{
	int rez = 0;
	for (poz++; poz; poz &= (poz - 1))
		rez += aib[poz];
	return rez;
}

#define __AINTCOMMON lc = (n << 1), rc = lc + 1, m = (l + r) >> 1
inline void buildTree( int n, int l, int r )
{
	if (l == r)
	{
		types[n] = typesC[l];
		number[n][0].resize( types[n].size(), 0 );
		number[n][1].resize( types[n].size(), 0 );
		aib[n][0].resize( types[n].size() + 1, 0 );
		aib[n][1].resize( types[n].size() + 1, 0 );
		return;
	}
	int __AINTCOMMON;
	buildTree( lc, l, m );
	buildTree( rc, m + 1, r );

	for (size_t i = 0, j = 0; i < types[lc].size() || j < types[rc].size(); )
	{
		if (i < types[lc].size() && j < types[rc].size() && types[lc][i] == types[rc][j])
		{
			j++;
			continue;
		}

		if (i < types[lc].size() && (j >= types[rc].size() || types[lc][i] < types[rc][j]))
			types[n].push_back( types[lc][i] ), i++;
		else
			types[n].push_back( types[rc][j] ), j++;
	}
	
	number[n][0].resize( types[n].size(), 0 );
	number[n][1].resize( types[n].size(), 0 );
	aib[n][0].resize( types[n].size() + 1, 0 );
	aib[n][1].resize( types[n].size() + 1, 0 );
}

inline int find( int n, int val )
{
	int poz = lower_bound( ALL( types[n] ), val + 1 ) - types[n].begin() - 1;
	if (poz < 0 || poz >= (int)types[n].size() || types[n][poz] != val)
		return -1;
	return poz;
}

int UPoz, UType, UCol, UVal;			//faster this way
inline void updateAdd( int n, int l, int r )
{
	if (l == r)
	{
		int tpoz = find( n, UType );
		number[n][UCol][tpoz] += UVal;
		aibAdd( aib[n][UCol], tpoz, UVal );
		return;
	}

	int __AINTCOMMON;
	if (UPoz <= m)
		updateAdd( lc, l, m );
	else
		updateAdd( rc, m + 1, r );

	int tpoz = find(n, UType);
	number[n][UCol][tpoz] += UVal;
	aibAdd( aib[n][UCol], tpoz, UVal );
}

inline void updateCol( int n, int l, int r )
{
	if (l == r)
	{
		int typepoz = find( n, UType );
		int a = number[n][0][typepoz], b = number[n][1][typepoz];
		number[n][0][typepoz] = b;
		number[n][1][typepoz] = a;

		aibAdd( aib[n][0], typepoz, b - a );
		aibAdd( aib[n][1], typepoz, a - b );

		return;
	}

	int __AINTCOMMON;
	if (UPoz <= m)
		updateCol( lc, l, m );
	else
		updateCol( rc, m + 1, r );

	int tpozn = find( n, UType );
	int tpozlc = find( lc, UType );
	int tpozrc = find( rc, UType );
	
	for (int i = 0; i <= 1; i++)
	{
		int old = number[n][i][tpozn];
		number[n][i][tpozn] = 0;
		if (tpozlc != -1)
			number[n][i][tpozn] += number[lc][i][tpozlc];
		if (tpozrc != -1)
			number[n][i][tpozn] += number[rc][i][tpozrc];
		aibAdd( aib[n][i], tpozn, number[n][i][tpozn] - old );
	}
}

int QL, QR, QCol, QRez;
inline int query( int n, int l, int r )
{
	if (QL <= l && r <= QR)
		return aibQuery( aib[n][QCol], lower_bound( ALL( types[n] ), QRez + 1 ) - types[n].begin() - 1 );

	int __AINTCOMMON;
	int rez = 0;
	if (QL <= m)
		rez += query( lc, l, m );
	if (QR > m)
		rez += query( rc, m + 1, r );
	return rez;
}

int main()
{
	freopen("kinder.in", "rt", stdin);
	freopen("kinder.out", "wt", stdout);

	scanf("%d %d %d", &N, &T, &M);

	for (int i = 0; i < M; i++)
	{
		vector<int> tmp;
		int type, nrparam;
		scanf("%d", &type);
		nrparam = 2 + 2 * (type != 2);

		tmp.resize( nrparam + 1 );
		tmp[0] = type;
		for (int i = 1; i <= nrparam; i++)
		{
			int val;
			scanf("%d", &val);
			tmp[i] = val;
		}

		if (type == 1)
			typesC[ tmp[1] ].push_back( tmp[2] );

		op.push_back( tmp );
	}

	for (int i = 1; i <= N; i++)
	{
		sort( ALL( typesC[i] ) );
		typesC[i].resize( unique( ALL( typesC[i] ) ) - typesC[i].begin() );
	}

	buildTree( 1, 1, N );
	for (int i = 0; i < M; i++)
	{
		if (op[i][0] == 1)
		{
			UPoz = op[i][1];
			UType = op[i][2];
			UCol = op[i][3];
			UVal = op[i][4];
			
			updateAdd( 1, 1, N );
		}
		else if (op[i][0] == 2)
		{
			UPoz = op[i][1];
			UType = op[i][2];

			updateCol( 1, 1, N );
		}
		else
		{
			QL = op[i][1];
			QR = op[i][2];
			QCol = op[i][3];
			int step = 1 << 15;
			for (QRez = 0; step; step >>= 1)
				if (QRez + step <= T)
				{
					QRez += step;

					if (query( 1, 1, N ) >= op[i][4])
						QRez -= step;
				}

			printf("%d\n", QRez + 1);
		}
	}

	return 0;
}
