/*  
	Daniel Pasaila, Romania
	O(N) queries 
*/
#include <cstdio>
#include <vector>
using namespace std;

#define MAXN 128
#define pb push_back

int N, res[MAXN], M[MAXN][MAXN];

int getN()
{
	int nr;
	scanf("%d", &nr);
	return nr;
}

int ask(int l, int c)
{
	int &ret = M[l][c];
	if (ret != -1)
		return ret;
	printf("ASK %d %d\n", l, c);
	fflush(stdout);

	scanf("%d", &ret);

	return ret;
}

void normalize(vector<int> &L, vector<int> &C)
{
	int k = 0;

	while (L.size() < C.size())
	{
		int nr1 = ask(L[k], C[k]), nr2 = ask(L[k], C[k + 1]);
		if (k < L.size() - 1 && nr1 > nr2)
			k++;
		else
			if (nr1 > nr2 && k == L.size() - 1)
				C.erase(C.begin() + L.size());
			else
				if (nr1 < nr2)
				{
					C.erase(C.begin() + k);
					if (k > 0)
						k--;
				}
	}
}

void solve(vector<int> &L, vector<int> &C)
{	
	if (L.size() == 1)
	{
		int pmax = C[0], vmax = ask(L[0], C[0]);
		for (int i = 1; i < C.size(); i++)
		{
			int nr = ask(L[0], C[i]);
			if (nr > vmax)
				pmax = C[i], vmax = nr;
		}
		res[L[0]] = pmax;

		return;
	}

	if (L.size() < C.size())
		normalize(L, C);

	vector<int> newl, newc = C;

	for (int i = 0; i < L.size(); i += 2)
		newl.pb(L[i]);

	solve(newl, newc);

	for (int i = 1; i < L.size(); i += 2)
	{
		int l1 = res[L[i - 1]], l2;
		if (i + 1 < L.size())
			l2 = res[L[i + 1]];
		else
			l2 = N - 1;

		for (int j = 0; j < C.size(); j++)
			if (C[j] >= l1)
			{
				l1 = j;
				break;
			}

		for (int j = C.size() - 1; j >= 0; j--)
			if (C[j] <= l2)
			{
				l2 = j;
				break;
			}

		int pmax = C[l1], vmax = ask(L[i], C[l1]);
		for (int k = l1 + 1; k <= l2; k++)
		{
			int nr = ask(L[i], C[k]);
			if (nr > vmax)
				vmax = nr, pmax = C[k];
		}
		res[L[i]] = pmax;
	}
}

int main()
{
	memset(M, -1, sizeof(M));
	vector<int> L, C;

	N = getN();
	for (int i = 0; i < N; i++)
	{
		L.pb(i);
		C.pb(i);
	}

	solve(L, C);

	printf("DONE ");
	for (int i = 0; i < N; i++)
		printf("%d ", res[i]);
	printf("\n");

	return 0;
}