#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXN 100005
#define MAXBUC 320
#define MAXM 20005

int N, M;
vector< vector<int> > gr;
vector<int> ord;
vector<char> isrev;

inline void reverseGr( int id, int l, int r )
{
	l--; r--;
	if (isrev[id])
		l = gr[id].size() - l - 1,
		r = gr[id].size() - r - 1;

	if (l > r)
		swap( l, r );
	for (; l < r; l++, r--)
		swap( gr[id][l], gr[id][r] );
}

inline void split( int id, int poz, int type )
{
#ifdef DEBUG
	printf("\t%d %d %d\n", id, poz, type);
#endif
	vector<int> newgr, curgr;
	poz--;
	if (isrev[id])
		poz = gr[id].size() - poz - 1,
		type ^= 1;
		
	if (type == 0)
	{
		for (int k = 0; k < poz; k++)
			curgr.push_back( gr[id][k] );
		for (int k = poz; k < (int)gr[id].size(); k++)
			newgr.push_back( gr[id][k] );
	}
	else
	{
		poz++;
		for (int k = 0; k < poz; k++)
			newgr.push_back( gr[id][k] );
		for (int k = poz; k < (int)gr[id].size(); k++)
			curgr.push_back( gr[id][k] );
	}

	gr[id] = curgr;
	gr.push_back( newgr );
	isrev.push_back( isrev[id] );
}

#ifdef DEBUG
inline void print()
{
	for (size_t k = 0; k < gr.size(); k++)
	{
		printf("%d %d: ", ord[k], isrev[ ord[k] ]);
		if (!isrev[ ord[k] ])
		{
			for (size_t a = 0; a < gr[ ord[k] ].size(); a++)
				printf("%d ", gr[ ord[k] ][a]);
		}
		else
		{
			for (int a = (int)gr[ ord[k] ].size() - 1; a >= 0; a--)
				printf("%d ", gr[ ord[k] ][a]);
		}
		printf("\n");
	}
	printf("\n");
	fflush(stdout);
}
#endif

inline void unite( int a, int b )
{
	if (isrev[a])
		reverse( gr[a].begin(), gr[a].end() ),
		isrev[a] = 0;
	if (isrev[b])
		reverse( gr[b].begin(), gr[b].end() ),
		isrev[b] = 0;

	for (size_t k = 0; k < gr[b].size(); k++)
		gr[a].push_back( gr[b][k] );
	vector<int>().swap( gr[b] );
}

inline int getElem( int id, int poz )
{
	poz--;
	if (isrev[id])
		poz = gr[id].size() - poz - 1;
	return gr[id][poz];
}

int main()
{
	freopen("rev.in", "rt", stdin);
	freopen("rev.out", "wt", stdout);

	scanf("%d %d", &N, &M);
	vector<int> tmp;
	for (int i = 1; i <= N; i++)
	{
		tmp.push_back(i);
		if (i % MAXBUC == 0)
			ord.push_back( gr.size() ),
			gr.push_back( tmp ),
			tmp.clear();
	}
	if (!tmp.empty())
		ord.push_back( gr.size() ),
		gr.push_back( tmp ),
		tmp.clear();
	isrev.resize( gr.size(), 0 );

#ifdef DEBUG
	print();
#endif
	for (int i = 0; i < M; i++)
	{
		int L, R, P;
		
		scanf("%d %d %d", &L, &R, &P);

		int beforeL = 0, beforeR;
		size_t grL, grR;
		for (grL = 0; grL < gr.size(); grL++)
		{
			if (beforeL + (int)gr[ ord[grL] ].size() < L)
				beforeL += (int)gr[ ord[grL] ].size();
			else
				break;
		}
		beforeR = beforeL;
		for (grR = grL; grR < gr.size(); grR++)
		{
			if (beforeR + (int)gr[ ord[grR] ].size() < R)
				beforeR += (int)gr[ ord[grR] ].size();
			else
				break;
		}

#ifdef DEBUG
		printf("%d %d %d %d\n", L, R, (int)grL, (int)grR);
#endif
		if (grL == grR)
			reverseGr( ord[grL], L - beforeL, R - beforeR );
		else
		{
			split( ord[grL], L - beforeL, 0 );
			ord.insert( ord.begin() + grL + 1, gr.size() - 1 ); grR++;
			
			split( ord[grR], R - beforeR, 1 );
			ord.insert( ord.begin() + grR, gr.size() - 1 ); grR++;

#ifdef DEBUG
			printf("%d %d\n", grL + 1, grR - 1);
			print();
#endif
			if (grL + 1 <= grR - 1)
			{
				for (grL++, grR--; grL < grR; grL++, grR--)	
					swap( ord[grL], ord[grR] ),
					isrev[ ord[grL] ] ^= 1, isrev[ ord[grR] ] ^= 1;
				if (grL == grR)
					isrev[ ord[grL] ] ^= 1;
			}
		}
#ifdef DEBUG
		print();
#endif

		for (size_t k = 0; k + 1 < ord.size(); )
		{
			if (gr[ ord[k] ].size() + gr[ ord[k + 1] ].size() < 2 * MAXBUC)
			{
				unite( ord[k], ord[k + 1] );
				ord.erase( ord.begin() + k + 1 );
			}
			else
				k++;
		}
		
		int before = 0;
		size_t grP;
		for (grP = 0; grP < gr.size(); grP++)
		{
			if (before + (int)gr[ ord[grP] ].size() < P)
				before += (int)gr[ ord[grP] ].size();
			else
				break;
		}
		printf("%d\n", getElem( ord[grP] , P - before ));
	}

	return 0;
}
