#include <stdio.h>
#include <math.h>

#define NMAX 1000100
#define INF 1e17
#define eps 1e-9
#define weps 1e-2

long long x[NMAX], w[NMAX], A, B, C, D;
double li, ls, dw, xleft, xright, xrightmin, xleftmax, xpos, d, dmax;
int i, j, k, N, L, ok;

#define minim(a,b) ((a) < (b) ? (a) : (b))
#define maxim(a,b) ((a) > (b) ? (a) : (b))

int main()
{
	freopen("center.in", "r", stdin);

	scanf("%d %d %lld %lld %lld %lld %lld", &N, &L, &w[1], &A, &B, &C, &D);
	x[1] = 0;

	for (i = 2; i <= N; i++)
	{ // good rule ?
		x[i] = x[i - 1] + 1 + (((x[i - 1] * i) ^ A) % B);
		//w[i] = 1 + ((((w[i - 1] * B) ^ (long long) (i * D)) % minim(i, N - i + 1)));
		if (2 * i <= N)
			k = 1;
		else
			k = -1;

		w[i] = maxim(1, w[i - 1] + k * (1 + ((w[i - 1] * (i + C)) ^ (D * i)) % D));
		C = 1 + ((((C * C) % D) * i) % D);
	}

	/*
	N = 3;
	x[1] = 0; w[1] = 2;
	x[2] = 33; w[2] = 7;
	x[3] = 60; w[3] = 2;
	*/

	fprintf(stderr, "N=%d\n", N);
	/*
	for (i = 1; i <= N; i++)
		fprintf(stderr, "%d: %lld %lld\n", i, x[i], w[i]);
	*/

	if (x[N] - x[1] <= L)
	{
		printf("0\n0\n");
		return 0;
	}

	li = 0.0; ls = INF;

	while (fabs(ls - li) > weps)
	{
		dw = 0.5 * (li + ls);

		//fprintf(stderr, "li=%.4lf, ls=%.4lf\n", li, ls);

		// feasibility test: for each point i, define an interval [x[i] - L - dw/w[i], x[i] + dw/w[i]]
		
		xleftmax = -INF;
		xrightmin = INF;

		for (i = 1; i <= N; i++)
		{
			xleft = (double)(x[i] - L) - dw/w[i];
			xright = (double)x[i] + dw/w[i];

			if (xleft > xleftmax)
				xleftmax = xleft;

			if (xright < xrightmin)
				xrightmin = xright;

			if (xleftmax > xrightmin)
				break;
		}

		if ((xleftmax < xrightmin) || (fabs(xleftmax - xrightmin) < eps))
			ls = dw,
			xpos = xrightmin;
		else
			li = dw;
	}

	dmax = 0.0;
	for (i = 1; i <= N; i++)
	{
		if (((x[i] > xpos) || (fabs((double) x[i] - xpos) < eps)) &&
			((x[i] < xpos + L) || (fabs((double) x[i] - xpos - L) < eps)))
			d = 0;
		else
		if (x[i] < xpos)
			d = w[i] * (xpos - x[i]);
		else
			d = w[i] * (x[i] - xpos - L);

		if (d > dmax)
			dmax = d;
	}

	fprintf(stderr, "%.3lf [%.3lf-%.3lf]\n", dmax, xpos, xpos + L);

	freopen("center.out", "w", stdout);
	printf("%.3lf\n%.8lf", dmax, xpos);

	return 0;
}
