// binsearch
// sort + p log s

#include <iostream>
#include <algorithm>
#include <utility>
#include <cassert>
#include <vector>

using namespace std;

#define Infile "sirag.in"
#define Outfile "sirag.out"

const int nmax = 100001;

int n, p;
vector < int > a;
vector < long long > s;

void init() {
        int i;
	scanf("%d%d", &n, &p);
	a.resize(n);
	for(i=0; i<n; i++) {
		scanf("%d", &a[i]);
	}
	sort(a.rbegin(), a.rend());
	s.resize(n + 1);
	s[n] = 0;
	for (i = n - 1; i >= 0; --i) {
		s[i] = s[i + 1] + a[i];
	}
}

int good(long long x) 
{int i;
 for (i=0; i<p; i++) 
	    {
    	    if (x*(p - i) > s[i]) return -1;
	    if (a[i] <= x) return i;
	    }
 return p;
}

void solve() 
{
long long t, left = 0;
long long right = s[0] / p + 2;
 while (left + 1 < right) 
       {
       t = (left + right) / 2;
       if (good(t) != -1) left = t; else right = t;
      }
int k1 = good(left);
long long rest = k1 + s[k1] - left*(p - k1);

cout << left*p + rest;
}

int main() 
{
freopen(Infile, "rt", stdin);
freopen(Outfile, "wt", stdout);
init();
solve();
return 0;
}
