#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>

using namespace std;

#define FIN "bombe.in"
#define FOUT "bombe.out"

#define MAX_N 305
#define EPS (1e-6)

int N, ans = 0x3f3f3f3f;
double R, x[MAX_N], v[MAX_N], pos[MAX_N], t_ans;

void check(double t) {
	if (t < .0) {
		return;
	}

	int i, sol;
	double prev;

	for (i = 0; i < N; i++) {
		pos[i] = x[i]+v[i]*t;
	}
	sort(pos, pos+N);
	for (i = sol = 1, prev = pos[0]; i < N; i++) {
		if (pos[i] > prev + R + EPS) {
			sol++;
			prev = pos[i];
		}
	}
	if (sol < ans || (sol == ans && t < t_ans)) {
		ans = sol;
		t_ans = t;
	}
}

int sgn(double x) {
	return x > EPS ? +1 : x < -EPS ? -1 : 0;
}

int equal(double a, double b) {
	return fabs(a-b) < EPS;
}

int main() {
	int i, j;

	freopen(FIN, "r", stdin);
	freopen(FOUT, "w", stdout);

	scanf("%d %lf", &N, &R);
 R*=2;

	for (i = 0; i < N; i++) {
		scanf("%lf %lf", &x[i], &v[i]);
	}
	
	check(0.0);
	for (i = 0; i < N; i++) {
		for (j = i+1; j < N; j++) {
			if (equal(v[i], v[j])) {
				continue;
			}
			check((+R-x[i]+x[j])/(v[i]-v[j]));
			check((-R-x[i]+x[j])/(v[i]-v[j]));
		}
	}
	printf("%d %0.3lf\n", ans, t_ans);
	return 0;
}
