#include <cstdio>
#include <cstring>
#include <stack>
#include <cassert>
#include <vector>

using namespace std;

#define maxn 10123
#define maxm 64

struct nod {
    vector<nod *> fii;
};

int N, M;
nod nodes[maxn];
int sizes[maxn];

void read_tree(int tnum)
{
    int N, i, p;
    scanf("%d", &N);
    sizes[tnum] = N;

    for (i = 1; i <= N; i++)
        nodes[i].fii.clear();
    
    for (i = 2; i <= N; i++) {
            scanf ("%d", &p);
            nodes[p].fii.push_back(nodes + i);
    }
}    

void represent_tree(nod* n, char*& buf)
{
    *buf++ = '+';
    for (int i = 0; i < n->fii.size(); i++) {
        represent_tree(n->fii[i], buf);
    }
    *buf++ = '-';
}

const int prime = 9907;
char tree[maxm][2*maxn];

void read_data()
{
    int i = 0;
    char *buf;
    scanf ("%d %d", &N, &M);
    for (i = 0; i < M; i++) {
        read_tree(i);
        buf = tree[i];
        represent_tree(&nodes[1], buf);
        fprintf (stderr, "%s\n", tree[i]);
    }
}

int countbad[maxn];
//  numarul de arbori cu i noduri, respectiv siruri de arbori valizi cu i noduri in total
int C[maxn], S[maxn];
int ok[maxm], Pi[2*maxn];

void calc_prefix(char *P)
{
    int i, k;

    P--; Pi[1] = k = 0;
    for (i = 2; P[i]; i++) {
       for (; k > 0 && P[k + 1] != P[i]; k = Pi[k]);

       if (P[k + 1] == P[i])
           k++;
       Pi[i] = k;
    }
}

bool kmp(char *P, char* T)
{
    int i, k;

    P --; 
    for (k = 0; *T; *T++) {
        for (; k > 0 && P[k + 1] != *T; k = Pi[k]);

        if (P[k + 1] == *T)
            k++;

        if (P[k + 1] == 0) { // full match
            return true;
        }
    }

    return false;
}

void elimina_duplicate()
{
    int i, j;

    for (i = 0; i < M; i++) if (ok[i]) {
        calc_prefix(tree[i]);

        for (j = 0; j < M; j++)  if (ok[j])  {
            // pentru aceeasi lungime, avem grija sa pastram pe primul
            if (sizes[j] == sizes[i] && j >= i) continue;
            if (kmp(tree[i], tree[j]))
                ok[j] = 0;
        }
    }
}

void solve()
{
    int i, j;
    
    for (i = 0; i < M; i++) ok[i] = 1;
    
    elimina_duplicate();

    for (i = 0; i < M; i++) {
        countbad[sizes[i]] += ok[i];
        fprintf (stderr, "tree nr. %d __ size %d __ %s\n", i, sizes[i], ok[i] ? "ok" : "excluded");
    }

    S[0] = C[0] = 1;
    for (i = 1; i <= N; i++) {
        C[i] = S[i - 1] - countbad[i];
        for (j = 1; j <= i; j++)
           S[i] = (S[i] + S[i - j] * C[j]) % prime;
    }

    printf ("%d\n", C[N]);
}

int main()
{
#ifndef DEBUG
    freopen ("arbnr.in", "rt", stdin);
    freopen ("arbnr.out", "wt", stdout);
#endif

    read_data();
    solve();

    return 0;
}

