#include <cstdio>
#include <cstring>
#include <queue>
using namespace std;

const int MAXN = 1000005;

int N;
int v[MAXN];

bool dead[MAXN];
bool survives[MAXN];
int visited[MAXN];
int deg[MAXN];
queue<int> Q;

void ReadData() {
	scanf("%d", &N);
	for (int i = 1; i <= N; ++i)
		scanf("%d", &v[i]);
}

int DF(int k) {
	int ret = 1;
	visited[k] = 1;

	for (int i = v[k]; !visited[i]; i = v[i], ++ret)
		visited[i] = 1;

	return ret;
}

int MinVictims() {
	int ret = 0;
	memset(visited, 0, sizeof(visited));
	memset(survives, 0, sizeof(survives));
	memset(deg, 0, sizeof(deg));

	for (int i = 1; i <= N; ++i)
		++deg[v[i]];
	for (int i = 1; i <= N; ++i)
		if (!deg[i])
			Q.push(i);

	while (!Q.empty()) {
		int nod = Q.front();
		Q.pop(); ++ret;

		if (!dead[v[nod]] && --deg[ v[v[nod]] ] == 0 && !dead[v[v[nod]]])
			Q.push(v[v[nod]]);
		dead[v[nod]] = 1;

		visited[nod] = visited[v[nod]] = 1;
	}

	for (int i = 1; i <= N; ++i)
		if (!visited[i])
			ret += DF(i)/2;

	return N-ret;
}

void DF2(int k) {
	visited[k] = 1;
	for (int i = v[k]; !visited[i]; i = v[i])
		visited[i] = 1;
}

int MaxVictims() {
	memset(visited, 0, sizeof(visited));
	memset(survives, 0, sizeof(survives));
	memset(deg, 0, sizeof(deg));
	
	int ret = 0;

	for (int i = 1; i <= N; ++i)
		++deg[v[i]];

	for (int i = 1; i <= N; ++i)
		if (deg[i] == 0) {
			DF2(i);
			++ret;
		}

	for (int i = 1; i <= N; ++i)
		if (!visited[i]) {
			DF2(i);
			if (i != v[i]) ++ret;
		}
	return N-ret;
}

int main() {
	freopen("paintball.in", "r", stdin);
	freopen("paintball.out", "w", stdout);

	ReadData();
	printf("%d %d", MinVictims(), MaxVictims());
	return 0;
}